// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityRequestBuilder.cs.tt

namespace Microsoft.Graph.CallRecords
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type SessionRequestBuilder.
    /// </summary>
    public partial class SessionRequestBuilder : Microsoft.Graph.EntityRequestBuilder, ISessionRequestBuilder
    {

        /// <summary>
        /// Constructs a new SessionRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="Microsoft.Graph.IBaseClient"/> for handling requests.</param>
        public SessionRequestBuilder(
            string requestUrl,
            Microsoft.Graph.IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public new ISessionRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public new ISessionRequest Request(IEnumerable<Microsoft.Graph.Option> options)
        {
            return new SessionRequest(this.RequestUrl, this.Client, options);
        }
    
        /// <summary>
        /// Gets the request builder for Segments.
        /// </summary>
        /// <returns>The <see cref="ISessionSegmentsCollectionRequestBuilder"/>.</returns>
        public ISessionSegmentsCollectionRequestBuilder Segments
        {
            get
            {
                return new SessionSegmentsCollectionRequestBuilder(this.AppendSegmentToRequestUrl("segments"), this.Client);
            }
        }
    
    }
}
