// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityCollectionRequestBuilder.cs.tt
namespace Microsoft.Graph.ExternalConnectors
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// The type ExternalConnectionGroupsCollectionRequestBuilder.
    /// </summary>
    public partial class ExternalConnectionGroupsCollectionRequestBuilder : Microsoft.Graph.BaseRequestBuilder, IExternalConnectionGroupsCollectionRequestBuilder
    {
        /// <summary>
        /// Constructs a new ExternalConnectionGroupsCollectionRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="Microsoft.Graph.IBaseClient"/> for handling requests.</param>
        public ExternalConnectionGroupsCollectionRequestBuilder(
            string requestUrl,
            Microsoft.Graph.IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public IExternalConnectionGroupsCollectionRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public IExternalConnectionGroupsCollectionRequest Request(IEnumerable<Microsoft.Graph.Option> options)
        {
            return new ExternalConnectionGroupsCollectionRequest(this.RequestUrl, this.Client, options);
        }

        /// <summary>
        /// Gets an <see cref="IExternalGroupRequestBuilder"/> for the specified ExternalConnectionExternalGroup.
        /// </summary>
        /// <param name="id">The ID for the ExternalConnectionExternalGroup.</param>
        /// <returns>The <see cref="IExternalGroupRequestBuilder"/>.</returns>
        public IExternalGroupRequestBuilder this[string id]
        {
            get
            {
                return new ExternalGroupRequestBuilder(this.AppendSegmentToRequestUrl(id), this.Client);
            }
        }

        
    }
}
