// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph.ExternalConnectors
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IExternalGroupRequest.
    /// </summary>
    public partial interface IExternalGroupRequest : Microsoft.Graph.IBaseRequest
    {
        /// <summary>
        /// Creates the specified ExternalGroup using POST.
        /// </summary>
        /// <param name="externalGroupToCreate">The ExternalGroup to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created ExternalGroup.</returns>
        System.Threading.Tasks.Task<ExternalGroup> CreateAsync(ExternalGroup externalGroupToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified ExternalGroup using POST and returns a <see cref="GraphResponse{ExternalGroup}"/> object.
        /// </summary>
        /// <param name="externalGroupToCreate">The ExternalGroup to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{ExternalGroup}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<ExternalGroup>> CreateResponseAsync(ExternalGroup externalGroupToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified ExternalGroup.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified ExternalGroup and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified ExternalGroup.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The ExternalGroup.</returns>
        System.Threading.Tasks.Task<ExternalGroup> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified ExternalGroup and returns a <see cref="GraphResponse{ExternalGroup}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{ExternalGroup}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<ExternalGroup>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified ExternalGroup using PATCH.
        /// </summary>
        /// <param name="externalGroupToUpdate">The ExternalGroup to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="Microsoft.Graph.ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated ExternalGroup.</returns>
        System.Threading.Tasks.Task<ExternalGroup> UpdateAsync(ExternalGroup externalGroupToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified ExternalGroup using PATCH and returns a <see cref="GraphResponse{ExternalGroup}"/> object.
        /// </summary>
        /// <param name="externalGroupToUpdate">The ExternalGroup to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="Microsoft.Graph.ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{ExternalGroup}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<ExternalGroup>> UpdateResponseAsync(ExternalGroup externalGroupToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified ExternalGroup using PUT.
        /// </summary>
        /// <param name="externalGroupToUpdate">The ExternalGroup object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<ExternalGroup> PutAsync(ExternalGroup externalGroupToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified ExternalGroup using PUT and returns a <see cref="GraphResponse{ExternalGroup}"/> object.
        /// </summary>
        /// <param name="externalGroupToUpdate">The ExternalGroup object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{ExternalGroup}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<ExternalGroup>> PutResponseAsync(ExternalGroup externalGroupToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IExternalGroupRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IExternalGroupRequest Expand(Expression<Func<ExternalGroup, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IExternalGroupRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IExternalGroupRequest Select(Expression<Func<ExternalGroup, object>> selectExpression);

    }
}
