// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type Access Package Catalog.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<AccessPackageCatalog>))]
    public partial class AccessPackageCatalog : Entity
    {
    
        /// <summary>
        /// Gets or sets catalog type.
        /// Whether the catalog is created by a user or entitlement management. The possible values are: userManaged, serviceDefault, serviceManaged, unknownFutureValue.
        /// </summary>
        [JsonPropertyName("catalogType")]
        public AccessPackageCatalogType? CatalogType { get; set; }
    
        /// <summary>
        /// Gets or sets created date time.
        /// The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z. Read-only.
        /// </summary>
        [JsonPropertyName("createdDateTime")]
        public DateTimeOffset? CreatedDateTime { get; set; }
    
        /// <summary>
        /// Gets or sets description.
        /// The description of the access package catalog.
        /// </summary>
        [JsonPropertyName("description")]
        public string Description { get; set; }
    
        /// <summary>
        /// Gets or sets display name.
        /// The display name of the access package catalog.
        /// </summary>
        [JsonPropertyName("displayName")]
        public string DisplayName { get; set; }
    
        /// <summary>
        /// Gets or sets is externally visible.
        /// Whether the access packages in this catalog can be requested by users outside of the tenant.
        /// </summary>
        [JsonPropertyName("isExternallyVisible")]
        public bool? IsExternallyVisible { get; set; }
    
        /// <summary>
        /// Gets or sets modified date time.
        /// The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z. Read-only.
        /// </summary>
        [JsonPropertyName("modifiedDateTime")]
        public DateTimeOffset? ModifiedDateTime { get; set; }
    
        /// <summary>
        /// Gets or sets state.
        /// Has the value published if the access packages are available for management. The possible values are: unpublished, published, unknownFutureValue.
        /// </summary>
        [JsonPropertyName("state")]
        public AccessPackageCatalogState? State { get; set; }
    
        /// <summary>
        /// Gets or sets access packages.
        /// The access packages in this catalog. Read-only. Nullable.
        /// </summary>
        [JsonPropertyName("accessPackages")]
        public IAccessPackageCatalogAccessPackagesCollectionPage AccessPackages { get; set; }

        /// <summary>
        /// Gets or sets accessPackagesNextLink.
        /// </summary>
        [JsonPropertyName("accessPackages@odata.nextLink")]
        [JsonConverter(typeof(NextLinkConverter))]
        public string AccessPackagesNextLink { get; set; }
    
    }
}

