// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type Apple Managed Identity Provider.
    /// </summary>
    public partial class AppleManagedIdentityProvider : IdentityProviderBase
    {
    
        ///<summary>
        /// The AppleManagedIdentityProvider constructor
        ///</summary>
        public AppleManagedIdentityProvider()
        {
            this.ODataType = "microsoft.graph.appleManagedIdentityProvider";
        }

        /// <summary>
        /// Gets or sets certificate data.
        /// The certificate data, which is a long string of text from the certificate. Can be null.
        /// </summary>
        [JsonPropertyName("certificateData")]
        public string CertificateData { get; set; }
    
        /// <summary>
        /// Gets or sets developer id.
        /// The Apple developer identifier. Required.
        /// </summary>
        [JsonPropertyName("developerId")]
        public string DeveloperId { get; set; }
    
        /// <summary>
        /// Gets or sets key id.
        /// The Apple key identifier. Required.
        /// </summary>
        [JsonPropertyName("keyId")]
        public string KeyId { get; set; }
    
        /// <summary>
        /// Gets or sets service id.
        /// The Apple service identifier. Required.
        /// </summary>
        [JsonPropertyName("serviceId")]
        public string ServiceId { get; set; }
    
    }
}

