// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type Authentication Methods Policy.
    /// </summary>
    public partial class AuthenticationMethodsPolicy : Entity
    {
    
        /// <summary>
        /// Gets or sets description.
        /// A description of the policy. Read-only.
        /// </summary>
        [JsonPropertyName("description")]
        public string Description { get; set; }
    
        /// <summary>
        /// Gets or sets display name.
        /// The name of the policy. Read-only.
        /// </summary>
        [JsonPropertyName("displayName")]
        public string DisplayName { get; set; }
    
        /// <summary>
        /// Gets or sets last modified date time.
        /// The date and time of the last update to the policy. Read-only.
        /// </summary>
        [JsonPropertyName("lastModifiedDateTime")]
        public DateTimeOffset? LastModifiedDateTime { get; set; }
    
        /// <summary>
        /// Gets or sets policy version.
        /// The version of the policy in use. Read-only.
        /// </summary>
        [JsonPropertyName("policyVersion")]
        public string PolicyVersion { get; set; }
    
        /// <summary>
        /// Gets or sets reconfirmation in days.
        /// </summary>
        [JsonPropertyName("reconfirmationInDays")]
        public Int32? ReconfirmationInDays { get; set; }
    
        /// <summary>
        /// Gets or sets registration enforcement.
        /// Enforce registration at sign-in time. This property can be used to remind users to set up targeted authentication methods.
        /// </summary>
        [JsonPropertyName("registrationEnforcement")]
        public RegistrationEnforcement RegistrationEnforcement { get; set; }
    
        /// <summary>
        /// Gets or sets authentication method configurations.
        /// Represents the settings for each authentication method.
        /// </summary>
        [JsonPropertyName("authenticationMethodConfigurations")]
        public IAuthenticationMethodsPolicyAuthenticationMethodConfigurationsCollectionPage AuthenticationMethodConfigurations { get; set; }

        /// <summary>
        /// Gets or sets authenticationMethodConfigurationsNextLink.
        /// </summary>
        [JsonPropertyName("authenticationMethodConfigurations@odata.nextLink")]
        [JsonConverter(typeof(NextLinkConverter))]
        public string AuthenticationMethodConfigurationsNextLink { get; set; }
    
    }
}

