// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type Authored Note.
    /// </summary>
    public partial class AuthoredNote : Entity
    {
    
        /// <summary>
        /// Gets or sets author.
        /// Identity information about the note's author.
        /// </summary>
        [JsonPropertyName("author")]
        public Identity Author { get; set; }
    
        /// <summary>
        /// Gets or sets content.
        /// The content of the note.
        /// </summary>
        [JsonPropertyName("content")]
        public ItemBody Content { get; set; }
    
        /// <summary>
        /// Gets or sets created date time.
        /// The date and time when the entity was created. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z.
        /// </summary>
        [JsonPropertyName("createdDateTime")]
        public DateTimeOffset? CreatedDateTime { get; set; }
    
    }
}

