// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type Bitlocker Recovery Key.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<BitlockerRecoveryKey>))]
    public partial class BitlockerRecoveryKey : Entity
    {
    
        /// <summary>
        /// Gets or sets created date time.
        /// The date and time when the key was originally backed up to Azure Active Directory. Not nullable.
        /// </summary>
        [JsonPropertyName("createdDateTime")]
        public DateTimeOffset? CreatedDateTime { get; set; }
    
        /// <summary>
        /// Gets or sets device id.
        /// Identifier of the device the BitLocker key is originally backed up from. Supports $filter (eq).
        /// </summary>
        [JsonPropertyName("deviceId")]
        public string DeviceId { get; set; }
    
        /// <summary>
        /// Gets or sets key.
        /// The BitLocker recovery key. Returned only on $select. Not nullable.
        /// </summary>
        [JsonPropertyName("key")]
        public string Key { get; set; }
    
        /// <summary>
        /// Gets or sets volume type.
        /// Indicates the type of volume the BitLocker key is associated with. The possible values are: 1 (for operatingSystemVolume), 2 (for fixedDataVolume), 3 (for removableDataVolume), and 4 (for unknownFutureValue).
        /// </summary>
        [JsonPropertyName("volumeType")]
        public VolumeType? VolumeType { get; set; }
    
    }
}

