// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: ComplexType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type BookingQuestionAnswer.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<BookingQuestionAnswer>))]
    public partial class BookingQuestionAnswer
    {

        /// <summary>
        /// Gets or sets answer.
        /// The answer given by the user in case the answerInputType is text.
        /// </summary>
        [JsonPropertyName("answer")]
        public string Answer { get; set; }
    
        /// <summary>
        /// Gets or sets answerInputType.
        /// The expected answer type. The possible values are: text, radioButton, unknownFutureValue.
        /// </summary>
        [JsonPropertyName("answerInputType")]
        public AnswerInputType? AnswerInputType { get; set; }
    
        /// <summary>
        /// Gets or sets answerOptions.
        /// In case the answerInputType is radioButton, this will consists of a list of possible answer values.
        /// </summary>
        [JsonPropertyName("answerOptions")]
        public IEnumerable<string> AnswerOptions { get; set; }
    
        /// <summary>
        /// Gets or sets isRequired.
        /// Indicates whether it is mandatory to answer the custom question.
        /// </summary>
        [JsonPropertyName("isRequired")]
        public bool? IsRequired { get; set; }
    
        /// <summary>
        /// Gets or sets question.
        /// The question.
        /// </summary>
        [JsonPropertyName("question")]
        public string Question { get; set; }
    
        /// <summary>
        /// Gets or sets questionId.
        /// The ID of the custom question.
        /// </summary>
        [JsonPropertyName("questionId")]
        public string QuestionId { get; set; }
    
        /// <summary>
        /// Gets or sets selectedOptions.
        /// The answers selected by the user.
        /// </summary>
        [JsonPropertyName("selectedOptions")]
        public IEnumerable<string> SelectedOptions { get; set; }
    
        /// <summary>
        /// Gets or sets additional data.
        /// </summary>
        [JsonExtensionData]
        public IDictionary<string, object> AdditionalData { get; set; }

        /// <summary>
        /// Gets or sets @odata.type.
        /// </summary>
        [JsonPropertyName("@odata.type")]
        public string ODataType { get; set; }
    
    }
}
