// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: ComplexType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type BookingSchedulingPolicy.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<BookingSchedulingPolicy>))]
    public partial class BookingSchedulingPolicy
    {

        /// <summary>
        /// Gets or sets allowStaffSelection.
        /// True if to allow customers to choose a specific person for the booking.
        /// </summary>
        [JsonPropertyName("allowStaffSelection")]
        public bool? AllowStaffSelection { get; set; }
    
        /// <summary>
        /// Gets or sets maximumAdvance.
        /// Maximum number of days in advance that a booking can be made. It follows the ISO 8601 format.
        /// </summary>
        [JsonPropertyName("maximumAdvance")]
        public Duration MaximumAdvance { get; set; }
    
        /// <summary>
        /// Gets or sets minimumLeadTime.
        /// The minimum amount of time before which bookings and cancellations must be made. It follows the ISO 8601 format.
        /// </summary>
        [JsonPropertyName("minimumLeadTime")]
        public Duration MinimumLeadTime { get; set; }
    
        /// <summary>
        /// Gets or sets sendConfirmationsToOwner.
        /// True to notify the business via email when a booking is created or changed. Use the email address specified in the email property of the bookingBusiness entity for the business.
        /// </summary>
        [JsonPropertyName("sendConfirmationsToOwner")]
        public bool? SendConfirmationsToOwner { get; set; }
    
        /// <summary>
        /// Gets or sets timeSlotInterval.
        /// Duration of each time slot, denoted in ISO 8601 format.
        /// </summary>
        [JsonPropertyName("timeSlotInterval")]
        public Duration TimeSlotInterval { get; set; }
    
        /// <summary>
        /// Gets or sets additional data.
        /// </summary>
        [JsonExtensionData]
        public IDictionary<string, object> AdditionalData { get; set; }

        /// <summary>
        /// Gets or sets @odata.type.
        /// </summary>
        [JsonPropertyName("@odata.type")]
        public string ODataType { get; set; }
    
    }
}
