// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: ComplexType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type ChangeNotificationCollection.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<ChangeNotificationCollection>))]
    public partial class ChangeNotificationCollection
    {

        /// <summary>
        /// Gets or sets validationTokens.
        /// Contains an array of JWT tokens generated by Microsoft Graph for the application to validate the origin of the notifications. Microsoft Graph generates a single token for each distinct app and tenant pair for an item if it exists in the value array. Keep in mind that notifications can contain a mix of items for various apps and tenants that subscribed using the same notification URL. Only provided for change notifications with resource data Optional.
        /// </summary>
        [JsonPropertyName("validationTokens")]
        public IEnumerable<string> ValidationTokens { get; set; }
    
        /// <summary>
        /// Gets or sets value.
        /// The set of notifications being sent to the notification URL. Required.
        /// </summary>
        [JsonPropertyName("value")]
        public IEnumerable<ChangeNotification> Value { get; set; }
    
        /// <summary>
        /// Gets or sets additional data.
        /// </summary>
        [JsonExtensionData]
        public IDictionary<string, object> AdditionalData { get; set; }

        /// <summary>
        /// Gets or sets @odata.type.
        /// </summary>
        [JsonPropertyName("@odata.type")]
        public string ODataType { get; set; }
    
    }
}
