// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: ComplexType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type ChatMessageMention.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<ChatMessageMention>))]
    public partial class ChatMessageMention
    {

        /// <summary>
        /// Gets or sets id.
        /// Index of an entity being mentioned in the specified chatMessage. Matches the {index} value in the corresponding &amp;lt;at id='{index}'&amp;gt; tag in the message body.
        /// </summary>
        [JsonPropertyName("id")]
        public Int32? Id { get; set; }
    
        /// <summary>
        /// Gets or sets mentioned.
        /// The entity (user, application, team, or channel) that was @mentioned.
        /// </summary>
        [JsonPropertyName("mentioned")]
        public ChatMessageMentionedIdentitySet Mentioned { get; set; }
    
        /// <summary>
        /// Gets or sets mentionText.
        /// String used to represent the mention. For example, a user's display name, a team name.
        /// </summary>
        [JsonPropertyName("mentionText")]
        public string MentionText { get; set; }
    
        /// <summary>
        /// Gets or sets additional data.
        /// </summary>
        [JsonExtensionData]
        public IDictionary<string, object> AdditionalData { get; set; }

        /// <summary>
        /// Gets or sets @odata.type.
        /// </summary>
        [JsonPropertyName("@odata.type")]
        public string ODataType { get; set; }
    
    }
}
