// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: ComplexType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type CloudAppSecurityState.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<CloudAppSecurityState>))]
    public partial class CloudAppSecurityState
    {

        /// <summary>
        /// Gets or sets destinationServiceIp.
        /// Destination IP Address of the connection to the cloud application/service.
        /// </summary>
        [JsonPropertyName("destinationServiceIp")]
        public string DestinationServiceIp { get; set; }
    
        /// <summary>
        /// Gets or sets destinationServiceName.
        /// Cloud application/service name (for example 'Salesforce', 'DropBox', etc.).
        /// </summary>
        [JsonPropertyName("destinationServiceName")]
        public string DestinationServiceName { get; set; }
    
        /// <summary>
        /// Gets or sets riskScore.
        /// Provider-generated/calculated risk score of the Cloud Application/Service. Recommended value range of 0-1, which equates to a percentage.
        /// </summary>
        [JsonPropertyName("riskScore")]
        public string RiskScore { get; set; }
    
        /// <summary>
        /// Gets or sets additional data.
        /// </summary>
        [JsonExtensionData]
        public IDictionary<string, object> AdditionalData { get; set; }

        /// <summary>
        /// Gets or sets @odata.type.
        /// </summary>
        [JsonPropertyName("@odata.type")]
        public string ODataType { get; set; }
    
    }
}
