// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: ComplexType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type ColumnValidation.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<ColumnValidation>))]
    public partial class ColumnValidation
    {

        /// <summary>
        /// Gets or sets defaultLanguage.
        /// Default BCP 47 language tag for the description.
        /// </summary>
        [JsonPropertyName("defaultLanguage")]
        public string DefaultLanguage { get; set; }
    
        /// <summary>
        /// Gets or sets descriptions.
        /// Localized messages that explain what is needed for this column's value to be considered valid. User will be prompted with this message if validation fails.
        /// </summary>
        [JsonPropertyName("descriptions")]
        public IEnumerable<DisplayNameLocalization> Descriptions { get; set; }
    
        /// <summary>
        /// Gets or sets formula.
        /// The formula to validate column value. For examples, see Examples of common formulas in lists.
        /// </summary>
        [JsonPropertyName("formula")]
        public string Formula { get; set; }
    
        /// <summary>
        /// Gets or sets additional data.
        /// </summary>
        [JsonExtensionData]
        public IDictionary<string, object> AdditionalData { get; set; }

        /// <summary>
        /// Gets or sets @odata.type.
        /// </summary>
        [JsonPropertyName("@odata.type")]
        public string ODataType { get; set; }
    
    }
}
