// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type Compliance Management Partner.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<ComplianceManagementPartner>))]
    public partial class ComplianceManagementPartner : Entity
    {
    
        /// <summary>
        /// Gets or sets android enrollment assignments.
        /// User groups which enroll Android devices through partner.
        /// </summary>
        [JsonPropertyName("androidEnrollmentAssignments")]
        public IEnumerable<ComplianceManagementPartnerAssignment> AndroidEnrollmentAssignments { get; set; }
    
        /// <summary>
        /// Gets or sets android onboarded.
        /// Partner onboarded for Android devices.
        /// </summary>
        [JsonPropertyName("androidOnboarded")]
        public bool? AndroidOnboarded { get; set; }
    
        /// <summary>
        /// Gets or sets display name.
        /// Partner display name
        /// </summary>
        [JsonPropertyName("displayName")]
        public string DisplayName { get; set; }
    
        /// <summary>
        /// Gets or sets ios enrollment assignments.
        /// User groups which enroll ios devices through partner.
        /// </summary>
        [JsonPropertyName("iosEnrollmentAssignments")]
        public IEnumerable<ComplianceManagementPartnerAssignment> IosEnrollmentAssignments { get; set; }
    
        /// <summary>
        /// Gets or sets ios onboarded.
        /// Partner onboarded for ios devices.
        /// </summary>
        [JsonPropertyName("iosOnboarded")]
        public bool? IosOnboarded { get; set; }
    
        /// <summary>
        /// Gets or sets last heartbeat date time.
        /// Timestamp of last heartbeat after admin onboarded to the compliance management partner
        /// </summary>
        [JsonPropertyName("lastHeartbeatDateTime")]
        public DateTimeOffset? LastHeartbeatDateTime { get; set; }
    
        /// <summary>
        /// Gets or sets mac os enrollment assignments.
        /// User groups which enroll Mac devices through partner.
        /// </summary>
        [JsonPropertyName("macOsEnrollmentAssignments")]
        public IEnumerable<ComplianceManagementPartnerAssignment> MacOsEnrollmentAssignments { get; set; }
    
        /// <summary>
        /// Gets or sets mac os onboarded.
        /// Partner onboarded for Mac devices.
        /// </summary>
        [JsonPropertyName("macOsOnboarded")]
        public bool? MacOsOnboarded { get; set; }
    
        /// <summary>
        /// Gets or sets partner state.
        /// Partner state of this tenant. Possible values are: unknown, unavailable, enabled, terminated, rejected, unresponsive.
        /// </summary>
        [JsonPropertyName("partnerState")]
        public DeviceManagementPartnerTenantState? PartnerState { get; set; }
    
    }
}

