// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type Contract.
    /// </summary>
    public partial class Contract : DirectoryObject
    {
    
        ///<summary>
        /// The Contract constructor
        ///</summary>
        public Contract()
        {
            this.ODataType = "microsoft.graph.contract";
        }

        /// <summary>
        /// Gets or sets contract type.
        /// Type of contract. Possible values are:  SyndicationPartner, BreadthPartner, ResellerPartner. See more in the table below.
        /// </summary>
        [JsonPropertyName("contractType")]
        public string ContractType { get; set; }
    
        /// <summary>
        /// Gets or sets customer id.
        /// The unique identifier for the customer tenant referenced by this partnership. Corresponds to the id property of the customer tenant's organization resource.
        /// </summary>
        [JsonPropertyName("customerId")]
        public Guid? CustomerId { get; set; }
    
        /// <summary>
        /// Gets or sets default domain name.
        /// A copy of the customer tenant's default domain name. The copy is made when the partnership with the customer is established. It is not automatically updated if the customer tenant's default domain name changes.
        /// </summary>
        [JsonPropertyName("defaultDomainName")]
        public string DefaultDomainName { get; set; }
    
        /// <summary>
        /// Gets or sets display name.
        /// A copy of the customer tenant's display name. The copy is made when the partnership with the customer is established. It is not automatically updated if the customer tenant's display name changes.
        /// </summary>
        [JsonPropertyName("displayName")]
        public string DisplayName { get; set; }
    
    }
}

