// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type Data Policy Operation.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<DataPolicyOperation>))]
    public partial class DataPolicyOperation : Entity
    {
    
        /// <summary>
        /// Gets or sets completed date time.
        /// Represents when the request for this data policy operation was completed, in UTC time, using the ISO 8601 format. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z. Null until the operation completes.
        /// </summary>
        [JsonPropertyName("completedDateTime")]
        public DateTimeOffset? CompletedDateTime { get; set; }
    
        /// <summary>
        /// Gets or sets progress.
        /// Specifies the progress of an operation.
        /// </summary>
        [JsonPropertyName("progress")]
        public double? Progress { get; set; }
    
        /// <summary>
        /// Gets or sets status.
        /// Possible values are: notStarted, running, complete, failed, unknownFutureValue.
        /// </summary>
        [JsonPropertyName("status")]
        public DataPolicyOperationStatus? Status { get; set; }
    
        /// <summary>
        /// Gets or sets storage location.
        /// The URL location to where data is being exported for export requests.
        /// </summary>
        [JsonPropertyName("storageLocation")]
        public string StorageLocation { get; set; }
    
        /// <summary>
        /// Gets or sets submitted date time.
        /// Represents when the request for this data operation was submitted, in UTC time, using the ISO 8601 format. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z
        /// </summary>
        [JsonPropertyName("submittedDateTime")]
        public DateTimeOffset? SubmittedDateTime { get; set; }
    
        /// <summary>
        /// Gets or sets user id.
        /// The id for the user on whom the operation is performed.
        /// </summary>
        [JsonPropertyName("userId")]
        public string UserId { get; set; }
    
    }
}

