// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: ComplexType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type DataSubject.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<DataSubject>))]
    public partial class DataSubject
    {

        /// <summary>
        /// Gets or sets email.
        /// Email of the data subject.
        /// </summary>
        [JsonPropertyName("email")]
        public string Email { get; set; }
    
        /// <summary>
        /// Gets or sets firstName.
        /// First name of the data subject.
        /// </summary>
        [JsonPropertyName("firstName")]
        public string FirstName { get; set; }
    
        /// <summary>
        /// Gets or sets lastName.
        /// Last Name of the data subject.
        /// </summary>
        [JsonPropertyName("lastName")]
        public string LastName { get; set; }
    
        /// <summary>
        /// Gets or sets residency.
        /// The country/region of residency. The residency information is uesed only for internal reporting but not for the content search.
        /// </summary>
        [JsonPropertyName("residency")]
        public string Residency { get; set; }
    
        /// <summary>
        /// Gets or sets additional data.
        /// </summary>
        [JsonExtensionData]
        public IDictionary<string, object> AdditionalData { get; set; }

        /// <summary>
        /// Gets or sets @odata.type.
        /// </summary>
        [JsonPropertyName("@odata.type")]
        public string ODataType { get; set; }
    
    }
}
