// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type Device Management.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<DeviceManagement>))]
    public partial class DeviceManagement : Entity
    {
    
        /// <summary>
        /// Gets or sets intune account id.
        /// Intune Account Id for given tenant
        /// </summary>
        [JsonPropertyName("intuneAccountId")]
        public Guid? IntuneAccountId { get; set; }
    
        /// <summary>
        /// Gets or sets settings.
        /// Account level settings.
        /// </summary>
        [JsonPropertyName("settings")]
        public DeviceManagementSettings Settings { get; set; }
    
        /// <summary>
        /// Gets or sets intune brand.
        /// intuneBrand contains data which is used in customizing the appearance of the Company Portal applications as well as the end user web portal.
        /// </summary>
        [JsonPropertyName("intuneBrand")]
        public IntuneBrand IntuneBrand { get; set; }
    
        /// <summary>
        /// Gets or sets subscription state.
        /// Tenant mobile device management subscription state. Possible values are: pending, active, warning, disabled, deleted, blocked, lockedOut.
        /// </summary>
        [JsonPropertyName("subscriptionState")]
        public DeviceManagementSubscriptionState? SubscriptionState { get; set; }
    
        /// <summary>
        /// Gets or sets terms and conditions.
        /// The terms and conditions associated with device management of the company.
        /// </summary>
        [JsonPropertyName("termsAndConditions")]
        public IDeviceManagementTermsAndConditionsCollectionPage TermsAndConditions { get; set; }

        /// <summary>
        /// Gets or sets termsAndConditionsNextLink.
        /// </summary>
        [JsonPropertyName("termsAndConditions@odata.nextLink")]
        [JsonConverter(typeof(NextLinkConverter))]
        public string TermsAndConditionsNextLink { get; set; }
    
        /// <summary>
        /// Gets or sets device compliance policies.
        /// The device compliance policies.
        /// </summary>
        [JsonPropertyName("deviceCompliancePolicies")]
        public IDeviceManagementDeviceCompliancePoliciesCollectionPage DeviceCompliancePolicies { get; set; }

        /// <summary>
        /// Gets or sets deviceCompliancePoliciesNextLink.
        /// </summary>
        [JsonPropertyName("deviceCompliancePolicies@odata.nextLink")]
        [JsonConverter(typeof(NextLinkConverter))]
        public string DeviceCompliancePoliciesNextLink { get; set; }
    
        /// <summary>
        /// Gets or sets device compliance policy device state summary.
        /// The device compliance state summary for this account.
        /// </summary>
        [JsonPropertyName("deviceCompliancePolicyDeviceStateSummary")]
        public DeviceCompliancePolicyDeviceStateSummary DeviceCompliancePolicyDeviceStateSummary { get; set; }
    
        /// <summary>
        /// Gets or sets device compliance policy setting state summaries.
        /// The summary states of compliance policy settings for this account.
        /// </summary>
        [JsonPropertyName("deviceCompliancePolicySettingStateSummaries")]
        public IDeviceManagementDeviceCompliancePolicySettingStateSummariesCollectionPage DeviceCompliancePolicySettingStateSummaries { get; set; }

        /// <summary>
        /// Gets or sets deviceCompliancePolicySettingStateSummariesNextLink.
        /// </summary>
        [JsonPropertyName("deviceCompliancePolicySettingStateSummaries@odata.nextLink")]
        [JsonConverter(typeof(NextLinkConverter))]
        public string DeviceCompliancePolicySettingStateSummariesNextLink { get; set; }
    
        /// <summary>
        /// Gets or sets device configuration device state summaries.
        /// The device configuration device state summary for this account.
        /// </summary>
        [JsonPropertyName("deviceConfigurationDeviceStateSummaries")]
        public DeviceConfigurationDeviceStateSummary DeviceConfigurationDeviceStateSummaries { get; set; }
    
        /// <summary>
        /// Gets or sets device configurations.
        /// The device configurations.
        /// </summary>
        [JsonPropertyName("deviceConfigurations")]
        public IDeviceManagementDeviceConfigurationsCollectionPage DeviceConfigurations { get; set; }

        /// <summary>
        /// Gets or sets deviceConfigurationsNextLink.
        /// </summary>
        [JsonPropertyName("deviceConfigurations@odata.nextLink")]
        [JsonConverter(typeof(NextLinkConverter))]
        public string DeviceConfigurationsNextLink { get; set; }
    
        /// <summary>
        /// Gets or sets ios update statuses.
        /// The IOS software update installation statuses for this account.
        /// </summary>
        [JsonPropertyName("iosUpdateStatuses")]
        public IDeviceManagementIosUpdateStatusesCollectionPage IosUpdateStatuses { get; set; }

        /// <summary>
        /// Gets or sets iosUpdateStatusesNextLink.
        /// </summary>
        [JsonPropertyName("iosUpdateStatuses@odata.nextLink")]
        [JsonConverter(typeof(NextLinkConverter))]
        public string IosUpdateStatusesNextLink { get; set; }
    
        /// <summary>
        /// Gets or sets software update status summary.
        /// The software update status summary.
        /// </summary>
        [JsonPropertyName("softwareUpdateStatusSummary")]
        public SoftwareUpdateStatusSummary SoftwareUpdateStatusSummary { get; set; }
    
        /// <summary>
        /// Gets or sets compliance management partners.
        /// The list of Compliance Management Partners configured by the tenant.
        /// </summary>
        [JsonPropertyName("complianceManagementPartners")]
        public IDeviceManagementComplianceManagementPartnersCollectionPage ComplianceManagementPartners { get; set; }

        /// <summary>
        /// Gets or sets complianceManagementPartnersNextLink.
        /// </summary>
        [JsonPropertyName("complianceManagementPartners@odata.nextLink")]
        [JsonConverter(typeof(NextLinkConverter))]
        public string ComplianceManagementPartnersNextLink { get; set; }
    
        /// <summary>
        /// Gets or sets conditional access settings.
        /// The Exchange on premises conditional access settings. On premises conditional access will require devices to be both enrolled and compliant for mail access
        /// </summary>
        [JsonPropertyName("conditionalAccessSettings")]
        public OnPremisesConditionalAccessSettings ConditionalAccessSettings { get; set; }
    
        /// <summary>
        /// Gets or sets device categories.
        /// The list of device categories with the tenant.
        /// </summary>
        [JsonPropertyName("deviceCategories")]
        public IDeviceManagementDeviceCategoriesCollectionPage DeviceCategories { get; set; }

        /// <summary>
        /// Gets or sets deviceCategoriesNextLink.
        /// </summary>
        [JsonPropertyName("deviceCategories@odata.nextLink")]
        [JsonConverter(typeof(NextLinkConverter))]
        public string DeviceCategoriesNextLink { get; set; }
    
        /// <summary>
        /// Gets or sets device enrollment configurations.
        /// The list of device enrollment configurations
        /// </summary>
        [JsonPropertyName("deviceEnrollmentConfigurations")]
        public IDeviceManagementDeviceEnrollmentConfigurationsCollectionPage DeviceEnrollmentConfigurations { get; set; }

        /// <summary>
        /// Gets or sets deviceEnrollmentConfigurationsNextLink.
        /// </summary>
        [JsonPropertyName("deviceEnrollmentConfigurations@odata.nextLink")]
        [JsonConverter(typeof(NextLinkConverter))]
        public string DeviceEnrollmentConfigurationsNextLink { get; set; }
    
        /// <summary>
        /// Gets or sets device management partners.
        /// The list of Device Management Partners configured by the tenant.
        /// </summary>
        [JsonPropertyName("deviceManagementPartners")]
        public IDeviceManagementDeviceManagementPartnersCollectionPage DeviceManagementPartners { get; set; }

        /// <summary>
        /// Gets or sets deviceManagementPartnersNextLink.
        /// </summary>
        [JsonPropertyName("deviceManagementPartners@odata.nextLink")]
        [JsonConverter(typeof(NextLinkConverter))]
        public string DeviceManagementPartnersNextLink { get; set; }
    
        /// <summary>
        /// Gets or sets exchange connectors.
        /// The list of Exchange Connectors configured by the tenant.
        /// </summary>
        [JsonPropertyName("exchangeConnectors")]
        public IDeviceManagementExchangeConnectorsCollectionPage ExchangeConnectors { get; set; }

        /// <summary>
        /// Gets or sets exchangeConnectorsNextLink.
        /// </summary>
        [JsonPropertyName("exchangeConnectors@odata.nextLink")]
        [JsonConverter(typeof(NextLinkConverter))]
        public string ExchangeConnectorsNextLink { get; set; }
    
        /// <summary>
        /// Gets or sets mobile threat defense connectors.
        /// The list of Mobile threat Defense connectors configured by the tenant.
        /// </summary>
        [JsonPropertyName("mobileThreatDefenseConnectors")]
        public IDeviceManagementMobileThreatDefenseConnectorsCollectionPage MobileThreatDefenseConnectors { get; set; }

        /// <summary>
        /// Gets or sets mobileThreatDefenseConnectorsNextLink.
        /// </summary>
        [JsonPropertyName("mobileThreatDefenseConnectors@odata.nextLink")]
        [JsonConverter(typeof(NextLinkConverter))]
        public string MobileThreatDefenseConnectorsNextLink { get; set; }
    
        /// <summary>
        /// Gets or sets apple push notification certificate.
        /// Apple push notification certificate.
        /// </summary>
        [JsonPropertyName("applePushNotificationCertificate")]
        public ApplePushNotificationCertificate ApplePushNotificationCertificate { get; set; }
    
        /// <summary>
        /// Gets or sets detected apps.
        /// The list of detected apps associated with a device.
        /// </summary>
        [JsonPropertyName("detectedApps")]
        public IDeviceManagementDetectedAppsCollectionPage DetectedApps { get; set; }

        /// <summary>
        /// Gets or sets detectedAppsNextLink.
        /// </summary>
        [JsonPropertyName("detectedApps@odata.nextLink")]
        [JsonConverter(typeof(NextLinkConverter))]
        public string DetectedAppsNextLink { get; set; }
    
        /// <summary>
        /// Gets or sets managed device overview.
        /// Device overview
        /// </summary>
        [JsonPropertyName("managedDeviceOverview")]
        public ManagedDeviceOverview ManagedDeviceOverview { get; set; }
    
        /// <summary>
        /// Gets or sets managed devices.
        /// The list of managed devices.
        /// </summary>
        [JsonPropertyName("managedDevices")]
        public IDeviceManagementManagedDevicesCollectionPage ManagedDevices { get; set; }

        /// <summary>
        /// Gets or sets managedDevicesNextLink.
        /// </summary>
        [JsonPropertyName("managedDevices@odata.nextLink")]
        [JsonConverter(typeof(NextLinkConverter))]
        public string ManagedDevicesNextLink { get; set; }
    
        /// <summary>
        /// Gets or sets imported windows autopilot device identities.
        /// Collection of imported Windows autopilot devices.
        /// </summary>
        [JsonPropertyName("importedWindowsAutopilotDeviceIdentities")]
        public IDeviceManagementImportedWindowsAutopilotDeviceIdentitiesCollectionPage ImportedWindowsAutopilotDeviceIdentities { get; set; }

        /// <summary>
        /// Gets or sets importedWindowsAutopilotDeviceIdentitiesNextLink.
        /// </summary>
        [JsonPropertyName("importedWindowsAutopilotDeviceIdentities@odata.nextLink")]
        [JsonConverter(typeof(NextLinkConverter))]
        public string ImportedWindowsAutopilotDeviceIdentitiesNextLink { get; set; }
    
        /// <summary>
        /// Gets or sets windows autopilot device identities.
        /// The Windows autopilot device identities contained collection.
        /// </summary>
        [JsonPropertyName("windowsAutopilotDeviceIdentities")]
        public IDeviceManagementWindowsAutopilotDeviceIdentitiesCollectionPage WindowsAutopilotDeviceIdentities { get; set; }

        /// <summary>
        /// Gets or sets windowsAutopilotDeviceIdentitiesNextLink.
        /// </summary>
        [JsonPropertyName("windowsAutopilotDeviceIdentities@odata.nextLink")]
        [JsonConverter(typeof(NextLinkConverter))]
        public string WindowsAutopilotDeviceIdentitiesNextLink { get; set; }
    
        /// <summary>
        /// Gets or sets notification message templates.
        /// The Notification Message Templates.
        /// </summary>
        [JsonPropertyName("notificationMessageTemplates")]
        public IDeviceManagementNotificationMessageTemplatesCollectionPage NotificationMessageTemplates { get; set; }

        /// <summary>
        /// Gets or sets notificationMessageTemplatesNextLink.
        /// </summary>
        [JsonPropertyName("notificationMessageTemplates@odata.nextLink")]
        [JsonConverter(typeof(NextLinkConverter))]
        public string NotificationMessageTemplatesNextLink { get; set; }
    
        /// <summary>
        /// Gets or sets resource operations.
        /// The Resource Operations.
        /// </summary>
        [JsonPropertyName("resourceOperations")]
        public IDeviceManagementResourceOperationsCollectionPage ResourceOperations { get; set; }

        /// <summary>
        /// Gets or sets resourceOperationsNextLink.
        /// </summary>
        [JsonPropertyName("resourceOperations@odata.nextLink")]
        [JsonConverter(typeof(NextLinkConverter))]
        public string ResourceOperationsNextLink { get; set; }
    
        /// <summary>
        /// Gets or sets role assignments.
        /// The Role Assignments.
        /// </summary>
        [JsonPropertyName("roleAssignments")]
        public IDeviceManagementRoleAssignmentsCollectionPage RoleAssignments { get; set; }

        /// <summary>
        /// Gets or sets roleAssignmentsNextLink.
        /// </summary>
        [JsonPropertyName("roleAssignments@odata.nextLink")]
        [JsonConverter(typeof(NextLinkConverter))]
        public string RoleAssignmentsNextLink { get; set; }
    
        /// <summary>
        /// Gets or sets role definitions.
        /// The Role Definitions.
        /// </summary>
        [JsonPropertyName("roleDefinitions")]
        public IDeviceManagementRoleDefinitionsCollectionPage RoleDefinitions { get; set; }

        /// <summary>
        /// Gets or sets roleDefinitionsNextLink.
        /// </summary>
        [JsonPropertyName("roleDefinitions@odata.nextLink")]
        [JsonConverter(typeof(NextLinkConverter))]
        public string RoleDefinitionsNextLink { get; set; }
    
        /// <summary>
        /// Gets or sets remote assistance partners.
        /// The remote assist partners.
        /// </summary>
        [JsonPropertyName("remoteAssistancePartners")]
        public IDeviceManagementRemoteAssistancePartnersCollectionPage RemoteAssistancePartners { get; set; }

        /// <summary>
        /// Gets or sets remoteAssistancePartnersNextLink.
        /// </summary>
        [JsonPropertyName("remoteAssistancePartners@odata.nextLink")]
        [JsonConverter(typeof(NextLinkConverter))]
        public string RemoteAssistancePartnersNextLink { get; set; }
    
        /// <summary>
        /// Gets or sets reports.
        /// Reports singleton
        /// </summary>
        [JsonPropertyName("reports")]
        public DeviceManagementReports Reports { get; set; }
    
        /// <summary>
        /// Gets or sets telecom expense management partners.
        /// The telecom expense management partners.
        /// </summary>
        [JsonPropertyName("telecomExpenseManagementPartners")]
        public IDeviceManagementTelecomExpenseManagementPartnersCollectionPage TelecomExpenseManagementPartners { get; set; }

        /// <summary>
        /// Gets or sets telecomExpenseManagementPartnersNextLink.
        /// </summary>
        [JsonPropertyName("telecomExpenseManagementPartners@odata.nextLink")]
        [JsonConverter(typeof(NextLinkConverter))]
        public string TelecomExpenseManagementPartnersNextLink { get; set; }
    
        /// <summary>
        /// Gets or sets troubleshooting events.
        /// The list of troubleshooting events for the tenant.
        /// </summary>
        [JsonPropertyName("troubleshootingEvents")]
        public IDeviceManagementTroubleshootingEventsCollectionPage TroubleshootingEvents { get; set; }

        /// <summary>
        /// Gets or sets troubleshootingEventsNextLink.
        /// </summary>
        [JsonPropertyName("troubleshootingEvents@odata.nextLink")]
        [JsonConverter(typeof(NextLinkConverter))]
        public string TroubleshootingEventsNextLink { get; set; }
    
        /// <summary>
        /// Gets or sets windows information protection app learning summaries.
        /// The windows information protection app learning summaries.
        /// </summary>
        [JsonPropertyName("windowsInformationProtectionAppLearningSummaries")]
        public IDeviceManagementWindowsInformationProtectionAppLearningSummariesCollectionPage WindowsInformationProtectionAppLearningSummaries { get; set; }

        /// <summary>
        /// Gets or sets windowsInformationProtectionAppLearningSummariesNextLink.
        /// </summary>
        [JsonPropertyName("windowsInformationProtectionAppLearningSummaries@odata.nextLink")]
        [JsonConverter(typeof(NextLinkConverter))]
        public string WindowsInformationProtectionAppLearningSummariesNextLink { get; set; }
    
        /// <summary>
        /// Gets or sets windows information protection network learning summaries.
        /// The windows information protection network learning summaries.
        /// </summary>
        [JsonPropertyName("windowsInformationProtectionNetworkLearningSummaries")]
        public IDeviceManagementWindowsInformationProtectionNetworkLearningSummariesCollectionPage WindowsInformationProtectionNetworkLearningSummaries { get; set; }

        /// <summary>
        /// Gets or sets windowsInformationProtectionNetworkLearningSummariesNextLink.
        /// </summary>
        [JsonPropertyName("windowsInformationProtectionNetworkLearningSummaries@odata.nextLink")]
        [JsonConverter(typeof(NextLinkConverter))]
        public string WindowsInformationProtectionNetworkLearningSummariesNextLink { get; set; }
    
    }
}

