// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type Device Management Exchange Connector.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<DeviceManagementExchangeConnector>))]
    public partial class DeviceManagementExchangeConnector : Entity
    {
    
        /// <summary>
        /// Gets or sets connector server name.
        /// The name of the server hosting the Exchange Connector.
        /// </summary>
        [JsonPropertyName("connectorServerName")]
        public string ConnectorServerName { get; set; }
    
        /// <summary>
        /// Gets or sets exchange alias.
        /// An alias assigned to the Exchange server
        /// </summary>
        [JsonPropertyName("exchangeAlias")]
        public string ExchangeAlias { get; set; }
    
        /// <summary>
        /// Gets or sets exchange connector type.
        /// The type of Exchange Connector Configured. Possible values are: onPremises, hosted, serviceToService, dedicated.
        /// </summary>
        [JsonPropertyName("exchangeConnectorType")]
        public DeviceManagementExchangeConnectorType? ExchangeConnectorType { get; set; }
    
        /// <summary>
        /// Gets or sets exchange organization.
        /// Exchange Organization to the Exchange server
        /// </summary>
        [JsonPropertyName("exchangeOrganization")]
        public string ExchangeOrganization { get; set; }
    
        /// <summary>
        /// Gets or sets last sync date time.
        /// Last sync time for the Exchange Connector
        /// </summary>
        [JsonPropertyName("lastSyncDateTime")]
        public DateTimeOffset? LastSyncDateTime { get; set; }
    
        /// <summary>
        /// Gets or sets primary smtp address.
        /// Email address used to configure the Service To Service Exchange Connector.
        /// </summary>
        [JsonPropertyName("primarySmtpAddress")]
        public string PrimarySmtpAddress { get; set; }
    
        /// <summary>
        /// Gets or sets server name.
        /// The name of the Exchange server.
        /// </summary>
        [JsonPropertyName("serverName")]
        public string ServerName { get; set; }
    
        /// <summary>
        /// Gets or sets status.
        /// Exchange Connector Status. Possible values are: none, connectionPending, connected, disconnected.
        /// </summary>
        [JsonPropertyName("status")]
        public DeviceManagementExchangeConnectorStatus? Status { get; set; }
    
        /// <summary>
        /// Gets or sets version.
        /// The version of the ExchangeConnectorAgent
        /// </summary>
        [JsonPropertyName("version")]
        public string Version { get; set; }
    
    }
}

