// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type Domain Dns Record.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<DomainDnsRecord>))]
    public partial class DomainDnsRecord : Entity
    {
    
        /// <summary>
        /// Gets or sets is optional.
        /// If false, this record must be configured by the customer at the DNS host for Microsoft Online Services to operate correctly with the domain.
        /// </summary>
        [JsonPropertyName("isOptional")]
        public bool? IsOptional { get; set; }
    
        /// <summary>
        /// Gets or sets label.
        /// Value used when configuring the name of the DNS record at the DNS host.
        /// </summary>
        [JsonPropertyName("label")]
        public string Label { get; set; }
    
        /// <summary>
        /// Gets or sets record type.
        /// Indicates what type of DNS record this entity represents.The value can be one of the following: CName, Mx, Srv, TxtKey
        /// </summary>
        [JsonPropertyName("recordType")]
        public string RecordType { get; set; }
    
        /// <summary>
        /// Gets or sets supported service.
        /// Microsoft Online Service or feature that has a dependency on this DNS record.Can be one of the following values: null, Email, Sharepoint, EmailInternalRelayOnly, OfficeCommunicationsOnline, SharePointDefaultDomain, FullRedelegation, SharePointPublic, OrgIdAuthentication, Yammer, Intune
        /// </summary>
        [JsonPropertyName("supportedService")]
        public string SupportedService { get; set; }
    
        /// <summary>
        /// Gets or sets ttl.
        /// Value to use when configuring the time-to-live (ttl) property of the DNS record at the DNS host. Not nullable
        /// </summary>
        [JsonPropertyName("ttl")]
        public Int32? Ttl { get; set; }
    
    }
}

