// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type Education Rubric.
    /// </summary>
    public partial class EducationRubric : Entity
    {
    
        /// <summary>
        /// Gets or sets created by.
        /// The user who created this resource.
        /// </summary>
        [JsonPropertyName("createdBy")]
        public IdentitySet CreatedBy { get; set; }
    
        /// <summary>
        /// Gets or sets created date time.
        /// The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z
        /// </summary>
        [JsonPropertyName("createdDateTime")]
        public DateTimeOffset? CreatedDateTime { get; set; }
    
        /// <summary>
        /// Gets or sets description.
        /// The description of this rubric.
        /// </summary>
        [JsonPropertyName("description")]
        public EducationItemBody Description { get; set; }
    
        /// <summary>
        /// Gets or sets display name.
        /// The name of this rubric.
        /// </summary>
        [JsonPropertyName("displayName")]
        public string DisplayName { get; set; }
    
        /// <summary>
        /// Gets or sets grading.
        /// The grading type of this rubric -- null for a no-points rubric, or educationAssignmentPointsGradeType for a points rubric.
        /// </summary>
        [JsonPropertyName("grading")]
        public EducationAssignmentGradeType Grading { get; set; }
    
        /// <summary>
        /// Gets or sets last modified by.
        /// The last user to modify the resource.
        /// </summary>
        [JsonPropertyName("lastModifiedBy")]
        public IdentitySet LastModifiedBy { get; set; }
    
        /// <summary>
        /// Gets or sets last modified date time.
        /// Moment in time when the resource was last modified.  The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z
        /// </summary>
        [JsonPropertyName("lastModifiedDateTime")]
        public DateTimeOffset? LastModifiedDateTime { get; set; }
    
        /// <summary>
        /// Gets or sets levels.
        /// The collection of levels making up this rubric.
        /// </summary>
        [JsonPropertyName("levels")]
        public IEnumerable<RubricLevel> Levels { get; set; }
    
        /// <summary>
        /// Gets or sets qualities.
        /// The collection of qualities making up this rubric.
        /// </summary>
        [JsonPropertyName("qualities")]
        public IEnumerable<RubricQuality> Qualities { get; set; }
    
    }
}

