// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type Education Rubric Outcome.
    /// </summary>
    public partial class EducationRubricOutcome : EducationOutcome
    {
    
        ///<summary>
        /// The EducationRubricOutcome constructor
        ///</summary>
        public EducationRubricOutcome()
        {
            this.ODataType = "microsoft.graph.educationRubricOutcome";
        }

        /// <summary>
        /// Gets or sets published rubric quality feedback.
        /// A copy of the rubricQualityFeedback property that is made when the grade is released to the student.
        /// </summary>
        [JsonPropertyName("publishedRubricQualityFeedback")]
        public IEnumerable<RubricQualityFeedbackModel> PublishedRubricQualityFeedback { get; set; }
    
        /// <summary>
        /// Gets or sets published rubric quality selected levels.
        /// A copy of the rubricQualitySelectedLevels property that is made when the grade is released to the student.
        /// </summary>
        [JsonPropertyName("publishedRubricQualitySelectedLevels")]
        public IEnumerable<RubricQualitySelectedColumnModel> PublishedRubricQualitySelectedLevels { get; set; }
    
        /// <summary>
        /// Gets or sets rubric quality feedback.
        /// A collection of specific feedback for each quality of this rubric.
        /// </summary>
        [JsonPropertyName("rubricQualityFeedback")]
        public IEnumerable<RubricQualityFeedbackModel> RubricQualityFeedback { get; set; }
    
        /// <summary>
        /// Gets or sets rubric quality selected levels.
        /// The level that the teacher has selected for each quality while grading this assignment.
        /// </summary>
        [JsonPropertyName("rubricQualitySelectedLevels")]
        public IEnumerable<RubricQualitySelectedColumnModel> RubricQualitySelectedLevels { get; set; }
    
    }
}

