// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: ComplexType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type EducationStudent.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<EducationStudent>))]
    public partial class EducationStudent
    {

        /// <summary>
        /// Gets or sets birthDate.
        /// Birth date of the student.
        /// </summary>
        [JsonPropertyName("birthDate")]
        public Date BirthDate { get; set; }
    
        /// <summary>
        /// Gets or sets externalId.
        /// ID of the student in the source system.
        /// </summary>
        [JsonPropertyName("externalId")]
        public string ExternalId { get; set; }
    
        /// <summary>
        /// Gets or sets gender.
        /// The possible values are: female, male, other, unknownFutureValue.
        /// </summary>
        [JsonPropertyName("gender")]
        public EducationGender? Gender { get; set; }
    
        /// <summary>
        /// Gets or sets grade.
        /// Current grade level of the student.
        /// </summary>
        [JsonPropertyName("grade")]
        public string Grade { get; set; }
    
        /// <summary>
        /// Gets or sets graduationYear.
        /// Year the student is graduating from the school.
        /// </summary>
        [JsonPropertyName("graduationYear")]
        public string GraduationYear { get; set; }
    
        /// <summary>
        /// Gets or sets studentNumber.
        /// Student Number.
        /// </summary>
        [JsonPropertyName("studentNumber")]
        public string StudentNumber { get; set; }
    
        /// <summary>
        /// Gets or sets additional data.
        /// </summary>
        [JsonExtensionData]
        public IDictionary<string, object> AdditionalData { get; set; }

        /// <summary>
        /// Gets or sets @odata.type.
        /// </summary>
        [JsonPropertyName("@odata.type")]
        public string ODataType { get; set; }
    
    }
}
