// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type Education Submission.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<EducationSubmission>))]
    public partial class EducationSubmission : Entity
    {
    
        /// <summary>
        /// Gets or sets reassigned by.
        /// User who moved the status of this submission to reassigned.
        /// </summary>
        [JsonPropertyName("reassignedBy")]
        public IdentitySet ReassignedBy { get; set; }
    
        /// <summary>
        /// Gets or sets reassigned date time.
        /// Moment in time when the submission was reassigned. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z
        /// </summary>
        [JsonPropertyName("reassignedDateTime")]
        public DateTimeOffset? ReassignedDateTime { get; set; }
    
        /// <summary>
        /// Gets or sets recipient.
        /// Who this submission is assigned to.
        /// </summary>
        [JsonPropertyName("recipient")]
        public EducationSubmissionRecipient Recipient { get; set; }
    
        /// <summary>
        /// Gets or sets resources folder url.
        /// Folder where all file resources for this submission need to be stored.
        /// </summary>
        [JsonPropertyName("resourcesFolderUrl")]
        public string ResourcesFolderUrl { get; set; }
    
        /// <summary>
        /// Gets or sets returned by.
        /// User who moved the status of this submission to returned.
        /// </summary>
        [JsonPropertyName("returnedBy")]
        public IdentitySet ReturnedBy { get; set; }
    
        /// <summary>
        /// Gets or sets returned date time.
        /// Moment in time when the submission was returned. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z
        /// </summary>
        [JsonPropertyName("returnedDateTime")]
        public DateTimeOffset? ReturnedDateTime { get; set; }
    
        /// <summary>
        /// Gets or sets status.
        /// Read-only. Possible values are: working, submitted, released, returned, and reassigned. Note that you must use the Prefer: include-unknown-enum-members request header to get the following value(s) in this evolvable enum: reassigned.
        /// </summary>
        [JsonPropertyName("status")]
        public EducationSubmissionStatus? Status { get; set; }
    
        /// <summary>
        /// Gets or sets submitted by.
        /// User who moved the resource into the submitted state.
        /// </summary>
        [JsonPropertyName("submittedBy")]
        public IdentitySet SubmittedBy { get; set; }
    
        /// <summary>
        /// Gets or sets submitted date time.
        /// Moment in time when the submission was moved into the submitted state. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z
        /// </summary>
        [JsonPropertyName("submittedDateTime")]
        public DateTimeOffset? SubmittedDateTime { get; set; }
    
        /// <summary>
        /// Gets or sets unsubmitted by.
        /// User who moved the resource from submitted into the working state.
        /// </summary>
        [JsonPropertyName("unsubmittedBy")]
        public IdentitySet UnsubmittedBy { get; set; }
    
        /// <summary>
        /// Gets or sets unsubmitted date time.
        /// Moment in time when the submission was moved from submitted into the working state. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z
        /// </summary>
        [JsonPropertyName("unsubmittedDateTime")]
        public DateTimeOffset? UnsubmittedDateTime { get; set; }
    
        /// <summary>
        /// Gets or sets outcomes.
        /// Read-Write. Nullable.
        /// </summary>
        [JsonPropertyName("outcomes")]
        public IEducationSubmissionOutcomesCollectionPage Outcomes { get; set; }

        /// <summary>
        /// Gets or sets outcomesNextLink.
        /// </summary>
        [JsonPropertyName("outcomes@odata.nextLink")]
        [JsonConverter(typeof(NextLinkConverter))]
        public string OutcomesNextLink { get; set; }
    
        /// <summary>
        /// Gets or sets resources.
        /// Nullable.
        /// </summary>
        [JsonPropertyName("resources")]
        public IEducationSubmissionResourcesCollectionPage Resources { get; set; }

        /// <summary>
        /// Gets or sets resourcesNextLink.
        /// </summary>
        [JsonPropertyName("resources@odata.nextLink")]
        [JsonConverter(typeof(NextLinkConverter))]
        public string ResourcesNextLink { get; set; }
    
        /// <summary>
        /// Gets or sets submitted resources.
        /// Read-only. Nullable.
        /// </summary>
        [JsonPropertyName("submittedResources")]
        public IEducationSubmissionSubmittedResourcesCollectionPage SubmittedResources { get; set; }

        /// <summary>
        /// Gets or sets submittedResourcesNextLink.
        /// </summary>
        [JsonPropertyName("submittedResources@odata.nextLink")]
        [JsonConverter(typeof(NextLinkConverter))]
        public string SubmittedResourcesNextLink { get; set; }
    
    }
}

