// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: ComplexType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type LocationConstraint.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<LocationConstraint>))]
    public partial class LocationConstraint
    {

        /// <summary>
        /// Gets or sets isRequired.
        /// The client requests the service to include in the response a meeting location for the meeting. If this is true and all the resources are busy, findMeetingTimes will not return any meeting time suggestions. If this is false and all the resources are busy, findMeetingTimes would still look for meeting times without locations.
        /// </summary>
        [JsonPropertyName("isRequired")]
        public bool? IsRequired { get; set; }
    
        /// <summary>
        /// Gets or sets locations.
        /// Constraint information for one or more locations that the client requests for the meeting.
        /// </summary>
        [JsonPropertyName("locations")]
        public IEnumerable<LocationConstraintItem> Locations { get; set; }
    
        /// <summary>
        /// Gets or sets suggestLocation.
        /// The client requests the service to suggest one or more meeting locations.
        /// </summary>
        [JsonPropertyName("suggestLocation")]
        public bool? SuggestLocation { get; set; }
    
        /// <summary>
        /// Gets or sets additional data.
        /// </summary>
        [JsonExtensionData]
        public IDictionary<string, object> AdditionalData { get; set; }

        /// <summary>
        /// Gets or sets @odata.type.
        /// </summary>
        [JsonPropertyName("@odata.type")]
        public string ODataType { get; set; }
    
    }
}
