// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type Meeting Attendance Report.
    /// </summary>
    public partial class MeetingAttendanceReport : Entity
    {
    
        /// <summary>
        /// Gets or sets meeting end date time.
        /// UTC time when the meeting ended. Read-only.
        /// </summary>
        [JsonPropertyName("meetingEndDateTime")]
        public DateTimeOffset? MeetingEndDateTime { get; set; }
    
        /// <summary>
        /// Gets or sets meeting start date time.
        /// UTC time when the meeting started. Read-only.
        /// </summary>
        [JsonPropertyName("meetingStartDateTime")]
        public DateTimeOffset? MeetingStartDateTime { get; set; }
    
        /// <summary>
        /// Gets or sets total participant count.
        /// Total number of participants. Read-only.
        /// </summary>
        [JsonPropertyName("totalParticipantCount")]
        public Int32? TotalParticipantCount { get; set; }
    
        /// <summary>
        /// Gets or sets attendance records.
        /// List of attendance records of an attendance report. Read-only.
        /// </summary>
        [JsonPropertyName("attendanceRecords")]
        public IMeetingAttendanceReportAttendanceRecordsCollectionPage AttendanceRecords { get; set; }

        /// <summary>
        /// Gets or sets attendanceRecordsNextLink.
        /// </summary>
        [JsonPropertyName("attendanceRecords@odata.nextLink")]
        [JsonConverter(typeof(NextLinkConverter))]
        public string AttendanceRecordsNextLink { get; set; }
    
    }
}

