// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type Mobile App.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<MobileApp>))]
    public partial class MobileApp : Entity
    {
    
        ///<summary>
        /// The internal MobileApp constructor
        ///</summary>
        protected internal MobileApp()
        {
            // Don't allow initialization of abstract entity types
        }
    
        /// <summary>
        /// Gets or sets created date time.
        /// The date and time the app was created.
        /// </summary>
        [JsonPropertyName("createdDateTime")]
        public DateTimeOffset? CreatedDateTime { get; set; }
    
        /// <summary>
        /// Gets or sets description.
        /// The description of the app.
        /// </summary>
        [JsonPropertyName("description")]
        public string Description { get; set; }
    
        /// <summary>
        /// Gets or sets developer.
        /// The developer of the app.
        /// </summary>
        [JsonPropertyName("developer")]
        public string Developer { get; set; }
    
        /// <summary>
        /// Gets or sets display name.
        /// The admin provided or imported title of the app.
        /// </summary>
        [JsonPropertyName("displayName")]
        public string DisplayName { get; set; }
    
        /// <summary>
        /// Gets or sets information url.
        /// The more information Url.
        /// </summary>
        [JsonPropertyName("informationUrl")]
        public string InformationUrl { get; set; }
    
        /// <summary>
        /// Gets or sets is featured.
        /// The value indicating whether the app is marked as featured by the admin.
        /// </summary>
        [JsonPropertyName("isFeatured")]
        public bool? IsFeatured { get; set; }
    
        /// <summary>
        /// Gets or sets large icon.
        /// The large icon, to be displayed in the app details and used for upload of the icon.
        /// </summary>
        [JsonPropertyName("largeIcon")]
        public MimeContent LargeIcon { get; set; }
    
        /// <summary>
        /// Gets or sets last modified date time.
        /// The date and time the app was last modified.
        /// </summary>
        [JsonPropertyName("lastModifiedDateTime")]
        public DateTimeOffset? LastModifiedDateTime { get; set; }
    
        /// <summary>
        /// Gets or sets notes.
        /// Notes for the app.
        /// </summary>
        [JsonPropertyName("notes")]
        public string Notes { get; set; }
    
        /// <summary>
        /// Gets or sets owner.
        /// The owner of the app.
        /// </summary>
        [JsonPropertyName("owner")]
        public string Owner { get; set; }
    
        /// <summary>
        /// Gets or sets privacy information url.
        /// The privacy statement Url.
        /// </summary>
        [JsonPropertyName("privacyInformationUrl")]
        public string PrivacyInformationUrl { get; set; }
    
        /// <summary>
        /// Gets or sets publisher.
        /// The publisher of the app.
        /// </summary>
        [JsonPropertyName("publisher")]
        public string Publisher { get; set; }
    
        /// <summary>
        /// Gets or sets publishing state.
        /// The publishing state for the app. The app cannot be assigned unless the app is published. Possible values are: notPublished, processing, published.
        /// </summary>
        [JsonPropertyName("publishingState")]
        public MobileAppPublishingState? PublishingState { get; set; }
    
        /// <summary>
        /// Gets or sets assignments.
        /// The list of group assignments for this mobile app.
        /// </summary>
        [JsonPropertyName("assignments")]
        public IMobileAppAssignmentsCollectionPage Assignments { get; set; }

        /// <summary>
        /// Gets or sets assignmentsNextLink.
        /// </summary>
        [JsonPropertyName("assignments@odata.nextLink")]
        [JsonConverter(typeof(NextLinkConverter))]
        public string AssignmentsNextLink { get; set; }
    
        /// <summary>
        /// Gets or sets categories.
        /// The list of categories for this app.
        /// </summary>
        [JsonPropertyName("categories")]
        public IMobileAppCategoriesCollectionWithReferencesPage Categories { get; set; }

        /// <summary>
        /// Gets or sets categoriesNextLink.
        /// </summary>
        [JsonPropertyName("categories@odata.nextLink")]
        [JsonConverter(typeof(NextLinkConverter))]
        public string CategoriesNextLink { get; set; }
    
    }
}

