// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type On Premises Conditional Access Settings.
    /// </summary>
    public partial class OnPremisesConditionalAccessSettings : Entity
    {
    
        /// <summary>
        /// Gets or sets enabled.
        /// Indicates if on premises conditional access is enabled for this organization
        /// </summary>
        [JsonPropertyName("enabled")]
        public bool? Enabled { get; set; }
    
        /// <summary>
        /// Gets or sets excluded groups.
        /// User groups that will be exempt by on premises conditional access. All users in these groups will be exempt from the conditional access policy.
        /// </summary>
        [JsonPropertyName("excludedGroups")]
        public IEnumerable<Guid> ExcludedGroups { get; set; }
    
        /// <summary>
        /// Gets or sets included groups.
        /// User groups that will be targeted by on premises conditional access. All users in these groups will be required to have mobile device managed and compliant for mail access.
        /// </summary>
        [JsonPropertyName("includedGroups")]
        public IEnumerable<Guid> IncludedGroups { get; set; }
    
        /// <summary>
        /// Gets or sets override default rule.
        /// Override the default access rule when allowing a device to ensure access is granted.
        /// </summary>
        [JsonPropertyName("overrideDefaultRule")]
        public bool? OverrideDefaultRule { get; set; }
    
    }
}

