// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type Organizational Branding Properties.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<OrganizationalBrandingProperties>))]
    public partial class OrganizationalBrandingProperties : Entity
    {
    
        ///<summary>
        /// The internal OrganizationalBrandingProperties constructor
        ///</summary>
        protected internal OrganizationalBrandingProperties()
        {
            // Don't allow initialization of abstract entity types
        }
    
        /// <summary>
        /// Gets or sets background color.
        /// Color that will appear in place of the background image in low-bandwidth connections. We recommend that you use the primary color of your banner logo or your organization color. Specify this in hexadecimal format, for example, white is #FFFFFF.
        /// </summary>
        [JsonPropertyName("backgroundColor")]
        public string BackgroundColor { get; set; }
    
        /// <summary>
        /// Gets or sets background image.
        /// Image that appears as the background of the sign-in page. The allowed types are PNG or JPEG not smaller than 300 KB and not larger than 1920 × 1080 pixels. A smaller image will reduce bandwidth requirements and make the page load faster.
        /// </summary>
        [JsonPropertyName("backgroundImage")]
        public Stream BackgroundImage { get; set; }
    
        /// <summary>
        /// Gets or sets background image relative url.
        /// A relative URL for the backgroundImage property that is combined with a CDN base URL from the cdnList to provide the version served by a CDN. Read-only.
        /// </summary>
        [JsonPropertyName("backgroundImageRelativeUrl")]
        public string BackgroundImageRelativeUrl { get; set; }
    
        /// <summary>
        /// Gets or sets banner logo.
        /// A banner version of your company logo that appears on the sign-in page. The allowed types are PNG or JPEG no larger than 36 × 245 pixels. We recommend using a transparent image with no padding around the logo.
        /// </summary>
        [JsonPropertyName("bannerLogo")]
        public Stream BannerLogo { get; set; }
    
        /// <summary>
        /// Gets or sets banner logo relative url.
        /// A relative url for the bannerLogo property that is combined with a CDN base URL from the cdnList to provide the read-only version served by a CDN. Read-only.
        /// </summary>
        [JsonPropertyName("bannerLogoRelativeUrl")]
        public string BannerLogoRelativeUrl { get; set; }
    
        /// <summary>
        /// Gets or sets cdn list.
        /// A list of base URLs for all available CDN providers that are serving the assets of the current resource. Several CDN providers are used at the same time for high availability of read requests. Read-only.
        /// </summary>
        [JsonPropertyName("cdnList")]
        public IEnumerable<string> CdnList { get; set; }
    
        /// <summary>
        /// Gets or sets sign in page text.
        /// Text that appears at the bottom of the sign-in box. You can use this to communicate additional information, such as the phone number to your help desk or a legal statement. This text must be Unicode and not exceed 1024 characters.
        /// </summary>
        [JsonPropertyName("signInPageText")]
        public string SignInPageText { get; set; }
    
        /// <summary>
        /// Gets or sets square logo.
        /// A square version of your company logo that appears in Windows 10 out-of-box experiences (OOBE) and when Windows Autopilot is enabled for deployment. Allowed types are PNG or JPEG no larger than 240 x 240 pixels and no more than 10 KB in size. We recommend using a transparent image with no padding around the logo.
        /// </summary>
        [JsonPropertyName("squareLogo")]
        public Stream SquareLogo { get; set; }
    
        /// <summary>
        /// Gets or sets square logo relative url.
        /// A relative url for the squareLogo property that is combined with a CDN base URL from the cdnList to provide the version served by a CDN. Read-only.
        /// </summary>
        [JsonPropertyName("squareLogoRelativeUrl")]
        public string SquareLogoRelativeUrl { get; set; }
    
        /// <summary>
        /// Gets or sets username hint text.
        /// String that shows as the hint in the username textbox on the sign-in screen. This text must be a Unicode, without links or code, and can't exceed 64 characters.
        /// </summary>
        [JsonPropertyName("usernameHintText")]
        public string UsernameHintText { get; set; }
    
    }
}

