// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: ComplexType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type PlannerChecklistItem.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<PlannerChecklistItem>))]
    public partial class PlannerChecklistItem
    {

        /// <summary>
        /// Gets or sets isChecked.
        /// Value is true if the item is checked and false otherwise.
        /// </summary>
        [JsonPropertyName("isChecked")]
        public bool? IsChecked { get; set; }
    
        /// <summary>
        /// Gets or sets lastModifiedBy.
        /// Read-only. User ID by which this is last modified.
        /// </summary>
        [JsonPropertyName("lastModifiedBy")]
        public IdentitySet LastModifiedBy { get; set; }
    
        /// <summary>
        /// Gets or sets lastModifiedDateTime.
        /// Read-only. Date and time at which this is last modified. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z
        /// </summary>
        [JsonPropertyName("lastModifiedDateTime")]
        public DateTimeOffset? LastModifiedDateTime { get; set; }
    
        /// <summary>
        /// Gets or sets orderHint.
        /// Used to set the relative order of items in the checklist. The format is defined as outlined here.
        /// </summary>
        [JsonPropertyName("orderHint")]
        public string OrderHint { get; set; }
    
        /// <summary>
        /// Gets or sets title.
        /// Title of the checklist item
        /// </summary>
        [JsonPropertyName("title")]
        public string Title { get; set; }
    
        /// <summary>
        /// Gets or sets additional data.
        /// </summary>
        [JsonExtensionData]
        public IDictionary<string, object> AdditionalData { get; set; }

        /// <summary>
        /// Gets or sets @odata.type.
        /// </summary>
        [JsonPropertyName("@odata.type")]
        public string ODataType { get; set; }
    
    }
}
