// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: ComplexType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type PlannerExternalReference.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<PlannerExternalReference>))]
    public partial class PlannerExternalReference
    {

        /// <summary>
        /// Gets or sets alias.
        /// A name alias to describe the reference.
        /// </summary>
        [JsonPropertyName("alias")]
        public string Alias { get; set; }
    
        /// <summary>
        /// Gets or sets lastModifiedBy.
        /// Read-only. User ID by which this is last modified.
        /// </summary>
        [JsonPropertyName("lastModifiedBy")]
        public IdentitySet LastModifiedBy { get; set; }
    
        /// <summary>
        /// Gets or sets lastModifiedDateTime.
        /// Read-only. Date and time at which this is last modified. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z
        /// </summary>
        [JsonPropertyName("lastModifiedDateTime")]
        public DateTimeOffset? LastModifiedDateTime { get; set; }
    
        /// <summary>
        /// Gets or sets previewPriority.
        /// Used to set the relative priority order in which the reference will be shown as a preview on the task.
        /// </summary>
        [JsonPropertyName("previewPriority")]
        public string PreviewPriority { get; set; }
    
        /// <summary>
        /// Gets or sets type.
        /// Used to describe the type of the reference. Types include: PowerPoint, Word, Excel, Other.
        /// </summary>
        [JsonPropertyName("type")]
        public string Type { get; set; }
    
        /// <summary>
        /// Gets or sets additional data.
        /// </summary>
        [JsonExtensionData]
        public IDictionary<string, object> AdditionalData { get; set; }

        /// <summary>
        /// Gets or sets @odata.type.
        /// </summary>
        [JsonPropertyName("@odata.type")]
        public string ODataType { get; set; }
    
    }
}
