// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: ComplexType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type PrinterLocation.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<PrinterLocation>))]
    public partial class PrinterLocation
    {

        /// <summary>
        /// Gets or sets altitudeInMeters.
        /// The altitude, in meters, that the printer is located at.
        /// </summary>
        [JsonPropertyName("altitudeInMeters")]
        public Int32? AltitudeInMeters { get; set; }
    
        /// <summary>
        /// Gets or sets building.
        /// The building that the printer is located in.
        /// </summary>
        [JsonPropertyName("building")]
        public string Building { get; set; }
    
        /// <summary>
        /// Gets or sets city.
        /// The city that the printer is located in.
        /// </summary>
        [JsonPropertyName("city")]
        public string City { get; set; }
    
        /// <summary>
        /// Gets or sets countryOrRegion.
        /// The country or region that the printer is located in.
        /// </summary>
        [JsonPropertyName("countryOrRegion")]
        public string CountryOrRegion { get; set; }
    
        /// <summary>
        /// Gets or sets floor.
        /// The floor that the printer is located on. Only numerical values are supported right now.
        /// </summary>
        [JsonPropertyName("floor")]
        public string Floor { get; set; }
    
        /// <summary>
        /// Gets or sets floorDescription.
        /// The description of the floor that the printer is located on.
        /// </summary>
        [JsonPropertyName("floorDescription")]
        public string FloorDescription { get; set; }
    
        /// <summary>
        /// Gets or sets latitude.
        /// The latitude that the printer is located at.
        /// </summary>
        [JsonPropertyName("latitude")]
        public double? Latitude { get; set; }
    
        /// <summary>
        /// Gets or sets longitude.
        /// The longitude that the printer is located at.
        /// </summary>
        [JsonPropertyName("longitude")]
        public double? Longitude { get; set; }
    
        /// <summary>
        /// Gets or sets organization.
        /// The organizational hierarchy that the printer belongs to. The elements should be in hierarchical order.
        /// </summary>
        [JsonPropertyName("organization")]
        public IEnumerable<string> Organization { get; set; }
    
        /// <summary>
        /// Gets or sets postalCode.
        /// The postal code that the printer is located in.
        /// </summary>
        [JsonPropertyName("postalCode")]
        public string PostalCode { get; set; }
    
        /// <summary>
        /// Gets or sets roomDescription.
        /// The description of the room that the printer is located in.
        /// </summary>
        [JsonPropertyName("roomDescription")]
        public string RoomDescription { get; set; }
    
        /// <summary>
        /// Gets or sets roomName.
        /// The room that the printer is located in. Only numerical values are supported right now.
        /// </summary>
        [JsonPropertyName("roomName")]
        public string RoomName { get; set; }
    
        /// <summary>
        /// Gets or sets site.
        /// The site that the printer is located in.
        /// </summary>
        [JsonPropertyName("site")]
        public string Site { get; set; }
    
        /// <summary>
        /// Gets or sets stateOrProvince.
        /// The state or province that the printer is located in.
        /// </summary>
        [JsonPropertyName("stateOrProvince")]
        public string StateOrProvince { get; set; }
    
        /// <summary>
        /// Gets or sets streetAddress.
        /// The street address where the printer is located.
        /// </summary>
        [JsonPropertyName("streetAddress")]
        public string StreetAddress { get; set; }
    
        /// <summary>
        /// Gets or sets subdivision.
        /// The subdivision that the printer is located in. The elements should be in hierarchical order.
        /// </summary>
        [JsonPropertyName("subdivision")]
        public IEnumerable<string> Subdivision { get; set; }
    
        /// <summary>
        /// Gets or sets subunit.
        /// </summary>
        [JsonPropertyName("subunit")]
        public IEnumerable<string> Subunit { get; set; }
    
        /// <summary>
        /// Gets or sets additional data.
        /// </summary>
        [JsonExtensionData]
        public IDictionary<string, object> AdditionalData { get; set; }

        /// <summary>
        /// Gets or sets @odata.type.
        /// </summary>
        [JsonPropertyName("@odata.type")]
        public string ODataType { get; set; }
    
    }
}
