// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type Printer Share.
    /// </summary>
    public partial class PrinterShare : PrinterBase
    {
    
        ///<summary>
        /// The PrinterShare constructor
        ///</summary>
        public PrinterShare()
        {
            this.ODataType = "microsoft.graph.printerShare";
        }

        /// <summary>
        /// Gets or sets allow all users.
        /// If true, all users and groups will be granted access to this printer share. This supersedes the allow lists defined by the allowedUsers and allowedGroups navigation properties.
        /// </summary>
        [JsonPropertyName("allowAllUsers")]
        public bool? AllowAllUsers { get; set; }
    
        /// <summary>
        /// Gets or sets created date time.
        /// The DateTimeOffset when the printer share was created. Read-only.
        /// </summary>
        [JsonPropertyName("createdDateTime")]
        public DateTimeOffset? CreatedDateTime { get; set; }
    
        /// <summary>
        /// Gets or sets allowed groups.
        /// The groups whose users have access to print using the printer.
        /// </summary>
        [JsonPropertyName("allowedGroups")]
        public IPrinterShareAllowedGroupsCollectionWithReferencesPage AllowedGroups { get; set; }

        /// <summary>
        /// Gets or sets allowedGroupsNextLink.
        /// </summary>
        [JsonPropertyName("allowedGroups@odata.nextLink")]
        [JsonConverter(typeof(NextLinkConverter))]
        public string AllowedGroupsNextLink { get; set; }
    
        /// <summary>
        /// Gets or sets allowed users.
        /// The users who have access to print using the printer.
        /// </summary>
        [JsonPropertyName("allowedUsers")]
        public IPrinterShareAllowedUsersCollectionWithReferencesPage AllowedUsers { get; set; }

        /// <summary>
        /// Gets or sets allowedUsersNextLink.
        /// </summary>
        [JsonPropertyName("allowedUsers@odata.nextLink")]
        [JsonConverter(typeof(NextLinkConverter))]
        public string AllowedUsersNextLink { get; set; }
    
        /// <summary>
        /// Gets or sets printer.
        /// The printer that this printer share is related to.
        /// </summary>
        [JsonPropertyName("printer")]
        public Printer Printer { get; set; }
    
    }
}

