// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: ComplexType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type Process.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<Process>))]
    public partial class Process
    {

        /// <summary>
        /// Gets or sets accountName.
        /// User account identifier (user account context the process ran under) for example, AccountName, SID, and so on.
        /// </summary>
        [JsonPropertyName("accountName")]
        public string AccountName { get; set; }
    
        /// <summary>
        /// Gets or sets commandLine.
        /// The full process invocation commandline including all parameters.
        /// </summary>
        [JsonPropertyName("commandLine")]
        public string CommandLine { get; set; }
    
        /// <summary>
        /// Gets or sets createdDateTime.
        /// Time at which the process was started. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z.
        /// </summary>
        [JsonPropertyName("createdDateTime")]
        public DateTimeOffset? CreatedDateTime { get; set; }
    
        /// <summary>
        /// Gets or sets fileHash.
        /// Complex type containing file hashes (cryptographic and location-sensitive).
        /// </summary>
        [JsonPropertyName("fileHash")]
        public FileHash FileHash { get; set; }
    
        /// <summary>
        /// Gets or sets integrityLevel.
        /// The integrity level of the process. Possible values are: unknown, untrusted, low, medium, high, system.
        /// </summary>
        [JsonPropertyName("integrityLevel")]
        public ProcessIntegrityLevel? IntegrityLevel { get; set; }
    
        /// <summary>
        /// Gets or sets isElevated.
        /// True if the process is elevated.
        /// </summary>
        [JsonPropertyName("isElevated")]
        public bool? IsElevated { get; set; }
    
        /// <summary>
        /// Gets or sets name.
        /// The name of the process' Image file.
        /// </summary>
        [JsonPropertyName("name")]
        public string Name { get; set; }
    
        /// <summary>
        /// Gets or sets parentProcessCreatedDateTime.
        /// DateTime at which the parent process was started. The Timestamp type represents date and time information using ISO 8601 format and is always in UTC time. For example, midnight UTC on Jan 1, 2014 is 2014-01-01T00:00:00Z.
        /// </summary>
        [JsonPropertyName("parentProcessCreatedDateTime")]
        public DateTimeOffset? ParentProcessCreatedDateTime { get; set; }
    
        /// <summary>
        /// Gets or sets parentProcessId.
        /// The Process ID (PID) of the parent process.
        /// </summary>
        [JsonPropertyName("parentProcessId")]
        public Int32? ParentProcessId { get; set; }
    
        /// <summary>
        /// Gets or sets parentProcessName.
        /// The name of the image file of the parent process.
        /// </summary>
        [JsonPropertyName("parentProcessName")]
        public string ParentProcessName { get; set; }
    
        /// <summary>
        /// Gets or sets path.
        /// Full path, including filename.
        /// </summary>
        [JsonPropertyName("path")]
        public string Path { get; set; }
    
        /// <summary>
        /// Gets or sets processId.
        /// The Process ID (PID) of the process.
        /// </summary>
        [JsonPropertyName("processId")]
        public Int32? ProcessId { get; set; }
    
        /// <summary>
        /// Gets or sets additional data.
        /// </summary>
        [JsonExtensionData]
        public IDictionary<string, object> AdditionalData { get; set; }

        /// <summary>
        /// Gets or sets @odata.type.
        /// </summary>
        [JsonPropertyName("@odata.type")]
        public string ODataType { get; set; }
    
    }
}
