// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type Remote Assistance Partner.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<RemoteAssistancePartner>))]
    public partial class RemoteAssistancePartner : Entity
    {
    
        /// <summary>
        /// Gets or sets display name.
        /// Display name of the partner.
        /// </summary>
        [JsonPropertyName("displayName")]
        public string DisplayName { get; set; }
    
        /// <summary>
        /// Gets or sets last connection date time.
        /// Timestamp of the last request sent to Intune by the TEM partner.
        /// </summary>
        [JsonPropertyName("lastConnectionDateTime")]
        public DateTimeOffset? LastConnectionDateTime { get; set; }
    
        /// <summary>
        /// Gets or sets onboarding status.
        /// A friendly description of the current TeamViewer connector status. Possible values are: notOnboarded, onboarding, onboarded.
        /// </summary>
        [JsonPropertyName("onboardingStatus")]
        public RemoteAssistanceOnboardingStatus? OnboardingStatus { get; set; }
    
        /// <summary>
        /// Gets or sets onboarding url.
        /// URL of the partner's onboarding portal, where an administrator can configure their Remote Assistance service.
        /// </summary>
        [JsonPropertyName("onboardingUrl")]
        public string OnboardingUrl { get; set; }
    
    }
}

