// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: ComplexType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type RequiredResourceAccess.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<RequiredResourceAccess>))]
    public partial class RequiredResourceAccess
    {

        /// <summary>
        /// Gets or sets resourceAccess.
        /// The list of OAuth2.0 permission scopes and app roles that the application requires from the specified resource.
        /// </summary>
        [JsonPropertyName("resourceAccess")]
        public IEnumerable<ResourceAccess> ResourceAccess { get; set; }
    
        /// <summary>
        /// Gets or sets resourceAppId.
        /// The unique identifier for the resource that the application requires access to. This should be equal to the appId declared on the target resource application.
        /// </summary>
        [JsonPropertyName("resourceAppId")]
        public string ResourceAppId { get; set; }
    
        /// <summary>
        /// Gets or sets additional data.
        /// </summary>
        [JsonExtensionData]
        public IDictionary<string, object> AdditionalData { get; set; }

        /// <summary>
        /// Gets or sets @odata.type.
        /// </summary>
        [JsonPropertyName("@odata.type")]
        public string ODataType { get; set; }
    
    }
}
