// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: ComplexType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type RubricQuality.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<RubricQuality>))]
    public partial class RubricQuality
    {

        /// <summary>
        /// Gets or sets criteria.
        /// The collection of criteria for this rubric quality.
        /// </summary>
        [JsonPropertyName("criteria")]
        public IEnumerable<RubricCriterion> Criteria { get; set; }
    
        /// <summary>
        /// Gets or sets description.
        /// The description of this rubric quality.
        /// </summary>
        [JsonPropertyName("description")]
        public EducationItemBody Description { get; set; }
    
        /// <summary>
        /// Gets or sets displayName.
        /// The name of this rubric quality.
        /// </summary>
        [JsonPropertyName("displayName")]
        public string DisplayName { get; set; }
    
        /// <summary>
        /// Gets or sets qualityId.
        /// The ID of this resource.
        /// </summary>
        [JsonPropertyName("qualityId")]
        public string QualityId { get; set; }
    
        /// <summary>
        /// Gets or sets weight.
        /// If present, a numerical weight for this quality.  Weights must add up to 100.
        /// </summary>
        [JsonPropertyName("weight")]
        public Single? Weight { get; set; }
    
        /// <summary>
        /// Gets or sets additional data.
        /// </summary>
        [JsonExtensionData]
        public IDictionary<string, object> AdditionalData { get; set; }

        /// <summary>
        /// Gets or sets @odata.type.
        /// </summary>
        [JsonPropertyName("@odata.type")]
        public string ODataType { get; set; }
    
    }
}
