// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: ComplexType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type ScoredEmailAddress.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<ScoredEmailAddress>))]
    public partial class ScoredEmailAddress
    {

        /// <summary>
        /// Gets or sets address.
        /// The email address.
        /// </summary>
        [JsonPropertyName("address")]
        public string Address { get; set; }
    
        /// <summary>
        /// Gets or sets itemId.
        /// </summary>
        [JsonPropertyName("itemId")]
        public string ItemId { get; set; }
    
        /// <summary>
        /// Gets or sets relevanceScore.
        /// The relevance score of the email address. A relevance score is used as a sort key, in relation to the other returned results. A higher relevance score value corresponds to a more relevant result. Relevance is determined by the user’s communication and collaboration patterns and business relationships.
        /// </summary>
        [JsonPropertyName("relevanceScore")]
        public double? RelevanceScore { get; set; }
    
        /// <summary>
        /// Gets or sets selectionLikelihood.
        /// </summary>
        [JsonPropertyName("selectionLikelihood")]
        public SelectionLikelihoodInfo? SelectionLikelihood { get; set; }
    
        /// <summary>
        /// Gets or sets additional data.
        /// </summary>
        [JsonExtensionData]
        public IDictionary<string, object> AdditionalData { get; set; }

        /// <summary>
        /// Gets or sets @odata.type.
        /// </summary>
        [JsonPropertyName("@odata.type")]
        public string ODataType { get; set; }
    
    }
}
