// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: ComplexType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type SearchBucket.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<SearchBucket>))]
    public partial class SearchBucket
    {

        /// <summary>
        /// Gets or sets aggregationFilterToken.
        /// A token containing the encoded filter to aggregate search matches by the specific key value. To use the filter, pass the token as part of the aggregationFilter property in a searchRequest object, in the format '{field}:/'{aggregationFilterToken}/''. See an example.
        /// </summary>
        [JsonPropertyName("aggregationFilterToken")]
        public string AggregationFilterToken { get; set; }
    
        /// <summary>
        /// Gets or sets count.
        /// The approximate number of search matches that share the same value specified in the key property. Note that this number is not the exact number of matches.
        /// </summary>
        [JsonPropertyName("count")]
        public Int32? Count { get; set; }
    
        /// <summary>
        /// Gets or sets key.
        /// The discrete value of the field that an aggregation was computed on.
        /// </summary>
        [JsonPropertyName("key")]
        public string Key { get; set; }
    
        /// <summary>
        /// Gets or sets additional data.
        /// </summary>
        [JsonExtensionData]
        public IDictionary<string, object> AdditionalData { get; set; }

        /// <summary>
        /// Gets or sets @odata.type.
        /// </summary>
        [JsonPropertyName("@odata.type")]
        public string ODataType { get; set; }
    
    }
}
