// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: ComplexType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type SearchHitsContainer.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<SearchHitsContainer>))]
    public partial class SearchHitsContainer
    {

        /// <summary>
        /// Gets or sets aggregations.
        /// Contains the collection of aggregations computed based on the provided aggregationOption specified in the request.
        /// </summary>
        [JsonPropertyName("aggregations")]
        public IEnumerable<SearchAggregation> Aggregations { get; set; }
    
        /// <summary>
        /// Gets or sets hits.
        /// A collection of the search results.
        /// </summary>
        [JsonPropertyName("hits")]
        public IEnumerable<SearchHit> Hits { get; set; }
    
        /// <summary>
        /// Gets or sets moreResultsAvailable.
        /// Provides information if more results are available. Based on this information, you can adjust the from and size properties of the searchRequest accordingly.
        /// </summary>
        [JsonPropertyName("moreResultsAvailable")]
        public bool? MoreResultsAvailable { get; set; }
    
        /// <summary>
        /// Gets or sets total.
        /// The total number of results. Note this is not the number of results on the page, but the total number of results satisfying the query.
        /// </summary>
        [JsonPropertyName("total")]
        public Int32? Total { get; set; }
    
        /// <summary>
        /// Gets or sets additional data.
        /// </summary>
        [JsonExtensionData]
        public IDictionary<string, object> AdditionalData { get; set; }

        /// <summary>
        /// Gets or sets @odata.type.
        /// </summary>
        [JsonPropertyName("@odata.type")]
        public string ODataType { get; set; }
    
    }
}
