// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type Section Group.
    /// </summary>
    public partial class SectionGroup : OnenoteEntityHierarchyModel
    {
    
        ///<summary>
        /// The SectionGroup constructor
        ///</summary>
        public SectionGroup()
        {
            this.ODataType = "microsoft.graph.sectionGroup";
        }

        /// <summary>
        /// Gets or sets section groups url.
        /// The URL for the sectionGroups navigation property, which returns all the section groups in the section group. Read-only.
        /// </summary>
        [JsonPropertyName("sectionGroupsUrl")]
        public string SectionGroupsUrl { get; set; }
    
        /// <summary>
        /// Gets or sets sections url.
        /// The URL for the sections navigation property, which returns all the sections in the section group. Read-only.
        /// </summary>
        [JsonPropertyName("sectionsUrl")]
        public string SectionsUrl { get; set; }
    
        /// <summary>
        /// Gets or sets parent notebook.
        /// The notebook that contains the section group. Read-only.
        /// </summary>
        [JsonPropertyName("parentNotebook")]
        public Notebook ParentNotebook { get; set; }
    
        /// <summary>
        /// Gets or sets parent section group.
        /// The section group that contains the section group. Read-only.
        /// </summary>
        [JsonPropertyName("parentSectionGroup")]
        public SectionGroup ParentSectionGroup { get; set; }
    
        /// <summary>
        /// Gets or sets section groups.
        /// The section groups in the section. Read-only. Nullable.
        /// </summary>
        [JsonPropertyName("sectionGroups")]
        public ISectionGroupSectionGroupsCollectionPage SectionGroups { get; set; }

        /// <summary>
        /// Gets or sets sectionGroupsNextLink.
        /// </summary>
        [JsonPropertyName("sectionGroups@odata.nextLink")]
        [JsonConverter(typeof(NextLinkConverter))]
        public string SectionGroupsNextLink { get; set; }
    
        /// <summary>
        /// Gets or sets sections.
        /// The sections in the section group. Read-only. Nullable.
        /// </summary>
        [JsonPropertyName("sections")]
        public ISectionGroupSectionsCollectionPage Sections { get; set; }

        /// <summary>
        /// Gets or sets sectionsNextLink.
        /// </summary>
        [JsonPropertyName("sections@odata.nextLink")]
        [JsonConverter(typeof(NextLinkConverter))]
        public string SectionsNextLink { get; set; }
    
    }
}

