// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type Shared Drive Item.
    /// </summary>
    public partial class SharedDriveItem : BaseItem
    {
    
        ///<summary>
        /// The SharedDriveItem constructor
        ///</summary>
        public SharedDriveItem()
        {
            this.ODataType = "microsoft.graph.sharedDriveItem";
        }

        /// <summary>
        /// Gets or sets owner.
        /// Information about the owner of the shared item being referenced.
        /// </summary>
        [JsonPropertyName("owner")]
        public IdentitySet Owner { get; set; }
    
        /// <summary>
        /// Gets or sets drive item.
        /// Used to access the underlying driveItem
        /// </summary>
        [JsonPropertyName("driveItem")]
        public DriveItem DriveItem { get; set; }
    
        /// <summary>
        /// Gets or sets items.
        /// All driveItems contained in the sharing root. This collection cannot be enumerated.
        /// </summary>
        [JsonPropertyName("items")]
        public ISharedDriveItemItemsCollectionPage Items { get; set; }

        /// <summary>
        /// Gets or sets itemsNextLink.
        /// </summary>
        [JsonPropertyName("items@odata.nextLink")]
        [JsonConverter(typeof(NextLinkConverter))]
        public string ItemsNextLink { get; set; }
    
        /// <summary>
        /// Gets or sets list.
        /// Used to access the underlying list
        /// </summary>
        [JsonPropertyName("list")]
        public List List { get; set; }
    
        /// <summary>
        /// Gets or sets list item.
        /// Used to access the underlying listItem
        /// </summary>
        [JsonPropertyName("listItem")]
        public ListItem ListItem { get; set; }
    
        /// <summary>
        /// Gets or sets permission.
        /// Used to access the permission representing the underlying sharing link
        /// </summary>
        [JsonPropertyName("permission")]
        public Permission Permission { get; set; }
    
        /// <summary>
        /// Gets or sets root.
        /// Used to access the underlying driveItem. Deprecated -- use driveItem instead.
        /// </summary>
        [JsonPropertyName("root")]
        public DriveItem Root { get; set; }
    
        /// <summary>
        /// Gets or sets site.
        /// Used to access the underlying site
        /// </summary>
        [JsonPropertyName("site")]
        public Site Site { get; set; }
    
    }
}

