// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: ComplexType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type SharingInvitation.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<SharingInvitation>))]
    public partial class SharingInvitation
    {

        /// <summary>
        /// Gets or sets email.
        /// The email address provided for the recipient of the sharing invitation. Read-only.
        /// </summary>
        [JsonPropertyName("email")]
        public string Email { get; set; }
    
        /// <summary>
        /// Gets or sets invitedBy.
        /// Provides information about who sent the invitation that created this permission, if that information is available. Read-only.
        /// </summary>
        [JsonPropertyName("invitedBy")]
        public IdentitySet InvitedBy { get; set; }
    
        /// <summary>
        /// Gets or sets redeemedBy.
        /// </summary>
        [JsonPropertyName("redeemedBy")]
        public string RedeemedBy { get; set; }
    
        /// <summary>
        /// Gets or sets signInRequired.
        /// If true the recipient of the invitation needs to sign in in order to access the shared item. Read-only.
        /// </summary>
        [JsonPropertyName("signInRequired")]
        public bool? SignInRequired { get; set; }
    
        /// <summary>
        /// Gets or sets additional data.
        /// </summary>
        [JsonExtensionData]
        public IDictionary<string, object> AdditionalData { get; set; }

        /// <summary>
        /// Gets or sets @odata.type.
        /// </summary>
        [JsonPropertyName("@odata.type")]
        public string ODataType { get; set; }
    
    }
}
