// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: ComplexType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type SharingLink.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<SharingLink>))]
    public partial class SharingLink
    {

        /// <summary>
        /// Gets or sets application.
        /// The app the link is associated with.
        /// </summary>
        [JsonPropertyName("application")]
        public Identity Application { get; set; }
    
        /// <summary>
        /// Gets or sets preventsDownload.
        /// If true then the user can only use this link to view the item on the web, and cannot use it to download the contents of the item. Only for OneDrive for Business and SharePoint.
        /// </summary>
        [JsonPropertyName("preventsDownload")]
        public bool? PreventsDownload { get; set; }
    
        /// <summary>
        /// Gets or sets scope.
        /// The scope of the link represented by this permission. Value anonymous indicates the link is usable by anyone, organization indicates the link is only usable for users signed into the same tenant.
        /// </summary>
        [JsonPropertyName("scope")]
        public string Scope { get; set; }
    
        /// <summary>
        /// Gets or sets type.
        /// The type of the link created.
        /// </summary>
        [JsonPropertyName("type")]
        public string Type { get; set; }
    
        /// <summary>
        /// Gets or sets webHtml.
        /// For embed links, this property contains the HTML code for an &amp;lt;iframe&amp;gt; element that will embed the item in a webpage.
        /// </summary>
        [JsonPropertyName("webHtml")]
        public string WebHtml { get; set; }
    
        /// <summary>
        /// Gets or sets webUrl.
        /// A URL that opens the item in the browser on the OneDrive website.
        /// </summary>
        [JsonPropertyName("webUrl")]
        public string WebUrl { get; set; }
    
        /// <summary>
        /// Gets or sets additional data.
        /// </summary>
        [JsonExtensionData]
        public IDictionary<string, object> AdditionalData { get; set; }

        /// <summary>
        /// Gets or sets @odata.type.
        /// </summary>
        [JsonPropertyName("@odata.type")]
        public string ODataType { get; set; }
    
    }
}
