// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: ComplexType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type SignInLocation.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<SignInLocation>))]
    public partial class SignInLocation
    {

        /// <summary>
        /// Gets or sets city.
        /// Provides the city where the sign-in originated. This is calculated using latitude/longitude information from the sign-in activity.
        /// </summary>
        [JsonPropertyName("city")]
        public string City { get; set; }
    
        /// <summary>
        /// Gets or sets countryOrRegion.
        /// Provides the country code info (2 letter code) where the sign-in originated.  This is calculated using latitude/longitude information from the sign-in activity.
        /// </summary>
        [JsonPropertyName("countryOrRegion")]
        public string CountryOrRegion { get; set; }
    
        /// <summary>
        /// Gets or sets geoCoordinates.
        /// Provides the latitude, longitude and altitude where the sign-in originated.
        /// </summary>
        [JsonPropertyName("geoCoordinates")]
        public GeoCoordinates GeoCoordinates { get; set; }
    
        /// <summary>
        /// Gets or sets state.
        /// Provides the State where the sign-in originated. This is calculated using latitude/longitude information from the sign-in activity.
        /// </summary>
        [JsonPropertyName("state")]
        public string State { get; set; }
    
        /// <summary>
        /// Gets or sets additional data.
        /// </summary>
        [JsonExtensionData]
        public IDictionary<string, object> AdditionalData { get; set; }

        /// <summary>
        /// Gets or sets @odata.type.
        /// </summary>
        [JsonPropertyName("@odata.type")]
        public string ODataType { get; set; }
    
    }
}
