// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type Subscribed Sku.
    /// </summary>
    public partial class SubscribedSku : Entity
    {
    
        /// <summary>
        /// Gets or sets applies to.
        /// For example, 'User' or 'Company'.
        /// </summary>
        [JsonPropertyName("appliesTo")]
        public string AppliesTo { get; set; }
    
        /// <summary>
        /// Gets or sets capability status.
        /// Possible values are: Enabled, Warning, Suspended, Deleted, LockedOut. The capabilityStatus is Enabled if the prepaidUnits property has at least 1 unit that is enabled, and LockedOut if the customer cancelled their subscription.
        /// </summary>
        [JsonPropertyName("capabilityStatus")]
        public string CapabilityStatus { get; set; }
    
        /// <summary>
        /// Gets or sets consumed units.
        /// The number of licenses that have been assigned.
        /// </summary>
        [JsonPropertyName("consumedUnits")]
        public Int32? ConsumedUnits { get; set; }
    
        /// <summary>
        /// Gets or sets prepaid units.
        /// Information about the number and status of prepaid licenses.
        /// </summary>
        [JsonPropertyName("prepaidUnits")]
        public LicenseUnitsDetail PrepaidUnits { get; set; }
    
        /// <summary>
        /// Gets or sets service plans.
        /// Information about the service plans that are available with the SKU. Not nullable
        /// </summary>
        [JsonPropertyName("servicePlans")]
        public IEnumerable<ServicePlanInfo> ServicePlans { get; set; }
    
        /// <summary>
        /// Gets or sets sku id.
        /// The unique identifier (GUID) for the service SKU.
        /// </summary>
        [JsonPropertyName("skuId")]
        public Guid? SkuId { get; set; }
    
        /// <summary>
        /// Gets or sets sku part number.
        /// The SKU part number; for example: 'AAD_PREMIUM' or 'RMSBASIC'. To get a list of commercial subscriptions that an organization has acquired, see List subscribedSkus.
        /// </summary>
        [JsonPropertyName("skuPartNumber")]
        public string SkuPartNumber { get; set; }
    
    }
}

