// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type Telecom Expense Management Partner.
    /// </summary>
    public partial class TelecomExpenseManagementPartner : Entity
    {
    
        /// <summary>
        /// Gets or sets app authorized.
        /// Whether the partner's AAD app has been authorized to access Intune.
        /// </summary>
        [JsonPropertyName("appAuthorized")]
        public bool? AppAuthorized { get; set; }
    
        /// <summary>
        /// Gets or sets display name.
        /// Display name of the TEM partner.
        /// </summary>
        [JsonPropertyName("displayName")]
        public string DisplayName { get; set; }
    
        /// <summary>
        /// Gets or sets enabled.
        /// Whether Intune's connection to the TEM service is currently enabled or disabled.
        /// </summary>
        [JsonPropertyName("enabled")]
        public bool? Enabled { get; set; }
    
        /// <summary>
        /// Gets or sets last connection date time.
        /// Timestamp of the last request sent to Intune by the TEM partner.
        /// </summary>
        [JsonPropertyName("lastConnectionDateTime")]
        public DateTimeOffset? LastConnectionDateTime { get; set; }
    
        /// <summary>
        /// Gets or sets url.
        /// URL of the TEM partner's administrative control panel, where an administrator can configure their TEM service.
        /// </summary>
        [JsonPropertyName("url")]
        public string Url { get; set; }
    
    }
}

