// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type Unified Role Definition.
    /// </summary>
    public partial class UnifiedRoleDefinition : Entity
    {
    
        /// <summary>
        /// Gets or sets description.
        /// The description for the unifiedRoleDefinition. Read-only when isBuiltIn is true.
        /// </summary>
        [JsonPropertyName("description")]
        public string Description { get; set; }
    
        /// <summary>
        /// Gets or sets display name.
        /// The display name for the unifiedRoleDefinition. Read-only when isBuiltIn is true. Required.  Supports $filter (eq, in).
        /// </summary>
        [JsonPropertyName("displayName")]
        public string DisplayName { get; set; }
    
        /// <summary>
        /// Gets or sets is built in.
        /// Flag indicating whether the role definition is part of the default set included in Azure Active Directory (Azure AD) or a custom definition. Read-only. Supports $filter (eq, in).
        /// </summary>
        [JsonPropertyName("isBuiltIn")]
        public bool? IsBuiltIn { get; set; }
    
        /// <summary>
        /// Gets or sets is enabled.
        /// Flag indicating whether the role is enabled for assignment. If false the role is not available for assignment. Read-only when isBuiltIn is true.
        /// </summary>
        [JsonPropertyName("isEnabled")]
        public bool? IsEnabled { get; set; }
    
        /// <summary>
        /// Gets or sets resource scopes.
        /// List of the scopes or permissions the role definition applies to. Currently only / is supported. Read-only when isBuiltIn is true. DO NOT USE. This will be deprecated soon. Attach scope to role assignment.
        /// </summary>
        [JsonPropertyName("resourceScopes")]
        public IEnumerable<string> ResourceScopes { get; set; }
    
        /// <summary>
        /// Gets or sets role permissions.
        /// List of permissions included in the role. Read-only when isBuiltIn is true. Required.
        /// </summary>
        [JsonPropertyName("rolePermissions")]
        public IEnumerable<UnifiedRolePermission> RolePermissions { get; set; }
    
        /// <summary>
        /// Gets or sets template id.
        /// Custom template identifier that can be set when isBuiltIn is false but is read-only when isBuiltIn is true. This identifier is typically used if one needs an identifier to be the same across different directories.
        /// </summary>
        [JsonPropertyName("templateId")]
        public string TemplateId { get; set; }
    
        /// <summary>
        /// Gets or sets version.
        /// Indicates version of the role definition. Read-only when isBuiltIn is true.
        /// </summary>
        [JsonPropertyName("version")]
        public string Version { get; set; }
    
        /// <summary>
        /// Gets or sets inherits permissions from.
        /// Read-only collection of role definitions that the given role definition inherits from. Only Azure AD built-in roles (isBuiltIn is true) support this attribute. Supports $expand.
        /// </summary>
        [JsonPropertyName("inheritsPermissionsFrom")]
        public IUnifiedRoleDefinitionInheritsPermissionsFromCollectionPage InheritsPermissionsFrom { get; set; }

        /// <summary>
        /// Gets or sets inheritsPermissionsFromNextLink.
        /// </summary>
        [JsonPropertyName("inheritsPermissionsFrom@odata.nextLink")]
        [JsonConverter(typeof(NextLinkConverter))]
        public string InheritsPermissionsFromNextLink { get; set; }
    
    }
}

