// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: ComplexType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type Video.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<Video>))]
    public partial class Video
    {

        /// <summary>
        /// Gets or sets audioBitsPerSample.
        /// Number of audio bits per sample.
        /// </summary>
        [JsonPropertyName("audioBitsPerSample")]
        public Int32? AudioBitsPerSample { get; set; }
    
        /// <summary>
        /// Gets or sets audioChannels.
        /// Number of audio channels.
        /// </summary>
        [JsonPropertyName("audioChannels")]
        public Int32? AudioChannels { get; set; }
    
        /// <summary>
        /// Gets or sets audioFormat.
        /// Name of the audio format (AAC, MP3, etc.).
        /// </summary>
        [JsonPropertyName("audioFormat")]
        public string AudioFormat { get; set; }
    
        /// <summary>
        /// Gets or sets audioSamplesPerSecond.
        /// Number of audio samples per second.
        /// </summary>
        [JsonPropertyName("audioSamplesPerSecond")]
        public Int32? AudioSamplesPerSecond { get; set; }
    
        /// <summary>
        /// Gets or sets bitrate.
        /// Bit rate of the video in bits per second.
        /// </summary>
        [JsonPropertyName("bitrate")]
        public Int32? Bitrate { get; set; }
    
        /// <summary>
        /// Gets or sets duration.
        /// Duration of the file in milliseconds.
        /// </summary>
        [JsonPropertyName("duration")]
        public Int64? Duration { get; set; }
    
        /// <summary>
        /// Gets or sets fourCC.
        /// 'Four character code' name of the video format.
        /// </summary>
        [JsonPropertyName("fourCC")]
        public string FourCC { get; set; }
    
        /// <summary>
        /// Gets or sets frameRate.
        /// Frame rate of the video.
        /// </summary>
        [JsonPropertyName("frameRate")]
        public double? FrameRate { get; set; }
    
        /// <summary>
        /// Gets or sets height.
        /// Height of the video, in pixels.
        /// </summary>
        [JsonPropertyName("height")]
        public Int32? Height { get; set; }
    
        /// <summary>
        /// Gets or sets width.
        /// Width of the video, in pixels.
        /// </summary>
        [JsonPropertyName("width")]
        public Int32? Width { get; set; }
    
        /// <summary>
        /// Gets or sets additional data.
        /// </summary>
        [JsonExtensionData]
        public IDictionary<string, object> AdditionalData { get; set; }

        /// <summary>
        /// Gets or sets @odata.type.
        /// </summary>
        [JsonPropertyName("@odata.type")]
        public string ODataType { get; set; }
    
    }
}
