// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: ComplexType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type Win32LobAppRegistryRule.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<Win32LobAppRegistryRule>))]
    public partial class Win32LobAppRegistryRule : Win32LobAppRule
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="Win32LobAppRegistryRule"/> class.
        /// </summary>
        public Win32LobAppRegistryRule()
        {
            this.ODataType = "microsoft.graph.win32LobAppRegistryRule";
        }

        /// <summary>
        /// Gets or sets check32BitOn64System.
        /// A value indicating whether to search the 32-bit registry on 64-bit systems.
        /// </summary>
        [JsonPropertyName("check32BitOn64System")]
        public bool? Check32BitOn64System { get; set; }
    
        /// <summary>
        /// Gets or sets comparisonValue.
        /// The registry comparison value.
        /// </summary>
        [JsonPropertyName("comparisonValue")]
        public string ComparisonValue { get; set; }
    
        /// <summary>
        /// Gets or sets keyPath.
        /// The full path of the registry entry containing the value to detect.
        /// </summary>
        [JsonPropertyName("keyPath")]
        public string KeyPath { get; set; }
    
        /// <summary>
        /// Gets or sets operationType.
        /// The registry operation type. Possible values are: notConfigured, exists, doesNotExist, string, integer, version.
        /// </summary>
        [JsonPropertyName("operationType")]
        public Win32LobAppRegistryRuleOperationType? OperationType { get; set; }
    
        /// <summary>
        /// Gets or sets operator.
        /// The operator for registry detection. Possible values are: notConfigured, equal, notEqual, greaterThan, greaterThanOrEqual, lessThan, lessThanOrEqual.
        /// </summary>
        [JsonPropertyName("operator")]
        public Win32LobAppRuleOperator? Operator { get; set; }
    
        /// <summary>
        /// Gets or sets valueName.
        /// The name of the registry value to detect.
        /// </summary>
        [JsonPropertyName("valueName")]
        public string ValueName { get; set; }
    
    }
}
