// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type Windows81General Configuration.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<Windows81GeneralConfiguration>))]
    public partial class Windows81GeneralConfiguration : DeviceConfiguration
    {
    
        ///<summary>
        /// The Windows81GeneralConfiguration constructor
        ///</summary>
        public Windows81GeneralConfiguration()
        {
            this.ODataType = "microsoft.graph.windows81GeneralConfiguration";
        }

        /// <summary>
        /// Gets or sets accounts block adding non microsoft account email.
        /// Indicates whether or not to Block the user from adding email accounts to the device that are not associated with a Microsoft account.
        /// </summary>
        [JsonPropertyName("accountsBlockAddingNonMicrosoftAccountEmail")]
        public bool? AccountsBlockAddingNonMicrosoftAccountEmail { get; set; }
    
        /// <summary>
        /// Gets or sets apply only to windows81.
        /// Value indicating whether this policy only applies to Windows 8.1. This property is read-only.
        /// </summary>
        [JsonPropertyName("applyOnlyToWindows81")]
        public bool? ApplyOnlyToWindows81 { get; set; }
    
        /// <summary>
        /// Gets or sets browser block autofill.
        /// Indicates whether or not to block auto fill.
        /// </summary>
        [JsonPropertyName("browserBlockAutofill")]
        public bool? BrowserBlockAutofill { get; set; }
    
        /// <summary>
        /// Gets or sets browser block automatic detection of intranet sites.
        /// Indicates whether or not to block automatic detection of Intranet sites.
        /// </summary>
        [JsonPropertyName("browserBlockAutomaticDetectionOfIntranetSites")]
        public bool? BrowserBlockAutomaticDetectionOfIntranetSites { get; set; }
    
        /// <summary>
        /// Gets or sets browser block enterprise mode access.
        /// Indicates whether or not to block enterprise mode access.
        /// </summary>
        [JsonPropertyName("browserBlockEnterpriseModeAccess")]
        public bool? BrowserBlockEnterpriseModeAccess { get; set; }
    
        /// <summary>
        /// Gets or sets browser block java script.
        /// Indicates whether or not to Block the user from using JavaScript.
        /// </summary>
        [JsonPropertyName("browserBlockJavaScript")]
        public bool? BrowserBlockJavaScript { get; set; }
    
        /// <summary>
        /// Gets or sets browser block plugins.
        /// Indicates whether or not to block plug-ins.
        /// </summary>
        [JsonPropertyName("browserBlockPlugins")]
        public bool? BrowserBlockPlugins { get; set; }
    
        /// <summary>
        /// Gets or sets browser block popups.
        /// Indicates whether or not to block popups.
        /// </summary>
        [JsonPropertyName("browserBlockPopups")]
        public bool? BrowserBlockPopups { get; set; }
    
        /// <summary>
        /// Gets or sets browser block sending do not track header.
        /// Indicates whether or not to Block the user from sending the do not track header.
        /// </summary>
        [JsonPropertyName("browserBlockSendingDoNotTrackHeader")]
        public bool? BrowserBlockSendingDoNotTrackHeader { get; set; }
    
        /// <summary>
        /// Gets or sets browser block single word entry on intranet sites.
        /// Indicates whether or not to block a single word entry on Intranet sites.
        /// </summary>
        [JsonPropertyName("browserBlockSingleWordEntryOnIntranetSites")]
        public bool? BrowserBlockSingleWordEntryOnIntranetSites { get; set; }
    
        /// <summary>
        /// Gets or sets browser enterprise mode site list location.
        /// The enterprise mode site list location. Could be a local file, local network or http location.
        /// </summary>
        [JsonPropertyName("browserEnterpriseModeSiteListLocation")]
        public string BrowserEnterpriseModeSiteListLocation { get; set; }
    
        /// <summary>
        /// Gets or sets browser internet security level.
        /// The internet security level. Possible values are: userDefined, medium, mediumHigh, high.
        /// </summary>
        [JsonPropertyName("browserInternetSecurityLevel")]
        public InternetSiteSecurityLevel? BrowserInternetSecurityLevel { get; set; }
    
        /// <summary>
        /// Gets or sets browser intranet security level.
        /// The Intranet security level. Possible values are: userDefined, low, mediumLow, medium, mediumHigh, high.
        /// </summary>
        [JsonPropertyName("browserIntranetSecurityLevel")]
        public SiteSecurityLevel? BrowserIntranetSecurityLevel { get; set; }
    
        /// <summary>
        /// Gets or sets browser logging report location.
        /// The logging report location.
        /// </summary>
        [JsonPropertyName("browserLoggingReportLocation")]
        public string BrowserLoggingReportLocation { get; set; }
    
        /// <summary>
        /// Gets or sets browser require firewall.
        /// Indicates whether or not to require a firewall.
        /// </summary>
        [JsonPropertyName("browserRequireFirewall")]
        public bool? BrowserRequireFirewall { get; set; }
    
        /// <summary>
        /// Gets or sets browser require fraud warning.
        /// Indicates whether or not to require fraud warning.
        /// </summary>
        [JsonPropertyName("browserRequireFraudWarning")]
        public bool? BrowserRequireFraudWarning { get; set; }
    
        /// <summary>
        /// Gets or sets browser require high security for restricted sites.
        /// Indicates whether or not to require high security for restricted sites.
        /// </summary>
        [JsonPropertyName("browserRequireHighSecurityForRestrictedSites")]
        public bool? BrowserRequireHighSecurityForRestrictedSites { get; set; }
    
        /// <summary>
        /// Gets or sets browser require smart screen.
        /// Indicates whether or not to require the user to use the smart screen filter.
        /// </summary>
        [JsonPropertyName("browserRequireSmartScreen")]
        public bool? BrowserRequireSmartScreen { get; set; }
    
        /// <summary>
        /// Gets or sets browser trusted sites security level.
        /// The trusted sites security level. Possible values are: userDefined, low, mediumLow, medium, mediumHigh, high.
        /// </summary>
        [JsonPropertyName("browserTrustedSitesSecurityLevel")]
        public SiteSecurityLevel? BrowserTrustedSitesSecurityLevel { get; set; }
    
        /// <summary>
        /// Gets or sets cellular block data roaming.
        /// Indicates whether or not to block data roaming.
        /// </summary>
        [JsonPropertyName("cellularBlockDataRoaming")]
        public bool? CellularBlockDataRoaming { get; set; }
    
        /// <summary>
        /// Gets or sets diagnostics block data submission.
        /// Indicates whether or not to block diagnostic data submission.
        /// </summary>
        [JsonPropertyName("diagnosticsBlockDataSubmission")]
        public bool? DiagnosticsBlockDataSubmission { get; set; }
    
        /// <summary>
        /// Gets or sets password block picture password and pin.
        /// Indicates whether or not to Block the user from using a pictures password and pin.
        /// </summary>
        [JsonPropertyName("passwordBlockPicturePasswordAndPin")]
        public bool? PasswordBlockPicturePasswordAndPin { get; set; }
    
        /// <summary>
        /// Gets or sets password expiration days.
        /// Password expiration in days.
        /// </summary>
        [JsonPropertyName("passwordExpirationDays")]
        public Int32? PasswordExpirationDays { get; set; }
    
        /// <summary>
        /// Gets or sets password minimum character set count.
        /// The number of character sets required in the password.
        /// </summary>
        [JsonPropertyName("passwordMinimumCharacterSetCount")]
        public Int32? PasswordMinimumCharacterSetCount { get; set; }
    
        /// <summary>
        /// Gets or sets password minimum length.
        /// The minimum password length.
        /// </summary>
        [JsonPropertyName("passwordMinimumLength")]
        public Int32? PasswordMinimumLength { get; set; }
    
        /// <summary>
        /// Gets or sets password minutes of inactivity before screen timeout.
        /// The minutes of inactivity before the screen times out.
        /// </summary>
        [JsonPropertyName("passwordMinutesOfInactivityBeforeScreenTimeout")]
        public Int32? PasswordMinutesOfInactivityBeforeScreenTimeout { get; set; }
    
        /// <summary>
        /// Gets or sets password previous password block count.
        /// The number of previous passwords to prevent re-use of. Valid values 0 to 24
        /// </summary>
        [JsonPropertyName("passwordPreviousPasswordBlockCount")]
        public Int32? PasswordPreviousPasswordBlockCount { get; set; }
    
        /// <summary>
        /// Gets or sets password required type.
        /// The required password type. Possible values are: deviceDefault, alphanumeric, numeric.
        /// </summary>
        [JsonPropertyName("passwordRequiredType")]
        public RequiredPasswordType? PasswordRequiredType { get; set; }
    
        /// <summary>
        /// Gets or sets password sign in failure count before factory reset.
        /// The number of sign in failures before factory reset.
        /// </summary>
        [JsonPropertyName("passwordSignInFailureCountBeforeFactoryReset")]
        public Int32? PasswordSignInFailureCountBeforeFactoryReset { get; set; }
    
        /// <summary>
        /// Gets or sets storage require device encryption.
        /// Indicates whether or not to require encryption on a mobile device.
        /// </summary>
        [JsonPropertyName("storageRequireDeviceEncryption")]
        public bool? StorageRequireDeviceEncryption { get; set; }
    
        /// <summary>
        /// Gets or sets updates require automatic updates.
        /// Indicates whether or not to require automatic updates.
        /// </summary>
        [JsonPropertyName("updatesRequireAutomaticUpdates")]
        public bool? UpdatesRequireAutomaticUpdates { get; set; }
    
        /// <summary>
        /// Gets or sets user account control settings.
        /// The user account control settings. Possible values are: userDefined, alwaysNotify, notifyOnAppChanges, notifyOnAppChangesWithoutDimming, neverNotify.
        /// </summary>
        [JsonPropertyName("userAccountControlSettings")]
        public WindowsUserAccountControlSettings? UserAccountControlSettings { get; set; }
    
        /// <summary>
        /// Gets or sets work folders url.
        /// The work folders url.
        /// </summary>
        [JsonPropertyName("workFoldersUrl")]
        public string WorkFoldersUrl { get; set; }
    
    }
}

