// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type Windows Universal App X.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<WindowsUniversalAppX>))]
    public partial class WindowsUniversalAppX : MobileLobApp
    {
    
        ///<summary>
        /// The WindowsUniversalAppX constructor
        ///</summary>
        public WindowsUniversalAppX()
        {
            this.ODataType = "microsoft.graph.windowsUniversalAppX";
        }

        /// <summary>
        /// Gets or sets applicable architectures.
        /// The Windows architecture(s) for which this app can run on. Possible values are: none, x86, x64, arm, neutral.
        /// </summary>
        [JsonPropertyName("applicableArchitectures")]
        public WindowsArchitecture? ApplicableArchitectures { get; set; }
    
        /// <summary>
        /// Gets or sets applicable device types.
        /// The Windows device type(s) for which this app can run on. Possible values are: none, desktop, mobile, holographic, team.
        /// </summary>
        [JsonPropertyName("applicableDeviceTypes")]
        public WindowsDeviceType? ApplicableDeviceTypes { get; set; }
    
        /// <summary>
        /// Gets or sets identity name.
        /// The Identity Name.
        /// </summary>
        [JsonPropertyName("identityName")]
        public string IdentityName { get; set; }
    
        /// <summary>
        /// Gets or sets identity publisher hash.
        /// The Identity Publisher Hash.
        /// </summary>
        [JsonPropertyName("identityPublisherHash")]
        public string IdentityPublisherHash { get; set; }
    
        /// <summary>
        /// Gets or sets identity resource identifier.
        /// The Identity Resource Identifier.
        /// </summary>
        [JsonPropertyName("identityResourceIdentifier")]
        public string IdentityResourceIdentifier { get; set; }
    
        /// <summary>
        /// Gets or sets identity version.
        /// The identity version.
        /// </summary>
        [JsonPropertyName("identityVersion")]
        public string IdentityVersion { get; set; }
    
        /// <summary>
        /// Gets or sets is bundle.
        /// Whether or not the app is a bundle.
        /// </summary>
        [JsonPropertyName("isBundle")]
        public bool? IsBundle { get; set; }
    
        /// <summary>
        /// Gets or sets minimum supported operating system.
        /// The value for the minimum applicable operating system.
        /// </summary>
        [JsonPropertyName("minimumSupportedOperatingSystem")]
        public WindowsMinimumOperatingSystem MinimumSupportedOperatingSystem { get; set; }
    
    }
}

