// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type Workbook Range Format.
    /// </summary>
    public partial class WorkbookRangeFormat : Entity
    {
    
        /// <summary>
        /// Gets or sets column width.
        /// Gets or sets the width of all colums within the range. If the column widths are not uniform, null will be returned.
        /// </summary>
        [JsonPropertyName("columnWidth")]
        public double? ColumnWidth { get; set; }
    
        /// <summary>
        /// Gets or sets horizontal alignment.
        /// Represents the horizontal alignment for the specified object. The possible values are: General, Left, Center, Right, Fill, Justify, CenterAcrossSelection, Distributed.
        /// </summary>
        [JsonPropertyName("horizontalAlignment")]
        public string HorizontalAlignment { get; set; }
    
        /// <summary>
        /// Gets or sets row height.
        /// Gets or sets the height of all rows in the range. If the row heights are not uniform null will be returned.
        /// </summary>
        [JsonPropertyName("rowHeight")]
        public double? RowHeight { get; set; }
    
        /// <summary>
        /// Gets or sets vertical alignment.
        /// Represents the vertical alignment for the specified object. The possible values are: Top, Center, Bottom, Justify, Distributed.
        /// </summary>
        [JsonPropertyName("verticalAlignment")]
        public string VerticalAlignment { get; set; }
    
        /// <summary>
        /// Gets or sets wrap text.
        /// Indicates if Excel wraps the text in the object. A null value indicates that the entire range doesn't have uniform wrap setting
        /// </summary>
        [JsonPropertyName("wrapText")]
        public bool? WrapText { get; set; }
    
        /// <summary>
        /// Gets or sets borders.
        /// Collection of border objects that apply to the overall range selected Read-only.
        /// </summary>
        [JsonPropertyName("borders")]
        public IWorkbookRangeFormatBordersCollectionPage Borders { get; set; }

        /// <summary>
        /// Gets or sets bordersNextLink.
        /// </summary>
        [JsonPropertyName("borders@odata.nextLink")]
        [JsonConverter(typeof(NextLinkConverter))]
        public string BordersNextLink { get; set; }
    
        /// <summary>
        /// Gets or sets fill.
        /// Returns the fill object defined on the overall range. Read-only.
        /// </summary>
        [JsonPropertyName("fill")]
        public WorkbookRangeFill Fill { get; set; }
    
        /// <summary>
        /// Gets or sets font.
        /// Returns the font object defined on the overall range selected Read-only.
        /// </summary>
        [JsonPropertyName("font")]
        public WorkbookRangeFont Font { get; set; }
    
        /// <summary>
        /// Gets or sets protection.
        /// Returns the format protection object for a range. Read-only.
        /// </summary>
        [JsonPropertyName("protection")]
        public WorkbookFormatProtection Protection { get; set; }
    
    }
}

