// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityCollectionRequestBuilder.cs.tt
namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// The type AccessReviewInstanceDecisionsCollectionRequestBuilder.
    /// </summary>
    public partial class AccessReviewInstanceDecisionsCollectionRequestBuilder : BaseRequestBuilder, IAccessReviewInstanceDecisionsCollectionRequestBuilder
    {
        /// <summary>
        /// Constructs a new AccessReviewInstanceDecisionsCollectionRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public AccessReviewInstanceDecisionsCollectionRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public IAccessReviewInstanceDecisionsCollectionRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public IAccessReviewInstanceDecisionsCollectionRequest Request(IEnumerable<Option> options)
        {
            return new AccessReviewInstanceDecisionsCollectionRequest(this.RequestUrl, this.Client, options);
        }

        /// <summary>
        /// Gets an <see cref="IAccessReviewInstanceDecisionItemRequestBuilder"/> for the specified AccessReviewInstanceAccessReviewInstanceDecisionItem.
        /// </summary>
        /// <param name="id">The ID for the AccessReviewInstanceAccessReviewInstanceDecisionItem.</param>
        /// <returns>The <see cref="IAccessReviewInstanceDecisionItemRequestBuilder"/>.</returns>
        public IAccessReviewInstanceDecisionItemRequestBuilder this[string id]
        {
            get
            {
                return new AccessReviewInstanceDecisionItemRequestBuilder(this.AppendSegmentToRequestUrl(id), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for AccessReviewInstanceDecisionItemFilterByCurrentUser.
        /// </summary>
        /// <returns>The <see cref="IAccessReviewInstanceDecisionItemFilterByCurrentUserRequestBuilder"/>.</returns>
        public IAccessReviewInstanceDecisionItemFilterByCurrentUserRequestBuilder FilterByCurrentUser(
            AccessReviewInstanceDecisionItemFilterByCurrentUserOptions on)
        {
            return new AccessReviewInstanceDecisionItemFilterByCurrentUserRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.filterByCurrentUser"),
                this.Client,
                on);
        }
    }
}
