// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type AdministrativeUnitRequestBuilder.
    /// </summary>
    public partial class AdministrativeUnitRequestBuilder : DirectoryObjectRequestBuilder, IAdministrativeUnitRequestBuilder
    {

        /// <summary>
        /// Constructs a new AdministrativeUnitRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public AdministrativeUnitRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public new IAdministrativeUnitRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public new IAdministrativeUnitRequest Request(IEnumerable<Option> options)
        {
            return new AdministrativeUnitRequest(this.RequestUrl, this.Client, options);
        }
    
        /// <summary>
        /// Gets the request builder for Members.
        /// </summary>
        /// <returns>The <see cref="IAdministrativeUnitMembersCollectionWithReferencesRequestBuilder"/>.</returns>
        public IAdministrativeUnitMembersCollectionWithReferencesRequestBuilder Members
        {
            get
            {
                return new AdministrativeUnitMembersCollectionWithReferencesRequestBuilder(this.AppendSegmentToRequestUrl("members"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for ScopedRoleMembers.
        /// </summary>
        /// <returns>The <see cref="IAdministrativeUnitScopedRoleMembersCollectionRequestBuilder"/>.</returns>
        public IAdministrativeUnitScopedRoleMembersCollectionRequestBuilder ScopedRoleMembers
        {
            get
            {
                return new AdministrativeUnitScopedRoleMembersCollectionRequestBuilder(this.AppendSegmentToRequestUrl("scopedRoleMembers"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for Extensions.
        /// </summary>
        /// <returns>The <see cref="IAdministrativeUnitExtensionsCollectionRequestBuilder"/>.</returns>
        public IAdministrativeUnitExtensionsCollectionRequestBuilder Extensions
        {
            get
            {
                return new AdministrativeUnitExtensionsCollectionRequestBuilder(this.AppendSegmentToRequestUrl("extensions"), this.Client);
            }
        }
    
        
    
    }
}
