// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type AgreementRequestBuilder.
    /// </summary>
    public partial class AgreementRequestBuilder : EntityRequestBuilder, IAgreementRequestBuilder
    {

        /// <summary>
        /// Constructs a new AgreementRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public AgreementRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public new IAgreementRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public new IAgreementRequest Request(IEnumerable<Option> options)
        {
            return new AgreementRequest(this.RequestUrl, this.Client, options);
        }
    
        /// <summary>
        /// Gets the request builder for Acceptances.
        /// </summary>
        /// <returns>The <see cref="IAgreementAcceptancesCollectionRequestBuilder"/>.</returns>
        public IAgreementAcceptancesCollectionRequestBuilder Acceptances
        {
            get
            {
                return new AgreementAcceptancesCollectionRequestBuilder(this.AppendSegmentToRequestUrl("acceptances"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for File.
        /// </summary>
        /// <returns>The <see cref="IAgreementFileRequestBuilder"/>.</returns>
        public IAgreementFileRequestBuilder File
        {
            get
            {
                return new AgreementFileRequestBuilder(this.AppendSegmentToRequestUrl("file"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for Files.
        /// </summary>
        /// <returns>The <see cref="IAgreementFilesCollectionRequestBuilder"/>.</returns>
        public IAgreementFilesCollectionRequestBuilder Files
        {
            get
            {
                return new AgreementFilesCollectionRequestBuilder(this.AppendSegmentToRequestUrl("files"), this.Client);
            }
        }
    
    }
}
