// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type AndroidManagedAppProtectionRequestBuilder.
    /// </summary>
    public partial class AndroidManagedAppProtectionRequestBuilder : TargetedManagedAppProtectionRequestBuilder, IAndroidManagedAppProtectionRequestBuilder
    {

        /// <summary>
        /// Constructs a new AndroidManagedAppProtectionRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public AndroidManagedAppProtectionRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public new IAndroidManagedAppProtectionRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public new IAndroidManagedAppProtectionRequest Request(IEnumerable<Option> options)
        {
            return new AndroidManagedAppProtectionRequest(this.RequestUrl, this.Client, options);
        }
    
        /// <summary>
        /// Gets the request builder for Apps.
        /// </summary>
        /// <returns>The <see cref="IAndroidManagedAppProtectionAppsCollectionRequestBuilder"/>.</returns>
        public IAndroidManagedAppProtectionAppsCollectionRequestBuilder Apps
        {
            get
            {
                return new AndroidManagedAppProtectionAppsCollectionRequestBuilder(this.AppendSegmentToRequestUrl("apps"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for DeploymentSummary.
        /// </summary>
        /// <returns>The <see cref="IManagedAppPolicyDeploymentSummaryRequestBuilder"/>.</returns>
        public IManagedAppPolicyDeploymentSummaryRequestBuilder DeploymentSummary
        {
            get
            {
                return new ManagedAppPolicyDeploymentSummaryRequestBuilder(this.AppendSegmentToRequestUrl("deploymentSummary"), this.Client);
            }
        }
    
    }
}
