// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityCollectionWithReferencesRequestBuilder.cs.tt
namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// The type ApplicationHomeRealmDiscoveryPoliciesCollectionWithReferencesRequestBuilder.
    /// </summary>
    public partial class ApplicationHomeRealmDiscoveryPoliciesCollectionWithReferencesRequestBuilder : BaseRequestBuilder, IApplicationHomeRealmDiscoveryPoliciesCollectionWithReferencesRequestBuilder
    {

        /// <summary>
        /// Constructs a new ApplicationHomeRealmDiscoveryPoliciesCollectionWithReferencesRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public ApplicationHomeRealmDiscoveryPoliciesCollectionWithReferencesRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public IApplicationHomeRealmDiscoveryPoliciesCollectionWithReferencesRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public IApplicationHomeRealmDiscoveryPoliciesCollectionWithReferencesRequest Request(IEnumerable<Option> options)
        {
            return new ApplicationHomeRealmDiscoveryPoliciesCollectionWithReferencesRequest(this.RequestUrl, this.Client, options);
        }

        /// <summary>
        /// Gets an <see cref="IHomeRealmDiscoveryPolicyWithReferenceRequestBuilder"/> for the specified ApplicationHomeRealmDiscoveryPolicy.
        /// </summary>
        /// <param name="id">The ID for the ApplicationHomeRealmDiscoveryPolicy.</param>
        /// <returns>The <see cref="IHomeRealmDiscoveryPolicyWithReferenceRequestBuilder"/>.</returns>
        public IHomeRealmDiscoveryPolicyWithReferenceRequestBuilder this[string id]
        {
            get
            {
                return new HomeRealmDiscoveryPolicyWithReferenceRequestBuilder(this.AppendSegmentToRequestUrl(id), this.Client);
            }
        }

        
        /// <summary>
        /// Gets an <see cref="IApplicationHomeRealmDiscoveryPoliciesCollectionReferencesRequestBuilder"/> for the references in the collection.
        /// </summary>
        /// <returns>The <see cref="IApplicationHomeRealmDiscoveryPoliciesCollectionReferencesRequestBuilder"/>.</returns>
        public IApplicationHomeRealmDiscoveryPoliciesCollectionReferencesRequestBuilder References
        {
            get
            {
                return new ApplicationHomeRealmDiscoveryPoliciesCollectionReferencesRequestBuilder(this.AppendSegmentToRequestUrl("$ref"), this.Client);
            }
        }

    }
}
