// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: MethodRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type ApplicationTemplateInstantiateRequestBuilder.
    /// </summary>
    public partial class ApplicationTemplateInstantiateRequestBuilder : BaseActionMethodRequestBuilder<IApplicationTemplateInstantiateRequest>, IApplicationTemplateInstantiateRequestBuilder
    {
        /// <summary>
        /// Constructs a new <see cref="ApplicationTemplateInstantiateRequestBuilder"/>.
        /// </summary>
        /// <param name="requestUrl">The URL for the request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        /// <param name="displayName">A displayName parameter for the OData method call.</param>
        public ApplicationTemplateInstantiateRequestBuilder(
            string requestUrl,
            IBaseClient client,
            string displayName)
            : base(requestUrl, client)
        {
            this.SetParameter("displayName", displayName, true);
        }

        /// <summary>
        /// A method used by the base class to construct a request class instance.
        /// </summary>
        /// <param name="functionUrl">The request URL to </param>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>An instance of a specific request class.</returns>
        protected override IApplicationTemplateInstantiateRequest CreateRequest(string functionUrl, IEnumerable<Option> options)
        {
            var request = new ApplicationTemplateInstantiateRequest(functionUrl, this.Client, options);

            if (this.HasParameter("displayName"))
            {
                request.RequestBody.DisplayName = this.GetParameter<string>("displayName");
            }

            return request;
        }
    }
}
