// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type B2xIdentityUserFlowRequestBuilder.
    /// </summary>
    public partial class B2xIdentityUserFlowRequestBuilder : IdentityUserFlowRequestBuilder, IB2xIdentityUserFlowRequestBuilder
    {

        /// <summary>
        /// Constructs a new B2xIdentityUserFlowRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public B2xIdentityUserFlowRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public new IB2xIdentityUserFlowRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public new IB2xIdentityUserFlowRequest Request(IEnumerable<Option> options)
        {
            return new B2xIdentityUserFlowRequest(this.RequestUrl, this.Client, options);
        }
    
        /// <summary>
        /// Gets the request builder for IdentityProviders.
        /// </summary>
        /// <returns>The <see cref="IB2xIdentityUserFlowIdentityProvidersCollectionWithReferencesRequestBuilder"/>.</returns>
        public IB2xIdentityUserFlowIdentityProvidersCollectionWithReferencesRequestBuilder IdentityProviders
        {
            get
            {
                return new B2xIdentityUserFlowIdentityProvidersCollectionWithReferencesRequestBuilder(this.AppendSegmentToRequestUrl("identityProviders"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for Languages.
        /// </summary>
        /// <returns>The <see cref="IB2xIdentityUserFlowLanguagesCollectionRequestBuilder"/>.</returns>
        public IB2xIdentityUserFlowLanguagesCollectionRequestBuilder Languages
        {
            get
            {
                return new B2xIdentityUserFlowLanguagesCollectionRequestBuilder(this.AppendSegmentToRequestUrl("languages"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for UserAttributeAssignments.
        /// </summary>
        /// <returns>The <see cref="IB2xIdentityUserFlowUserAttributeAssignmentsCollectionRequestBuilder"/>.</returns>
        public IB2xIdentityUserFlowUserAttributeAssignmentsCollectionRequestBuilder UserAttributeAssignments
        {
            get
            {
                return new B2xIdentityUserFlowUserAttributeAssignmentsCollectionRequestBuilder(this.AppendSegmentToRequestUrl("userAttributeAssignments"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for UserFlowIdentityProviders.
        /// </summary>
        /// <returns>The <see cref="IB2xIdentityUserFlowUserFlowIdentityProvidersCollectionWithReferencesRequestBuilder"/>.</returns>
        public IB2xIdentityUserFlowUserFlowIdentityProvidersCollectionWithReferencesRequestBuilder UserFlowIdentityProviders
        {
            get
            {
                return new B2xIdentityUserFlowUserFlowIdentityProvidersCollectionWithReferencesRequestBuilder(this.AppendSegmentToRequestUrl("userFlowIdentityProviders"), this.Client);
            }
        }
    
    }
}
