// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type BookingAppointmentRequestBuilder.
    /// </summary>
    public partial class BookingAppointmentRequestBuilder : EntityRequestBuilder, IBookingAppointmentRequestBuilder
    {

        /// <summary>
        /// Constructs a new BookingAppointmentRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public BookingAppointmentRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public new IBookingAppointmentRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public new IBookingAppointmentRequest Request(IEnumerable<Option> options)
        {
            return new BookingAppointmentRequest(this.RequestUrl, this.Client, options);
        }
    
        /// <summary>
        /// Gets the request builder for BookingAppointmentCancel.
        /// </summary>
        /// <returns>The <see cref="IBookingAppointmentCancelRequestBuilder"/>.</returns>
        public IBookingAppointmentCancelRequestBuilder Cancel(
            string cancellationMessage = null)
        {
            return new BookingAppointmentCancelRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.cancel"),
                this.Client,
                cancellationMessage);
        }
    
    }
}
