// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityCollectionRequestBuilder.cs.tt
namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// The type CalendarCalendarPermissionsCollectionRequestBuilder.
    /// </summary>
    public partial class CalendarCalendarPermissionsCollectionRequestBuilder : BaseRequestBuilder, ICalendarCalendarPermissionsCollectionRequestBuilder
    {
        /// <summary>
        /// Constructs a new CalendarCalendarPermissionsCollectionRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public CalendarCalendarPermissionsCollectionRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public ICalendarCalendarPermissionsCollectionRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public ICalendarCalendarPermissionsCollectionRequest Request(IEnumerable<Option> options)
        {
            return new CalendarCalendarPermissionsCollectionRequest(this.RequestUrl, this.Client, options);
        }

        /// <summary>
        /// Gets an <see cref="ICalendarPermissionRequestBuilder"/> for the specified CalendarCalendarPermission.
        /// </summary>
        /// <param name="id">The ID for the CalendarCalendarPermission.</param>
        /// <returns>The <see cref="ICalendarPermissionRequestBuilder"/>.</returns>
        public ICalendarPermissionRequestBuilder this[string id]
        {
            get
            {
                return new CalendarPermissionRequestBuilder(this.AppendSegmentToRequestUrl(id), this.Client);
            }
        }

        
    }
}
