// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityCollectionRequestBuilder.cs.tt
namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// The type CallOperationsCollectionRequestBuilder.
    /// </summary>
    public partial class CallOperationsCollectionRequestBuilder : BaseRequestBuilder, ICallOperationsCollectionRequestBuilder
    {
        /// <summary>
        /// Constructs a new CallOperationsCollectionRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public CallOperationsCollectionRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public ICallOperationsCollectionRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public ICallOperationsCollectionRequest Request(IEnumerable<Option> options)
        {
            return new CallOperationsCollectionRequest(this.RequestUrl, this.Client, options);
        }

        /// <summary>
        /// Gets an <see cref="ICommsOperationRequestBuilder"/> for the specified CallCommsOperation.
        /// </summary>
        /// <param name="id">The ID for the CallCommsOperation.</param>
        /// <returns>The <see cref="ICommsOperationRequestBuilder"/>.</returns>
        public ICommsOperationRequestBuilder this[string id]
        {
            get
            {
                return new CommsOperationRequestBuilder(this.AppendSegmentToRequestUrl(id), this.Client);
            }
        }

        
    }
}
