// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: MethodRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type CallRedirectRequestBuilder.
    /// </summary>
    public partial class CallRedirectRequestBuilder : BaseActionMethodRequestBuilder<ICallRedirectRequest>, ICallRedirectRequestBuilder
    {
        /// <summary>
        /// Constructs a new <see cref="CallRedirectRequestBuilder"/>.
        /// </summary>
        /// <param name="requestUrl">The URL for the request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        /// <param name="targets">A targets parameter for the OData method call.</param>
        /// <param name="timeout">A timeout parameter for the OData method call.</param>
        /// <param name="callbackUri">A callbackUri parameter for the OData method call.</param>
        public CallRedirectRequestBuilder(
            string requestUrl,
            IBaseClient client,
            IEnumerable<InvitationParticipantInfo> targets,
            Int32? timeout,
            string callbackUri)
            : base(requestUrl, client)
        {
            this.SetParameter("targets", targets, false);
            this.SetParameter("timeout", timeout, true);
            this.SetParameter("callbackUri", callbackUri, true);
        }

        /// <summary>
        /// A method used by the base class to construct a request class instance.
        /// </summary>
        /// <param name="functionUrl">The request URL to </param>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>An instance of a specific request class.</returns>
        protected override ICallRedirectRequest CreateRequest(string functionUrl, IEnumerable<Option> options)
        {
            var request = new CallRedirectRequest(functionUrl, this.Client, options);

            if (this.HasParameter("targets"))
            {
                request.RequestBody.Targets = this.GetParameter<IEnumerable<InvitationParticipantInfo>>("targets");
            }

            if (this.HasParameter("timeout"))
            {
                request.RequestBody.Timeout = this.GetParameter<Int32?>("timeout");
            }

            if (this.HasParameter("callbackUri"))
            {
                request.RequestBody.CallbackUri = this.GetParameter<string>("callbackUri");
            }

            return request;
        }
    }
}
