// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityCollectionRequestBuilder.cs.tt
namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// The type ChatInstalledAppsCollectionRequestBuilder.
    /// </summary>
    public partial class ChatInstalledAppsCollectionRequestBuilder : BaseRequestBuilder, IChatInstalledAppsCollectionRequestBuilder
    {
        /// <summary>
        /// Constructs a new ChatInstalledAppsCollectionRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public ChatInstalledAppsCollectionRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public IChatInstalledAppsCollectionRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public IChatInstalledAppsCollectionRequest Request(IEnumerable<Option> options)
        {
            return new ChatInstalledAppsCollectionRequest(this.RequestUrl, this.Client, options);
        }

        /// <summary>
        /// Gets an <see cref="ITeamsAppInstallationRequestBuilder"/> for the specified ChatTeamsAppInstallation.
        /// </summary>
        /// <param name="id">The ID for the ChatTeamsAppInstallation.</param>
        /// <returns>The <see cref="ITeamsAppInstallationRequestBuilder"/>.</returns>
        public ITeamsAppInstallationRequestBuilder this[string id]
        {
            get
            {
                return new TeamsAppInstallationRequestBuilder(this.AppendSegmentToRequestUrl(id), this.Client);
            }
        }

        
    }
}
