// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityCollectionRequestBuilder.cs.tt
namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// The type CloudCommunicationsCallsCollectionRequestBuilder.
    /// </summary>
    public partial class CloudCommunicationsCallsCollectionRequestBuilder : BaseRequestBuilder, ICloudCommunicationsCallsCollectionRequestBuilder
    {
        /// <summary>
        /// Constructs a new CloudCommunicationsCallsCollectionRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public CloudCommunicationsCallsCollectionRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public ICloudCommunicationsCallsCollectionRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public ICloudCommunicationsCallsCollectionRequest Request(IEnumerable<Option> options)
        {
            return new CloudCommunicationsCallsCollectionRequest(this.RequestUrl, this.Client, options);
        }

        /// <summary>
        /// Gets an <see cref="ICallRequestBuilder"/> for the specified CloudCommunicationsCall.
        /// </summary>
        /// <param name="id">The ID for the CloudCommunicationsCall.</param>
        /// <returns>The <see cref="ICallRequestBuilder"/>.</returns>
        public ICallRequestBuilder this[string id]
        {
            get
            {
                return new CallRequestBuilder(this.AppendSegmentToRequestUrl(id), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for CallLogTeleconferenceDeviceQuality.
        /// </summary>
        /// <returns>The <see cref="ICallLogTeleconferenceDeviceQualityRequestBuilder"/>.</returns>
        public ICallLogTeleconferenceDeviceQualityRequestBuilder LogTeleconferenceDeviceQuality(
            TeleconferenceDeviceQuality quality)
        {
            return new CallLogTeleconferenceDeviceQualityRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.logTeleconferenceDeviceQuality"),
                this.Client,
                quality);
        }
    }
}
