// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type ConditionalAccessRootRequestBuilder.
    /// </summary>
    public partial class ConditionalAccessRootRequestBuilder : EntityRequestBuilder, IConditionalAccessRootRequestBuilder
    {

        /// <summary>
        /// Constructs a new ConditionalAccessRootRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public ConditionalAccessRootRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public new IConditionalAccessRootRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public new IConditionalAccessRootRequest Request(IEnumerable<Option> options)
        {
            return new ConditionalAccessRootRequest(this.RequestUrl, this.Client, options);
        }
    
        /// <summary>
        /// Gets the request builder for NamedLocations.
        /// </summary>
        /// <returns>The <see cref="IConditionalAccessRootNamedLocationsCollectionRequestBuilder"/>.</returns>
        public IConditionalAccessRootNamedLocationsCollectionRequestBuilder NamedLocations
        {
            get
            {
                return new ConditionalAccessRootNamedLocationsCollectionRequestBuilder(this.AppendSegmentToRequestUrl("namedLocations"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for Policies.
        /// </summary>
        /// <returns>The <see cref="IConditionalAccessRootPoliciesCollectionRequestBuilder"/>.</returns>
        public IConditionalAccessRootPoliciesCollectionRequestBuilder Policies
        {
            get
            {
                return new ConditionalAccessRootPoliciesCollectionRequestBuilder(this.AppendSegmentToRequestUrl("policies"), this.Client);
            }
        }
    
    }
}
