// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityCollectionWithReferencesRequestBuilder.cs.tt
namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// The type ContentTypeBaseTypesCollectionWithReferencesRequestBuilder.
    /// </summary>
    public partial class ContentTypeBaseTypesCollectionWithReferencesRequestBuilder : BaseRequestBuilder, IContentTypeBaseTypesCollectionWithReferencesRequestBuilder
    {

        /// <summary>
        /// Constructs a new ContentTypeBaseTypesCollectionWithReferencesRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public ContentTypeBaseTypesCollectionWithReferencesRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public IContentTypeBaseTypesCollectionWithReferencesRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public IContentTypeBaseTypesCollectionWithReferencesRequest Request(IEnumerable<Option> options)
        {
            return new ContentTypeBaseTypesCollectionWithReferencesRequest(this.RequestUrl, this.Client, options);
        }

        /// <summary>
        /// Gets an <see cref="IContentTypeWithReferenceRequestBuilder"/> for the specified ContentTypeContentType.
        /// </summary>
        /// <param name="id">The ID for the ContentTypeContentType.</param>
        /// <returns>The <see cref="IContentTypeWithReferenceRequestBuilder"/>.</returns>
        public IContentTypeWithReferenceRequestBuilder this[string id]
        {
            get
            {
                return new ContentTypeWithReferenceRequestBuilder(this.AppendSegmentToRequestUrl(id), this.Client);
            }
        }

        
        /// <summary>
        /// Gets an <see cref="IContentTypeBaseTypesCollectionReferencesRequestBuilder"/> for the references in the collection.
        /// </summary>
        /// <returns>The <see cref="IContentTypeBaseTypesCollectionReferencesRequestBuilder"/>.</returns>
        public IContentTypeBaseTypesCollectionReferencesRequestBuilder References
        {
            get
            {
                return new ContentTypeBaseTypesCollectionReferencesRequestBuilder(this.AppendSegmentToRequestUrl("$ref"), this.Client);
            }
        }

    }
}
