// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: MethodRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type ContentTypeCopyToDefaultContentLocationRequestBuilder.
    /// </summary>
    public partial class ContentTypeCopyToDefaultContentLocationRequestBuilder : BaseActionMethodRequestBuilder<IContentTypeCopyToDefaultContentLocationRequest>, IContentTypeCopyToDefaultContentLocationRequestBuilder
    {
        /// <summary>
        /// Constructs a new <see cref="ContentTypeCopyToDefaultContentLocationRequestBuilder"/>.
        /// </summary>
        /// <param name="requestUrl">The URL for the request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        /// <param name="sourceFile">A sourceFile parameter for the OData method call.</param>
        /// <param name="destinationFileName">A destinationFileName parameter for the OData method call.</param>
        public ContentTypeCopyToDefaultContentLocationRequestBuilder(
            string requestUrl,
            IBaseClient client,
            ItemReference sourceFile,
            string destinationFileName)
            : base(requestUrl, client)
        {
            this.SetParameter("sourceFile", sourceFile, false);
            this.SetParameter("destinationFileName", destinationFileName, true);
        }

        /// <summary>
        /// A method used by the base class to construct a request class instance.
        /// </summary>
        /// <param name="functionUrl">The request URL to </param>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>An instance of a specific request class.</returns>
        protected override IContentTypeCopyToDefaultContentLocationRequest CreateRequest(string functionUrl, IEnumerable<Option> options)
        {
            var request = new ContentTypeCopyToDefaultContentLocationRequest(functionUrl, this.Client, options);

            if (this.HasParameter("sourceFile"))
            {
                request.RequestBody.SourceFile = this.GetParameter<ItemReference>("sourceFile");
            }

            if (this.HasParameter("destinationFileName"))
            {
                request.RequestBody.DestinationFileName = this.GetParameter<string>("destinationFileName");
            }

            return request;
        }
    }
}
