// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityCollectionRequestBuilder.cs.tt
namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// The type ConversationThreadPostsCollectionRequestBuilder.
    /// </summary>
    public partial class ConversationThreadPostsCollectionRequestBuilder : BaseRequestBuilder, IConversationThreadPostsCollectionRequestBuilder
    {
        /// <summary>
        /// Constructs a new ConversationThreadPostsCollectionRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public ConversationThreadPostsCollectionRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public IConversationThreadPostsCollectionRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public IConversationThreadPostsCollectionRequest Request(IEnumerable<Option> options)
        {
            return new ConversationThreadPostsCollectionRequest(this.RequestUrl, this.Client, options);
        }

        /// <summary>
        /// Gets an <see cref="IPostRequestBuilder"/> for the specified ConversationThreadPost.
        /// </summary>
        /// <param name="id">The ID for the ConversationThreadPost.</param>
        /// <returns>The <see cref="IPostRequestBuilder"/>.</returns>
        public IPostRequestBuilder this[string id]
        {
            get
            {
                return new PostRequestBuilder(this.AppendSegmentToRequestUrl(id), this.Client);
            }
        }

        
    }
}
