// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type ConversationThreadRequestBuilder.
    /// </summary>
    public partial class ConversationThreadRequestBuilder : EntityRequestBuilder, IConversationThreadRequestBuilder
    {

        /// <summary>
        /// Constructs a new ConversationThreadRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public ConversationThreadRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public new IConversationThreadRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public new IConversationThreadRequest Request(IEnumerable<Option> options)
        {
            return new ConversationThreadRequest(this.RequestUrl, this.Client, options);
        }
    
        /// <summary>
        /// Gets the request builder for Posts.
        /// </summary>
        /// <returns>The <see cref="IConversationThreadPostsCollectionRequestBuilder"/>.</returns>
        public IConversationThreadPostsCollectionRequestBuilder Posts
        {
            get
            {
                return new ConversationThreadPostsCollectionRequestBuilder(this.AppendSegmentToRequestUrl("posts"), this.Client);
            }
        }
    
        /// <summary>
        /// Gets the request builder for ConversationThreadReply.
        /// </summary>
        /// <returns>The <see cref="IConversationThreadReplyRequestBuilder"/>.</returns>
        public IConversationThreadReplyRequestBuilder Reply(
            Post Post)
        {
            return new ConversationThreadReplyRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.reply"),
                this.Client,
                Post);
        }
    
    }
}
