// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type DeviceManagementExchangeConnectorRequestBuilder.
    /// </summary>
    public partial class DeviceManagementExchangeConnectorRequestBuilder : EntityRequestBuilder, IDeviceManagementExchangeConnectorRequestBuilder
    {

        /// <summary>
        /// Constructs a new DeviceManagementExchangeConnectorRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public DeviceManagementExchangeConnectorRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public new IDeviceManagementExchangeConnectorRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public new IDeviceManagementExchangeConnectorRequest Request(IEnumerable<Option> options)
        {
            return new DeviceManagementExchangeConnectorRequest(this.RequestUrl, this.Client, options);
        }
    
        /// <summary>
        /// Gets the request builder for DeviceManagementExchangeConnectorSync.
        /// </summary>
        /// <returns>The <see cref="IDeviceManagementExchangeConnectorSyncRequestBuilder"/>.</returns>
        public IDeviceManagementExchangeConnectorSyncRequestBuilder Sync(
            DeviceManagementExchangeConnectorSyncType syncType)
        {
            return new DeviceManagementExchangeConnectorSyncRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.sync"),
                this.Client,
                syncType);
        }
    
    }
}
