// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: MethodRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type DeviceManagementExchangeConnectorSyncRequestBuilder.
    /// </summary>
    public partial class DeviceManagementExchangeConnectorSyncRequestBuilder : BaseActionMethodRequestBuilder<IDeviceManagementExchangeConnectorSyncRequest>, IDeviceManagementExchangeConnectorSyncRequestBuilder
    {
        /// <summary>
        /// Constructs a new <see cref="DeviceManagementExchangeConnectorSyncRequestBuilder"/>.
        /// </summary>
        /// <param name="requestUrl">The URL for the request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        /// <param name="syncType">A syncType parameter for the OData method call.</param>
        public DeviceManagementExchangeConnectorSyncRequestBuilder(
            string requestUrl,
            IBaseClient client,
            DeviceManagementExchangeConnectorSyncType syncType)
            : base(requestUrl, client)
        {
            this.SetParameter("syncType", syncType, false);
        }

        /// <summary>
        /// A method used by the base class to construct a request class instance.
        /// </summary>
        /// <param name="functionUrl">The request URL to </param>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>An instance of a specific request class.</returns>
        protected override IDeviceManagementExchangeConnectorSyncRequest CreateRequest(string functionUrl, IEnumerable<Option> options)
        {
            var request = new DeviceManagementExchangeConnectorSyncRequest(functionUrl, this.Client, options);

            if (this.HasParameter("syncType"))
            {
                request.RequestBody.SyncType = this.GetParameter<DeviceManagementExchangeConnectorSyncType>("syncType");
            }

            return request;
        }
    }
}
