// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: MethodRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type DirectoryObjectGetByIdsRequestBuilder.
    /// </summary>
    public partial class DirectoryObjectGetByIdsRequestBuilder : BaseActionMethodRequestBuilder<IDirectoryObjectGetByIdsRequest>, IDirectoryObjectGetByIdsRequestBuilder
    {
        /// <summary>
        /// Constructs a new <see cref="DirectoryObjectGetByIdsRequestBuilder"/>.
        /// </summary>
        /// <param name="requestUrl">The URL for the request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        /// <param name="ids">A ids parameter for the OData method call.</param>
        /// <param name="types">A types parameter for the OData method call.</param>
        public DirectoryObjectGetByIdsRequestBuilder(
            string requestUrl,
            IBaseClient client,
            IEnumerable<string> ids,
            IEnumerable<string> types)
            : base(requestUrl, client)
        {
            this.SetParameter("ids", ids, false);
            this.SetParameter("types", types, true);
        }

        /// <summary>
        /// A method used by the base class to construct a request class instance.
        /// </summary>
        /// <param name="functionUrl">The request URL to </param>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>An instance of a specific request class.</returns>
        protected override IDirectoryObjectGetByIdsRequest CreateRequest(string functionUrl, IEnumerable<Option> options)
        {
            var request = new DirectoryObjectGetByIdsRequest(functionUrl, this.Client, options);

            if (this.HasParameter("ids"))
            {
                request.RequestBody.Ids = this.GetParameter<IEnumerable<string>>("ids");
            }

            if (this.HasParameter("types"))
            {
                request.RequestBody.Types = this.GetParameter<IEnumerable<string>>("types");
            }

            return request;
        }
    }
}
