// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityCollectionRequestBuilder.cs.tt
namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// The type DriveItemThumbnailsCollectionRequestBuilder.
    /// </summary>
    public partial class DriveItemThumbnailsCollectionRequestBuilder : BaseRequestBuilder, IDriveItemThumbnailsCollectionRequestBuilder
    {
        /// <summary>
        /// Constructs a new DriveItemThumbnailsCollectionRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public DriveItemThumbnailsCollectionRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public IDriveItemThumbnailsCollectionRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public IDriveItemThumbnailsCollectionRequest Request(IEnumerable<Option> options)
        {
            return new DriveItemThumbnailsCollectionRequest(this.RequestUrl, this.Client, options);
        }

        /// <summary>
        /// Gets an <see cref="IThumbnailSetRequestBuilder"/> for the specified DriveItemThumbnailSet.
        /// </summary>
        /// <param name="id">The ID for the DriveItemThumbnailSet.</param>
        /// <returns>The <see cref="IThumbnailSetRequestBuilder"/>.</returns>
        public IThumbnailSetRequestBuilder this[string id]
        {
            get
            {
                return new ThumbnailSetRequestBuilder(this.AppendSegmentToRequestUrl(id), this.Client);
            }
        }

        
    }
}
