// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: MethodRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type DriveItemValidatePermissionRequestBuilder.
    /// </summary>
    public partial class DriveItemValidatePermissionRequestBuilder : BaseActionMethodRequestBuilder<IDriveItemValidatePermissionRequest>, IDriveItemValidatePermissionRequestBuilder
    {
        /// <summary>
        /// Constructs a new <see cref="DriveItemValidatePermissionRequestBuilder"/>.
        /// </summary>
        /// <param name="requestUrl">The URL for the request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        /// <param name="password">A password parameter for the OData method call.</param>
        /// <param name="challengeToken">A challengeToken parameter for the OData method call.</param>
        public DriveItemValidatePermissionRequestBuilder(
            string requestUrl,
            IBaseClient client,
            string password,
            string challengeToken)
            : base(requestUrl, client)
        {
            this.SetParameter("password", password, false);
            this.SetParameter("challengeToken", challengeToken, true);
        }

        /// <summary>
        /// A method used by the base class to construct a request class instance.
        /// </summary>
        /// <param name="functionUrl">The request URL to </param>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>An instance of a specific request class.</returns>
        protected override IDriveItemValidatePermissionRequest CreateRequest(string functionUrl, IEnumerable<Option> options)
        {
            var request = new DriveItemValidatePermissionRequest(functionUrl, this.Client, options);

            if (this.HasParameter("password"))
            {
                request.RequestBody.Password = this.GetParameter<string>("password");
            }

            if (this.HasParameter("challengeToken"))
            {
                request.RequestBody.ChallengeToken = this.GetParameter<string>("challengeToken");
            }

            return request;
        }
    }
}
