// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityCollectionRequestBuilder.cs.tt
namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// The type EducationRootSchoolsCollectionRequestBuilder.
    /// </summary>
    public partial class EducationRootSchoolsCollectionRequestBuilder : BaseRequestBuilder, IEducationRootSchoolsCollectionRequestBuilder
    {
        /// <summary>
        /// Constructs a new EducationRootSchoolsCollectionRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public EducationRootSchoolsCollectionRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public IEducationRootSchoolsCollectionRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public IEducationRootSchoolsCollectionRequest Request(IEnumerable<Option> options)
        {
            return new EducationRootSchoolsCollectionRequest(this.RequestUrl, this.Client, options);
        }

        /// <summary>
        /// Gets an <see cref="IEducationSchoolRequestBuilder"/> for the specified EducationRootEducationSchool.
        /// </summary>
        /// <param name="id">The ID for the EducationRootEducationSchool.</param>
        /// <returns>The <see cref="IEducationSchoolRequestBuilder"/>.</returns>
        public IEducationSchoolRequestBuilder this[string id]
        {
            get
            {
                return new EducationSchoolRequestBuilder(this.AppendSegmentToRequestUrl(id), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for EducationSchoolDelta.
        /// </summary>
        /// <returns>The <see cref="IEducationSchoolDeltaRequestBuilder"/>.</returns>
        public IEducationSchoolDeltaRequestBuilder Delta()
        {
            return new EducationSchoolDeltaRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.delta"),
                this.Client);
        }
    }
}
