// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityCollectionRequestBuilder.cs.tt
namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// The type EntitlementManagementAssignmentRequestsCollectionRequestBuilder.
    /// </summary>
    public partial class EntitlementManagementAssignmentRequestsCollectionRequestBuilder : BaseRequestBuilder, IEntitlementManagementAssignmentRequestsCollectionRequestBuilder
    {
        /// <summary>
        /// Constructs a new EntitlementManagementAssignmentRequestsCollectionRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public EntitlementManagementAssignmentRequestsCollectionRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public IEntitlementManagementAssignmentRequestsCollectionRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public IEntitlementManagementAssignmentRequestsCollectionRequest Request(IEnumerable<Option> options)
        {
            return new EntitlementManagementAssignmentRequestsCollectionRequest(this.RequestUrl, this.Client, options);
        }

        /// <summary>
        /// Gets an <see cref="IAccessPackageAssignmentRequestRequestBuilder"/> for the specified EntitlementManagementAccessPackageAssignmentRequest.
        /// </summary>
        /// <param name="id">The ID for the EntitlementManagementAccessPackageAssignmentRequest.</param>
        /// <returns>The <see cref="IAccessPackageAssignmentRequestRequestBuilder"/>.</returns>
        public IAccessPackageAssignmentRequestRequestBuilder this[string id]
        {
            get
            {
                return new AccessPackageAssignmentRequestRequestBuilder(this.AppendSegmentToRequestUrl(id), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for AccessPackageAssignmentRequestFilterByCurrentUser.
        /// </summary>
        /// <returns>The <see cref="IAccessPackageAssignmentRequestFilterByCurrentUserRequestBuilder"/>.</returns>
        public IAccessPackageAssignmentRequestFilterByCurrentUserRequestBuilder FilterByCurrentUser(
            AccessPackageAssignmentRequestFilterByCurrentUserOptions on)
        {
            return new AccessPackageAssignmentRequestFilterByCurrentUserRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.filterByCurrentUser"),
                this.Client,
                on);
        }
    }
}
