// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityCollectionRequestBuilder.cs.tt
namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// The type EntitlementManagementCatalogsCollectionRequestBuilder.
    /// </summary>
    public partial class EntitlementManagementCatalogsCollectionRequestBuilder : BaseRequestBuilder, IEntitlementManagementCatalogsCollectionRequestBuilder
    {
        /// <summary>
        /// Constructs a new EntitlementManagementCatalogsCollectionRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public EntitlementManagementCatalogsCollectionRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public IEntitlementManagementCatalogsCollectionRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public IEntitlementManagementCatalogsCollectionRequest Request(IEnumerable<Option> options)
        {
            return new EntitlementManagementCatalogsCollectionRequest(this.RequestUrl, this.Client, options);
        }

        /// <summary>
        /// Gets an <see cref="IAccessPackageCatalogRequestBuilder"/> for the specified EntitlementManagementAccessPackageCatalog.
        /// </summary>
        /// <param name="id">The ID for the EntitlementManagementAccessPackageCatalog.</param>
        /// <returns>The <see cref="IAccessPackageCatalogRequestBuilder"/>.</returns>
        public IAccessPackageCatalogRequestBuilder this[string id]
        {
            get
            {
                return new AccessPackageCatalogRequestBuilder(this.AppendSegmentToRequestUrl(id), this.Client);
            }
        }

        
    }
}
