// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type EntitlementManagementRequestBuilder.
    /// </summary>
    public partial class EntitlementManagementRequestBuilder : EntityRequestBuilder, IEntitlementManagementRequestBuilder
    {

        /// <summary>
        /// Constructs a new EntitlementManagementRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public EntitlementManagementRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public new IEntitlementManagementRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public new IEntitlementManagementRequest Request(IEnumerable<Option> options)
        {
            return new EntitlementManagementRequest(this.RequestUrl, this.Client, options);
        }
    
        /// <summary>
        /// Gets the request builder for AccessPackageAssignmentApprovals.
        /// </summary>
        /// <returns>The <see cref="IEntitlementManagementAccessPackageAssignmentApprovalsCollectionRequestBuilder"/>.</returns>
        public IEntitlementManagementAccessPackageAssignmentApprovalsCollectionRequestBuilder AccessPackageAssignmentApprovals
        {
            get
            {
                return new EntitlementManagementAccessPackageAssignmentApprovalsCollectionRequestBuilder(this.AppendSegmentToRequestUrl("accessPackageAssignmentApprovals"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for AccessPackages.
        /// </summary>
        /// <returns>The <see cref="IEntitlementManagementAccessPackagesCollectionRequestBuilder"/>.</returns>
        public IEntitlementManagementAccessPackagesCollectionRequestBuilder AccessPackages
        {
            get
            {
                return new EntitlementManagementAccessPackagesCollectionRequestBuilder(this.AppendSegmentToRequestUrl("accessPackages"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for AssignmentRequests.
        /// </summary>
        /// <returns>The <see cref="IEntitlementManagementAssignmentRequestsCollectionRequestBuilder"/>.</returns>
        public IEntitlementManagementAssignmentRequestsCollectionRequestBuilder AssignmentRequests
        {
            get
            {
                return new EntitlementManagementAssignmentRequestsCollectionRequestBuilder(this.AppendSegmentToRequestUrl("assignmentRequests"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for Assignments.
        /// </summary>
        /// <returns>The <see cref="IEntitlementManagementAssignmentsCollectionRequestBuilder"/>.</returns>
        public IEntitlementManagementAssignmentsCollectionRequestBuilder Assignments
        {
            get
            {
                return new EntitlementManagementAssignmentsCollectionRequestBuilder(this.AppendSegmentToRequestUrl("assignments"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for Catalogs.
        /// </summary>
        /// <returns>The <see cref="IEntitlementManagementCatalogsCollectionRequestBuilder"/>.</returns>
        public IEntitlementManagementCatalogsCollectionRequestBuilder Catalogs
        {
            get
            {
                return new EntitlementManagementCatalogsCollectionRequestBuilder(this.AppendSegmentToRequestUrl("catalogs"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for ConnectedOrganizations.
        /// </summary>
        /// <returns>The <see cref="IEntitlementManagementConnectedOrganizationsCollectionRequestBuilder"/>.</returns>
        public IEntitlementManagementConnectedOrganizationsCollectionRequestBuilder ConnectedOrganizations
        {
            get
            {
                return new EntitlementManagementConnectedOrganizationsCollectionRequestBuilder(this.AppendSegmentToRequestUrl("connectedOrganizations"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for Settings.
        /// </summary>
        /// <returns>The <see cref="IEntitlementManagementSettingsRequestBuilder"/>.</returns>
        public IEntitlementManagementSettingsRequestBuilder Settings
        {
            get
            {
                return new EntitlementManagementSettingsRequestBuilder(this.AppendSegmentToRequestUrl("settings"), this.Client);
            }
        }
    
    }
}
