// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityCollectionRequestBuilder.cs.tt
namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// The type GraphServiceCertificateBasedAuthConfigurationCollectionRequestBuilder.
    /// </summary>
    public partial class GraphServiceCertificateBasedAuthConfigurationCollectionRequestBuilder : BaseRequestBuilder, IGraphServiceCertificateBasedAuthConfigurationCollectionRequestBuilder
    {
        /// <summary>
        /// Constructs a new GraphServiceCertificateBasedAuthConfigurationCollectionRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public GraphServiceCertificateBasedAuthConfigurationCollectionRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public IGraphServiceCertificateBasedAuthConfigurationCollectionRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public IGraphServiceCertificateBasedAuthConfigurationCollectionRequest Request(IEnumerable<Option> options)
        {
            return new GraphServiceCertificateBasedAuthConfigurationCollectionRequest(this.RequestUrl, this.Client, options);
        }

        /// <summary>
        /// Gets an <see cref="ICertificateBasedAuthConfigurationRequestBuilder"/> for the specified GraphServiceCertificateBasedAuthConfiguration.
        /// </summary>
        /// <param name="id">The ID for the GraphServiceCertificateBasedAuthConfiguration.</param>
        /// <returns>The <see cref="ICertificateBasedAuthConfigurationRequestBuilder"/>.</returns>
        public ICertificateBasedAuthConfigurationRequestBuilder this[string id]
        {
            get
            {
                return new CertificateBasedAuthConfigurationRequestBuilder(this.AppendSegmentToRequestUrl(id), this.Client);
            }
        }

        
    }
}
