// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityCollectionRequestBuilder.cs.tt
namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// The type GraphServiceSchemaExtensionsCollectionRequestBuilder.
    /// </summary>
    public partial class GraphServiceSchemaExtensionsCollectionRequestBuilder : BaseRequestBuilder, IGraphServiceSchemaExtensionsCollectionRequestBuilder
    {
        /// <summary>
        /// Constructs a new GraphServiceSchemaExtensionsCollectionRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public GraphServiceSchemaExtensionsCollectionRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public IGraphServiceSchemaExtensionsCollectionRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public IGraphServiceSchemaExtensionsCollectionRequest Request(IEnumerable<Option> options)
        {
            return new GraphServiceSchemaExtensionsCollectionRequest(this.RequestUrl, this.Client, options);
        }

        /// <summary>
        /// Gets an <see cref="ISchemaExtensionRequestBuilder"/> for the specified GraphServiceSchemaExtension.
        /// </summary>
        /// <param name="id">The ID for the GraphServiceSchemaExtension.</param>
        /// <returns>The <see cref="ISchemaExtensionRequestBuilder"/>.</returns>
        public ISchemaExtensionRequestBuilder this[string id]
        {
            get
            {
                return new SchemaExtensionRequestBuilder(this.AppendSegmentToRequestUrl(id), this.Client);
            }
        }

        
    }
}
