// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IActivityHistoryItemRequest.
    /// </summary>
    public partial interface IActivityHistoryItemRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified ActivityHistoryItem using POST.
        /// </summary>
        /// <param name="activityHistoryItemToCreate">The ActivityHistoryItem to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created ActivityHistoryItem.</returns>
        System.Threading.Tasks.Task<ActivityHistoryItem> CreateAsync(ActivityHistoryItem activityHistoryItemToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified ActivityHistoryItem using POST and returns a <see cref="GraphResponse{ActivityHistoryItem}"/> object.
        /// </summary>
        /// <param name="activityHistoryItemToCreate">The ActivityHistoryItem to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{ActivityHistoryItem}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<ActivityHistoryItem>> CreateResponseAsync(ActivityHistoryItem activityHistoryItemToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified ActivityHistoryItem.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified ActivityHistoryItem and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified ActivityHistoryItem.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The ActivityHistoryItem.</returns>
        System.Threading.Tasks.Task<ActivityHistoryItem> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified ActivityHistoryItem and returns a <see cref="GraphResponse{ActivityHistoryItem}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{ActivityHistoryItem}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<ActivityHistoryItem>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified ActivityHistoryItem using PATCH.
        /// </summary>
        /// <param name="activityHistoryItemToUpdate">The ActivityHistoryItem to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated ActivityHistoryItem.</returns>
        System.Threading.Tasks.Task<ActivityHistoryItem> UpdateAsync(ActivityHistoryItem activityHistoryItemToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified ActivityHistoryItem using PATCH and returns a <see cref="GraphResponse{ActivityHistoryItem}"/> object.
        /// </summary>
        /// <param name="activityHistoryItemToUpdate">The ActivityHistoryItem to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{ActivityHistoryItem}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<ActivityHistoryItem>> UpdateResponseAsync(ActivityHistoryItem activityHistoryItemToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified ActivityHistoryItem using PUT.
        /// </summary>
        /// <param name="activityHistoryItemToUpdate">The ActivityHistoryItem object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<ActivityHistoryItem> PutAsync(ActivityHistoryItem activityHistoryItemToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified ActivityHistoryItem using PUT and returns a <see cref="GraphResponse{ActivityHistoryItem}"/> object.
        /// </summary>
        /// <param name="activityHistoryItemToUpdate">The ActivityHistoryItem object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{ActivityHistoryItem}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<ActivityHistoryItem>> PutResponseAsync(ActivityHistoryItem activityHistoryItemToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IActivityHistoryItemRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IActivityHistoryItemRequest Expand(Expression<Func<ActivityHistoryItem, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IActivityHistoryItemRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IActivityHistoryItemRequest Select(Expression<Func<ActivityHistoryItem, object>> selectExpression);

    }
}
