// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IAdminRequest.
    /// </summary>
    public partial interface IAdminRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified Admin using POST.
        /// </summary>
        /// <param name="adminToCreate">The Admin to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created Admin.</returns>
        System.Threading.Tasks.Task<Admin> CreateAsync(Admin adminToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified Admin using POST and returns a <see cref="GraphResponse{Admin}"/> object.
        /// </summary>
        /// <param name="adminToCreate">The Admin to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{Admin}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<Admin>> CreateResponseAsync(Admin adminToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified Admin.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified Admin and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified Admin.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The Admin.</returns>
        System.Threading.Tasks.Task<Admin> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified Admin and returns a <see cref="GraphResponse{Admin}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{Admin}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<Admin>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified Admin using PATCH.
        /// </summary>
        /// <param name="adminToUpdate">The Admin to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated Admin.</returns>
        System.Threading.Tasks.Task<Admin> UpdateAsync(Admin adminToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified Admin using PATCH and returns a <see cref="GraphResponse{Admin}"/> object.
        /// </summary>
        /// <param name="adminToUpdate">The Admin to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{Admin}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<Admin>> UpdateResponseAsync(Admin adminToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified Admin using PUT.
        /// </summary>
        /// <param name="adminToUpdate">The Admin object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<Admin> PutAsync(Admin adminToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified Admin using PUT and returns a <see cref="GraphResponse{Admin}"/> object.
        /// </summary>
        /// <param name="adminToUpdate">The Admin object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{Admin}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<Admin>> PutResponseAsync(Admin adminToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IAdminRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IAdminRequest Expand(Expression<Func<Admin, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IAdminRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IAdminRequest Select(Expression<Func<Admin, object>> selectExpression);

    }
}
