// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IAgreementAcceptanceRequest.
    /// </summary>
    public partial interface IAgreementAcceptanceRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified AgreementAcceptance using POST.
        /// </summary>
        /// <param name="agreementAcceptanceToCreate">The AgreementAcceptance to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created AgreementAcceptance.</returns>
        System.Threading.Tasks.Task<AgreementAcceptance> CreateAsync(AgreementAcceptance agreementAcceptanceToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified AgreementAcceptance using POST and returns a <see cref="GraphResponse{AgreementAcceptance}"/> object.
        /// </summary>
        /// <param name="agreementAcceptanceToCreate">The AgreementAcceptance to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{AgreementAcceptance}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<AgreementAcceptance>> CreateResponseAsync(AgreementAcceptance agreementAcceptanceToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified AgreementAcceptance.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified AgreementAcceptance and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified AgreementAcceptance.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The AgreementAcceptance.</returns>
        System.Threading.Tasks.Task<AgreementAcceptance> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified AgreementAcceptance and returns a <see cref="GraphResponse{AgreementAcceptance}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{AgreementAcceptance}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<AgreementAcceptance>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified AgreementAcceptance using PATCH.
        /// </summary>
        /// <param name="agreementAcceptanceToUpdate">The AgreementAcceptance to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated AgreementAcceptance.</returns>
        System.Threading.Tasks.Task<AgreementAcceptance> UpdateAsync(AgreementAcceptance agreementAcceptanceToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified AgreementAcceptance using PATCH and returns a <see cref="GraphResponse{AgreementAcceptance}"/> object.
        /// </summary>
        /// <param name="agreementAcceptanceToUpdate">The AgreementAcceptance to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{AgreementAcceptance}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<AgreementAcceptance>> UpdateResponseAsync(AgreementAcceptance agreementAcceptanceToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified AgreementAcceptance using PUT.
        /// </summary>
        /// <param name="agreementAcceptanceToUpdate">The AgreementAcceptance object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<AgreementAcceptance> PutAsync(AgreementAcceptance agreementAcceptanceToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified AgreementAcceptance using PUT and returns a <see cref="GraphResponse{AgreementAcceptance}"/> object.
        /// </summary>
        /// <param name="agreementAcceptanceToUpdate">The AgreementAcceptance object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{AgreementAcceptance}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<AgreementAcceptance>> PutResponseAsync(AgreementAcceptance agreementAcceptanceToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IAgreementAcceptanceRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IAgreementAcceptanceRequest Expand(Expression<Func<AgreementAcceptance, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IAgreementAcceptanceRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IAgreementAcceptanceRequest Select(Expression<Func<AgreementAcceptance, object>> selectExpression);

    }
}
