// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IAndroidManagedAppProtectionRequest.
    /// </summary>
    public partial interface IAndroidManagedAppProtectionRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified AndroidManagedAppProtection using POST.
        /// </summary>
        /// <param name="androidManagedAppProtectionToCreate">The AndroidManagedAppProtection to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created AndroidManagedAppProtection.</returns>
        System.Threading.Tasks.Task<AndroidManagedAppProtection> CreateAsync(AndroidManagedAppProtection androidManagedAppProtectionToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified AndroidManagedAppProtection using POST and returns a <see cref="GraphResponse{AndroidManagedAppProtection}"/> object.
        /// </summary>
        /// <param name="androidManagedAppProtectionToCreate">The AndroidManagedAppProtection to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{AndroidManagedAppProtection}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<AndroidManagedAppProtection>> CreateResponseAsync(AndroidManagedAppProtection androidManagedAppProtectionToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified AndroidManagedAppProtection.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified AndroidManagedAppProtection and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified AndroidManagedAppProtection.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The AndroidManagedAppProtection.</returns>
        System.Threading.Tasks.Task<AndroidManagedAppProtection> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified AndroidManagedAppProtection and returns a <see cref="GraphResponse{AndroidManagedAppProtection}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{AndroidManagedAppProtection}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<AndroidManagedAppProtection>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified AndroidManagedAppProtection using PATCH.
        /// </summary>
        /// <param name="androidManagedAppProtectionToUpdate">The AndroidManagedAppProtection to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated AndroidManagedAppProtection.</returns>
        System.Threading.Tasks.Task<AndroidManagedAppProtection> UpdateAsync(AndroidManagedAppProtection androidManagedAppProtectionToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified AndroidManagedAppProtection using PATCH and returns a <see cref="GraphResponse{AndroidManagedAppProtection}"/> object.
        /// </summary>
        /// <param name="androidManagedAppProtectionToUpdate">The AndroidManagedAppProtection to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{AndroidManagedAppProtection}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<AndroidManagedAppProtection>> UpdateResponseAsync(AndroidManagedAppProtection androidManagedAppProtectionToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified AndroidManagedAppProtection using PUT.
        /// </summary>
        /// <param name="androidManagedAppProtectionToUpdate">The AndroidManagedAppProtection object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<AndroidManagedAppProtection> PutAsync(AndroidManagedAppProtection androidManagedAppProtectionToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified AndroidManagedAppProtection using PUT and returns a <see cref="GraphResponse{AndroidManagedAppProtection}"/> object.
        /// </summary>
        /// <param name="androidManagedAppProtectionToUpdate">The AndroidManagedAppProtection object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{AndroidManagedAppProtection}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<AndroidManagedAppProtection>> PutResponseAsync(AndroidManagedAppProtection androidManagedAppProtectionToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IAndroidManagedAppProtectionRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IAndroidManagedAppProtectionRequest Expand(Expression<Func<AndroidManagedAppProtection, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IAndroidManagedAppProtectionRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IAndroidManagedAppProtectionRequest Select(Expression<Func<AndroidManagedAppProtection, object>> selectExpression);

    }
}
