// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IAndroidWorkProfileCompliancePolicyRequest.
    /// </summary>
    public partial interface IAndroidWorkProfileCompliancePolicyRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified AndroidWorkProfileCompliancePolicy using POST.
        /// </summary>
        /// <param name="androidWorkProfileCompliancePolicyToCreate">The AndroidWorkProfileCompliancePolicy to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created AndroidWorkProfileCompliancePolicy.</returns>
        System.Threading.Tasks.Task<AndroidWorkProfileCompliancePolicy> CreateAsync(AndroidWorkProfileCompliancePolicy androidWorkProfileCompliancePolicyToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified AndroidWorkProfileCompliancePolicy using POST and returns a <see cref="GraphResponse{AndroidWorkProfileCompliancePolicy}"/> object.
        /// </summary>
        /// <param name="androidWorkProfileCompliancePolicyToCreate">The AndroidWorkProfileCompliancePolicy to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{AndroidWorkProfileCompliancePolicy}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<AndroidWorkProfileCompliancePolicy>> CreateResponseAsync(AndroidWorkProfileCompliancePolicy androidWorkProfileCompliancePolicyToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified AndroidWorkProfileCompliancePolicy.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified AndroidWorkProfileCompliancePolicy and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified AndroidWorkProfileCompliancePolicy.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The AndroidWorkProfileCompliancePolicy.</returns>
        System.Threading.Tasks.Task<AndroidWorkProfileCompliancePolicy> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified AndroidWorkProfileCompliancePolicy and returns a <see cref="GraphResponse{AndroidWorkProfileCompliancePolicy}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{AndroidWorkProfileCompliancePolicy}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<AndroidWorkProfileCompliancePolicy>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified AndroidWorkProfileCompliancePolicy using PATCH.
        /// </summary>
        /// <param name="androidWorkProfileCompliancePolicyToUpdate">The AndroidWorkProfileCompliancePolicy to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated AndroidWorkProfileCompliancePolicy.</returns>
        System.Threading.Tasks.Task<AndroidWorkProfileCompliancePolicy> UpdateAsync(AndroidWorkProfileCompliancePolicy androidWorkProfileCompliancePolicyToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified AndroidWorkProfileCompliancePolicy using PATCH and returns a <see cref="GraphResponse{AndroidWorkProfileCompliancePolicy}"/> object.
        /// </summary>
        /// <param name="androidWorkProfileCompliancePolicyToUpdate">The AndroidWorkProfileCompliancePolicy to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{AndroidWorkProfileCompliancePolicy}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<AndroidWorkProfileCompliancePolicy>> UpdateResponseAsync(AndroidWorkProfileCompliancePolicy androidWorkProfileCompliancePolicyToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified AndroidWorkProfileCompliancePolicy using PUT.
        /// </summary>
        /// <param name="androidWorkProfileCompliancePolicyToUpdate">The AndroidWorkProfileCompliancePolicy object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<AndroidWorkProfileCompliancePolicy> PutAsync(AndroidWorkProfileCompliancePolicy androidWorkProfileCompliancePolicyToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified AndroidWorkProfileCompliancePolicy using PUT and returns a <see cref="GraphResponse{AndroidWorkProfileCompliancePolicy}"/> object.
        /// </summary>
        /// <param name="androidWorkProfileCompliancePolicyToUpdate">The AndroidWorkProfileCompliancePolicy object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{AndroidWorkProfileCompliancePolicy}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<AndroidWorkProfileCompliancePolicy>> PutResponseAsync(AndroidWorkProfileCompliancePolicy androidWorkProfileCompliancePolicyToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IAndroidWorkProfileCompliancePolicyRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IAndroidWorkProfileCompliancePolicyRequest Expand(Expression<Func<AndroidWorkProfileCompliancePolicy, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IAndroidWorkProfileCompliancePolicyRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IAndroidWorkProfileCompliancePolicyRequest Select(Expression<Func<AndroidWorkProfileCompliancePolicy, object>> selectExpression);

    }
}
