// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityCollectionRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IAuditLogRootDirectoryAuditsCollectionRequest.
    /// </summary>
    public partial interface IAuditLogRootDirectoryAuditsCollectionRequest : IBaseRequest
    {
        /// <summary>
        /// Adds the specified DirectoryAudit to the collection via POST.
        /// </summary>
        /// <param name="directoryAudit">The DirectoryAudit to add.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created DirectoryAudit.</returns>
        System.Threading.Tasks.Task<DirectoryAudit> AddAsync(DirectoryAudit directoryAudit, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified DirectoryAudit to the collection via POST and returns a <see cref="GraphResponse{DirectoryAudit}"/> object of the request.
        /// </summary>
        /// <param name="directoryAudit">The DirectoryAudit to add.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{DirectoryAudit}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<DirectoryAudit>> AddResponseAsync(DirectoryAudit directoryAudit, CancellationToken cancellationToken = default);


        /// <summary>
        /// Gets the collection page.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The collection page.</returns>
        System.Threading.Tasks.Task<IAuditLogRootDirectoryAuditsCollectionPage> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the collection page and returns a <see cref="GraphResponse{AuditLogRootDirectoryAuditsCollectionResponse}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{AuditLogRootDirectoryAuditsCollectionResponse}"/> object.</returns>
        System.Threading.Tasks.Task<GraphResponse<AuditLogRootDirectoryAuditsCollectionResponse>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IAuditLogRootDirectoryAuditsCollectionRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IAuditLogRootDirectoryAuditsCollectionRequest Expand(Expression<Func<DirectoryAudit, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IAuditLogRootDirectoryAuditsCollectionRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IAuditLogRootDirectoryAuditsCollectionRequest Select(Expression<Func<DirectoryAudit, object>> selectExpression);

        /// <summary>
        /// Adds the specified top value to the request.
        /// </summary>
        /// <param name="value">The top value.</param>
        /// <returns>The request object to send.</returns>
        IAuditLogRootDirectoryAuditsCollectionRequest Top(int value);

        /// <summary>
        /// Adds the specified filter value to the request.
        /// </summary>
        /// <param name="value">The filter value.</param>
        /// <returns>The request object to send.</returns>
        IAuditLogRootDirectoryAuditsCollectionRequest Filter(string value);

        /// <summary>
        /// Adds the specified skip value to the request.
        /// </summary>
        /// <param name="value">The skip value.</param>
        /// <returns>The request object to send.</returns>
        IAuditLogRootDirectoryAuditsCollectionRequest Skip(int value);

        /// <summary>
        /// Adds the specified orderby value to the request.
        /// </summary>
        /// <param name="value">The orderby value.</param>
        /// <returns>The request object to send.</returns>
        IAuditLogRootDirectoryAuditsCollectionRequest OrderBy(string value);
    }
}
