// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IAuthoredNoteRequest.
    /// </summary>
    public partial interface IAuthoredNoteRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified AuthoredNote using POST.
        /// </summary>
        /// <param name="authoredNoteToCreate">The AuthoredNote to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created AuthoredNote.</returns>
        System.Threading.Tasks.Task<AuthoredNote> CreateAsync(AuthoredNote authoredNoteToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified AuthoredNote using POST and returns a <see cref="GraphResponse{AuthoredNote}"/> object.
        /// </summary>
        /// <param name="authoredNoteToCreate">The AuthoredNote to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{AuthoredNote}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<AuthoredNote>> CreateResponseAsync(AuthoredNote authoredNoteToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified AuthoredNote.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified AuthoredNote and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified AuthoredNote.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The AuthoredNote.</returns>
        System.Threading.Tasks.Task<AuthoredNote> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified AuthoredNote and returns a <see cref="GraphResponse{AuthoredNote}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{AuthoredNote}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<AuthoredNote>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified AuthoredNote using PATCH.
        /// </summary>
        /// <param name="authoredNoteToUpdate">The AuthoredNote to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated AuthoredNote.</returns>
        System.Threading.Tasks.Task<AuthoredNote> UpdateAsync(AuthoredNote authoredNoteToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified AuthoredNote using PATCH and returns a <see cref="GraphResponse{AuthoredNote}"/> object.
        /// </summary>
        /// <param name="authoredNoteToUpdate">The AuthoredNote to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{AuthoredNote}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<AuthoredNote>> UpdateResponseAsync(AuthoredNote authoredNoteToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified AuthoredNote using PUT.
        /// </summary>
        /// <param name="authoredNoteToUpdate">The AuthoredNote object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<AuthoredNote> PutAsync(AuthoredNote authoredNoteToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified AuthoredNote using PUT and returns a <see cref="GraphResponse{AuthoredNote}"/> object.
        /// </summary>
        /// <param name="authoredNoteToUpdate">The AuthoredNote object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{AuthoredNote}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<AuthoredNote>> PutResponseAsync(AuthoredNote authoredNoteToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IAuthoredNoteRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IAuthoredNoteRequest Expand(Expression<Func<AuthoredNote, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IAuthoredNoteRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IAuthoredNoteRequest Select(Expression<Func<AuthoredNote, object>> selectExpression);

    }
}
