// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IBookingCustomQuestionRequest.
    /// </summary>
    public partial interface IBookingCustomQuestionRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified BookingCustomQuestion using POST.
        /// </summary>
        /// <param name="bookingCustomQuestionToCreate">The BookingCustomQuestion to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created BookingCustomQuestion.</returns>
        System.Threading.Tasks.Task<BookingCustomQuestion> CreateAsync(BookingCustomQuestion bookingCustomQuestionToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified BookingCustomQuestion using POST and returns a <see cref="GraphResponse{BookingCustomQuestion}"/> object.
        /// </summary>
        /// <param name="bookingCustomQuestionToCreate">The BookingCustomQuestion to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{BookingCustomQuestion}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<BookingCustomQuestion>> CreateResponseAsync(BookingCustomQuestion bookingCustomQuestionToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified BookingCustomQuestion.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified BookingCustomQuestion and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified BookingCustomQuestion.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The BookingCustomQuestion.</returns>
        System.Threading.Tasks.Task<BookingCustomQuestion> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified BookingCustomQuestion and returns a <see cref="GraphResponse{BookingCustomQuestion}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{BookingCustomQuestion}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<BookingCustomQuestion>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified BookingCustomQuestion using PATCH.
        /// </summary>
        /// <param name="bookingCustomQuestionToUpdate">The BookingCustomQuestion to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated BookingCustomQuestion.</returns>
        System.Threading.Tasks.Task<BookingCustomQuestion> UpdateAsync(BookingCustomQuestion bookingCustomQuestionToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified BookingCustomQuestion using PATCH and returns a <see cref="GraphResponse{BookingCustomQuestion}"/> object.
        /// </summary>
        /// <param name="bookingCustomQuestionToUpdate">The BookingCustomQuestion to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{BookingCustomQuestion}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<BookingCustomQuestion>> UpdateResponseAsync(BookingCustomQuestion bookingCustomQuestionToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified BookingCustomQuestion using PUT.
        /// </summary>
        /// <param name="bookingCustomQuestionToUpdate">The BookingCustomQuestion object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<BookingCustomQuestion> PutAsync(BookingCustomQuestion bookingCustomQuestionToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified BookingCustomQuestion using PUT and returns a <see cref="GraphResponse{BookingCustomQuestion}"/> object.
        /// </summary>
        /// <param name="bookingCustomQuestionToUpdate">The BookingCustomQuestion object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{BookingCustomQuestion}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<BookingCustomQuestion>> PutResponseAsync(BookingCustomQuestion bookingCustomQuestionToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IBookingCustomQuestionRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IBookingCustomQuestionRequest Expand(Expression<Func<BookingCustomQuestion, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IBookingCustomQuestionRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IBookingCustomQuestionRequest Select(Expression<Func<BookingCustomQuestion, object>> selectExpression);

    }
}
