// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The interface IChatRequestBuilder.
    /// </summary>
    public partial interface IChatRequestBuilder : IEntityRequestBuilder
    {
        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        new IChatRequest Request();

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        new IChatRequest Request(IEnumerable<Option> options);
    
        /// <summary>
        /// Gets the request builder for InstalledApps.
        /// </summary>
        /// <returns>The <see cref="IChatInstalledAppsCollectionRequestBuilder"/>.</returns>
        IChatInstalledAppsCollectionRequestBuilder InstalledApps { get; }

        /// <summary>
        /// Gets the request builder for Members.
        /// </summary>
        /// <returns>The <see cref="IChatMembersCollectionRequestBuilder"/>.</returns>
        IChatMembersCollectionRequestBuilder Members { get; }

        /// <summary>
        /// Gets the request builder for Messages.
        /// </summary>
        /// <returns>The <see cref="IChatMessagesCollectionRequestBuilder"/>.</returns>
        IChatMessagesCollectionRequestBuilder Messages { get; }

        /// <summary>
        /// Gets the request builder for Tabs.
        /// </summary>
        /// <returns>The <see cref="IChatTabsCollectionRequestBuilder"/>.</returns>
        IChatTabsCollectionRequestBuilder Tabs { get; }
    
        /// <summary>
        /// Gets the request builder for ChatSendActivityNotification.
        /// </summary>
        /// <returns>The <see cref="IChatSendActivityNotificationRequestBuilder"/>.</returns>
        IChatSendActivityNotificationRequestBuilder SendActivityNotification(
            TeamworkActivityTopic topic = null,
            string activityType = null,
            Int64? chainId = null,
            ItemBody previewText = null,
            IEnumerable<KeyValuePair> templateParameters = null,
            TeamworkNotificationRecipient recipient = null);
    
    }
}
