// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IComplianceManagementPartnerRequest.
    /// </summary>
    public partial interface IComplianceManagementPartnerRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified ComplianceManagementPartner using POST.
        /// </summary>
        /// <param name="complianceManagementPartnerToCreate">The ComplianceManagementPartner to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created ComplianceManagementPartner.</returns>
        System.Threading.Tasks.Task<ComplianceManagementPartner> CreateAsync(ComplianceManagementPartner complianceManagementPartnerToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified ComplianceManagementPartner using POST and returns a <see cref="GraphResponse{ComplianceManagementPartner}"/> object.
        /// </summary>
        /// <param name="complianceManagementPartnerToCreate">The ComplianceManagementPartner to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{ComplianceManagementPartner}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<ComplianceManagementPartner>> CreateResponseAsync(ComplianceManagementPartner complianceManagementPartnerToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified ComplianceManagementPartner.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified ComplianceManagementPartner and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified ComplianceManagementPartner.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The ComplianceManagementPartner.</returns>
        System.Threading.Tasks.Task<ComplianceManagementPartner> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified ComplianceManagementPartner and returns a <see cref="GraphResponse{ComplianceManagementPartner}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{ComplianceManagementPartner}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<ComplianceManagementPartner>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified ComplianceManagementPartner using PATCH.
        /// </summary>
        /// <param name="complianceManagementPartnerToUpdate">The ComplianceManagementPartner to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated ComplianceManagementPartner.</returns>
        System.Threading.Tasks.Task<ComplianceManagementPartner> UpdateAsync(ComplianceManagementPartner complianceManagementPartnerToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified ComplianceManagementPartner using PATCH and returns a <see cref="GraphResponse{ComplianceManagementPartner}"/> object.
        /// </summary>
        /// <param name="complianceManagementPartnerToUpdate">The ComplianceManagementPartner to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{ComplianceManagementPartner}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<ComplianceManagementPartner>> UpdateResponseAsync(ComplianceManagementPartner complianceManagementPartnerToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified ComplianceManagementPartner using PUT.
        /// </summary>
        /// <param name="complianceManagementPartnerToUpdate">The ComplianceManagementPartner object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<ComplianceManagementPartner> PutAsync(ComplianceManagementPartner complianceManagementPartnerToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified ComplianceManagementPartner using PUT and returns a <see cref="GraphResponse{ComplianceManagementPartner}"/> object.
        /// </summary>
        /// <param name="complianceManagementPartnerToUpdate">The ComplianceManagementPartner object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{ComplianceManagementPartner}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<ComplianceManagementPartner>> PutResponseAsync(ComplianceManagementPartner complianceManagementPartnerToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IComplianceManagementPartnerRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IComplianceManagementPartnerRequest Expand(Expression<Func<ComplianceManagementPartner, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IComplianceManagementPartnerRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IComplianceManagementPartnerRequest Select(Expression<Func<ComplianceManagementPartner, object>> selectExpression);

    }
}
