// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IComplianceRequest.
    /// </summary>
    public partial interface IComplianceRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified Compliance using POST.
        /// </summary>
        /// <param name="complianceToCreate">The Compliance to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created Compliance.</returns>
        System.Threading.Tasks.Task<Compliance> CreateAsync(Compliance complianceToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified Compliance using POST and returns a <see cref="GraphResponse{Compliance}"/> object.
        /// </summary>
        /// <param name="complianceToCreate">The Compliance to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{Compliance}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<Compliance>> CreateResponseAsync(Compliance complianceToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified Compliance.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified Compliance and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified Compliance.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The Compliance.</returns>
        System.Threading.Tasks.Task<Compliance> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified Compliance and returns a <see cref="GraphResponse{Compliance}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{Compliance}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<Compliance>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified Compliance using PATCH.
        /// </summary>
        /// <param name="complianceToUpdate">The Compliance to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated Compliance.</returns>
        System.Threading.Tasks.Task<Compliance> UpdateAsync(Compliance complianceToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified Compliance using PATCH and returns a <see cref="GraphResponse{Compliance}"/> object.
        /// </summary>
        /// <param name="complianceToUpdate">The Compliance to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{Compliance}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<Compliance>> UpdateResponseAsync(Compliance complianceToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified Compliance using PUT.
        /// </summary>
        /// <param name="complianceToUpdate">The Compliance object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<Compliance> PutAsync(Compliance complianceToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified Compliance using PUT and returns a <see cref="GraphResponse{Compliance}"/> object.
        /// </summary>
        /// <param name="complianceToUpdate">The Compliance object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{Compliance}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<Compliance>> PutResponseAsync(Compliance complianceToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IComplianceRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IComplianceRequest Expand(Expression<Func<Compliance, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IComplianceRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IComplianceRequest Select(Expression<Func<Compliance, object>> selectExpression);

    }
}
