// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IConditionalAccessRootRequest.
    /// </summary>
    public partial interface IConditionalAccessRootRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified ConditionalAccessRoot using POST.
        /// </summary>
        /// <param name="conditionalAccessRootToCreate">The ConditionalAccessRoot to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created ConditionalAccessRoot.</returns>
        System.Threading.Tasks.Task<ConditionalAccessRoot> CreateAsync(ConditionalAccessRoot conditionalAccessRootToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified ConditionalAccessRoot using POST and returns a <see cref="GraphResponse{ConditionalAccessRoot}"/> object.
        /// </summary>
        /// <param name="conditionalAccessRootToCreate">The ConditionalAccessRoot to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{ConditionalAccessRoot}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<ConditionalAccessRoot>> CreateResponseAsync(ConditionalAccessRoot conditionalAccessRootToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified ConditionalAccessRoot.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified ConditionalAccessRoot and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified ConditionalAccessRoot.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The ConditionalAccessRoot.</returns>
        System.Threading.Tasks.Task<ConditionalAccessRoot> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified ConditionalAccessRoot and returns a <see cref="GraphResponse{ConditionalAccessRoot}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{ConditionalAccessRoot}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<ConditionalAccessRoot>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified ConditionalAccessRoot using PATCH.
        /// </summary>
        /// <param name="conditionalAccessRootToUpdate">The ConditionalAccessRoot to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated ConditionalAccessRoot.</returns>
        System.Threading.Tasks.Task<ConditionalAccessRoot> UpdateAsync(ConditionalAccessRoot conditionalAccessRootToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified ConditionalAccessRoot using PATCH and returns a <see cref="GraphResponse{ConditionalAccessRoot}"/> object.
        /// </summary>
        /// <param name="conditionalAccessRootToUpdate">The ConditionalAccessRoot to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{ConditionalAccessRoot}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<ConditionalAccessRoot>> UpdateResponseAsync(ConditionalAccessRoot conditionalAccessRootToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified ConditionalAccessRoot using PUT.
        /// </summary>
        /// <param name="conditionalAccessRootToUpdate">The ConditionalAccessRoot object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<ConditionalAccessRoot> PutAsync(ConditionalAccessRoot conditionalAccessRootToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified ConditionalAccessRoot using PUT and returns a <see cref="GraphResponse{ConditionalAccessRoot}"/> object.
        /// </summary>
        /// <param name="conditionalAccessRootToUpdate">The ConditionalAccessRoot object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{ConditionalAccessRoot}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<ConditionalAccessRoot>> PutResponseAsync(ConditionalAccessRoot conditionalAccessRootToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IConditionalAccessRootRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IConditionalAccessRootRequest Expand(Expression<Func<ConditionalAccessRoot, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IConditionalAccessRootRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IConditionalAccessRootRequest Select(Expression<Func<ConditionalAccessRoot, object>> selectExpression);

    }
}
