// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IDeviceCategoryRequest.
    /// </summary>
    public partial interface IDeviceCategoryRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified DeviceCategory using POST.
        /// </summary>
        /// <param name="deviceCategoryToCreate">The DeviceCategory to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created DeviceCategory.</returns>
        System.Threading.Tasks.Task<DeviceCategory> CreateAsync(DeviceCategory deviceCategoryToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified DeviceCategory using POST and returns a <see cref="GraphResponse{DeviceCategory}"/> object.
        /// </summary>
        /// <param name="deviceCategoryToCreate">The DeviceCategory to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{DeviceCategory}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<DeviceCategory>> CreateResponseAsync(DeviceCategory deviceCategoryToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified DeviceCategory.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified DeviceCategory and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified DeviceCategory.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The DeviceCategory.</returns>
        System.Threading.Tasks.Task<DeviceCategory> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified DeviceCategory and returns a <see cref="GraphResponse{DeviceCategory}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{DeviceCategory}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<DeviceCategory>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified DeviceCategory using PATCH.
        /// </summary>
        /// <param name="deviceCategoryToUpdate">The DeviceCategory to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated DeviceCategory.</returns>
        System.Threading.Tasks.Task<DeviceCategory> UpdateAsync(DeviceCategory deviceCategoryToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified DeviceCategory using PATCH and returns a <see cref="GraphResponse{DeviceCategory}"/> object.
        /// </summary>
        /// <param name="deviceCategoryToUpdate">The DeviceCategory to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{DeviceCategory}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<DeviceCategory>> UpdateResponseAsync(DeviceCategory deviceCategoryToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified DeviceCategory using PUT.
        /// </summary>
        /// <param name="deviceCategoryToUpdate">The DeviceCategory object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<DeviceCategory> PutAsync(DeviceCategory deviceCategoryToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified DeviceCategory using PUT and returns a <see cref="GraphResponse{DeviceCategory}"/> object.
        /// </summary>
        /// <param name="deviceCategoryToUpdate">The DeviceCategory object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{DeviceCategory}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<DeviceCategory>> PutResponseAsync(DeviceCategory deviceCategoryToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IDeviceCategoryRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IDeviceCategoryRequest Expand(Expression<Func<DeviceCategory, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IDeviceCategoryRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IDeviceCategoryRequest Select(Expression<Func<DeviceCategory, object>> selectExpression);

    }
}
