// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The interface IDeviceCompliancePolicyRequestBuilder.
    /// </summary>
    public partial interface IDeviceCompliancePolicyRequestBuilder : IEntityRequestBuilder
    {
        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        new IDeviceCompliancePolicyRequest Request();

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        new IDeviceCompliancePolicyRequest Request(IEnumerable<Option> options);
    
        /// <summary>
        /// Gets the request builder for Assignments.
        /// </summary>
        /// <returns>The <see cref="IDeviceCompliancePolicyAssignmentsCollectionRequestBuilder"/>.</returns>
        IDeviceCompliancePolicyAssignmentsCollectionRequestBuilder Assignments { get; }

        /// <summary>
        /// Gets the request builder for DeviceSettingStateSummaries.
        /// </summary>
        /// <returns>The <see cref="IDeviceCompliancePolicyDeviceSettingStateSummariesCollectionRequestBuilder"/>.</returns>
        IDeviceCompliancePolicyDeviceSettingStateSummariesCollectionRequestBuilder DeviceSettingStateSummaries { get; }

        /// <summary>
        /// Gets the request builder for DeviceStatuses.
        /// </summary>
        /// <returns>The <see cref="IDeviceCompliancePolicyDeviceStatusesCollectionRequestBuilder"/>.</returns>
        IDeviceCompliancePolicyDeviceStatusesCollectionRequestBuilder DeviceStatuses { get; }

        /// <summary>
        /// Gets the request builder for DeviceStatusOverview.
        /// </summary>
        /// <returns>The <see cref="IDeviceComplianceDeviceOverviewRequestBuilder"/>.</returns>
        IDeviceComplianceDeviceOverviewRequestBuilder DeviceStatusOverview { get; }

        /// <summary>
        /// Gets the request builder for ScheduledActionsForRule.
        /// </summary>
        /// <returns>The <see cref="IDeviceCompliancePolicyScheduledActionsForRuleCollectionRequestBuilder"/>.</returns>
        IDeviceCompliancePolicyScheduledActionsForRuleCollectionRequestBuilder ScheduledActionsForRule { get; }

        /// <summary>
        /// Gets the request builder for UserStatuses.
        /// </summary>
        /// <returns>The <see cref="IDeviceCompliancePolicyUserStatusesCollectionRequestBuilder"/>.</returns>
        IDeviceCompliancePolicyUserStatusesCollectionRequestBuilder UserStatuses { get; }

        /// <summary>
        /// Gets the request builder for UserStatusOverview.
        /// </summary>
        /// <returns>The <see cref="IDeviceComplianceUserOverviewRequestBuilder"/>.</returns>
        IDeviceComplianceUserOverviewRequestBuilder UserStatusOverview { get; }
    
        /// <summary>
        /// Gets the request builder for DeviceCompliancePolicyAssign.
        /// </summary>
        /// <returns>The <see cref="IDeviceCompliancePolicyAssignRequestBuilder"/>.</returns>
        IDeviceCompliancePolicyAssignRequestBuilder Assign(
            IEnumerable<DeviceCompliancePolicyAssignment> assignments = null);

        /// <summary>
        /// Gets the request builder for DeviceCompliancePolicyScheduleActionsForRules.
        /// </summary>
        /// <returns>The <see cref="IDeviceCompliancePolicyScheduleActionsForRulesRequestBuilder"/>.</returns>
        IDeviceCompliancePolicyScheduleActionsForRulesRequestBuilder ScheduleActionsForRules(
            IEnumerable<DeviceComplianceScheduledActionForRule> deviceComplianceScheduledActionForRules = null);
    
    }
}
