// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IDeviceCompliancePolicyStateRequest.
    /// </summary>
    public partial interface IDeviceCompliancePolicyStateRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified DeviceCompliancePolicyState using POST.
        /// </summary>
        /// <param name="deviceCompliancePolicyStateToCreate">The DeviceCompliancePolicyState to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created DeviceCompliancePolicyState.</returns>
        System.Threading.Tasks.Task<DeviceCompliancePolicyState> CreateAsync(DeviceCompliancePolicyState deviceCompliancePolicyStateToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified DeviceCompliancePolicyState using POST and returns a <see cref="GraphResponse{DeviceCompliancePolicyState}"/> object.
        /// </summary>
        /// <param name="deviceCompliancePolicyStateToCreate">The DeviceCompliancePolicyState to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{DeviceCompliancePolicyState}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<DeviceCompliancePolicyState>> CreateResponseAsync(DeviceCompliancePolicyState deviceCompliancePolicyStateToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified DeviceCompliancePolicyState.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified DeviceCompliancePolicyState and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified DeviceCompliancePolicyState.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The DeviceCompliancePolicyState.</returns>
        System.Threading.Tasks.Task<DeviceCompliancePolicyState> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified DeviceCompliancePolicyState and returns a <see cref="GraphResponse{DeviceCompliancePolicyState}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{DeviceCompliancePolicyState}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<DeviceCompliancePolicyState>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified DeviceCompliancePolicyState using PATCH.
        /// </summary>
        /// <param name="deviceCompliancePolicyStateToUpdate">The DeviceCompliancePolicyState to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated DeviceCompliancePolicyState.</returns>
        System.Threading.Tasks.Task<DeviceCompliancePolicyState> UpdateAsync(DeviceCompliancePolicyState deviceCompliancePolicyStateToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified DeviceCompliancePolicyState using PATCH and returns a <see cref="GraphResponse{DeviceCompliancePolicyState}"/> object.
        /// </summary>
        /// <param name="deviceCompliancePolicyStateToUpdate">The DeviceCompliancePolicyState to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{DeviceCompliancePolicyState}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<DeviceCompliancePolicyState>> UpdateResponseAsync(DeviceCompliancePolicyState deviceCompliancePolicyStateToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified DeviceCompliancePolicyState using PUT.
        /// </summary>
        /// <param name="deviceCompliancePolicyStateToUpdate">The DeviceCompliancePolicyState object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<DeviceCompliancePolicyState> PutAsync(DeviceCompliancePolicyState deviceCompliancePolicyStateToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified DeviceCompliancePolicyState using PUT and returns a <see cref="GraphResponse{DeviceCompliancePolicyState}"/> object.
        /// </summary>
        /// <param name="deviceCompliancePolicyStateToUpdate">The DeviceCompliancePolicyState object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{DeviceCompliancePolicyState}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<DeviceCompliancePolicyState>> PutResponseAsync(DeviceCompliancePolicyState deviceCompliancePolicyStateToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IDeviceCompliancePolicyStateRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IDeviceCompliancePolicyStateRequest Expand(Expression<Func<DeviceCompliancePolicyState, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IDeviceCompliancePolicyStateRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IDeviceCompliancePolicyStateRequest Select(Expression<Func<DeviceCompliancePolicyState, object>> selectExpression);

    }
}
