// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The interface IDeviceManagementReportsRequestBuilder.
    /// </summary>
    public partial interface IDeviceManagementReportsRequestBuilder : IEntityRequestBuilder
    {
        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        new IDeviceManagementReportsRequest Request();

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        new IDeviceManagementReportsRequest Request(IEnumerable<Option> options);
    
        /// <summary>
        /// Gets the request builder for ExportJobs.
        /// </summary>
        /// <returns>The <see cref="IDeviceManagementReportsExportJobsCollectionRequestBuilder"/>.</returns>
        IDeviceManagementReportsExportJobsCollectionRequestBuilder ExportJobs { get; }
    
        /// <summary>
        /// Gets the request builder for DeviceManagementReportsGetCachedReport.
        /// </summary>
        /// <returns>The <see cref="IDeviceManagementReportsGetCachedReportRequestBuilder"/>.</returns>
        IDeviceManagementReportsGetCachedReportRequestBuilder GetCachedReport(
            string id = null,
            IEnumerable<string> select = null,
            string search = null,
            IEnumerable<string> groupBy = null,
            IEnumerable<string> orderBy = null,
            Int32? skip = null,
            Int32? top = null);

        /// <summary>
        /// Gets the request builder for DeviceManagementReportsGetCompliancePolicyNonComplianceReport.
        /// </summary>
        /// <returns>The <see cref="IDeviceManagementReportsGetCompliancePolicyNonComplianceReportRequestBuilder"/>.</returns>
        IDeviceManagementReportsGetCompliancePolicyNonComplianceReportRequestBuilder GetCompliancePolicyNonComplianceReport(
            string name = null,
            IEnumerable<string> select = null,
            string search = null,
            IEnumerable<string> groupBy = null,
            IEnumerable<string> orderBy = null,
            Int32? skip = null,
            Int32? top = null,
            string sessionId = null,
            string filter = null);

        /// <summary>
        /// Gets the request builder for DeviceManagementReportsGetCompliancePolicyNonComplianceSummaryReport.
        /// </summary>
        /// <returns>The <see cref="IDeviceManagementReportsGetCompliancePolicyNonComplianceSummaryReportRequestBuilder"/>.</returns>
        IDeviceManagementReportsGetCompliancePolicyNonComplianceSummaryReportRequestBuilder GetCompliancePolicyNonComplianceSummaryReport(
            string name = null,
            IEnumerable<string> select = null,
            string search = null,
            IEnumerable<string> groupBy = null,
            IEnumerable<string> orderBy = null,
            Int32? skip = null,
            Int32? top = null,
            string sessionId = null,
            string filter = null);

        /// <summary>
        /// Gets the request builder for DeviceManagementReportsGetComplianceSettingNonComplianceReport.
        /// </summary>
        /// <returns>The <see cref="IDeviceManagementReportsGetComplianceSettingNonComplianceReportRequestBuilder"/>.</returns>
        IDeviceManagementReportsGetComplianceSettingNonComplianceReportRequestBuilder GetComplianceSettingNonComplianceReport(
            string name = null,
            IEnumerable<string> select = null,
            string search = null,
            IEnumerable<string> groupBy = null,
            IEnumerable<string> orderBy = null,
            Int32? skip = null,
            Int32? top = null,
            string sessionId = null,
            string filter = null);

        /// <summary>
        /// Gets the request builder for DeviceManagementReportsGetConfigurationPolicyNonComplianceReport.
        /// </summary>
        /// <returns>The <see cref="IDeviceManagementReportsGetConfigurationPolicyNonComplianceReportRequestBuilder"/>.</returns>
        IDeviceManagementReportsGetConfigurationPolicyNonComplianceReportRequestBuilder GetConfigurationPolicyNonComplianceReport(
            string name = null,
            IEnumerable<string> select = null,
            string search = null,
            IEnumerable<string> groupBy = null,
            IEnumerable<string> orderBy = null,
            Int32? skip = null,
            Int32? top = null,
            string sessionId = null,
            string filter = null);

        /// <summary>
        /// Gets the request builder for DeviceManagementReportsGetConfigurationPolicyNonComplianceSummaryReport.
        /// </summary>
        /// <returns>The <see cref="IDeviceManagementReportsGetConfigurationPolicyNonComplianceSummaryReportRequestBuilder"/>.</returns>
        IDeviceManagementReportsGetConfigurationPolicyNonComplianceSummaryReportRequestBuilder GetConfigurationPolicyNonComplianceSummaryReport(
            string name = null,
            IEnumerable<string> select = null,
            string search = null,
            IEnumerable<string> groupBy = null,
            IEnumerable<string> orderBy = null,
            Int32? skip = null,
            Int32? top = null,
            string sessionId = null,
            string filter = null);

        /// <summary>
        /// Gets the request builder for DeviceManagementReportsGetConfigurationSettingNonComplianceReport.
        /// </summary>
        /// <returns>The <see cref="IDeviceManagementReportsGetConfigurationSettingNonComplianceReportRequestBuilder"/>.</returns>
        IDeviceManagementReportsGetConfigurationSettingNonComplianceReportRequestBuilder GetConfigurationSettingNonComplianceReport(
            string name = null,
            IEnumerable<string> select = null,
            string search = null,
            IEnumerable<string> groupBy = null,
            IEnumerable<string> orderBy = null,
            Int32? skip = null,
            Int32? top = null,
            string sessionId = null,
            string filter = null);

        /// <summary>
        /// Gets the request builder for DeviceManagementReportsGetDeviceManagementIntentPerSettingContributingProfiles.
        /// </summary>
        /// <returns>The <see cref="IDeviceManagementReportsGetDeviceManagementIntentPerSettingContributingProfilesRequestBuilder"/>.</returns>
        IDeviceManagementReportsGetDeviceManagementIntentPerSettingContributingProfilesRequestBuilder GetDeviceManagementIntentPerSettingContributingProfiles(
            string name = null,
            IEnumerable<string> select = null,
            string search = null,
            IEnumerable<string> groupBy = null,
            IEnumerable<string> orderBy = null,
            Int32? skip = null,
            Int32? top = null,
            string sessionId = null,
            string filter = null);

        /// <summary>
        /// Gets the request builder for DeviceManagementReportsGetDeviceManagementIntentSettingsReport.
        /// </summary>
        /// <returns>The <see cref="IDeviceManagementReportsGetDeviceManagementIntentSettingsReportRequestBuilder"/>.</returns>
        IDeviceManagementReportsGetDeviceManagementIntentSettingsReportRequestBuilder GetDeviceManagementIntentSettingsReport(
            string name = null,
            IEnumerable<string> select = null,
            string search = null,
            IEnumerable<string> groupBy = null,
            IEnumerable<string> orderBy = null,
            Int32? skip = null,
            Int32? top = null,
            string sessionId = null,
            string filter = null);

        /// <summary>
        /// Gets the request builder for DeviceManagementReportsGetDeviceNonComplianceReport.
        /// </summary>
        /// <returns>The <see cref="IDeviceManagementReportsGetDeviceNonComplianceReportRequestBuilder"/>.</returns>
        IDeviceManagementReportsGetDeviceNonComplianceReportRequestBuilder GetDeviceNonComplianceReport(
            string name = null,
            IEnumerable<string> select = null,
            string search = null,
            IEnumerable<string> groupBy = null,
            IEnumerable<string> orderBy = null,
            Int32? skip = null,
            Int32? top = null,
            string sessionId = null,
            string filter = null);

        /// <summary>
        /// Gets the request builder for DeviceManagementReportsGetHistoricalReport.
        /// </summary>
        /// <returns>The <see cref="IDeviceManagementReportsGetHistoricalReportRequestBuilder"/>.</returns>
        IDeviceManagementReportsGetHistoricalReportRequestBuilder GetHistoricalReport(
            string name = null,
            IEnumerable<string> select = null,
            string search = null,
            IEnumerable<string> groupBy = null,
            IEnumerable<string> orderBy = null,
            Int32? skip = null,
            Int32? top = null,
            string filter = null);

        /// <summary>
        /// Gets the request builder for DeviceManagementReportsGetPolicyNonComplianceMetadata.
        /// </summary>
        /// <returns>The <see cref="IDeviceManagementReportsGetPolicyNonComplianceMetadataRequestBuilder"/>.</returns>
        IDeviceManagementReportsGetPolicyNonComplianceMetadataRequestBuilder GetPolicyNonComplianceMetadata(
            string name = null,
            IEnumerable<string> select = null,
            string search = null,
            IEnumerable<string> groupBy = null,
            IEnumerable<string> orderBy = null,
            Int32? skip = null,
            Int32? top = null,
            string sessionId = null,
            string filter = null);

        /// <summary>
        /// Gets the request builder for DeviceManagementReportsGetPolicyNonComplianceReport.
        /// </summary>
        /// <returns>The <see cref="IDeviceManagementReportsGetPolicyNonComplianceReportRequestBuilder"/>.</returns>
        IDeviceManagementReportsGetPolicyNonComplianceReportRequestBuilder GetPolicyNonComplianceReport(
            string name = null,
            IEnumerable<string> select = null,
            string search = null,
            IEnumerable<string> groupBy = null,
            IEnumerable<string> orderBy = null,
            Int32? skip = null,
            Int32? top = null,
            string sessionId = null,
            string filter = null);

        /// <summary>
        /// Gets the request builder for DeviceManagementReportsGetPolicyNonComplianceSummaryReport.
        /// </summary>
        /// <returns>The <see cref="IDeviceManagementReportsGetPolicyNonComplianceSummaryReportRequestBuilder"/>.</returns>
        IDeviceManagementReportsGetPolicyNonComplianceSummaryReportRequestBuilder GetPolicyNonComplianceSummaryReport(
            string name = null,
            IEnumerable<string> select = null,
            string search = null,
            IEnumerable<string> groupBy = null,
            IEnumerable<string> orderBy = null,
            Int32? skip = null,
            Int32? top = null,
            string sessionId = null,
            string filter = null);

        /// <summary>
        /// Gets the request builder for DeviceManagementReportsGetReportFilters.
        /// </summary>
        /// <returns>The <see cref="IDeviceManagementReportsGetReportFiltersRequestBuilder"/>.</returns>
        IDeviceManagementReportsGetReportFiltersRequestBuilder GetReportFilters(
            string name = null,
            IEnumerable<string> select = null,
            string search = null,
            IEnumerable<string> groupBy = null,
            IEnumerable<string> orderBy = null,
            Int32? skip = null,
            Int32? top = null,
            string sessionId = null,
            string filter = null);

        /// <summary>
        /// Gets the request builder for DeviceManagementReportsGetSettingNonComplianceReport.
        /// </summary>
        /// <returns>The <see cref="IDeviceManagementReportsGetSettingNonComplianceReportRequestBuilder"/>.</returns>
        IDeviceManagementReportsGetSettingNonComplianceReportRequestBuilder GetSettingNonComplianceReport(
            string name = null,
            IEnumerable<string> select = null,
            string search = null,
            IEnumerable<string> groupBy = null,
            IEnumerable<string> orderBy = null,
            Int32? skip = null,
            Int32? top = null,
            string sessionId = null,
            string filter = null);
    
    }
}
