// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IDomainDnsUnavailableRecordRequest.
    /// </summary>
    public partial interface IDomainDnsUnavailableRecordRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified DomainDnsUnavailableRecord using POST.
        /// </summary>
        /// <param name="domainDnsUnavailableRecordToCreate">The DomainDnsUnavailableRecord to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created DomainDnsUnavailableRecord.</returns>
        System.Threading.Tasks.Task<DomainDnsUnavailableRecord> CreateAsync(DomainDnsUnavailableRecord domainDnsUnavailableRecordToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified DomainDnsUnavailableRecord using POST and returns a <see cref="GraphResponse{DomainDnsUnavailableRecord}"/> object.
        /// </summary>
        /// <param name="domainDnsUnavailableRecordToCreate">The DomainDnsUnavailableRecord to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{DomainDnsUnavailableRecord}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<DomainDnsUnavailableRecord>> CreateResponseAsync(DomainDnsUnavailableRecord domainDnsUnavailableRecordToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified DomainDnsUnavailableRecord.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified DomainDnsUnavailableRecord and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified DomainDnsUnavailableRecord.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The DomainDnsUnavailableRecord.</returns>
        System.Threading.Tasks.Task<DomainDnsUnavailableRecord> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified DomainDnsUnavailableRecord and returns a <see cref="GraphResponse{DomainDnsUnavailableRecord}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{DomainDnsUnavailableRecord}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<DomainDnsUnavailableRecord>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified DomainDnsUnavailableRecord using PATCH.
        /// </summary>
        /// <param name="domainDnsUnavailableRecordToUpdate">The DomainDnsUnavailableRecord to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated DomainDnsUnavailableRecord.</returns>
        System.Threading.Tasks.Task<DomainDnsUnavailableRecord> UpdateAsync(DomainDnsUnavailableRecord domainDnsUnavailableRecordToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified DomainDnsUnavailableRecord using PATCH and returns a <see cref="GraphResponse{DomainDnsUnavailableRecord}"/> object.
        /// </summary>
        /// <param name="domainDnsUnavailableRecordToUpdate">The DomainDnsUnavailableRecord to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{DomainDnsUnavailableRecord}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<DomainDnsUnavailableRecord>> UpdateResponseAsync(DomainDnsUnavailableRecord domainDnsUnavailableRecordToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified DomainDnsUnavailableRecord using PUT.
        /// </summary>
        /// <param name="domainDnsUnavailableRecordToUpdate">The DomainDnsUnavailableRecord object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<DomainDnsUnavailableRecord> PutAsync(DomainDnsUnavailableRecord domainDnsUnavailableRecordToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified DomainDnsUnavailableRecord using PUT and returns a <see cref="GraphResponse{DomainDnsUnavailableRecord}"/> object.
        /// </summary>
        /// <param name="domainDnsUnavailableRecordToUpdate">The DomainDnsUnavailableRecord object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{DomainDnsUnavailableRecord}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<DomainDnsUnavailableRecord>> PutResponseAsync(DomainDnsUnavailableRecord domainDnsUnavailableRecordToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IDomainDnsUnavailableRecordRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IDomainDnsUnavailableRecordRequest Expand(Expression<Func<DomainDnsUnavailableRecord, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IDomainDnsUnavailableRecordRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IDomainDnsUnavailableRecordRequest Select(Expression<Func<DomainDnsUnavailableRecord, object>> selectExpression);

    }
}
