// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The interface IDomainRequestBuilder.
    /// </summary>
    public partial interface IDomainRequestBuilder : IEntityRequestBuilder
    {
        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        new IDomainRequest Request();

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        new IDomainRequest Request(IEnumerable<Option> options);
    
        /// <summary>
        /// Gets the request builder for DomainNameReferences.
        /// </summary>
        /// <returns>The <see cref="IDomainDomainNameReferencesCollectionWithReferencesRequestBuilder"/>.</returns>
        IDomainDomainNameReferencesCollectionWithReferencesRequestBuilder DomainNameReferences { get; }

        /// <summary>
        /// Gets the request builder for ServiceConfigurationRecords.
        /// </summary>
        /// <returns>The <see cref="IDomainServiceConfigurationRecordsCollectionRequestBuilder"/>.</returns>
        IDomainServiceConfigurationRecordsCollectionRequestBuilder ServiceConfigurationRecords { get; }

        /// <summary>
        /// Gets the request builder for VerificationDnsRecords.
        /// </summary>
        /// <returns>The <see cref="IDomainVerificationDnsRecordsCollectionRequestBuilder"/>.</returns>
        IDomainVerificationDnsRecordsCollectionRequestBuilder VerificationDnsRecords { get; }
    
        /// <summary>
        /// Gets the request builder for DomainForceDelete.
        /// </summary>
        /// <returns>The <see cref="IDomainForceDeleteRequestBuilder"/>.</returns>
        IDomainForceDeleteRequestBuilder ForceDelete(
            bool? disableUserAccounts = null);

        /// <summary>
        /// Gets the request builder for DomainVerify.
        /// </summary>
        /// <returns>The <see cref="IDomainVerifyRequestBuilder"/>.</returns>
        IDomainVerifyRequestBuilder Verify();
    
    }
}
