// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IDriveRequest.
    /// </summary>
    public partial interface IDriveRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified Drive using POST.
        /// </summary>
        /// <param name="driveToCreate">The Drive to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created Drive.</returns>
        System.Threading.Tasks.Task<Drive> CreateAsync(Drive driveToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified Drive using POST and returns a <see cref="GraphResponse{Drive}"/> object.
        /// </summary>
        /// <param name="driveToCreate">The Drive to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{Drive}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<Drive>> CreateResponseAsync(Drive driveToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified Drive.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified Drive and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified Drive.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The Drive.</returns>
        System.Threading.Tasks.Task<Drive> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified Drive and returns a <see cref="GraphResponse{Drive}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{Drive}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<Drive>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified Drive using PATCH.
        /// </summary>
        /// <param name="driveToUpdate">The Drive to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated Drive.</returns>
        System.Threading.Tasks.Task<Drive> UpdateAsync(Drive driveToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified Drive using PATCH and returns a <see cref="GraphResponse{Drive}"/> object.
        /// </summary>
        /// <param name="driveToUpdate">The Drive to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{Drive}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<Drive>> UpdateResponseAsync(Drive driveToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified Drive using PUT.
        /// </summary>
        /// <param name="driveToUpdate">The Drive object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<Drive> PutAsync(Drive driveToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified Drive using PUT and returns a <see cref="GraphResponse{Drive}"/> object.
        /// </summary>
        /// <param name="driveToUpdate">The Drive object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{Drive}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<Drive>> PutResponseAsync(Drive driveToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IDriveRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IDriveRequest Expand(Expression<Func<Drive, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IDriveRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IDriveRequest Select(Expression<Func<Drive, object>> selectExpression);

    }
}
