// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IEducationFeedbackOutcomeRequest.
    /// </summary>
    public partial interface IEducationFeedbackOutcomeRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified EducationFeedbackOutcome using POST.
        /// </summary>
        /// <param name="educationFeedbackOutcomeToCreate">The EducationFeedbackOutcome to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created EducationFeedbackOutcome.</returns>
        System.Threading.Tasks.Task<EducationFeedbackOutcome> CreateAsync(EducationFeedbackOutcome educationFeedbackOutcomeToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified EducationFeedbackOutcome using POST and returns a <see cref="GraphResponse{EducationFeedbackOutcome}"/> object.
        /// </summary>
        /// <param name="educationFeedbackOutcomeToCreate">The EducationFeedbackOutcome to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{EducationFeedbackOutcome}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<EducationFeedbackOutcome>> CreateResponseAsync(EducationFeedbackOutcome educationFeedbackOutcomeToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified EducationFeedbackOutcome.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified EducationFeedbackOutcome and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified EducationFeedbackOutcome.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The EducationFeedbackOutcome.</returns>
        System.Threading.Tasks.Task<EducationFeedbackOutcome> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified EducationFeedbackOutcome and returns a <see cref="GraphResponse{EducationFeedbackOutcome}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{EducationFeedbackOutcome}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<EducationFeedbackOutcome>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified EducationFeedbackOutcome using PATCH.
        /// </summary>
        /// <param name="educationFeedbackOutcomeToUpdate">The EducationFeedbackOutcome to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated EducationFeedbackOutcome.</returns>
        System.Threading.Tasks.Task<EducationFeedbackOutcome> UpdateAsync(EducationFeedbackOutcome educationFeedbackOutcomeToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified EducationFeedbackOutcome using PATCH and returns a <see cref="GraphResponse{EducationFeedbackOutcome}"/> object.
        /// </summary>
        /// <param name="educationFeedbackOutcomeToUpdate">The EducationFeedbackOutcome to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{EducationFeedbackOutcome}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<EducationFeedbackOutcome>> UpdateResponseAsync(EducationFeedbackOutcome educationFeedbackOutcomeToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified EducationFeedbackOutcome using PUT.
        /// </summary>
        /// <param name="educationFeedbackOutcomeToUpdate">The EducationFeedbackOutcome object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<EducationFeedbackOutcome> PutAsync(EducationFeedbackOutcome educationFeedbackOutcomeToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified EducationFeedbackOutcome using PUT and returns a <see cref="GraphResponse{EducationFeedbackOutcome}"/> object.
        /// </summary>
        /// <param name="educationFeedbackOutcomeToUpdate">The EducationFeedbackOutcome object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{EducationFeedbackOutcome}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<EducationFeedbackOutcome>> PutResponseAsync(EducationFeedbackOutcome educationFeedbackOutcomeToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IEducationFeedbackOutcomeRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IEducationFeedbackOutcomeRequest Expand(Expression<Func<EducationFeedbackOutcome, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IEducationFeedbackOutcomeRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IEducationFeedbackOutcomeRequest Select(Expression<Func<EducationFeedbackOutcome, object>> selectExpression);

    }
}
