// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IEducationRubricOutcomeRequest.
    /// </summary>
    public partial interface IEducationRubricOutcomeRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified EducationRubricOutcome using POST.
        /// </summary>
        /// <param name="educationRubricOutcomeToCreate">The EducationRubricOutcome to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created EducationRubricOutcome.</returns>
        System.Threading.Tasks.Task<EducationRubricOutcome> CreateAsync(EducationRubricOutcome educationRubricOutcomeToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified EducationRubricOutcome using POST and returns a <see cref="GraphResponse{EducationRubricOutcome}"/> object.
        /// </summary>
        /// <param name="educationRubricOutcomeToCreate">The EducationRubricOutcome to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{EducationRubricOutcome}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<EducationRubricOutcome>> CreateResponseAsync(EducationRubricOutcome educationRubricOutcomeToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified EducationRubricOutcome.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified EducationRubricOutcome and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified EducationRubricOutcome.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The EducationRubricOutcome.</returns>
        System.Threading.Tasks.Task<EducationRubricOutcome> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified EducationRubricOutcome and returns a <see cref="GraphResponse{EducationRubricOutcome}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{EducationRubricOutcome}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<EducationRubricOutcome>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified EducationRubricOutcome using PATCH.
        /// </summary>
        /// <param name="educationRubricOutcomeToUpdate">The EducationRubricOutcome to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated EducationRubricOutcome.</returns>
        System.Threading.Tasks.Task<EducationRubricOutcome> UpdateAsync(EducationRubricOutcome educationRubricOutcomeToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified EducationRubricOutcome using PATCH and returns a <see cref="GraphResponse{EducationRubricOutcome}"/> object.
        /// </summary>
        /// <param name="educationRubricOutcomeToUpdate">The EducationRubricOutcome to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{EducationRubricOutcome}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<EducationRubricOutcome>> UpdateResponseAsync(EducationRubricOutcome educationRubricOutcomeToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified EducationRubricOutcome using PUT.
        /// </summary>
        /// <param name="educationRubricOutcomeToUpdate">The EducationRubricOutcome object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<EducationRubricOutcome> PutAsync(EducationRubricOutcome educationRubricOutcomeToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified EducationRubricOutcome using PUT and returns a <see cref="GraphResponse{EducationRubricOutcome}"/> object.
        /// </summary>
        /// <param name="educationRubricOutcomeToUpdate">The EducationRubricOutcome object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{EducationRubricOutcome}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<EducationRubricOutcome>> PutResponseAsync(EducationRubricOutcome educationRubricOutcomeToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IEducationRubricOutcomeRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IEducationRubricOutcomeRequest Expand(Expression<Func<EducationRubricOutcome, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IEducationRubricOutcomeRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IEducationRubricOutcomeRequest Select(Expression<Func<EducationRubricOutcome, object>> selectExpression);

    }
}
