// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The interface IEntitlementManagementRequestBuilder.
    /// </summary>
    public partial interface IEntitlementManagementRequestBuilder : IEntityRequestBuilder
    {
        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        new IEntitlementManagementRequest Request();

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        new IEntitlementManagementRequest Request(IEnumerable<Option> options);
    
        /// <summary>
        /// Gets the request builder for AccessPackageAssignmentApprovals.
        /// </summary>
        /// <returns>The <see cref="IEntitlementManagementAccessPackageAssignmentApprovalsCollectionRequestBuilder"/>.</returns>
        IEntitlementManagementAccessPackageAssignmentApprovalsCollectionRequestBuilder AccessPackageAssignmentApprovals { get; }

        /// <summary>
        /// Gets the request builder for AccessPackages.
        /// </summary>
        /// <returns>The <see cref="IEntitlementManagementAccessPackagesCollectionRequestBuilder"/>.</returns>
        IEntitlementManagementAccessPackagesCollectionRequestBuilder AccessPackages { get; }

        /// <summary>
        /// Gets the request builder for AssignmentRequests.
        /// </summary>
        /// <returns>The <see cref="IEntitlementManagementAssignmentRequestsCollectionRequestBuilder"/>.</returns>
        IEntitlementManagementAssignmentRequestsCollectionRequestBuilder AssignmentRequests { get; }

        /// <summary>
        /// Gets the request builder for Assignments.
        /// </summary>
        /// <returns>The <see cref="IEntitlementManagementAssignmentsCollectionRequestBuilder"/>.</returns>
        IEntitlementManagementAssignmentsCollectionRequestBuilder Assignments { get; }

        /// <summary>
        /// Gets the request builder for Catalogs.
        /// </summary>
        /// <returns>The <see cref="IEntitlementManagementCatalogsCollectionRequestBuilder"/>.</returns>
        IEntitlementManagementCatalogsCollectionRequestBuilder Catalogs { get; }

        /// <summary>
        /// Gets the request builder for ConnectedOrganizations.
        /// </summary>
        /// <returns>The <see cref="IEntitlementManagementConnectedOrganizationsCollectionRequestBuilder"/>.</returns>
        IEntitlementManagementConnectedOrganizationsCollectionRequestBuilder ConnectedOrganizations { get; }

        /// <summary>
        /// Gets the request builder for Settings.
        /// </summary>
        /// <returns>The <see cref="IEntitlementManagementSettingsRequestBuilder"/>.</returns>
        IEntitlementManagementSettingsRequestBuilder Settings { get; }
    
    }
}
