// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IEventMessageResponseRequest.
    /// </summary>
    public partial interface IEventMessageResponseRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified EventMessageResponse using POST.
        /// </summary>
        /// <param name="eventMessageResponseToCreate">The EventMessageResponse to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created EventMessageResponse.</returns>
        System.Threading.Tasks.Task<EventMessageResponse> CreateAsync(EventMessageResponse eventMessageResponseToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified EventMessageResponse using POST and returns a <see cref="GraphResponse{EventMessageResponse}"/> object.
        /// </summary>
        /// <param name="eventMessageResponseToCreate">The EventMessageResponse to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{EventMessageResponse}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<EventMessageResponse>> CreateResponseAsync(EventMessageResponse eventMessageResponseToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified EventMessageResponse.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified EventMessageResponse and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified EventMessageResponse.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The EventMessageResponse.</returns>
        System.Threading.Tasks.Task<EventMessageResponse> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified EventMessageResponse and returns a <see cref="GraphResponse{EventMessageResponse}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{EventMessageResponse}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<EventMessageResponse>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified EventMessageResponse using PATCH.
        /// </summary>
        /// <param name="eventMessageResponseToUpdate">The EventMessageResponse to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated EventMessageResponse.</returns>
        System.Threading.Tasks.Task<EventMessageResponse> UpdateAsync(EventMessageResponse eventMessageResponseToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified EventMessageResponse using PATCH and returns a <see cref="GraphResponse{EventMessageResponse}"/> object.
        /// </summary>
        /// <param name="eventMessageResponseToUpdate">The EventMessageResponse to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{EventMessageResponse}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<EventMessageResponse>> UpdateResponseAsync(EventMessageResponse eventMessageResponseToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified EventMessageResponse using PUT.
        /// </summary>
        /// <param name="eventMessageResponseToUpdate">The EventMessageResponse object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<EventMessageResponse> PutAsync(EventMessageResponse eventMessageResponseToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified EventMessageResponse using PUT and returns a <see cref="GraphResponse{EventMessageResponse}"/> object.
        /// </summary>
        /// <param name="eventMessageResponseToUpdate">The EventMessageResponse object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{EventMessageResponse}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<EventMessageResponse>> PutResponseAsync(EventMessageResponse eventMessageResponseToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IEventMessageResponseRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IEventMessageResponseRequest Expand(Expression<Func<EventMessageResponse, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IEventMessageResponseRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IEventMessageResponseRequest Select(Expression<Func<EventMessageResponse, object>> selectExpression);

    }
}
