// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IFeatureRolloutPolicyRequest.
    /// </summary>
    public partial interface IFeatureRolloutPolicyRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified FeatureRolloutPolicy using POST.
        /// </summary>
        /// <param name="featureRolloutPolicyToCreate">The FeatureRolloutPolicy to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created FeatureRolloutPolicy.</returns>
        System.Threading.Tasks.Task<FeatureRolloutPolicy> CreateAsync(FeatureRolloutPolicy featureRolloutPolicyToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified FeatureRolloutPolicy using POST and returns a <see cref="GraphResponse{FeatureRolloutPolicy}"/> object.
        /// </summary>
        /// <param name="featureRolloutPolicyToCreate">The FeatureRolloutPolicy to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{FeatureRolloutPolicy}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<FeatureRolloutPolicy>> CreateResponseAsync(FeatureRolloutPolicy featureRolloutPolicyToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified FeatureRolloutPolicy.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified FeatureRolloutPolicy and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified FeatureRolloutPolicy.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The FeatureRolloutPolicy.</returns>
        System.Threading.Tasks.Task<FeatureRolloutPolicy> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified FeatureRolloutPolicy and returns a <see cref="GraphResponse{FeatureRolloutPolicy}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{FeatureRolloutPolicy}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<FeatureRolloutPolicy>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified FeatureRolloutPolicy using PATCH.
        /// </summary>
        /// <param name="featureRolloutPolicyToUpdate">The FeatureRolloutPolicy to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated FeatureRolloutPolicy.</returns>
        System.Threading.Tasks.Task<FeatureRolloutPolicy> UpdateAsync(FeatureRolloutPolicy featureRolloutPolicyToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified FeatureRolloutPolicy using PATCH and returns a <see cref="GraphResponse{FeatureRolloutPolicy}"/> object.
        /// </summary>
        /// <param name="featureRolloutPolicyToUpdate">The FeatureRolloutPolicy to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{FeatureRolloutPolicy}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<FeatureRolloutPolicy>> UpdateResponseAsync(FeatureRolloutPolicy featureRolloutPolicyToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified FeatureRolloutPolicy using PUT.
        /// </summary>
        /// <param name="featureRolloutPolicyToUpdate">The FeatureRolloutPolicy object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<FeatureRolloutPolicy> PutAsync(FeatureRolloutPolicy featureRolloutPolicyToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified FeatureRolloutPolicy using PUT and returns a <see cref="GraphResponse{FeatureRolloutPolicy}"/> object.
        /// </summary>
        /// <param name="featureRolloutPolicyToUpdate">The FeatureRolloutPolicy object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{FeatureRolloutPolicy}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<FeatureRolloutPolicy>> PutResponseAsync(FeatureRolloutPolicy featureRolloutPolicyToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IFeatureRolloutPolicyRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IFeatureRolloutPolicyRequest Expand(Expression<Func<FeatureRolloutPolicy, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IFeatureRolloutPolicyRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IFeatureRolloutPolicyRequest Select(Expression<Func<FeatureRolloutPolicy, object>> selectExpression);

    }
}
