// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityCollectionRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IIdentityContainerB2xUserFlowsCollectionRequest.
    /// </summary>
    public partial interface IIdentityContainerB2xUserFlowsCollectionRequest : IBaseRequest
    {
        /// <summary>
        /// Adds the specified B2xIdentityUserFlow to the collection via POST.
        /// </summary>
        /// <param name="b2xIdentityUserFlow">The B2xIdentityUserFlow to add.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created B2xIdentityUserFlow.</returns>
        System.Threading.Tasks.Task<B2xIdentityUserFlow> AddAsync(B2xIdentityUserFlow b2xIdentityUserFlow, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified B2xIdentityUserFlow to the collection via POST and returns a <see cref="GraphResponse{B2xIdentityUserFlow}"/> object of the request.
        /// </summary>
        /// <param name="b2xIdentityUserFlow">The B2xIdentityUserFlow to add.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{B2xIdentityUserFlow}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<B2xIdentityUserFlow>> AddResponseAsync(B2xIdentityUserFlow b2xIdentityUserFlow, CancellationToken cancellationToken = default);


        /// <summary>
        /// Gets the collection page.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The collection page.</returns>
        System.Threading.Tasks.Task<IIdentityContainerB2xUserFlowsCollectionPage> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the collection page and returns a <see cref="GraphResponse{IdentityContainerB2xUserFlowsCollectionResponse}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{IdentityContainerB2xUserFlowsCollectionResponse}"/> object.</returns>
        System.Threading.Tasks.Task<GraphResponse<IdentityContainerB2xUserFlowsCollectionResponse>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IIdentityContainerB2xUserFlowsCollectionRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IIdentityContainerB2xUserFlowsCollectionRequest Expand(Expression<Func<B2xIdentityUserFlow, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IIdentityContainerB2xUserFlowsCollectionRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IIdentityContainerB2xUserFlowsCollectionRequest Select(Expression<Func<B2xIdentityUserFlow, object>> selectExpression);

        /// <summary>
        /// Adds the specified top value to the request.
        /// </summary>
        /// <param name="value">The top value.</param>
        /// <returns>The request object to send.</returns>
        IIdentityContainerB2xUserFlowsCollectionRequest Top(int value);

        /// <summary>
        /// Adds the specified filter value to the request.
        /// </summary>
        /// <param name="value">The filter value.</param>
        /// <returns>The request object to send.</returns>
        IIdentityContainerB2xUserFlowsCollectionRequest Filter(string value);

        /// <summary>
        /// Adds the specified skip value to the request.
        /// </summary>
        /// <param name="value">The skip value.</param>
        /// <returns>The request object to send.</returns>
        IIdentityContainerB2xUserFlowsCollectionRequest Skip(int value);

        /// <summary>
        /// Adds the specified orderby value to the request.
        /// </summary>
        /// <param name="value">The orderby value.</param>
        /// <returns>The request object to send.</returns>
        IIdentityContainerB2xUserFlowsCollectionRequest OrderBy(string value);
    }
}
