// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IIdentityUserFlowRequest.
    /// </summary>
    public partial interface IIdentityUserFlowRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified IdentityUserFlow using POST.
        /// </summary>
        /// <param name="identityUserFlowToCreate">The IdentityUserFlow to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created IdentityUserFlow.</returns>
        System.Threading.Tasks.Task<IdentityUserFlow> CreateAsync(IdentityUserFlow identityUserFlowToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified IdentityUserFlow using POST and returns a <see cref="GraphResponse{IdentityUserFlow}"/> object.
        /// </summary>
        /// <param name="identityUserFlowToCreate">The IdentityUserFlow to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{IdentityUserFlow}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<IdentityUserFlow>> CreateResponseAsync(IdentityUserFlow identityUserFlowToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified IdentityUserFlow.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified IdentityUserFlow and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified IdentityUserFlow.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The IdentityUserFlow.</returns>
        System.Threading.Tasks.Task<IdentityUserFlow> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified IdentityUserFlow and returns a <see cref="GraphResponse{IdentityUserFlow}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{IdentityUserFlow}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<IdentityUserFlow>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified IdentityUserFlow using PATCH.
        /// </summary>
        /// <param name="identityUserFlowToUpdate">The IdentityUserFlow to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated IdentityUserFlow.</returns>
        System.Threading.Tasks.Task<IdentityUserFlow> UpdateAsync(IdentityUserFlow identityUserFlowToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified IdentityUserFlow using PATCH and returns a <see cref="GraphResponse{IdentityUserFlow}"/> object.
        /// </summary>
        /// <param name="identityUserFlowToUpdate">The IdentityUserFlow to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{IdentityUserFlow}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<IdentityUserFlow>> UpdateResponseAsync(IdentityUserFlow identityUserFlowToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified IdentityUserFlow using PUT.
        /// </summary>
        /// <param name="identityUserFlowToUpdate">The IdentityUserFlow object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<IdentityUserFlow> PutAsync(IdentityUserFlow identityUserFlowToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified IdentityUserFlow using PUT and returns a <see cref="GraphResponse{IdentityUserFlow}"/> object.
        /// </summary>
        /// <param name="identityUserFlowToUpdate">The IdentityUserFlow object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{IdentityUserFlow}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<IdentityUserFlow>> PutResponseAsync(IdentityUserFlow identityUserFlowToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IIdentityUserFlowRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IIdentityUserFlowRequest Expand(Expression<Func<IdentityUserFlow, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IIdentityUserFlowRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IIdentityUserFlowRequest Select(Expression<Func<IdentityUserFlow, object>> selectExpression);

    }
}
