// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IImportedWindowsAutopilotDeviceIdentityUploadRequest.
    /// </summary>
    public partial interface IImportedWindowsAutopilotDeviceIdentityUploadRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified ImportedWindowsAutopilotDeviceIdentityUpload using POST.
        /// </summary>
        /// <param name="importedWindowsAutopilotDeviceIdentityUploadToCreate">The ImportedWindowsAutopilotDeviceIdentityUpload to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created ImportedWindowsAutopilotDeviceIdentityUpload.</returns>
        System.Threading.Tasks.Task<ImportedWindowsAutopilotDeviceIdentityUpload> CreateAsync(ImportedWindowsAutopilotDeviceIdentityUpload importedWindowsAutopilotDeviceIdentityUploadToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified ImportedWindowsAutopilotDeviceIdentityUpload using POST and returns a <see cref="GraphResponse{ImportedWindowsAutopilotDeviceIdentityUpload}"/> object.
        /// </summary>
        /// <param name="importedWindowsAutopilotDeviceIdentityUploadToCreate">The ImportedWindowsAutopilotDeviceIdentityUpload to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{ImportedWindowsAutopilotDeviceIdentityUpload}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<ImportedWindowsAutopilotDeviceIdentityUpload>> CreateResponseAsync(ImportedWindowsAutopilotDeviceIdentityUpload importedWindowsAutopilotDeviceIdentityUploadToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified ImportedWindowsAutopilotDeviceIdentityUpload.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified ImportedWindowsAutopilotDeviceIdentityUpload and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified ImportedWindowsAutopilotDeviceIdentityUpload.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The ImportedWindowsAutopilotDeviceIdentityUpload.</returns>
        System.Threading.Tasks.Task<ImportedWindowsAutopilotDeviceIdentityUpload> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified ImportedWindowsAutopilotDeviceIdentityUpload and returns a <see cref="GraphResponse{ImportedWindowsAutopilotDeviceIdentityUpload}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{ImportedWindowsAutopilotDeviceIdentityUpload}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<ImportedWindowsAutopilotDeviceIdentityUpload>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified ImportedWindowsAutopilotDeviceIdentityUpload using PATCH.
        /// </summary>
        /// <param name="importedWindowsAutopilotDeviceIdentityUploadToUpdate">The ImportedWindowsAutopilotDeviceIdentityUpload to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated ImportedWindowsAutopilotDeviceIdentityUpload.</returns>
        System.Threading.Tasks.Task<ImportedWindowsAutopilotDeviceIdentityUpload> UpdateAsync(ImportedWindowsAutopilotDeviceIdentityUpload importedWindowsAutopilotDeviceIdentityUploadToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified ImportedWindowsAutopilotDeviceIdentityUpload using PATCH and returns a <see cref="GraphResponse{ImportedWindowsAutopilotDeviceIdentityUpload}"/> object.
        /// </summary>
        /// <param name="importedWindowsAutopilotDeviceIdentityUploadToUpdate">The ImportedWindowsAutopilotDeviceIdentityUpload to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{ImportedWindowsAutopilotDeviceIdentityUpload}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<ImportedWindowsAutopilotDeviceIdentityUpload>> UpdateResponseAsync(ImportedWindowsAutopilotDeviceIdentityUpload importedWindowsAutopilotDeviceIdentityUploadToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified ImportedWindowsAutopilotDeviceIdentityUpload using PUT.
        /// </summary>
        /// <param name="importedWindowsAutopilotDeviceIdentityUploadToUpdate">The ImportedWindowsAutopilotDeviceIdentityUpload object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<ImportedWindowsAutopilotDeviceIdentityUpload> PutAsync(ImportedWindowsAutopilotDeviceIdentityUpload importedWindowsAutopilotDeviceIdentityUploadToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified ImportedWindowsAutopilotDeviceIdentityUpload using PUT and returns a <see cref="GraphResponse{ImportedWindowsAutopilotDeviceIdentityUpload}"/> object.
        /// </summary>
        /// <param name="importedWindowsAutopilotDeviceIdentityUploadToUpdate">The ImportedWindowsAutopilotDeviceIdentityUpload object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{ImportedWindowsAutopilotDeviceIdentityUpload}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<ImportedWindowsAutopilotDeviceIdentityUpload>> PutResponseAsync(ImportedWindowsAutopilotDeviceIdentityUpload importedWindowsAutopilotDeviceIdentityUploadToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IImportedWindowsAutopilotDeviceIdentityUploadRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IImportedWindowsAutopilotDeviceIdentityUploadRequest Expand(Expression<Func<ImportedWindowsAutopilotDeviceIdentityUpload, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IImportedWindowsAutopilotDeviceIdentityUploadRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IImportedWindowsAutopilotDeviceIdentityUploadRequest Select(Expression<Func<ImportedWindowsAutopilotDeviceIdentityUpload, object>> selectExpression);

    }
}
