// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IIosVppAppRequest.
    /// </summary>
    public partial interface IIosVppAppRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified IosVppApp using POST.
        /// </summary>
        /// <param name="iosVppAppToCreate">The IosVppApp to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created IosVppApp.</returns>
        System.Threading.Tasks.Task<IosVppApp> CreateAsync(IosVppApp iosVppAppToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified IosVppApp using POST and returns a <see cref="GraphResponse{IosVppApp}"/> object.
        /// </summary>
        /// <param name="iosVppAppToCreate">The IosVppApp to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{IosVppApp}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<IosVppApp>> CreateResponseAsync(IosVppApp iosVppAppToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified IosVppApp.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified IosVppApp and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified IosVppApp.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The IosVppApp.</returns>
        System.Threading.Tasks.Task<IosVppApp> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified IosVppApp and returns a <see cref="GraphResponse{IosVppApp}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{IosVppApp}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<IosVppApp>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified IosVppApp using PATCH.
        /// </summary>
        /// <param name="iosVppAppToUpdate">The IosVppApp to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated IosVppApp.</returns>
        System.Threading.Tasks.Task<IosVppApp> UpdateAsync(IosVppApp iosVppAppToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified IosVppApp using PATCH and returns a <see cref="GraphResponse{IosVppApp}"/> object.
        /// </summary>
        /// <param name="iosVppAppToUpdate">The IosVppApp to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{IosVppApp}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<IosVppApp>> UpdateResponseAsync(IosVppApp iosVppAppToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified IosVppApp using PUT.
        /// </summary>
        /// <param name="iosVppAppToUpdate">The IosVppApp object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<IosVppApp> PutAsync(IosVppApp iosVppAppToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified IosVppApp using PUT and returns a <see cref="GraphResponse{IosVppApp}"/> object.
        /// </summary>
        /// <param name="iosVppAppToUpdate">The IosVppApp object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{IosVppApp}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<IosVppApp>> PutResponseAsync(IosVppApp iosVppAppToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IIosVppAppRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IIosVppAppRequest Expand(Expression<Func<IosVppApp, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IIosVppAppRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IIosVppAppRequest Select(Expression<Func<IosVppApp, object>> selectExpression);

    }
}
