// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IMailAssessmentRequestRequest.
    /// </summary>
    public partial interface IMailAssessmentRequestRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified MailAssessmentRequestObject using POST.
        /// </summary>
        /// <param name="mailAssessmentRequestObjectToCreate">The MailAssessmentRequestObject to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created MailAssessmentRequestObject.</returns>
        System.Threading.Tasks.Task<MailAssessmentRequestObject> CreateAsync(MailAssessmentRequestObject mailAssessmentRequestObjectToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified MailAssessmentRequestObject using POST and returns a <see cref="GraphResponse{MailAssessmentRequestObject}"/> object.
        /// </summary>
        /// <param name="mailAssessmentRequestObjectToCreate">The MailAssessmentRequestObject to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{MailAssessmentRequestObject}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<MailAssessmentRequestObject>> CreateResponseAsync(MailAssessmentRequestObject mailAssessmentRequestObjectToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified MailAssessmentRequestObject.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified MailAssessmentRequestObject and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified MailAssessmentRequestObject.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The MailAssessmentRequestObject.</returns>
        System.Threading.Tasks.Task<MailAssessmentRequestObject> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified MailAssessmentRequestObject and returns a <see cref="GraphResponse{MailAssessmentRequestObject}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{MailAssessmentRequestObject}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<MailAssessmentRequestObject>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified MailAssessmentRequestObject using PATCH.
        /// </summary>
        /// <param name="mailAssessmentRequestObjectToUpdate">The MailAssessmentRequestObject to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated MailAssessmentRequestObject.</returns>
        System.Threading.Tasks.Task<MailAssessmentRequestObject> UpdateAsync(MailAssessmentRequestObject mailAssessmentRequestObjectToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified MailAssessmentRequestObject using PATCH and returns a <see cref="GraphResponse{MailAssessmentRequestObject}"/> object.
        /// </summary>
        /// <param name="mailAssessmentRequestObjectToUpdate">The MailAssessmentRequestObject to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{MailAssessmentRequestObject}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<MailAssessmentRequestObject>> UpdateResponseAsync(MailAssessmentRequestObject mailAssessmentRequestObjectToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified MailAssessmentRequestObject using PUT.
        /// </summary>
        /// <param name="mailAssessmentRequestObjectToUpdate">The MailAssessmentRequestObject object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<MailAssessmentRequestObject> PutAsync(MailAssessmentRequestObject mailAssessmentRequestObjectToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified MailAssessmentRequestObject using PUT and returns a <see cref="GraphResponse{MailAssessmentRequestObject}"/> object.
        /// </summary>
        /// <param name="mailAssessmentRequestObjectToUpdate">The MailAssessmentRequestObject object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{MailAssessmentRequestObject}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<MailAssessmentRequestObject>> PutResponseAsync(MailAssessmentRequestObject mailAssessmentRequestObjectToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IMailAssessmentRequestRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IMailAssessmentRequestRequest Expand(Expression<Func<MailAssessmentRequestObject, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IMailAssessmentRequestRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IMailAssessmentRequestRequest Select(Expression<Func<MailAssessmentRequestObject, object>> selectExpression);

    }
}
