// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IOpenTypeExtensionRequest.
    /// </summary>
    public partial interface IOpenTypeExtensionRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified OpenTypeExtension using POST.
        /// </summary>
        /// <param name="openTypeExtensionToCreate">The OpenTypeExtension to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created OpenTypeExtension.</returns>
        System.Threading.Tasks.Task<OpenTypeExtension> CreateAsync(OpenTypeExtension openTypeExtensionToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified OpenTypeExtension using POST and returns a <see cref="GraphResponse{OpenTypeExtension}"/> object.
        /// </summary>
        /// <param name="openTypeExtensionToCreate">The OpenTypeExtension to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{OpenTypeExtension}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<OpenTypeExtension>> CreateResponseAsync(OpenTypeExtension openTypeExtensionToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified OpenTypeExtension.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified OpenTypeExtension and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified OpenTypeExtension.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The OpenTypeExtension.</returns>
        System.Threading.Tasks.Task<OpenTypeExtension> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified OpenTypeExtension and returns a <see cref="GraphResponse{OpenTypeExtension}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{OpenTypeExtension}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<OpenTypeExtension>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified OpenTypeExtension using PATCH.
        /// </summary>
        /// <param name="openTypeExtensionToUpdate">The OpenTypeExtension to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated OpenTypeExtension.</returns>
        System.Threading.Tasks.Task<OpenTypeExtension> UpdateAsync(OpenTypeExtension openTypeExtensionToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified OpenTypeExtension using PATCH and returns a <see cref="GraphResponse{OpenTypeExtension}"/> object.
        /// </summary>
        /// <param name="openTypeExtensionToUpdate">The OpenTypeExtension to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{OpenTypeExtension}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<OpenTypeExtension>> UpdateResponseAsync(OpenTypeExtension openTypeExtensionToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified OpenTypeExtension using PUT.
        /// </summary>
        /// <param name="openTypeExtensionToUpdate">The OpenTypeExtension object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<OpenTypeExtension> PutAsync(OpenTypeExtension openTypeExtensionToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified OpenTypeExtension using PUT and returns a <see cref="GraphResponse{OpenTypeExtension}"/> object.
        /// </summary>
        /// <param name="openTypeExtensionToUpdate">The OpenTypeExtension object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{OpenTypeExtension}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<OpenTypeExtension>> PutResponseAsync(OpenTypeExtension openTypeExtensionToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IOpenTypeExtensionRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IOpenTypeExtensionRequest Expand(Expression<Func<OpenTypeExtension, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IOpenTypeExtensionRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IOpenTypeExtensionRequest Select(Expression<Func<OpenTypeExtension, object>> selectExpression);

    }
}
