// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IPermissionGrantPolicyRequest.
    /// </summary>
    public partial interface IPermissionGrantPolicyRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified PermissionGrantPolicy using POST.
        /// </summary>
        /// <param name="permissionGrantPolicyToCreate">The PermissionGrantPolicy to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created PermissionGrantPolicy.</returns>
        System.Threading.Tasks.Task<PermissionGrantPolicy> CreateAsync(PermissionGrantPolicy permissionGrantPolicyToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified PermissionGrantPolicy using POST and returns a <see cref="GraphResponse{PermissionGrantPolicy}"/> object.
        /// </summary>
        /// <param name="permissionGrantPolicyToCreate">The PermissionGrantPolicy to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{PermissionGrantPolicy}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<PermissionGrantPolicy>> CreateResponseAsync(PermissionGrantPolicy permissionGrantPolicyToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified PermissionGrantPolicy.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified PermissionGrantPolicy and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified PermissionGrantPolicy.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The PermissionGrantPolicy.</returns>
        System.Threading.Tasks.Task<PermissionGrantPolicy> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified PermissionGrantPolicy and returns a <see cref="GraphResponse{PermissionGrantPolicy}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{PermissionGrantPolicy}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<PermissionGrantPolicy>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified PermissionGrantPolicy using PATCH.
        /// </summary>
        /// <param name="permissionGrantPolicyToUpdate">The PermissionGrantPolicy to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated PermissionGrantPolicy.</returns>
        System.Threading.Tasks.Task<PermissionGrantPolicy> UpdateAsync(PermissionGrantPolicy permissionGrantPolicyToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified PermissionGrantPolicy using PATCH and returns a <see cref="GraphResponse{PermissionGrantPolicy}"/> object.
        /// </summary>
        /// <param name="permissionGrantPolicyToUpdate">The PermissionGrantPolicy to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{PermissionGrantPolicy}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<PermissionGrantPolicy>> UpdateResponseAsync(PermissionGrantPolicy permissionGrantPolicyToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified PermissionGrantPolicy using PUT.
        /// </summary>
        /// <param name="permissionGrantPolicyToUpdate">The PermissionGrantPolicy object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<PermissionGrantPolicy> PutAsync(PermissionGrantPolicy permissionGrantPolicyToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified PermissionGrantPolicy using PUT and returns a <see cref="GraphResponse{PermissionGrantPolicy}"/> object.
        /// </summary>
        /// <param name="permissionGrantPolicyToUpdate">The PermissionGrantPolicy object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{PermissionGrantPolicy}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<PermissionGrantPolicy>> PutResponseAsync(PermissionGrantPolicy permissionGrantPolicyToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IPermissionGrantPolicyRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IPermissionGrantPolicyRequest Expand(Expression<Func<PermissionGrantPolicy, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IPermissionGrantPolicyRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IPermissionGrantPolicyRequest Select(Expression<Func<PermissionGrantPolicy, object>> selectExpression);

    }
}
