// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IPermissionRequest.
    /// </summary>
    public partial interface IPermissionRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified Permission using POST.
        /// </summary>
        /// <param name="permissionToCreate">The Permission to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created Permission.</returns>
        System.Threading.Tasks.Task<Permission> CreateAsync(Permission permissionToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified Permission using POST and returns a <see cref="GraphResponse{Permission}"/> object.
        /// </summary>
        /// <param name="permissionToCreate">The Permission to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{Permission}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<Permission>> CreateResponseAsync(Permission permissionToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified Permission.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified Permission and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified Permission.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The Permission.</returns>
        System.Threading.Tasks.Task<Permission> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified Permission and returns a <see cref="GraphResponse{Permission}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{Permission}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<Permission>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified Permission using PATCH.
        /// </summary>
        /// <param name="permissionToUpdate">The Permission to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated Permission.</returns>
        System.Threading.Tasks.Task<Permission> UpdateAsync(Permission permissionToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified Permission using PATCH and returns a <see cref="GraphResponse{Permission}"/> object.
        /// </summary>
        /// <param name="permissionToUpdate">The Permission to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{Permission}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<Permission>> UpdateResponseAsync(Permission permissionToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified Permission using PUT.
        /// </summary>
        /// <param name="permissionToUpdate">The Permission object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<Permission> PutAsync(Permission permissionToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified Permission using PUT and returns a <see cref="GraphResponse{Permission}"/> object.
        /// </summary>
        /// <param name="permissionToUpdate">The Permission object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{Permission}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<Permission>> PutResponseAsync(Permission permissionToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IPermissionRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IPermissionRequest Expand(Expression<Func<Permission, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IPermissionRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IPermissionRequest Select(Expression<Func<Permission, object>> selectExpression);

    }
}
