// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IPlannerTaskRequest.
    /// </summary>
    public partial interface IPlannerTaskRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified PlannerTask using POST.
        /// </summary>
        /// <param name="plannerTaskToCreate">The PlannerTask to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created PlannerTask.</returns>
        System.Threading.Tasks.Task<PlannerTask> CreateAsync(PlannerTask plannerTaskToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified PlannerTask using POST and returns a <see cref="GraphResponse{PlannerTask}"/> object.
        /// </summary>
        /// <param name="plannerTaskToCreate">The PlannerTask to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{PlannerTask}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<PlannerTask>> CreateResponseAsync(PlannerTask plannerTaskToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified PlannerTask.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified PlannerTask and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified PlannerTask.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The PlannerTask.</returns>
        System.Threading.Tasks.Task<PlannerTask> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified PlannerTask and returns a <see cref="GraphResponse{PlannerTask}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{PlannerTask}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<PlannerTask>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified PlannerTask using PATCH.
        /// </summary>
        /// <param name="plannerTaskToUpdate">The PlannerTask to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated PlannerTask.</returns>
        System.Threading.Tasks.Task<PlannerTask> UpdateAsync(PlannerTask plannerTaskToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified PlannerTask using PATCH and returns a <see cref="GraphResponse{PlannerTask}"/> object.
        /// </summary>
        /// <param name="plannerTaskToUpdate">The PlannerTask to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{PlannerTask}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<PlannerTask>> UpdateResponseAsync(PlannerTask plannerTaskToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified PlannerTask using PUT.
        /// </summary>
        /// <param name="plannerTaskToUpdate">The PlannerTask object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<PlannerTask> PutAsync(PlannerTask plannerTaskToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified PlannerTask using PUT and returns a <see cref="GraphResponse{PlannerTask}"/> object.
        /// </summary>
        /// <param name="plannerTaskToUpdate">The PlannerTask object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{PlannerTask}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<PlannerTask>> PutResponseAsync(PlannerTask plannerTaskToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IPlannerTaskRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IPlannerTaskRequest Expand(Expression<Func<PlannerTask, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IPlannerTaskRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IPlannerTaskRequest Select(Expression<Func<PlannerTask, object>> selectExpression);

    }
}
