// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The interface IPresenceRequestBuilder.
    /// </summary>
    public partial interface IPresenceRequestBuilder : IEntityRequestBuilder
    {
        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        new IPresenceRequest Request();

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        new IPresenceRequest Request(IEnumerable<Option> options);
    
        /// <summary>
        /// Gets the request builder for PresenceClearPresence.
        /// </summary>
        /// <returns>The <see cref="IPresenceClearPresenceRequestBuilder"/>.</returns>
        IPresenceClearPresenceRequestBuilder ClearPresence(
            string sessionId = null);

        /// <summary>
        /// Gets the request builder for PresenceSetPresence.
        /// </summary>
        /// <returns>The <see cref="IPresenceSetPresenceRequestBuilder"/>.</returns>
        IPresenceSetPresenceRequestBuilder SetPresence(
            string availability,
            string activity,
            string sessionId = null,
            Duration expirationDuration = null);
    
    }
}
