// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IPrintServiceRequest.
    /// </summary>
    public partial interface IPrintServiceRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified PrintService using POST.
        /// </summary>
        /// <param name="printServiceToCreate">The PrintService to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created PrintService.</returns>
        System.Threading.Tasks.Task<PrintService> CreateAsync(PrintService printServiceToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified PrintService using POST and returns a <see cref="GraphResponse{PrintService}"/> object.
        /// </summary>
        /// <param name="printServiceToCreate">The PrintService to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{PrintService}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<PrintService>> CreateResponseAsync(PrintService printServiceToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified PrintService.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified PrintService and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified PrintService.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The PrintService.</returns>
        System.Threading.Tasks.Task<PrintService> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified PrintService and returns a <see cref="GraphResponse{PrintService}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{PrintService}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<PrintService>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified PrintService using PATCH.
        /// </summary>
        /// <param name="printServiceToUpdate">The PrintService to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated PrintService.</returns>
        System.Threading.Tasks.Task<PrintService> UpdateAsync(PrintService printServiceToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified PrintService using PATCH and returns a <see cref="GraphResponse{PrintService}"/> object.
        /// </summary>
        /// <param name="printServiceToUpdate">The PrintService to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{PrintService}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<PrintService>> UpdateResponseAsync(PrintService printServiceToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified PrintService using PUT.
        /// </summary>
        /// <param name="printServiceToUpdate">The PrintService object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<PrintService> PutAsync(PrintService printServiceToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified PrintService using PUT and returns a <see cref="GraphResponse{PrintService}"/> object.
        /// </summary>
        /// <param name="printServiceToUpdate">The PrintService object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{PrintService}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<PrintService>> PutResponseAsync(PrintService printServiceToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IPrintServiceRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IPrintServiceRequest Expand(Expression<Func<PrintService, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IPrintServiceRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IPrintServiceRequest Select(Expression<Func<PrintService, object>> selectExpression);

    }
}
