// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IPrintTaskRequest.
    /// </summary>
    public partial interface IPrintTaskRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified PrintTask using POST.
        /// </summary>
        /// <param name="printTaskToCreate">The PrintTask to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created PrintTask.</returns>
        System.Threading.Tasks.Task<PrintTask> CreateAsync(PrintTask printTaskToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified PrintTask using POST and returns a <see cref="GraphResponse{PrintTask}"/> object.
        /// </summary>
        /// <param name="printTaskToCreate">The PrintTask to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{PrintTask}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<PrintTask>> CreateResponseAsync(PrintTask printTaskToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified PrintTask.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified PrintTask and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified PrintTask.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The PrintTask.</returns>
        System.Threading.Tasks.Task<PrintTask> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified PrintTask and returns a <see cref="GraphResponse{PrintTask}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{PrintTask}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<PrintTask>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified PrintTask using PATCH.
        /// </summary>
        /// <param name="printTaskToUpdate">The PrintTask to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated PrintTask.</returns>
        System.Threading.Tasks.Task<PrintTask> UpdateAsync(PrintTask printTaskToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified PrintTask using PATCH and returns a <see cref="GraphResponse{PrintTask}"/> object.
        /// </summary>
        /// <param name="printTaskToUpdate">The PrintTask to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{PrintTask}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<PrintTask>> UpdateResponseAsync(PrintTask printTaskToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified PrintTask using PUT.
        /// </summary>
        /// <param name="printTaskToUpdate">The PrintTask object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<PrintTask> PutAsync(PrintTask printTaskToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified PrintTask using PUT and returns a <see cref="GraphResponse{PrintTask}"/> object.
        /// </summary>
        /// <param name="printTaskToUpdate">The PrintTask object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{PrintTask}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<PrintTask>> PutResponseAsync(PrintTask printTaskToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IPrintTaskRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IPrintTaskRequest Expand(Expression<Func<PrintTask, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IPrintTaskRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IPrintTaskRequest Select(Expression<Func<PrintTask, object>> selectExpression);

    }
}
