// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IPrinterCreateOperationRequest.
    /// </summary>
    public partial interface IPrinterCreateOperationRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified PrinterCreateOperation using POST.
        /// </summary>
        /// <param name="printerCreateOperationToCreate">The PrinterCreateOperation to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created PrinterCreateOperation.</returns>
        System.Threading.Tasks.Task<PrinterCreateOperation> CreateAsync(PrinterCreateOperation printerCreateOperationToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified PrinterCreateOperation using POST and returns a <see cref="GraphResponse{PrinterCreateOperation}"/> object.
        /// </summary>
        /// <param name="printerCreateOperationToCreate">The PrinterCreateOperation to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{PrinterCreateOperation}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<PrinterCreateOperation>> CreateResponseAsync(PrinterCreateOperation printerCreateOperationToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified PrinterCreateOperation.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified PrinterCreateOperation and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified PrinterCreateOperation.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The PrinterCreateOperation.</returns>
        System.Threading.Tasks.Task<PrinterCreateOperation> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified PrinterCreateOperation and returns a <see cref="GraphResponse{PrinterCreateOperation}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{PrinterCreateOperation}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<PrinterCreateOperation>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified PrinterCreateOperation using PATCH.
        /// </summary>
        /// <param name="printerCreateOperationToUpdate">The PrinterCreateOperation to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated PrinterCreateOperation.</returns>
        System.Threading.Tasks.Task<PrinterCreateOperation> UpdateAsync(PrinterCreateOperation printerCreateOperationToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified PrinterCreateOperation using PATCH and returns a <see cref="GraphResponse{PrinterCreateOperation}"/> object.
        /// </summary>
        /// <param name="printerCreateOperationToUpdate">The PrinterCreateOperation to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{PrinterCreateOperation}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<PrinterCreateOperation>> UpdateResponseAsync(PrinterCreateOperation printerCreateOperationToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified PrinterCreateOperation using PUT.
        /// </summary>
        /// <param name="printerCreateOperationToUpdate">The PrinterCreateOperation object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<PrinterCreateOperation> PutAsync(PrinterCreateOperation printerCreateOperationToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified PrinterCreateOperation using PUT and returns a <see cref="GraphResponse{PrinterCreateOperation}"/> object.
        /// </summary>
        /// <param name="printerCreateOperationToUpdate">The PrinterCreateOperation object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{PrinterCreateOperation}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<PrinterCreateOperation>> PutResponseAsync(PrinterCreateOperation printerCreateOperationToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IPrinterCreateOperationRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IPrinterCreateOperationRequest Expand(Expression<Func<PrinterCreateOperation, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IPrinterCreateOperationRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IPrinterCreateOperationRequest Select(Expression<Func<PrinterCreateOperation, object>> selectExpression);

    }
}
