// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityWithReferenceRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IPrinterWithReferenceRequest.
    /// </summary>
    public partial interface IPrinterWithReferenceRequest : IBaseRequest
    {
        /// <summary>
        /// Gets the specified Printer.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The Printer.</returns>
        System.Threading.Tasks.Task<Printer> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified Printer and returns a <see cref="GraphResponse{Printer}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{Printer}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<Printer>> GetResponseAsync(CancellationToken cancellationToken = default);

		/// <summary>
        /// Creates the specified Printer using POST.
        /// </summary>
        /// <param name="printerToCreate">The Printer to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created Printer.</returns>
        System.Threading.Tasks.Task<Printer> CreateAsync(Printer printerToCreate, CancellationToken cancellationToken = default);

		/// <summary>
        /// Creates the specified Printer using POST and returns a <see cref="GraphResponse{Printer}"/> object.
        /// </summary>
        /// <param name="printerToCreate">The Printer to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{Printer}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<Printer>> CreateResponseAsync(Printer printerToCreate, CancellationToken cancellationToken = default);

		/// <summary>
        /// Updates the specified Printer using PATCH.
        /// </summary>
        /// <param name="printerToUpdate">The Printer to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated Printer.</returns>
        System.Threading.Tasks.Task<Printer> UpdateAsync(Printer printerToUpdate, CancellationToken cancellationToken = default);

		/// <summary>
        /// Updates the specified Printer using PATCH and returns a <see cref="GraphResponse{Printer}"/> object.
        /// </summary>
        /// <param name="printerToUpdate">The Printer to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{Printer}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<Printer>> UpdateResponseAsync(Printer printerToUpdate, CancellationToken cancellationToken = default);

		/// <summary>
        /// Deletes the specified Printer.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

		/// <summary>
        /// Deletes the specified Printer and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IPrinterWithReferenceRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IPrinterWithReferenceRequest Expand(Expression<Func<Printer, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IPrinterWithReferenceRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IPrinterWithReferenceRequest Select(Expression<Func<Printer, object>> selectExpression);

    }
}
