// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IPrivacyRequest.
    /// </summary>
    public partial interface IPrivacyRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified Privacy using POST.
        /// </summary>
        /// <param name="privacyToCreate">The Privacy to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created Privacy.</returns>
        System.Threading.Tasks.Task<Privacy> CreateAsync(Privacy privacyToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified Privacy using POST and returns a <see cref="GraphResponse{Privacy}"/> object.
        /// </summary>
        /// <param name="privacyToCreate">The Privacy to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{Privacy}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<Privacy>> CreateResponseAsync(Privacy privacyToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified Privacy.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified Privacy and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified Privacy.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The Privacy.</returns>
        System.Threading.Tasks.Task<Privacy> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified Privacy and returns a <see cref="GraphResponse{Privacy}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{Privacy}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<Privacy>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified Privacy using PATCH.
        /// </summary>
        /// <param name="privacyToUpdate">The Privacy to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated Privacy.</returns>
        System.Threading.Tasks.Task<Privacy> UpdateAsync(Privacy privacyToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified Privacy using PATCH and returns a <see cref="GraphResponse{Privacy}"/> object.
        /// </summary>
        /// <param name="privacyToUpdate">The Privacy to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{Privacy}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<Privacy>> UpdateResponseAsync(Privacy privacyToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified Privacy using PUT.
        /// </summary>
        /// <param name="privacyToUpdate">The Privacy object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<Privacy> PutAsync(Privacy privacyToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified Privacy using PUT and returns a <see cref="GraphResponse{Privacy}"/> object.
        /// </summary>
        /// <param name="privacyToUpdate">The Privacy object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{Privacy}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<Privacy>> PutResponseAsync(Privacy privacyToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IPrivacyRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IPrivacyRequest Expand(Expression<Func<Privacy, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IPrivacyRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IPrivacyRequest Select(Expression<Func<Privacy, object>> selectExpression);

    }
}
