// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IProvisioningObjectSummaryRequest.
    /// </summary>
    public partial interface IProvisioningObjectSummaryRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified ProvisioningObjectSummary using POST.
        /// </summary>
        /// <param name="provisioningObjectSummaryToCreate">The ProvisioningObjectSummary to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created ProvisioningObjectSummary.</returns>
        System.Threading.Tasks.Task<ProvisioningObjectSummary> CreateAsync(ProvisioningObjectSummary provisioningObjectSummaryToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified ProvisioningObjectSummary using POST and returns a <see cref="GraphResponse{ProvisioningObjectSummary}"/> object.
        /// </summary>
        /// <param name="provisioningObjectSummaryToCreate">The ProvisioningObjectSummary to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{ProvisioningObjectSummary}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<ProvisioningObjectSummary>> CreateResponseAsync(ProvisioningObjectSummary provisioningObjectSummaryToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified ProvisioningObjectSummary.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified ProvisioningObjectSummary and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified ProvisioningObjectSummary.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The ProvisioningObjectSummary.</returns>
        System.Threading.Tasks.Task<ProvisioningObjectSummary> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified ProvisioningObjectSummary and returns a <see cref="GraphResponse{ProvisioningObjectSummary}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{ProvisioningObjectSummary}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<ProvisioningObjectSummary>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified ProvisioningObjectSummary using PATCH.
        /// </summary>
        /// <param name="provisioningObjectSummaryToUpdate">The ProvisioningObjectSummary to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated ProvisioningObjectSummary.</returns>
        System.Threading.Tasks.Task<ProvisioningObjectSummary> UpdateAsync(ProvisioningObjectSummary provisioningObjectSummaryToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified ProvisioningObjectSummary using PATCH and returns a <see cref="GraphResponse{ProvisioningObjectSummary}"/> object.
        /// </summary>
        /// <param name="provisioningObjectSummaryToUpdate">The ProvisioningObjectSummary to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{ProvisioningObjectSummary}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<ProvisioningObjectSummary>> UpdateResponseAsync(ProvisioningObjectSummary provisioningObjectSummaryToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified ProvisioningObjectSummary using PUT.
        /// </summary>
        /// <param name="provisioningObjectSummaryToUpdate">The ProvisioningObjectSummary object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<ProvisioningObjectSummary> PutAsync(ProvisioningObjectSummary provisioningObjectSummaryToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified ProvisioningObjectSummary using PUT and returns a <see cref="GraphResponse{ProvisioningObjectSummary}"/> object.
        /// </summary>
        /// <param name="provisioningObjectSummaryToUpdate">The ProvisioningObjectSummary object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{ProvisioningObjectSummary}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<ProvisioningObjectSummary>> PutResponseAsync(ProvisioningObjectSummary provisioningObjectSummaryToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IProvisioningObjectSummaryRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IProvisioningObjectSummaryRequest Expand(Expression<Func<ProvisioningObjectSummary, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IProvisioningObjectSummaryRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IProvisioningObjectSummaryRequest Select(Expression<Func<ProvisioningObjectSummary, object>> selectExpression);

    }
}
