// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface ISearchEntityRequest.
    /// </summary>
    public partial interface ISearchEntityRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified SearchEntity using POST.
        /// </summary>
        /// <param name="searchEntityToCreate">The SearchEntity to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created SearchEntity.</returns>
        System.Threading.Tasks.Task<SearchEntity> CreateAsync(SearchEntity searchEntityToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified SearchEntity using POST and returns a <see cref="GraphResponse{SearchEntity}"/> object.
        /// </summary>
        /// <param name="searchEntityToCreate">The SearchEntity to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{SearchEntity}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<SearchEntity>> CreateResponseAsync(SearchEntity searchEntityToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified SearchEntity.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified SearchEntity and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified SearchEntity.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The SearchEntity.</returns>
        System.Threading.Tasks.Task<SearchEntity> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified SearchEntity and returns a <see cref="GraphResponse{SearchEntity}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{SearchEntity}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<SearchEntity>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified SearchEntity using PATCH.
        /// </summary>
        /// <param name="searchEntityToUpdate">The SearchEntity to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated SearchEntity.</returns>
        System.Threading.Tasks.Task<SearchEntity> UpdateAsync(SearchEntity searchEntityToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified SearchEntity using PATCH and returns a <see cref="GraphResponse{SearchEntity}"/> object.
        /// </summary>
        /// <param name="searchEntityToUpdate">The SearchEntity to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{SearchEntity}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<SearchEntity>> UpdateResponseAsync(SearchEntity searchEntityToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified SearchEntity using PUT.
        /// </summary>
        /// <param name="searchEntityToUpdate">The SearchEntity object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<SearchEntity> PutAsync(SearchEntity searchEntityToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified SearchEntity using PUT and returns a <see cref="GraphResponse{SearchEntity}"/> object.
        /// </summary>
        /// <param name="searchEntityToUpdate">The SearchEntity object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{SearchEntity}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<SearchEntity>> PutResponseAsync(SearchEntity searchEntityToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        ISearchEntityRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        ISearchEntityRequest Expand(Expression<Func<SearchEntity, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        ISearchEntityRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        ISearchEntityRequest Select(Expression<Func<SearchEntity, object>> selectExpression);

    }
}
