// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface ISecureScoreRequest.
    /// </summary>
    public partial interface ISecureScoreRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified SecureScore using POST.
        /// </summary>
        /// <param name="secureScoreToCreate">The SecureScore to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created SecureScore.</returns>
        System.Threading.Tasks.Task<SecureScore> CreateAsync(SecureScore secureScoreToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified SecureScore using POST and returns a <see cref="GraphResponse{SecureScore}"/> object.
        /// </summary>
        /// <param name="secureScoreToCreate">The SecureScore to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{SecureScore}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<SecureScore>> CreateResponseAsync(SecureScore secureScoreToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified SecureScore.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified SecureScore and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified SecureScore.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The SecureScore.</returns>
        System.Threading.Tasks.Task<SecureScore> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified SecureScore and returns a <see cref="GraphResponse{SecureScore}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{SecureScore}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<SecureScore>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified SecureScore using PATCH.
        /// </summary>
        /// <param name="secureScoreToUpdate">The SecureScore to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated SecureScore.</returns>
        System.Threading.Tasks.Task<SecureScore> UpdateAsync(SecureScore secureScoreToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified SecureScore using PATCH and returns a <see cref="GraphResponse{SecureScore}"/> object.
        /// </summary>
        /// <param name="secureScoreToUpdate">The SecureScore to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{SecureScore}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<SecureScore>> UpdateResponseAsync(SecureScore secureScoreToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified SecureScore using PUT.
        /// </summary>
        /// <param name="secureScoreToUpdate">The SecureScore object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<SecureScore> PutAsync(SecureScore secureScoreToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified SecureScore using PUT and returns a <see cref="GraphResponse{SecureScore}"/> object.
        /// </summary>
        /// <param name="secureScoreToUpdate">The SecureScore object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{SecureScore}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<SecureScore>> PutResponseAsync(SecureScore secureScoreToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        ISecureScoreRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        ISecureScoreRequest Expand(Expression<Func<SecureScore, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        ISecureScoreRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        ISecureScoreRequest Select(Expression<Func<SecureScore, object>> selectExpression);

    }
}
