// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IServiceHealthIssueRequest.
    /// </summary>
    public partial interface IServiceHealthIssueRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified ServiceHealthIssue using POST.
        /// </summary>
        /// <param name="serviceHealthIssueToCreate">The ServiceHealthIssue to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created ServiceHealthIssue.</returns>
        System.Threading.Tasks.Task<ServiceHealthIssue> CreateAsync(ServiceHealthIssue serviceHealthIssueToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified ServiceHealthIssue using POST and returns a <see cref="GraphResponse{ServiceHealthIssue}"/> object.
        /// </summary>
        /// <param name="serviceHealthIssueToCreate">The ServiceHealthIssue to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{ServiceHealthIssue}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<ServiceHealthIssue>> CreateResponseAsync(ServiceHealthIssue serviceHealthIssueToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified ServiceHealthIssue.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified ServiceHealthIssue and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified ServiceHealthIssue.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The ServiceHealthIssue.</returns>
        System.Threading.Tasks.Task<ServiceHealthIssue> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified ServiceHealthIssue and returns a <see cref="GraphResponse{ServiceHealthIssue}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{ServiceHealthIssue}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<ServiceHealthIssue>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified ServiceHealthIssue using PATCH.
        /// </summary>
        /// <param name="serviceHealthIssueToUpdate">The ServiceHealthIssue to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated ServiceHealthIssue.</returns>
        System.Threading.Tasks.Task<ServiceHealthIssue> UpdateAsync(ServiceHealthIssue serviceHealthIssueToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified ServiceHealthIssue using PATCH and returns a <see cref="GraphResponse{ServiceHealthIssue}"/> object.
        /// </summary>
        /// <param name="serviceHealthIssueToUpdate">The ServiceHealthIssue to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{ServiceHealthIssue}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<ServiceHealthIssue>> UpdateResponseAsync(ServiceHealthIssue serviceHealthIssueToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified ServiceHealthIssue using PUT.
        /// </summary>
        /// <param name="serviceHealthIssueToUpdate">The ServiceHealthIssue object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<ServiceHealthIssue> PutAsync(ServiceHealthIssue serviceHealthIssueToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified ServiceHealthIssue using PUT and returns a <see cref="GraphResponse{ServiceHealthIssue}"/> object.
        /// </summary>
        /// <param name="serviceHealthIssueToUpdate">The ServiceHealthIssue object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{ServiceHealthIssue}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<ServiceHealthIssue>> PutResponseAsync(ServiceHealthIssue serviceHealthIssueToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IServiceHealthIssueRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IServiceHealthIssueRequest Expand(Expression<Func<ServiceHealthIssue, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IServiceHealthIssueRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IServiceHealthIssueRequest Select(Expression<Func<ServiceHealthIssue, object>> selectExpression);

    }
}
