// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IServiceHealthRequest.
    /// </summary>
    public partial interface IServiceHealthRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified ServiceHealth using POST.
        /// </summary>
        /// <param name="serviceHealthToCreate">The ServiceHealth to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created ServiceHealth.</returns>
        System.Threading.Tasks.Task<ServiceHealth> CreateAsync(ServiceHealth serviceHealthToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified ServiceHealth using POST and returns a <see cref="GraphResponse{ServiceHealth}"/> object.
        /// </summary>
        /// <param name="serviceHealthToCreate">The ServiceHealth to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{ServiceHealth}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<ServiceHealth>> CreateResponseAsync(ServiceHealth serviceHealthToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified ServiceHealth.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified ServiceHealth and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified ServiceHealth.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The ServiceHealth.</returns>
        System.Threading.Tasks.Task<ServiceHealth> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified ServiceHealth and returns a <see cref="GraphResponse{ServiceHealth}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{ServiceHealth}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<ServiceHealth>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified ServiceHealth using PATCH.
        /// </summary>
        /// <param name="serviceHealthToUpdate">The ServiceHealth to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated ServiceHealth.</returns>
        System.Threading.Tasks.Task<ServiceHealth> UpdateAsync(ServiceHealth serviceHealthToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified ServiceHealth using PATCH and returns a <see cref="GraphResponse{ServiceHealth}"/> object.
        /// </summary>
        /// <param name="serviceHealthToUpdate">The ServiceHealth to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{ServiceHealth}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<ServiceHealth>> UpdateResponseAsync(ServiceHealth serviceHealthToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified ServiceHealth using PUT.
        /// </summary>
        /// <param name="serviceHealthToUpdate">The ServiceHealth object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<ServiceHealth> PutAsync(ServiceHealth serviceHealthToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified ServiceHealth using PUT and returns a <see cref="GraphResponse{ServiceHealth}"/> object.
        /// </summary>
        /// <param name="serviceHealthToUpdate">The ServiceHealth object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{ServiceHealth}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<ServiceHealth>> PutResponseAsync(ServiceHealth serviceHealthToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IServiceHealthRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IServiceHealthRequest Expand(Expression<Func<ServiceHealth, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IServiceHealthRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IServiceHealthRequest Select(Expression<Func<ServiceHealth, object>> selectExpression);

    }
}
