// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The interface ISharedDriveItemRequestBuilder.
    /// </summary>
    public partial interface ISharedDriveItemRequestBuilder : IBaseItemRequestBuilder
    {
        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        new ISharedDriveItemRequest Request();

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        new ISharedDriveItemRequest Request(IEnumerable<Option> options);
    
        /// <summary>
        /// Gets the request builder for DriveItem.
        /// </summary>
        /// <returns>The <see cref="IDriveItemRequestBuilder"/>.</returns>
        IDriveItemRequestBuilder DriveItem { get; }

        /// <summary>
        /// Gets the request builder for Items.
        /// </summary>
        /// <returns>The <see cref="ISharedDriveItemItemsCollectionRequestBuilder"/>.</returns>
        ISharedDriveItemItemsCollectionRequestBuilder Items { get; }

        /// <summary>
        /// Gets the request builder for List.
        /// </summary>
        /// <returns>The <see cref="IListRequestBuilder"/>.</returns>
        IListRequestBuilder List { get; }

        /// <summary>
        /// Gets the request builder for ListItem.
        /// </summary>
        /// <returns>The <see cref="IListItemRequestBuilder"/>.</returns>
        IListItemRequestBuilder ListItem { get; }

        /// <summary>
        /// Gets the request builder for Permission.
        /// </summary>
        /// <returns>The <see cref="IPermissionRequestBuilder"/>.</returns>
        IPermissionRequestBuilder Permission { get; }

        /// <summary>
        /// Gets the request builder for Root.
        /// </summary>
        /// <returns>The <see cref="IDriveItemRequestBuilder"/>.</returns>
        IDriveItemRequestBuilder Root { get; }

        /// <summary>
        /// Gets the request builder for Site.
        /// </summary>
        /// <returns>The <see cref="ISiteRequestBuilder"/>.</returns>
        ISiteRequestBuilder Site { get; }
    
    }
}
