// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityCollectionRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface ISiteTermStoresCollectionRequest.
    /// </summary>
    public partial interface ISiteTermStoresCollectionRequest : IBaseRequest
    {
        /// <summary>
        /// Adds the specified Microsoft.Graph.TermStore.Store to the collection via POST.
        /// </summary>
        /// <param name="store">The Microsoft.Graph.TermStore.Store to add.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created Microsoft.Graph.TermStore.Store.</returns>
        System.Threading.Tasks.Task<Microsoft.Graph.TermStore.Store> AddAsync(Microsoft.Graph.TermStore.Store store, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified Microsoft.Graph.TermStore.Store to the collection via POST and returns a <see cref="GraphResponse{Microsoft.Graph.TermStore.Store}"/> object of the request.
        /// </summary>
        /// <param name="store">The Microsoft.Graph.TermStore.Store to add.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{Microsoft.Graph.TermStore.Store}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<Microsoft.Graph.TermStore.Store>> AddResponseAsync(Microsoft.Graph.TermStore.Store store, CancellationToken cancellationToken = default);


        /// <summary>
        /// Gets the collection page.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The collection page.</returns>
        System.Threading.Tasks.Task<ISiteTermStoresCollectionPage> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the collection page and returns a <see cref="GraphResponse{SiteTermStoresCollectionResponse}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{SiteTermStoresCollectionResponse}"/> object.</returns>
        System.Threading.Tasks.Task<GraphResponse<SiteTermStoresCollectionResponse>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        ISiteTermStoresCollectionRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        ISiteTermStoresCollectionRequest Expand(Expression<Func<Microsoft.Graph.TermStore.Store, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        ISiteTermStoresCollectionRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        ISiteTermStoresCollectionRequest Select(Expression<Func<Microsoft.Graph.TermStore.Store, object>> selectExpression);

        /// <summary>
        /// Adds the specified top value to the request.
        /// </summary>
        /// <param name="value">The top value.</param>
        /// <returns>The request object to send.</returns>
        ISiteTermStoresCollectionRequest Top(int value);

        /// <summary>
        /// Adds the specified filter value to the request.
        /// </summary>
        /// <param name="value">The filter value.</param>
        /// <returns>The request object to send.</returns>
        ISiteTermStoresCollectionRequest Filter(string value);

        /// <summary>
        /// Adds the specified skip value to the request.
        /// </summary>
        /// <param name="value">The skip value.</param>
        /// <returns>The request object to send.</returns>
        ISiteTermStoresCollectionRequest Skip(int value);

        /// <summary>
        /// Adds the specified orderby value to the request.
        /// </summary>
        /// <param name="value">The orderby value.</param>
        /// <returns>The request object to send.</returns>
        ISiteTermStoresCollectionRequest OrderBy(string value);
    }
}
