// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface ITimeOffReasonRequest.
    /// </summary>
    public partial interface ITimeOffReasonRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified TimeOffReason using POST.
        /// </summary>
        /// <param name="timeOffReasonToCreate">The TimeOffReason to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created TimeOffReason.</returns>
        System.Threading.Tasks.Task<TimeOffReason> CreateAsync(TimeOffReason timeOffReasonToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified TimeOffReason using POST and returns a <see cref="GraphResponse{TimeOffReason}"/> object.
        /// </summary>
        /// <param name="timeOffReasonToCreate">The TimeOffReason to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{TimeOffReason}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<TimeOffReason>> CreateResponseAsync(TimeOffReason timeOffReasonToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified TimeOffReason.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified TimeOffReason and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified TimeOffReason.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The TimeOffReason.</returns>
        System.Threading.Tasks.Task<TimeOffReason> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified TimeOffReason and returns a <see cref="GraphResponse{TimeOffReason}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{TimeOffReason}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<TimeOffReason>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified TimeOffReason using PATCH.
        /// </summary>
        /// <param name="timeOffReasonToUpdate">The TimeOffReason to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated TimeOffReason.</returns>
        System.Threading.Tasks.Task<TimeOffReason> UpdateAsync(TimeOffReason timeOffReasonToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified TimeOffReason using PATCH and returns a <see cref="GraphResponse{TimeOffReason}"/> object.
        /// </summary>
        /// <param name="timeOffReasonToUpdate">The TimeOffReason to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{TimeOffReason}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<TimeOffReason>> UpdateResponseAsync(TimeOffReason timeOffReasonToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified TimeOffReason using PUT.
        /// </summary>
        /// <param name="timeOffReasonToUpdate">The TimeOffReason object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<TimeOffReason> PutAsync(TimeOffReason timeOffReasonToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified TimeOffReason using PUT and returns a <see cref="GraphResponse{TimeOffReason}"/> object.
        /// </summary>
        /// <param name="timeOffReasonToUpdate">The TimeOffReason object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{TimeOffReason}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<TimeOffReason>> PutResponseAsync(TimeOffReason timeOffReasonToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        ITimeOffReasonRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        ITimeOffReasonRequest Expand(Expression<Func<TimeOffReason, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        ITimeOffReasonRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        ITimeOffReasonRequest Select(Expression<Func<TimeOffReason, object>> selectExpression);

    }
}
