// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IUnifiedRoleDefinitionRequest.
    /// </summary>
    public partial interface IUnifiedRoleDefinitionRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified UnifiedRoleDefinition using POST.
        /// </summary>
        /// <param name="unifiedRoleDefinitionToCreate">The UnifiedRoleDefinition to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created UnifiedRoleDefinition.</returns>
        System.Threading.Tasks.Task<UnifiedRoleDefinition> CreateAsync(UnifiedRoleDefinition unifiedRoleDefinitionToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified UnifiedRoleDefinition using POST and returns a <see cref="GraphResponse{UnifiedRoleDefinition}"/> object.
        /// </summary>
        /// <param name="unifiedRoleDefinitionToCreate">The UnifiedRoleDefinition to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{UnifiedRoleDefinition}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<UnifiedRoleDefinition>> CreateResponseAsync(UnifiedRoleDefinition unifiedRoleDefinitionToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified UnifiedRoleDefinition.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified UnifiedRoleDefinition and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified UnifiedRoleDefinition.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The UnifiedRoleDefinition.</returns>
        System.Threading.Tasks.Task<UnifiedRoleDefinition> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified UnifiedRoleDefinition and returns a <see cref="GraphResponse{UnifiedRoleDefinition}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{UnifiedRoleDefinition}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<UnifiedRoleDefinition>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified UnifiedRoleDefinition using PATCH.
        /// </summary>
        /// <param name="unifiedRoleDefinitionToUpdate">The UnifiedRoleDefinition to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated UnifiedRoleDefinition.</returns>
        System.Threading.Tasks.Task<UnifiedRoleDefinition> UpdateAsync(UnifiedRoleDefinition unifiedRoleDefinitionToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified UnifiedRoleDefinition using PATCH and returns a <see cref="GraphResponse{UnifiedRoleDefinition}"/> object.
        /// </summary>
        /// <param name="unifiedRoleDefinitionToUpdate">The UnifiedRoleDefinition to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{UnifiedRoleDefinition}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<UnifiedRoleDefinition>> UpdateResponseAsync(UnifiedRoleDefinition unifiedRoleDefinitionToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified UnifiedRoleDefinition using PUT.
        /// </summary>
        /// <param name="unifiedRoleDefinitionToUpdate">The UnifiedRoleDefinition object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<UnifiedRoleDefinition> PutAsync(UnifiedRoleDefinition unifiedRoleDefinitionToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified UnifiedRoleDefinition using PUT and returns a <see cref="GraphResponse{UnifiedRoleDefinition}"/> object.
        /// </summary>
        /// <param name="unifiedRoleDefinitionToUpdate">The UnifiedRoleDefinition object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{UnifiedRoleDefinition}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<UnifiedRoleDefinition>> PutResponseAsync(UnifiedRoleDefinition unifiedRoleDefinitionToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IUnifiedRoleDefinitionRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IUnifiedRoleDefinitionRequest Expand(Expression<Func<UnifiedRoleDefinition, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IUnifiedRoleDefinitionRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IUnifiedRoleDefinitionRequest Select(Expression<Func<UnifiedRoleDefinition, object>> selectExpression);

    }
}
