// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IUserConsentRequestRequest.
    /// </summary>
    public partial interface IUserConsentRequestRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified UserConsentRequestObject using POST.
        /// </summary>
        /// <param name="userConsentRequestObjectToCreate">The UserConsentRequestObject to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created UserConsentRequestObject.</returns>
        System.Threading.Tasks.Task<UserConsentRequestObject> CreateAsync(UserConsentRequestObject userConsentRequestObjectToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified UserConsentRequestObject using POST and returns a <see cref="GraphResponse{UserConsentRequestObject}"/> object.
        /// </summary>
        /// <param name="userConsentRequestObjectToCreate">The UserConsentRequestObject to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{UserConsentRequestObject}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<UserConsentRequestObject>> CreateResponseAsync(UserConsentRequestObject userConsentRequestObjectToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified UserConsentRequestObject.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified UserConsentRequestObject and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified UserConsentRequestObject.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The UserConsentRequestObject.</returns>
        System.Threading.Tasks.Task<UserConsentRequestObject> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified UserConsentRequestObject and returns a <see cref="GraphResponse{UserConsentRequestObject}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{UserConsentRequestObject}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<UserConsentRequestObject>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified UserConsentRequestObject using PATCH.
        /// </summary>
        /// <param name="userConsentRequestObjectToUpdate">The UserConsentRequestObject to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated UserConsentRequestObject.</returns>
        System.Threading.Tasks.Task<UserConsentRequestObject> UpdateAsync(UserConsentRequestObject userConsentRequestObjectToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified UserConsentRequestObject using PATCH and returns a <see cref="GraphResponse{UserConsentRequestObject}"/> object.
        /// </summary>
        /// <param name="userConsentRequestObjectToUpdate">The UserConsentRequestObject to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{UserConsentRequestObject}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<UserConsentRequestObject>> UpdateResponseAsync(UserConsentRequestObject userConsentRequestObjectToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified UserConsentRequestObject using PUT.
        /// </summary>
        /// <param name="userConsentRequestObjectToUpdate">The UserConsentRequestObject object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<UserConsentRequestObject> PutAsync(UserConsentRequestObject userConsentRequestObjectToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified UserConsentRequestObject using PUT and returns a <see cref="GraphResponse{UserConsentRequestObject}"/> object.
        /// </summary>
        /// <param name="userConsentRequestObjectToUpdate">The UserConsentRequestObject object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{UserConsentRequestObject}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<UserConsentRequestObject>> PutResponseAsync(UserConsentRequestObject userConsentRequestObjectToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IUserConsentRequestRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IUserConsentRequestRequest Expand(Expression<Func<UserConsentRequestObject, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IUserConsentRequestRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IUserConsentRequestRequest Select(Expression<Func<UserConsentRequestObject, object>> selectExpression);

    }
}
