// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IUserFlowLanguagePageRequest.
    /// </summary>
    public partial interface IUserFlowLanguagePageRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified UserFlowLanguagePage using POST.
        /// </summary>
        /// <param name="userFlowLanguagePageToCreate">The UserFlowLanguagePage to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created UserFlowLanguagePage.</returns>
        System.Threading.Tasks.Task<UserFlowLanguagePage> CreateAsync(UserFlowLanguagePage userFlowLanguagePageToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified UserFlowLanguagePage using POST and returns a <see cref="GraphResponse{UserFlowLanguagePage}"/> object.
        /// </summary>
        /// <param name="userFlowLanguagePageToCreate">The UserFlowLanguagePage to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{UserFlowLanguagePage}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<UserFlowLanguagePage>> CreateResponseAsync(UserFlowLanguagePage userFlowLanguagePageToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified UserFlowLanguagePage.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified UserFlowLanguagePage and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified UserFlowLanguagePage.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The UserFlowLanguagePage.</returns>
        System.Threading.Tasks.Task<UserFlowLanguagePage> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified UserFlowLanguagePage and returns a <see cref="GraphResponse{UserFlowLanguagePage}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{UserFlowLanguagePage}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<UserFlowLanguagePage>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified UserFlowLanguagePage using PATCH.
        /// </summary>
        /// <param name="userFlowLanguagePageToUpdate">The UserFlowLanguagePage to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated UserFlowLanguagePage.</returns>
        System.Threading.Tasks.Task<UserFlowLanguagePage> UpdateAsync(UserFlowLanguagePage userFlowLanguagePageToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified UserFlowLanguagePage using PATCH and returns a <see cref="GraphResponse{UserFlowLanguagePage}"/> object.
        /// </summary>
        /// <param name="userFlowLanguagePageToUpdate">The UserFlowLanguagePage to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{UserFlowLanguagePage}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<UserFlowLanguagePage>> UpdateResponseAsync(UserFlowLanguagePage userFlowLanguagePageToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified UserFlowLanguagePage using PUT.
        /// </summary>
        /// <param name="userFlowLanguagePageToUpdate">The UserFlowLanguagePage object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<UserFlowLanguagePage> PutAsync(UserFlowLanguagePage userFlowLanguagePageToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified UserFlowLanguagePage using PUT and returns a <see cref="GraphResponse{UserFlowLanguagePage}"/> object.
        /// </summary>
        /// <param name="userFlowLanguagePageToUpdate">The UserFlowLanguagePage object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{UserFlowLanguagePage}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<UserFlowLanguagePage>> PutResponseAsync(UserFlowLanguagePage userFlowLanguagePageToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IUserFlowLanguagePageRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IUserFlowLanguagePageRequest Expand(Expression<Func<UserFlowLanguagePage, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IUserFlowLanguagePageRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IUserFlowLanguagePageRequest Select(Expression<Func<UserFlowLanguagePage, object>> selectExpression);

    }
}
