// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IUserSettingsRequest.
    /// </summary>
    public partial interface IUserSettingsRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified UserSettings using POST.
        /// </summary>
        /// <param name="userSettingsToCreate">The UserSettings to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created UserSettings.</returns>
        System.Threading.Tasks.Task<UserSettings> CreateAsync(UserSettings userSettingsToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified UserSettings using POST and returns a <see cref="GraphResponse{UserSettings}"/> object.
        /// </summary>
        /// <param name="userSettingsToCreate">The UserSettings to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{UserSettings}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<UserSettings>> CreateResponseAsync(UserSettings userSettingsToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified UserSettings.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified UserSettings and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified UserSettings.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The UserSettings.</returns>
        System.Threading.Tasks.Task<UserSettings> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified UserSettings and returns a <see cref="GraphResponse{UserSettings}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{UserSettings}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<UserSettings>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified UserSettings using PATCH.
        /// </summary>
        /// <param name="userSettingsToUpdate">The UserSettings to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated UserSettings.</returns>
        System.Threading.Tasks.Task<UserSettings> UpdateAsync(UserSettings userSettingsToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified UserSettings using PATCH and returns a <see cref="GraphResponse{UserSettings}"/> object.
        /// </summary>
        /// <param name="userSettingsToUpdate">The UserSettings to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{UserSettings}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<UserSettings>> UpdateResponseAsync(UserSettings userSettingsToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified UserSettings using PUT.
        /// </summary>
        /// <param name="userSettingsToUpdate">The UserSettings object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<UserSettings> PutAsync(UserSettings userSettingsToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified UserSettings using PUT and returns a <see cref="GraphResponse{UserSettings}"/> object.
        /// </summary>
        /// <param name="userSettingsToUpdate">The UserSettings object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{UserSettings}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<UserSettings>> PutResponseAsync(UserSettings userSettingsToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IUserSettingsRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IUserSettingsRequest Expand(Expression<Func<UserSettings, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IUserSettingsRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IUserSettingsRequest Select(Expression<Func<UserSettings, object>> selectExpression);

    }
}
