// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IUserTeamworkRequest.
    /// </summary>
    public partial interface IUserTeamworkRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified UserTeamwork using POST.
        /// </summary>
        /// <param name="userTeamworkToCreate">The UserTeamwork to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created UserTeamwork.</returns>
        System.Threading.Tasks.Task<UserTeamwork> CreateAsync(UserTeamwork userTeamworkToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified UserTeamwork using POST and returns a <see cref="GraphResponse{UserTeamwork}"/> object.
        /// </summary>
        /// <param name="userTeamworkToCreate">The UserTeamwork to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{UserTeamwork}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<UserTeamwork>> CreateResponseAsync(UserTeamwork userTeamworkToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified UserTeamwork.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified UserTeamwork and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified UserTeamwork.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The UserTeamwork.</returns>
        System.Threading.Tasks.Task<UserTeamwork> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified UserTeamwork and returns a <see cref="GraphResponse{UserTeamwork}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{UserTeamwork}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<UserTeamwork>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified UserTeamwork using PATCH.
        /// </summary>
        /// <param name="userTeamworkToUpdate">The UserTeamwork to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated UserTeamwork.</returns>
        System.Threading.Tasks.Task<UserTeamwork> UpdateAsync(UserTeamwork userTeamworkToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified UserTeamwork using PATCH and returns a <see cref="GraphResponse{UserTeamwork}"/> object.
        /// </summary>
        /// <param name="userTeamworkToUpdate">The UserTeamwork to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{UserTeamwork}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<UserTeamwork>> UpdateResponseAsync(UserTeamwork userTeamworkToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified UserTeamwork using PUT.
        /// </summary>
        /// <param name="userTeamworkToUpdate">The UserTeamwork object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<UserTeamwork> PutAsync(UserTeamwork userTeamworkToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified UserTeamwork using PUT and returns a <see cref="GraphResponse{UserTeamwork}"/> object.
        /// </summary>
        /// <param name="userTeamworkToUpdate">The UserTeamwork object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{UserTeamwork}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<UserTeamwork>> PutResponseAsync(UserTeamwork userTeamworkToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IUserTeamworkRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IUserTeamworkRequest Expand(Expression<Func<UserTeamwork, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IUserTeamworkRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IUserTeamworkRequest Select(Expression<Func<UserTeamwork, object>> selectExpression);

    }
}
