// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The interface IWorkbookChartRequestBuilder.
    /// </summary>
    public partial interface IWorkbookChartRequestBuilder : IEntityRequestBuilder
    {
        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        new IWorkbookChartRequest Request();

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        new IWorkbookChartRequest Request(IEnumerable<Option> options);
    
        /// <summary>
        /// Gets the request builder for Axes.
        /// </summary>
        /// <returns>The <see cref="IWorkbookChartAxesRequestBuilder"/>.</returns>
        IWorkbookChartAxesRequestBuilder Axes { get; }

        /// <summary>
        /// Gets the request builder for DataLabels.
        /// </summary>
        /// <returns>The <see cref="IWorkbookChartDataLabelsRequestBuilder"/>.</returns>
        IWorkbookChartDataLabelsRequestBuilder DataLabels { get; }

        /// <summary>
        /// Gets the request builder for Format.
        /// </summary>
        /// <returns>The <see cref="IWorkbookChartAreaFormatRequestBuilder"/>.</returns>
        IWorkbookChartAreaFormatRequestBuilder Format { get; }

        /// <summary>
        /// Gets the request builder for Legend.
        /// </summary>
        /// <returns>The <see cref="IWorkbookChartLegendRequestBuilder"/>.</returns>
        IWorkbookChartLegendRequestBuilder Legend { get; }

        /// <summary>
        /// Gets the request builder for Series.
        /// </summary>
        /// <returns>The <see cref="IWorkbookChartSeriesCollectionRequestBuilder"/>.</returns>
        IWorkbookChartSeriesCollectionRequestBuilder Series { get; }

        /// <summary>
        /// Gets the request builder for Title.
        /// </summary>
        /// <returns>The <see cref="IWorkbookChartTitleRequestBuilder"/>.</returns>
        IWorkbookChartTitleRequestBuilder Title { get; }

        /// <summary>
        /// Gets the request builder for Worksheet.
        /// </summary>
        /// <returns>The <see cref="IWorkbookWorksheetRequestBuilder"/>.</returns>
        IWorkbookWorksheetRequestBuilder Worksheet { get; }
    
        /// <summary>
        /// Gets the request builder for WorkbookChartSetData.
        /// </summary>
        /// <returns>The <see cref="IWorkbookChartSetDataRequestBuilder"/>.</returns>
        IWorkbookChartSetDataRequestBuilder SetData(
            string seriesBy,
            System.Text.Json.JsonDocument sourceData = null);

        /// <summary>
        /// Gets the request builder for WorkbookChartSetPosition.
        /// </summary>
        /// <returns>The <see cref="IWorkbookChartSetPositionRequestBuilder"/>.</returns>
        IWorkbookChartSetPositionRequestBuilder SetPosition(
            System.Text.Json.JsonDocument startCell = null,
            System.Text.Json.JsonDocument endCell = null);

        /// <summary>
        /// Gets the request builder for WorkbookChartImage.
        /// </summary>
        /// <returns>The <see cref="IWorkbookChartImageRequestBuilder"/>.</returns>
        IWorkbookChartImageRequestBuilder Image();

        /// <summary>
        /// Gets the request builder for WorkbookChartImage.
        /// </summary>
        /// <returns>The <see cref="IWorkbookChartImageRequestBuilder"/>.</returns>
        IWorkbookChartImageRequestBuilder Image(
            Int32 width);

        /// <summary>
        /// Gets the request builder for WorkbookChartImage.
        /// </summary>
        /// <returns>The <see cref="IWorkbookChartImageRequestBuilder"/>.</returns>
        IWorkbookChartImageRequestBuilder Image(
            Int32 width,
            Int32 height);

        /// <summary>
        /// Gets the request builder for WorkbookChartImage.
        /// </summary>
        /// <returns>The <see cref="IWorkbookChartImageRequestBuilder"/>.</returns>
        IWorkbookChartImageRequestBuilder Image(
            Int32 width,
            Int32 height,
            string fittingMode);
    
    }
}
