// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IWorkbookTableSortRequest.
    /// </summary>
    public partial interface IWorkbookTableSortRequest : IBaseRequest
    {
        /// <summary>
        /// Creates the specified WorkbookTableSort using POST.
        /// </summary>
        /// <param name="workbookTableSortToCreate">The WorkbookTableSort to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created WorkbookTableSort.</returns>
        System.Threading.Tasks.Task<WorkbookTableSort> CreateAsync(WorkbookTableSort workbookTableSortToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified WorkbookTableSort using POST and returns a <see cref="GraphResponse{WorkbookTableSort}"/> object.
        /// </summary>
        /// <param name="workbookTableSortToCreate">The WorkbookTableSort to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{WorkbookTableSort}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<WorkbookTableSort>> CreateResponseAsync(WorkbookTableSort workbookTableSortToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified WorkbookTableSort.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified WorkbookTableSort and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified WorkbookTableSort.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The WorkbookTableSort.</returns>
        System.Threading.Tasks.Task<WorkbookTableSort> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified WorkbookTableSort and returns a <see cref="GraphResponse{WorkbookTableSort}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{WorkbookTableSort}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<WorkbookTableSort>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified WorkbookTableSort using PATCH.
        /// </summary>
        /// <param name="workbookTableSortToUpdate">The WorkbookTableSort to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated WorkbookTableSort.</returns>
        System.Threading.Tasks.Task<WorkbookTableSort> UpdateAsync(WorkbookTableSort workbookTableSortToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified WorkbookTableSort using PATCH and returns a <see cref="GraphResponse{WorkbookTableSort}"/> object.
        /// </summary>
        /// <param name="workbookTableSortToUpdate">The WorkbookTableSort to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{WorkbookTableSort}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<WorkbookTableSort>> UpdateResponseAsync(WorkbookTableSort workbookTableSortToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified WorkbookTableSort using PUT.
        /// </summary>
        /// <param name="workbookTableSortToUpdate">The WorkbookTableSort object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<WorkbookTableSort> PutAsync(WorkbookTableSort workbookTableSortToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified WorkbookTableSort using PUT and returns a <see cref="GraphResponse{WorkbookTableSort}"/> object.
        /// </summary>
        /// <param name="workbookTableSortToUpdate">The WorkbookTableSort object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{WorkbookTableSort}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<WorkbookTableSort>> PutResponseAsync(WorkbookTableSort workbookTableSortToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IWorkbookTableSortRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IWorkbookTableSortRequest Expand(Expression<Func<WorkbookTableSort, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IWorkbookTableSortRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IWorkbookTableSortRequest Select(Expression<Func<WorkbookTableSort, object>> selectExpression);

    }
}
