// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: MethodRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type IdentityApiConnectorUploadClientCertificateRequestBuilder.
    /// </summary>
    public partial class IdentityApiConnectorUploadClientCertificateRequestBuilder : BaseActionMethodRequestBuilder<IIdentityApiConnectorUploadClientCertificateRequest>, IIdentityApiConnectorUploadClientCertificateRequestBuilder
    {
        /// <summary>
        /// Constructs a new <see cref="IdentityApiConnectorUploadClientCertificateRequestBuilder"/>.
        /// </summary>
        /// <param name="requestUrl">The URL for the request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        /// <param name="pkcs12Value">A pkcs12Value parameter for the OData method call.</param>
        /// <param name="password">A password parameter for the OData method call.</param>
        public IdentityApiConnectorUploadClientCertificateRequestBuilder(
            string requestUrl,
            IBaseClient client,
            string pkcs12Value,
            string password)
            : base(requestUrl, client)
        {
            this.SetParameter("pkcs12Value", pkcs12Value, true);
            this.SetParameter("password", password, true);
        }

        /// <summary>
        /// A method used by the base class to construct a request class instance.
        /// </summary>
        /// <param name="functionUrl">The request URL to </param>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>An instance of a specific request class.</returns>
        protected override IIdentityApiConnectorUploadClientCertificateRequest CreateRequest(string functionUrl, IEnumerable<Option> options)
        {
            var request = new IdentityApiConnectorUploadClientCertificateRequest(functionUrl, this.Client, options);

            if (this.HasParameter("pkcs12Value"))
            {
                request.RequestBody.Pkcs12Value = this.GetParameter<string>("pkcs12Value");
            }

            if (this.HasParameter("password"))
            {
                request.RequestBody.Password = this.GetParameter<string>("password");
            }

            return request;
        }
    }
}
