// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type InformationProtectionRequestBuilder.
    /// </summary>
    public partial class InformationProtectionRequestBuilder : EntityRequestBuilder, IInformationProtectionRequestBuilder
    {

        /// <summary>
        /// Constructs a new InformationProtectionRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public InformationProtectionRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public new IInformationProtectionRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public new IInformationProtectionRequest Request(IEnumerable<Option> options)
        {
            return new InformationProtectionRequest(this.RequestUrl, this.Client, options);
        }
    
        /// <summary>
        /// Gets the request builder for Bitlocker.
        /// </summary>
        /// <returns>The <see cref="IBitlockerRequestBuilder"/>.</returns>
        public IBitlockerRequestBuilder Bitlocker
        {
            get
            {
                return new BitlockerRequestBuilder(this.AppendSegmentToRequestUrl("bitlocker"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for ThreatAssessmentRequests.
        /// </summary>
        /// <returns>The <see cref="IInformationProtectionThreatAssessmentRequestsCollectionRequestBuilder"/>.</returns>
        public IInformationProtectionThreatAssessmentRequestsCollectionRequestBuilder ThreatAssessmentRequests
        {
            get
            {
                return new InformationProtectionThreatAssessmentRequestsCollectionRequestBuilder(this.AppendSegmentToRequestUrl("threatAssessmentRequests"), this.Client);
            }
        }
    
    }
}
