// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityCollectionRequestBuilder.cs.tt
namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// The type MailFolderMessagesCollectionRequestBuilder.
    /// </summary>
    public partial class MailFolderMessagesCollectionRequestBuilder : BaseRequestBuilder, IMailFolderMessagesCollectionRequestBuilder
    {
        /// <summary>
        /// Constructs a new MailFolderMessagesCollectionRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public MailFolderMessagesCollectionRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public IMailFolderMessagesCollectionRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public IMailFolderMessagesCollectionRequest Request(IEnumerable<Option> options)
        {
            return new MailFolderMessagesCollectionRequest(this.RequestUrl, this.Client, options);
        }

        /// <summary>
        /// Gets an <see cref="IMessageRequestBuilder"/> for the specified MailFolderMessage.
        /// </summary>
        /// <param name="id">The ID for the MailFolderMessage.</param>
        /// <returns>The <see cref="IMessageRequestBuilder"/>.</returns>
        public IMessageRequestBuilder this[string id]
        {
            get
            {
                return new MessageRequestBuilder(this.AppendSegmentToRequestUrl(id), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for MessageDelta.
        /// </summary>
        /// <returns>The <see cref="IMessageDeltaRequestBuilder"/>.</returns>
        public IMessageDeltaRequestBuilder Delta()
        {
            return new MessageDeltaRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.delta"),
                this.Client);
        }
    }
}
