// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type ManagedAppRegistrationRequestBuilder.
    /// </summary>
    public partial class ManagedAppRegistrationRequestBuilder : EntityRequestBuilder, IManagedAppRegistrationRequestBuilder
    {

        /// <summary>
        /// Constructs a new ManagedAppRegistrationRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public ManagedAppRegistrationRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public new IManagedAppRegistrationRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public new IManagedAppRegistrationRequest Request(IEnumerable<Option> options)
        {
            return new ManagedAppRegistrationRequest(this.RequestUrl, this.Client, options);
        }
    
        /// <summary>
        /// Gets the request builder for AppliedPolicies.
        /// </summary>
        /// <returns>The <see cref="IManagedAppRegistrationAppliedPoliciesCollectionRequestBuilder"/>.</returns>
        public IManagedAppRegistrationAppliedPoliciesCollectionRequestBuilder AppliedPolicies
        {
            get
            {
                return new ManagedAppRegistrationAppliedPoliciesCollectionRequestBuilder(this.AppendSegmentToRequestUrl("appliedPolicies"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for IntendedPolicies.
        /// </summary>
        /// <returns>The <see cref="IManagedAppRegistrationIntendedPoliciesCollectionRequestBuilder"/>.</returns>
        public IManagedAppRegistrationIntendedPoliciesCollectionRequestBuilder IntendedPolicies
        {
            get
            {
                return new ManagedAppRegistrationIntendedPoliciesCollectionRequestBuilder(this.AppendSegmentToRequestUrl("intendedPolicies"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for Operations.
        /// </summary>
        /// <returns>The <see cref="IManagedAppRegistrationOperationsCollectionRequestBuilder"/>.</returns>
        public IManagedAppRegistrationOperationsCollectionRequestBuilder Operations
        {
            get
            {
                return new ManagedAppRegistrationOperationsCollectionRequestBuilder(this.AppendSegmentToRequestUrl("operations"), this.Client);
            }
        }
    
        
    
    }
}
