// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: MethodRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type ManagedDeviceWipeRequestBuilder.
    /// </summary>
    public partial class ManagedDeviceWipeRequestBuilder : BaseActionMethodRequestBuilder<IManagedDeviceWipeRequest>, IManagedDeviceWipeRequestBuilder
    {
        /// <summary>
        /// Constructs a new <see cref="ManagedDeviceWipeRequestBuilder"/>.
        /// </summary>
        /// <param name="requestUrl">The URL for the request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        /// <param name="keepEnrollmentData">A keepEnrollmentData parameter for the OData method call.</param>
        /// <param name="keepUserData">A keepUserData parameter for the OData method call.</param>
        /// <param name="macOsUnlockCode">A macOsUnlockCode parameter for the OData method call.</param>
        /// <param name="persistEsimDataPlan">A persistEsimDataPlan parameter for the OData method call.</param>
        public ManagedDeviceWipeRequestBuilder(
            string requestUrl,
            IBaseClient client,
            bool? keepEnrollmentData,
            bool? keepUserData,
            string macOsUnlockCode,
            bool? persistEsimDataPlan)
            : base(requestUrl, client)
        {
            this.SetParameter("keepEnrollmentData", keepEnrollmentData, true);
            this.SetParameter("keepUserData", keepUserData, true);
            this.SetParameter("macOsUnlockCode", macOsUnlockCode, true);
            this.SetParameter("persistEsimDataPlan", persistEsimDataPlan, true);
        }

        /// <summary>
        /// A method used by the base class to construct a request class instance.
        /// </summary>
        /// <param name="functionUrl">The request URL to </param>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>An instance of a specific request class.</returns>
        protected override IManagedDeviceWipeRequest CreateRequest(string functionUrl, IEnumerable<Option> options)
        {
            var request = new ManagedDeviceWipeRequest(functionUrl, this.Client, options);

            if (this.HasParameter("keepEnrollmentData"))
            {
                request.RequestBody.KeepEnrollmentData = this.GetParameter<bool?>("keepEnrollmentData");
            }

            if (this.HasParameter("keepUserData"))
            {
                request.RequestBody.KeepUserData = this.GetParameter<bool?>("keepUserData");
            }

            if (this.HasParameter("macOsUnlockCode"))
            {
                request.RequestBody.MacOsUnlockCode = this.GetParameter<string>("macOsUnlockCode");
            }

            if (this.HasParameter("persistEsimDataPlan"))
            {
                request.RequestBody.PersistEsimDataPlan = this.GetParameter<bool?>("persistEsimDataPlan");
            }

            return request;
        }
    }
}
