// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type MicrosoftAuthenticatorAuthenticationMethodConfigurationRequestBuilder.
    /// </summary>
    public partial class MicrosoftAuthenticatorAuthenticationMethodConfigurationRequestBuilder : AuthenticationMethodConfigurationRequestBuilder, IMicrosoftAuthenticatorAuthenticationMethodConfigurationRequestBuilder
    {

        /// <summary>
        /// Constructs a new MicrosoftAuthenticatorAuthenticationMethodConfigurationRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public MicrosoftAuthenticatorAuthenticationMethodConfigurationRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public new IMicrosoftAuthenticatorAuthenticationMethodConfigurationRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public new IMicrosoftAuthenticatorAuthenticationMethodConfigurationRequest Request(IEnumerable<Option> options)
        {
            return new MicrosoftAuthenticatorAuthenticationMethodConfigurationRequest(this.RequestUrl, this.Client, options);
        }
    
        /// <summary>
        /// Gets the request builder for IncludeTargets.
        /// </summary>
        /// <returns>The <see cref="IMicrosoftAuthenticatorAuthenticationMethodConfigurationIncludeTargetsCollectionRequestBuilder"/>.</returns>
        public IMicrosoftAuthenticatorAuthenticationMethodConfigurationIncludeTargetsCollectionRequestBuilder IncludeTargets
        {
            get
            {
                return new MicrosoftAuthenticatorAuthenticationMethodConfigurationIncludeTargetsCollectionRequestBuilder(this.AppendSegmentToRequestUrl("includeTargets"), this.Client);
            }
        }
    
    }
}
