// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type OfficeGraphInsightsRequestBuilder.
    /// </summary>
    public partial class OfficeGraphInsightsRequestBuilder : EntityRequestBuilder, IOfficeGraphInsightsRequestBuilder
    {

        /// <summary>
        /// Constructs a new OfficeGraphInsightsRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public OfficeGraphInsightsRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public new IOfficeGraphInsightsRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public new IOfficeGraphInsightsRequest Request(IEnumerable<Option> options)
        {
            return new OfficeGraphInsightsRequest(this.RequestUrl, this.Client, options);
        }
    
        /// <summary>
        /// Gets the request builder for Shared.
        /// </summary>
        /// <returns>The <see cref="IOfficeGraphInsightsSharedCollectionRequestBuilder"/>.</returns>
        public IOfficeGraphInsightsSharedCollectionRequestBuilder Shared
        {
            get
            {
                return new OfficeGraphInsightsSharedCollectionRequestBuilder(this.AppendSegmentToRequestUrl("shared"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for Trending.
        /// </summary>
        /// <returns>The <see cref="IOfficeGraphInsightsTrendingCollectionRequestBuilder"/>.</returns>
        public IOfficeGraphInsightsTrendingCollectionRequestBuilder Trending
        {
            get
            {
                return new OfficeGraphInsightsTrendingCollectionRequestBuilder(this.AppendSegmentToRequestUrl("trending"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for Used.
        /// </summary>
        /// <returns>The <see cref="IOfficeGraphInsightsUsedCollectionRequestBuilder"/>.</returns>
        public IOfficeGraphInsightsUsedCollectionRequestBuilder Used
        {
            get
            {
                return new OfficeGraphInsightsUsedCollectionRequestBuilder(this.AppendSegmentToRequestUrl("used"), this.Client);
            }
        }
    
    }
}
