// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityCollectionRequestBuilder.cs.tt
namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// The type OfficeGraphInsightsSharedCollectionRequestBuilder.
    /// </summary>
    public partial class OfficeGraphInsightsSharedCollectionRequestBuilder : BaseRequestBuilder, IOfficeGraphInsightsSharedCollectionRequestBuilder
    {
        /// <summary>
        /// Constructs a new OfficeGraphInsightsSharedCollectionRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public OfficeGraphInsightsSharedCollectionRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public IOfficeGraphInsightsSharedCollectionRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public IOfficeGraphInsightsSharedCollectionRequest Request(IEnumerable<Option> options)
        {
            return new OfficeGraphInsightsSharedCollectionRequest(this.RequestUrl, this.Client, options);
        }

        /// <summary>
        /// Gets an <see cref="ISharedInsightRequestBuilder"/> for the specified OfficeGraphInsightsSharedInsight.
        /// </summary>
        /// <param name="id">The ID for the OfficeGraphInsightsSharedInsight.</param>
        /// <returns>The <see cref="ISharedInsightRequestBuilder"/>.</returns>
        public ISharedInsightRequestBuilder this[string id]
        {
            get
            {
                return new SharedInsightRequestBuilder(this.AppendSegmentToRequestUrl(id), this.Client);
            }
        }

        
    }
}
