// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type OnenotePageRequestBuilder.
    /// </summary>
    public partial class OnenotePageRequestBuilder : OnenoteEntitySchemaObjectModelRequestBuilder, IOnenotePageRequestBuilder
    {

        /// <summary>
        /// Constructs a new OnenotePageRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public OnenotePageRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public new IOnenotePageRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public new IOnenotePageRequest Request(IEnumerable<Option> options)
        {
            return new OnenotePageRequest(this.RequestUrl, this.Client, options);
        }
    
        /// <summary>
        /// Gets the request builder for ParentNotebook.
        /// </summary>
        /// <returns>The <see cref="INotebookRequestBuilder"/>.</returns>
        public INotebookRequestBuilder ParentNotebook
        {
            get
            {
                return new NotebookRequestBuilder(this.AppendSegmentToRequestUrl("parentNotebook"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for ParentSection.
        /// </summary>
        /// <returns>The <see cref="IOnenoteSectionRequestBuilder"/>.</returns>
        public IOnenoteSectionRequestBuilder ParentSection
        {
            get
            {
                return new OnenoteSectionRequestBuilder(this.AppendSegmentToRequestUrl("parentSection"), this.Client);
            }
        }
    
        /// <summary>
        /// Gets the request builder for Content.
        /// </summary>
        /// <returns>The <see cref="IOnenotePageContentRequestBuilder"/>.</returns>
        public IOnenotePageContentRequestBuilder Content
        {
            get
            {
                return new OnenotePageContentRequestBuilder(this.AppendSegmentToRequestUrl("content"), this.Client);
            }
        }
    
        /// <summary>
        /// Gets the request builder for OnenotePageCopyToSection.
        /// </summary>
        /// <returns>The <see cref="IOnenotePageCopyToSectionRequestBuilder"/>.</returns>
        public IOnenotePageCopyToSectionRequestBuilder CopyToSection(
            string id = null,
            string groupId = null,
            string siteCollectionId = null,
            string siteId = null)
        {
            return new OnenotePageCopyToSectionRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.copyToSection"),
                this.Client,
                id,
                groupId,
                siteCollectionId,
                siteId);
        }

        /// <summary>
        /// Gets the request builder for OnenotePageOnenotePatchContent.
        /// </summary>
        /// <returns>The <see cref="IOnenotePageOnenotePatchContentRequestBuilder"/>.</returns>
        public IOnenotePageOnenotePatchContentRequestBuilder OnenotePatchContent(
            IEnumerable<OnenotePatchContentCommand> commands = null)
        {
            return new OnenotePageOnenotePatchContentRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.onenotePatchContent"),
                this.Client,
                commands);
        }

        /// <summary>
        /// Gets the request builder for OnenotePagePreview.
        /// </summary>
        /// <returns>The <see cref="IOnenotePagePreviewRequestBuilder"/>.</returns>
        public IOnenotePagePreviewRequestBuilder Preview()
        {
            return new OnenotePagePreviewRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.preview"),
                this.Client);
        }
    
    }
}
