// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityCollectionRequestBuilder.cs.tt
namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// The type OnenoteResourcesCollectionRequestBuilder.
    /// </summary>
    public partial class OnenoteResourcesCollectionRequestBuilder : BaseRequestBuilder, IOnenoteResourcesCollectionRequestBuilder
    {
        /// <summary>
        /// Constructs a new OnenoteResourcesCollectionRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public OnenoteResourcesCollectionRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public IOnenoteResourcesCollectionRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public IOnenoteResourcesCollectionRequest Request(IEnumerable<Option> options)
        {
            return new OnenoteResourcesCollectionRequest(this.RequestUrl, this.Client, options);
        }

        /// <summary>
        /// Gets an <see cref="IOnenoteResourceRequestBuilder"/> for the specified OnenoteOnenoteResource.
        /// </summary>
        /// <param name="id">The ID for the OnenoteOnenoteResource.</param>
        /// <returns>The <see cref="IOnenoteResourceRequestBuilder"/>.</returns>
        public IOnenoteResourceRequestBuilder this[string id]
        {
            get
            {
                return new OnenoteResourceRequestBuilder(this.AppendSegmentToRequestUrl(id), this.Client);
            }
        }

        
    }
}
