// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The type ParticipantLeftNotificationRequest.
    /// </summary>
    public partial class ParticipantLeftNotificationRequest : BaseRequest, IParticipantLeftNotificationRequest
    {
        /// <summary>
        /// Constructs a new ParticipantLeftNotificationRequest.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        /// <param name="options">Query and header option name value pairs for the request.</param>
        public ParticipantLeftNotificationRequest(
            string requestUrl,
            IBaseClient client,
            IEnumerable<Option> options)
            : base(requestUrl, client, options)
        {
        }

        /// <summary>
        /// Creates the specified ParticipantLeftNotification using POST.
        /// </summary>
        /// <param name="participantLeftNotificationToCreate">The ParticipantLeftNotification to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created ParticipantLeftNotification.</returns>
        public async System.Threading.Tasks.Task<ParticipantLeftNotification> CreateAsync(ParticipantLeftNotification participantLeftNotificationToCreate, CancellationToken cancellationToken = default)
        {
            this.ContentType = CoreConstants.MimeTypeNames.Application.Json;
            this.Method = HttpMethods.POST;
            var newEntity = await this.SendAsync<ParticipantLeftNotification>(participantLeftNotificationToCreate, cancellationToken).ConfigureAwait(false);
            this.InitializeCollectionProperties(newEntity);
            return newEntity;
        }

        /// <summary>
        /// Creates the specified ParticipantLeftNotification using POST and returns a <see cref="GraphResponse{ParticipantLeftNotification}"/> object.
        /// </summary>
        /// <param name="participantLeftNotificationToCreate">The ParticipantLeftNotification to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{ParticipantLeftNotification}"/> object of the request.</returns>
        public System.Threading.Tasks.Task<GraphResponse<ParticipantLeftNotification>> CreateResponseAsync(ParticipantLeftNotification participantLeftNotificationToCreate, CancellationToken cancellationToken = default)
        {
            this.ContentType = CoreConstants.MimeTypeNames.Application.Json;
            this.Method = HttpMethods.POST;
            return this.SendAsyncWithGraphResponse<ParticipantLeftNotification>(participantLeftNotificationToCreate, cancellationToken);
        }

        /// <summary>
        /// Deletes the specified ParticipantLeftNotification.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        public async System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default)
        {
            this.Method = HttpMethods.DELETE;
            await this.SendAsync<ParticipantLeftNotification>(null, cancellationToken).ConfigureAwait(false);
        }

        /// <summary>
        /// Deletes the specified ParticipantLeftNotification and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        public System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default)
        {
            this.Method = HttpMethods.DELETE;
            return this.SendAsyncWithGraphResponse(null, cancellationToken);
        }

        /// <summary>
        /// Gets the specified ParticipantLeftNotification.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The ParticipantLeftNotification.</returns>
        public async System.Threading.Tasks.Task<ParticipantLeftNotification> GetAsync(CancellationToken cancellationToken = default)
        {
            this.Method = HttpMethods.GET;
            var retrievedEntity = await this.SendAsync<ParticipantLeftNotification>(null, cancellationToken).ConfigureAwait(false);
            this.InitializeCollectionProperties(retrievedEntity);
            return retrievedEntity;
        }

        /// <summary>
        /// Gets the specified ParticipantLeftNotification and returns a <see cref="GraphResponse{ParticipantLeftNotification}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{ParticipantLeftNotification}"/> object of the request.</returns>
        public System.Threading.Tasks.Task<GraphResponse<ParticipantLeftNotification>> GetResponseAsync(CancellationToken cancellationToken = default)
        {
            this.Method = HttpMethods.GET;
            return this.SendAsyncWithGraphResponse<ParticipantLeftNotification>(null, cancellationToken);
        }

        /// <summary>
        /// Updates the specified ParticipantLeftNotification using PATCH.
        /// </summary>
        /// <param name="participantLeftNotificationToUpdate">The ParticipantLeftNotification to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated ParticipantLeftNotification.</returns>
        public async System.Threading.Tasks.Task<ParticipantLeftNotification> UpdateAsync(ParticipantLeftNotification participantLeftNotificationToUpdate, CancellationToken cancellationToken = default)
        {
            this.ContentType = CoreConstants.MimeTypeNames.Application.Json;
            this.Method = HttpMethods.PATCH;
            var updatedEntity = await this.SendAsync<ParticipantLeftNotification>(participantLeftNotificationToUpdate, cancellationToken).ConfigureAwait(false);
            this.InitializeCollectionProperties(updatedEntity);
            return updatedEntity;
        }

        /// <summary>
        /// Updates the specified ParticipantLeftNotification using PATCH and returns a <see cref="GraphResponse{ParticipantLeftNotification}"/> object.
        /// </summary>
        /// <param name="participantLeftNotificationToUpdate">The ParticipantLeftNotification to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{ParticipantLeftNotification}"/> object of the request.</returns>
        public System.Threading.Tasks.Task<GraphResponse<ParticipantLeftNotification>> UpdateResponseAsync(ParticipantLeftNotification participantLeftNotificationToUpdate, CancellationToken cancellationToken = default)
        {
            this.ContentType = CoreConstants.MimeTypeNames.Application.Json;
            this.Method = HttpMethods.PATCH;
            return this.SendAsyncWithGraphResponse<ParticipantLeftNotification>(participantLeftNotificationToUpdate, cancellationToken);
        }

        /// <summary>
        /// Updates the specified ParticipantLeftNotification using PUT.
        /// </summary>
        /// <param name="participantLeftNotificationToUpdate">The ParticipantLeftNotification object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        public async System.Threading.Tasks.Task<ParticipantLeftNotification> PutAsync(ParticipantLeftNotification participantLeftNotificationToUpdate, CancellationToken cancellationToken = default)
        {
            this.ContentType = CoreConstants.MimeTypeNames.Application.Json;
            this.Method = HttpMethods.PUT;
            var updatedEntity = await this.SendAsync<ParticipantLeftNotification>(participantLeftNotificationToUpdate, cancellationToken).ConfigureAwait(false);
            this.InitializeCollectionProperties(updatedEntity);
            return updatedEntity;
        }

        /// <summary>
        /// Updates the specified ParticipantLeftNotification using PUT and returns a <see cref="GraphResponse{ParticipantLeftNotification}"/> object.
        /// </summary>
        /// <param name="participantLeftNotificationToUpdate">The ParticipantLeftNotification object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await of <see cref="GraphResponse{ParticipantLeftNotification}"/>.</returns>
        public System.Threading.Tasks.Task<GraphResponse<ParticipantLeftNotification>> PutResponseAsync(ParticipantLeftNotification participantLeftNotificationToUpdate, CancellationToken cancellationToken = default)
        {
            this.ContentType = CoreConstants.MimeTypeNames.Application.Json;
            this.Method = HttpMethods.PUT;
            return this.SendAsyncWithGraphResponse<ParticipantLeftNotification>(participantLeftNotificationToUpdate, cancellationToken);
        }

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        public IParticipantLeftNotificationRequest Expand(string value)
        {
            this.QueryOptions.Add(new QueryOption("$expand", value));
            return this;
        }

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        public IParticipantLeftNotificationRequest Expand(Expression<Func<ParticipantLeftNotification, object>> expandExpression)
        {
		    if (expandExpression == null)
            {
                throw new ArgumentNullException(nameof(expandExpression));
            }
            string error;
            string value = ExpressionExtractHelper.ExtractMembers(expandExpression, out error);
            if (value == null)
            {
                throw new ArgumentException(error, nameof(expandExpression));
            }
            else
            {
                this.QueryOptions.Add(new QueryOption("$expand", value));
            }
            return this;
        }

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        public IParticipantLeftNotificationRequest Select(string value)
        {
            this.QueryOptions.Add(new QueryOption("$select", value));
            return this;
        }

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        public IParticipantLeftNotificationRequest Select(Expression<Func<ParticipantLeftNotification, object>> selectExpression)
        {
            if (selectExpression == null)
            {
                throw new ArgumentNullException(nameof(selectExpression));
            }
            string error;
            string value = ExpressionExtractHelper.ExtractMembers(selectExpression, out error);
            if (value == null)
            {
                throw new ArgumentException(error, nameof(selectExpression));
            }
            else
            {
                this.QueryOptions.Add(new QueryOption("$select", value));
            }
            return this;
        }

        /// <summary>
        /// Initializes any collection properties after deserialization, like next requests for paging.
        /// </summary>
        /// <param name="participantLeftNotificationToInitialize">The <see cref="ParticipantLeftNotification"/> with the collection properties to initialize.</param>
        private void InitializeCollectionProperties(ParticipantLeftNotification participantLeftNotificationToInitialize)
        {

        }
    }
}
