// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: MethodRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type PermissionGrantRequestBuilder.
    /// </summary>
    public partial class PermissionGrantRequestBuilder : BaseActionMethodRequestBuilder<IPermissionGrantRequest>, IPermissionGrantRequestBuilder
    {
        /// <summary>
        /// Constructs a new <see cref="PermissionGrantRequestBuilder"/>.
        /// </summary>
        /// <param name="requestUrl">The URL for the request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        /// <param name="roles">A roles parameter for the OData method call.</param>
        /// <param name="recipients">A recipients parameter for the OData method call.</param>
        public PermissionGrantRequestBuilder(
            string requestUrl,
            IBaseClient client,
            IEnumerable<string> roles,
            IEnumerable<DriveRecipient> recipients)
            : base(requestUrl, client)
        {
            this.SetParameter("roles", roles, true);
            this.SetParameter("recipients", recipients, true);
        }

        /// <summary>
        /// A method used by the base class to construct a request class instance.
        /// </summary>
        /// <param name="functionUrl">The request URL to </param>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>An instance of a specific request class.</returns>
        protected override IPermissionGrantRequest CreateRequest(string functionUrl, IEnumerable<Option> options)
        {
            var request = new PermissionGrantRequest(functionUrl, this.Client, options);

            if (this.HasParameter("roles"))
            {
                request.RequestBody.Roles = this.GetParameter<IEnumerable<string>>("roles");
            }

            if (this.HasParameter("recipients"))
            {
                request.RequestBody.Recipients = this.GetParameter<IEnumerable<DriveRecipient>>("recipients");
            }

            return request;
        }
    }
}
