// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityCollectionRequestBuilder.cs.tt
namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// The type PrintJobTasksCollectionRequestBuilder.
    /// </summary>
    public partial class PrintJobTasksCollectionRequestBuilder : BaseRequestBuilder, IPrintJobTasksCollectionRequestBuilder
    {
        /// <summary>
        /// Constructs a new PrintJobTasksCollectionRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public PrintJobTasksCollectionRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public IPrintJobTasksCollectionRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public IPrintJobTasksCollectionRequest Request(IEnumerable<Option> options)
        {
            return new PrintJobTasksCollectionRequest(this.RequestUrl, this.Client, options);
        }

        /// <summary>
        /// Gets an <see cref="IPrintTaskRequestBuilder"/> for the specified PrintJobPrintTask.
        /// </summary>
        /// <param name="id">The ID for the PrintJobPrintTask.</param>
        /// <returns>The <see cref="IPrintTaskRequestBuilder"/>.</returns>
        public IPrintTaskRequestBuilder this[string id]
        {
            get
            {
                return new PrintTaskRequestBuilder(this.AppendSegmentToRequestUrl(id), this.Client);
            }
        }

        
    }
}
