// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityCollectionRequestBuilder.cs.tt
namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// The type PrintPrintersCollectionRequestBuilder.
    /// </summary>
    public partial class PrintPrintersCollectionRequestBuilder : BaseRequestBuilder, IPrintPrintersCollectionRequestBuilder
    {
        /// <summary>
        /// Constructs a new PrintPrintersCollectionRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public PrintPrintersCollectionRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public IPrintPrintersCollectionRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public IPrintPrintersCollectionRequest Request(IEnumerable<Option> options)
        {
            return new PrintPrintersCollectionRequest(this.RequestUrl, this.Client, options);
        }

        /// <summary>
        /// Gets an <see cref="IPrinterRequestBuilder"/> for the specified PrintPrinter.
        /// </summary>
        /// <param name="id">The ID for the PrintPrinter.</param>
        /// <returns>The <see cref="IPrinterRequestBuilder"/>.</returns>
        public IPrinterRequestBuilder this[string id]
        {
            get
            {
                return new PrinterRequestBuilder(this.AppendSegmentToRequestUrl(id), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for PrinterCreate.
        /// </summary>
        /// <returns>The <see cref="IPrinterCreateRequestBuilder"/>.</returns>
        public IPrinterCreateRequestBuilder Create(
            string displayName,
            string manufacturer,
            string model,
            PrintCertificateSigningRequestObject certificateSigningRequest,
            string physicalDeviceId = null,
            bool? hasPhysicalDevice = null,
            string connectorId = null)
        {
            return new PrinterCreateRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.create"),
                this.Client,
                displayName,
                manufacturer,
                model,
                certificateSigningRequest,
                physicalDeviceId,
                hasPhysicalDevice,
                connectorId);
        }
    }
}
