// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityCollectionRequestBuilder.cs.tt
namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// The type PrintServiceEndpointsCollectionRequestBuilder.
    /// </summary>
    public partial class PrintServiceEndpointsCollectionRequestBuilder : BaseRequestBuilder, IPrintServiceEndpointsCollectionRequestBuilder
    {
        /// <summary>
        /// Constructs a new PrintServiceEndpointsCollectionRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public PrintServiceEndpointsCollectionRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public IPrintServiceEndpointsCollectionRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public IPrintServiceEndpointsCollectionRequest Request(IEnumerable<Option> options)
        {
            return new PrintServiceEndpointsCollectionRequest(this.RequestUrl, this.Client, options);
        }

        /// <summary>
        /// Gets an <see cref="IPrintServiceEndpointRequestBuilder"/> for the specified PrintServicePrintServiceEndpoint.
        /// </summary>
        /// <param name="id">The ID for the PrintServicePrintServiceEndpoint.</param>
        /// <returns>The <see cref="IPrintServiceEndpointRequestBuilder"/>.</returns>
        public IPrintServiceEndpointRequestBuilder this[string id]
        {
            get
            {
                return new PrintServiceEndpointRequestBuilder(this.AppendSegmentToRequestUrl(id), this.Client);
            }
        }

        
    }
}
