// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type PrintTaskRequestBuilder.
    /// </summary>
    public partial class PrintTaskRequestBuilder : EntityRequestBuilder, IPrintTaskRequestBuilder
    {

        /// <summary>
        /// Constructs a new PrintTaskRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public PrintTaskRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public new IPrintTaskRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public new IPrintTaskRequest Request(IEnumerable<Option> options)
        {
            return new PrintTaskRequest(this.RequestUrl, this.Client, options);
        }
    
        /// <summary>
        /// Gets the request builder for Definition.
        /// </summary>
        /// <returns>The <see cref="IPrintTaskDefinitionWithReferenceRequestBuilder"/>.</returns>
        public IPrintTaskDefinitionWithReferenceRequestBuilder Definition
        {
            get
            {
                return new PrintTaskDefinitionWithReferenceRequestBuilder(this.AppendSegmentToRequestUrl("definition"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for Trigger.
        /// </summary>
        /// <returns>The <see cref="IPrintTaskTriggerWithReferenceRequestBuilder"/>.</returns>
        public IPrintTaskTriggerWithReferenceRequestBuilder Trigger
        {
            get
            {
                return new PrintTaskTriggerWithReferenceRequestBuilder(this.AppendSegmentToRequestUrl("trigger"), this.Client);
            }
        }
    
    }
}
