// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The type PrintUsageByPrinterRequest.
    /// </summary>
    public partial class PrintUsageByPrinterRequest : BaseRequest, IPrintUsageByPrinterRequest
    {
        /// <summary>
        /// Constructs a new PrintUsageByPrinterRequest.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        /// <param name="options">Query and header option name value pairs for the request.</param>
        public PrintUsageByPrinterRequest(
            string requestUrl,
            IBaseClient client,
            IEnumerable<Option> options)
            : base(requestUrl, client, options)
        {
        }

        /// <summary>
        /// Creates the specified PrintUsageByPrinter using POST.
        /// </summary>
        /// <param name="printUsageByPrinterToCreate">The PrintUsageByPrinter to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created PrintUsageByPrinter.</returns>
        public async System.Threading.Tasks.Task<PrintUsageByPrinter> CreateAsync(PrintUsageByPrinter printUsageByPrinterToCreate, CancellationToken cancellationToken = default)
        {
            this.ContentType = CoreConstants.MimeTypeNames.Application.Json;
            this.Method = HttpMethods.POST;
            var newEntity = await this.SendAsync<PrintUsageByPrinter>(printUsageByPrinterToCreate, cancellationToken).ConfigureAwait(false);
            this.InitializeCollectionProperties(newEntity);
            return newEntity;
        }

        /// <summary>
        /// Creates the specified PrintUsageByPrinter using POST and returns a <see cref="GraphResponse{PrintUsageByPrinter}"/> object.
        /// </summary>
        /// <param name="printUsageByPrinterToCreate">The PrintUsageByPrinter to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{PrintUsageByPrinter}"/> object of the request.</returns>
        public System.Threading.Tasks.Task<GraphResponse<PrintUsageByPrinter>> CreateResponseAsync(PrintUsageByPrinter printUsageByPrinterToCreate, CancellationToken cancellationToken = default)
        {
            this.ContentType = CoreConstants.MimeTypeNames.Application.Json;
            this.Method = HttpMethods.POST;
            return this.SendAsyncWithGraphResponse<PrintUsageByPrinter>(printUsageByPrinterToCreate, cancellationToken);
        }

        /// <summary>
        /// Deletes the specified PrintUsageByPrinter.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        public async System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default)
        {
            this.Method = HttpMethods.DELETE;
            await this.SendAsync<PrintUsageByPrinter>(null, cancellationToken).ConfigureAwait(false);
        }

        /// <summary>
        /// Deletes the specified PrintUsageByPrinter and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        public System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default)
        {
            this.Method = HttpMethods.DELETE;
            return this.SendAsyncWithGraphResponse(null, cancellationToken);
        }

        /// <summary>
        /// Gets the specified PrintUsageByPrinter.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The PrintUsageByPrinter.</returns>
        public async System.Threading.Tasks.Task<PrintUsageByPrinter> GetAsync(CancellationToken cancellationToken = default)
        {
            this.Method = HttpMethods.GET;
            var retrievedEntity = await this.SendAsync<PrintUsageByPrinter>(null, cancellationToken).ConfigureAwait(false);
            this.InitializeCollectionProperties(retrievedEntity);
            return retrievedEntity;
        }

        /// <summary>
        /// Gets the specified PrintUsageByPrinter and returns a <see cref="GraphResponse{PrintUsageByPrinter}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{PrintUsageByPrinter}"/> object of the request.</returns>
        public System.Threading.Tasks.Task<GraphResponse<PrintUsageByPrinter>> GetResponseAsync(CancellationToken cancellationToken = default)
        {
            this.Method = HttpMethods.GET;
            return this.SendAsyncWithGraphResponse<PrintUsageByPrinter>(null, cancellationToken);
        }

        /// <summary>
        /// Updates the specified PrintUsageByPrinter using PATCH.
        /// </summary>
        /// <param name="printUsageByPrinterToUpdate">The PrintUsageByPrinter to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated PrintUsageByPrinter.</returns>
        public async System.Threading.Tasks.Task<PrintUsageByPrinter> UpdateAsync(PrintUsageByPrinter printUsageByPrinterToUpdate, CancellationToken cancellationToken = default)
        {
            this.ContentType = CoreConstants.MimeTypeNames.Application.Json;
            this.Method = HttpMethods.PATCH;
            var updatedEntity = await this.SendAsync<PrintUsageByPrinter>(printUsageByPrinterToUpdate, cancellationToken).ConfigureAwait(false);
            this.InitializeCollectionProperties(updatedEntity);
            return updatedEntity;
        }

        /// <summary>
        /// Updates the specified PrintUsageByPrinter using PATCH and returns a <see cref="GraphResponse{PrintUsageByPrinter}"/> object.
        /// </summary>
        /// <param name="printUsageByPrinterToUpdate">The PrintUsageByPrinter to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{PrintUsageByPrinter}"/> object of the request.</returns>
        public System.Threading.Tasks.Task<GraphResponse<PrintUsageByPrinter>> UpdateResponseAsync(PrintUsageByPrinter printUsageByPrinterToUpdate, CancellationToken cancellationToken = default)
        {
            this.ContentType = CoreConstants.MimeTypeNames.Application.Json;
            this.Method = HttpMethods.PATCH;
            return this.SendAsyncWithGraphResponse<PrintUsageByPrinter>(printUsageByPrinterToUpdate, cancellationToken);
        }

        /// <summary>
        /// Updates the specified PrintUsageByPrinter using PUT.
        /// </summary>
        /// <param name="printUsageByPrinterToUpdate">The PrintUsageByPrinter object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        public async System.Threading.Tasks.Task<PrintUsageByPrinter> PutAsync(PrintUsageByPrinter printUsageByPrinterToUpdate, CancellationToken cancellationToken = default)
        {
            this.ContentType = CoreConstants.MimeTypeNames.Application.Json;
            this.Method = HttpMethods.PUT;
            var updatedEntity = await this.SendAsync<PrintUsageByPrinter>(printUsageByPrinterToUpdate, cancellationToken).ConfigureAwait(false);
            this.InitializeCollectionProperties(updatedEntity);
            return updatedEntity;
        }

        /// <summary>
        /// Updates the specified PrintUsageByPrinter using PUT and returns a <see cref="GraphResponse{PrintUsageByPrinter}"/> object.
        /// </summary>
        /// <param name="printUsageByPrinterToUpdate">The PrintUsageByPrinter object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await of <see cref="GraphResponse{PrintUsageByPrinter}"/>.</returns>
        public System.Threading.Tasks.Task<GraphResponse<PrintUsageByPrinter>> PutResponseAsync(PrintUsageByPrinter printUsageByPrinterToUpdate, CancellationToken cancellationToken = default)
        {
            this.ContentType = CoreConstants.MimeTypeNames.Application.Json;
            this.Method = HttpMethods.PUT;
            return this.SendAsyncWithGraphResponse<PrintUsageByPrinter>(printUsageByPrinterToUpdate, cancellationToken);
        }

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        public IPrintUsageByPrinterRequest Expand(string value)
        {
            this.QueryOptions.Add(new QueryOption("$expand", value));
            return this;
        }

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        public IPrintUsageByPrinterRequest Expand(Expression<Func<PrintUsageByPrinter, object>> expandExpression)
        {
		    if (expandExpression == null)
            {
                throw new ArgumentNullException(nameof(expandExpression));
            }
            string error;
            string value = ExpressionExtractHelper.ExtractMembers(expandExpression, out error);
            if (value == null)
            {
                throw new ArgumentException(error, nameof(expandExpression));
            }
            else
            {
                this.QueryOptions.Add(new QueryOption("$expand", value));
            }
            return this;
        }

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        public IPrintUsageByPrinterRequest Select(string value)
        {
            this.QueryOptions.Add(new QueryOption("$select", value));
            return this;
        }

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        public IPrintUsageByPrinterRequest Select(Expression<Func<PrintUsageByPrinter, object>> selectExpression)
        {
            if (selectExpression == null)
            {
                throw new ArgumentNullException(nameof(selectExpression));
            }
            string error;
            string value = ExpressionExtractHelper.ExtractMembers(selectExpression, out error);
            if (value == null)
            {
                throw new ArgumentException(error, nameof(selectExpression));
            }
            else
            {
                this.QueryOptions.Add(new QueryOption("$select", value));
            }
            return this;
        }

        /// <summary>
        /// Initializes any collection properties after deserialization, like next requests for paging.
        /// </summary>
        /// <param name="printUsageByPrinterToInitialize">The <see cref="PrintUsageByPrinter"/> with the collection properties to initialize.</param>
        private void InitializeCollectionProperties(PrintUsageByPrinter printUsageByPrinterToInitialize)
        {

        }
    }
}
