// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type PrinterRequestBuilder.
    /// </summary>
    public partial class PrinterRequestBuilder : PrinterBaseRequestBuilder, IPrinterRequestBuilder
    {

        /// <summary>
        /// Constructs a new PrinterRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public PrinterRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public new IPrinterRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public new IPrinterRequest Request(IEnumerable<Option> options)
        {
            return new PrinterRequest(this.RequestUrl, this.Client, options);
        }
    
        /// <summary>
        /// Gets the request builder for Connectors.
        /// </summary>
        /// <returns>The <see cref="IPrinterConnectorsCollectionWithReferencesRequestBuilder"/>.</returns>
        public IPrinterConnectorsCollectionWithReferencesRequestBuilder Connectors
        {
            get
            {
                return new PrinterConnectorsCollectionWithReferencesRequestBuilder(this.AppendSegmentToRequestUrl("connectors"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for Shares.
        /// </summary>
        /// <returns>The <see cref="IPrinterSharesCollectionWithReferencesRequestBuilder"/>.</returns>
        public IPrinterSharesCollectionWithReferencesRequestBuilder Shares
        {
            get
            {
                return new PrinterSharesCollectionWithReferencesRequestBuilder(this.AppendSegmentToRequestUrl("shares"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for TaskTriggers.
        /// </summary>
        /// <returns>The <see cref="IPrinterTaskTriggersCollectionRequestBuilder"/>.</returns>
        public IPrinterTaskTriggersCollectionRequestBuilder TaskTriggers
        {
            get
            {
                return new PrinterTaskTriggersCollectionRequestBuilder(this.AppendSegmentToRequestUrl("taskTriggers"), this.Client);
            }
        }
    
        /// <summary>
        /// Gets the request builder for PrinterRestoreFactoryDefaults.
        /// </summary>
        /// <returns>The <see cref="IPrinterRestoreFactoryDefaultsRequestBuilder"/>.</returns>
        public IPrinterRestoreFactoryDefaultsRequestBuilder RestoreFactoryDefaults()
        {
            return new PrinterRestoreFactoryDefaultsRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.restoreFactoryDefaults"),
                this.Client);
        }
    
    }
}
