// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityCollectionRequestBuilder.cs.tt
namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// The type PrinterTaskTriggersCollectionRequestBuilder.
    /// </summary>
    public partial class PrinterTaskTriggersCollectionRequestBuilder : BaseRequestBuilder, IPrinterTaskTriggersCollectionRequestBuilder
    {
        /// <summary>
        /// Constructs a new PrinterTaskTriggersCollectionRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public PrinterTaskTriggersCollectionRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public IPrinterTaskTriggersCollectionRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public IPrinterTaskTriggersCollectionRequest Request(IEnumerable<Option> options)
        {
            return new PrinterTaskTriggersCollectionRequest(this.RequestUrl, this.Client, options);
        }

        /// <summary>
        /// Gets an <see cref="IPrintTaskTriggerRequestBuilder"/> for the specified PrinterPrintTaskTrigger.
        /// </summary>
        /// <param name="id">The ID for the PrinterPrintTaskTrigger.</param>
        /// <returns>The <see cref="IPrintTaskTriggerRequestBuilder"/>.</returns>
        public IPrintTaskTriggerRequestBuilder this[string id]
        {
            get
            {
                return new PrintTaskTriggerRequestBuilder(this.AppendSegmentToRequestUrl(id), this.Client);
            }
        }

        
    }
}
