// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityCollectionRequestBuilder.cs.tt
namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// The type ScheduleTimeOffReasonsCollectionRequestBuilder.
    /// </summary>
    public partial class ScheduleTimeOffReasonsCollectionRequestBuilder : BaseRequestBuilder, IScheduleTimeOffReasonsCollectionRequestBuilder
    {
        /// <summary>
        /// Constructs a new ScheduleTimeOffReasonsCollectionRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public ScheduleTimeOffReasonsCollectionRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public IScheduleTimeOffReasonsCollectionRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public IScheduleTimeOffReasonsCollectionRequest Request(IEnumerable<Option> options)
        {
            return new ScheduleTimeOffReasonsCollectionRequest(this.RequestUrl, this.Client, options);
        }

        /// <summary>
        /// Gets an <see cref="ITimeOffReasonRequestBuilder"/> for the specified ScheduleTimeOffReason.
        /// </summary>
        /// <param name="id">The ID for the ScheduleTimeOffReason.</param>
        /// <returns>The <see cref="ITimeOffReasonRequestBuilder"/>.</returns>
        public ITimeOffReasonRequestBuilder this[string id]
        {
            get
            {
                return new TimeOffReasonRequestBuilder(this.AppendSegmentToRequestUrl(id), this.Client);
            }
        }

        
    }
}
