// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityCollectionRequestBuilder.cs.tt
namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// The type SectionGroupSectionsCollectionRequestBuilder.
    /// </summary>
    public partial class SectionGroupSectionsCollectionRequestBuilder : BaseRequestBuilder, ISectionGroupSectionsCollectionRequestBuilder
    {
        /// <summary>
        /// Constructs a new SectionGroupSectionsCollectionRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public SectionGroupSectionsCollectionRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public ISectionGroupSectionsCollectionRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public ISectionGroupSectionsCollectionRequest Request(IEnumerable<Option> options)
        {
            return new SectionGroupSectionsCollectionRequest(this.RequestUrl, this.Client, options);
        }

        /// <summary>
        /// Gets an <see cref="IOnenoteSectionRequestBuilder"/> for the specified SectionGroupOnenoteSection.
        /// </summary>
        /// <param name="id">The ID for the SectionGroupOnenoteSection.</param>
        /// <returns>The <see cref="IOnenoteSectionRequestBuilder"/>.</returns>
        public IOnenoteSectionRequestBuilder this[string id]
        {
            get
            {
                return new OnenoteSectionRequestBuilder(this.AppendSegmentToRequestUrl(id), this.Client);
            }
        }

        
    }
}
