// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityCollectionRequestBuilder.cs.tt
namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// The type SecuritySecureScoresCollectionRequestBuilder.
    /// </summary>
    public partial class SecuritySecureScoresCollectionRequestBuilder : BaseRequestBuilder, ISecuritySecureScoresCollectionRequestBuilder
    {
        /// <summary>
        /// Constructs a new SecuritySecureScoresCollectionRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public SecuritySecureScoresCollectionRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public ISecuritySecureScoresCollectionRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public ISecuritySecureScoresCollectionRequest Request(IEnumerable<Option> options)
        {
            return new SecuritySecureScoresCollectionRequest(this.RequestUrl, this.Client, options);
        }

        /// <summary>
        /// Gets an <see cref="ISecureScoreRequestBuilder"/> for the specified SecuritySecureScore.
        /// </summary>
        /// <param name="id">The ID for the SecuritySecureScore.</param>
        /// <returns>The <see cref="ISecureScoreRequestBuilder"/>.</returns>
        public ISecureScoreRequestBuilder this[string id]
        {
            get
            {
                return new SecureScoreRequestBuilder(this.AppendSegmentToRequestUrl(id), this.Client);
            }
        }

        
    }
}
