// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityCollectionRequestBuilder.cs.tt
namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// The type ServicePrincipalEndpointsCollectionRequestBuilder.
    /// </summary>
    public partial class ServicePrincipalEndpointsCollectionRequestBuilder : BaseRequestBuilder, IServicePrincipalEndpointsCollectionRequestBuilder
    {
        /// <summary>
        /// Constructs a new ServicePrincipalEndpointsCollectionRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public ServicePrincipalEndpointsCollectionRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public IServicePrincipalEndpointsCollectionRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public IServicePrincipalEndpointsCollectionRequest Request(IEnumerable<Option> options)
        {
            return new ServicePrincipalEndpointsCollectionRequest(this.RequestUrl, this.Client, options);
        }

        /// <summary>
        /// Gets an <see cref="IEndpointRequestBuilder"/> for the specified ServicePrincipalEndpoint.
        /// </summary>
        /// <param name="id">The ID for the ServicePrincipalEndpoint.</param>
        /// <returns>The <see cref="IEndpointRequestBuilder"/>.</returns>
        public IEndpointRequestBuilder this[string id]
        {
            get
            {
                return new EndpointRequestBuilder(this.AppendSegmentToRequestUrl(id), this.Client);
            }
        }

        
    }
}
