// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: MethodRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type ServicePrincipalRemoveKeyRequestBuilder.
    /// </summary>
    public partial class ServicePrincipalRemoveKeyRequestBuilder : BaseActionMethodRequestBuilder<IServicePrincipalRemoveKeyRequest>, IServicePrincipalRemoveKeyRequestBuilder
    {
        /// <summary>
        /// Constructs a new <see cref="ServicePrincipalRemoveKeyRequestBuilder"/>.
        /// </summary>
        /// <param name="requestUrl">The URL for the request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        /// <param name="keyId">A keyId parameter for the OData method call.</param>
        /// <param name="proof">A proof parameter for the OData method call.</param>
        public ServicePrincipalRemoveKeyRequestBuilder(
            string requestUrl,
            IBaseClient client,
            Guid keyId,
            string proof)
            : base(requestUrl, client)
        {
            this.SetParameter("keyId", keyId, false);
            this.SetParameter("proof", proof, false);
        }

        /// <summary>
        /// A method used by the base class to construct a request class instance.
        /// </summary>
        /// <param name="functionUrl">The request URL to </param>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>An instance of a specific request class.</returns>
        protected override IServicePrincipalRemoveKeyRequest CreateRequest(string functionUrl, IEnumerable<Option> options)
        {
            var request = new ServicePrincipalRemoveKeyRequest(functionUrl, this.Client, options);

            if (this.HasParameter("keyId"))
            {
                request.RequestBody.KeyId = this.GetParameter<Guid>("keyId");
            }

            if (this.HasParameter("proof"))
            {
                request.RequestBody.Proof = this.GetParameter<string>("proof");
            }

            return request;
        }
    }
}
