// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityCollectionWithReferencesRequestBuilder.cs.tt
namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// The type SiteExternalColumnsCollectionWithReferencesRequestBuilder.
    /// </summary>
    public partial class SiteExternalColumnsCollectionWithReferencesRequestBuilder : BaseRequestBuilder, ISiteExternalColumnsCollectionWithReferencesRequestBuilder
    {

        /// <summary>
        /// Constructs a new SiteExternalColumnsCollectionWithReferencesRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public SiteExternalColumnsCollectionWithReferencesRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public ISiteExternalColumnsCollectionWithReferencesRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public ISiteExternalColumnsCollectionWithReferencesRequest Request(IEnumerable<Option> options)
        {
            return new SiteExternalColumnsCollectionWithReferencesRequest(this.RequestUrl, this.Client, options);
        }

        /// <summary>
        /// Gets an <see cref="IColumnDefinitionWithReferenceRequestBuilder"/> for the specified SiteColumnDefinition.
        /// </summary>
        /// <param name="id">The ID for the SiteColumnDefinition.</param>
        /// <returns>The <see cref="IColumnDefinitionWithReferenceRequestBuilder"/>.</returns>
        public IColumnDefinitionWithReferenceRequestBuilder this[string id]
        {
            get
            {
                return new ColumnDefinitionWithReferenceRequestBuilder(this.AppendSegmentToRequestUrl(id), this.Client);
            }
        }

        
        /// <summary>
        /// Gets an <see cref="ISiteExternalColumnsCollectionReferencesRequestBuilder"/> for the references in the collection.
        /// </summary>
        /// <returns>The <see cref="ISiteExternalColumnsCollectionReferencesRequestBuilder"/>.</returns>
        public ISiteExternalColumnsCollectionReferencesRequestBuilder References
        {
            get
            {
                return new SiteExternalColumnsCollectionReferencesRequestBuilder(this.AppendSegmentToRequestUrl("$ref"), this.Client);
            }
        }

    }
}
