// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityCollectionRequestBuilder.cs.tt
namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// The type SiteListsCollectionRequestBuilder.
    /// </summary>
    public partial class SiteListsCollectionRequestBuilder : BaseRequestBuilder, ISiteListsCollectionRequestBuilder
    {
        /// <summary>
        /// Constructs a new SiteListsCollectionRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public SiteListsCollectionRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public ISiteListsCollectionRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public ISiteListsCollectionRequest Request(IEnumerable<Option> options)
        {
            return new SiteListsCollectionRequest(this.RequestUrl, this.Client, options);
        }

        /// <summary>
        /// Gets an <see cref="IListRequestBuilder"/> for the specified SiteList.
        /// </summary>
        /// <param name="id">The ID for the SiteList.</param>
        /// <returns>The <see cref="IListRequestBuilder"/>.</returns>
        public IListRequestBuilder this[string id]
        {
            get
            {
                return new ListRequestBuilder(this.AppendSegmentToRequestUrl(id), this.Client);
            }
        }

        
    }
}
