// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityCollectionRequestBuilder.cs.tt
namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// The type SiteTermStoresCollectionRequestBuilder.
    /// </summary>
    public partial class SiteTermStoresCollectionRequestBuilder : BaseRequestBuilder, ISiteTermStoresCollectionRequestBuilder
    {
        /// <summary>
        /// Constructs a new SiteTermStoresCollectionRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public SiteTermStoresCollectionRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public ISiteTermStoresCollectionRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public ISiteTermStoresCollectionRequest Request(IEnumerable<Option> options)
        {
            return new SiteTermStoresCollectionRequest(this.RequestUrl, this.Client, options);
        }

        /// <summary>
        /// Gets an <see cref="Microsoft.Graph.TermStore.IStoreRequestBuilder"/> for the specified SiteMicrosoft.Graph.TermStore.Store.
        /// </summary>
        /// <param name="id">The ID for the SiteMicrosoft.Graph.TermStore.Store.</param>
        /// <returns>The <see cref="Microsoft.Graph.TermStore.IStoreRequestBuilder"/>.</returns>
        public Microsoft.Graph.TermStore.IStoreRequestBuilder this[string id]
        {
            get
            {
                return new Microsoft.Graph.TermStore.StoreRequestBuilder(this.AppendSegmentToRequestUrl(id), this.Client);
            }
        }

        
    }
}
