// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The type SolutionsRootRequest.
    /// </summary>
    public partial class SolutionsRootRequest : BaseRequest, ISolutionsRootRequest
    {
        /// <summary>
        /// Constructs a new SolutionsRootRequest.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        /// <param name="options">Query and header option name value pairs for the request.</param>
        public SolutionsRootRequest(
            string requestUrl,
            IBaseClient client,
            IEnumerable<Option> options)
            : base(requestUrl, client, options)
        {
        }

        /// <summary>
        /// Creates the specified SolutionsRoot using POST.
        /// </summary>
        /// <param name="solutionsRootToCreate">The SolutionsRoot to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created SolutionsRoot.</returns>
        public async System.Threading.Tasks.Task<SolutionsRoot> CreateAsync(SolutionsRoot solutionsRootToCreate, CancellationToken cancellationToken = default)
        {
            this.ContentType = CoreConstants.MimeTypeNames.Application.Json;
            this.Method = HttpMethods.POST;
            var newEntity = await this.SendAsync<SolutionsRoot>(solutionsRootToCreate, cancellationToken).ConfigureAwait(false);
            this.InitializeCollectionProperties(newEntity);
            return newEntity;
        }

        /// <summary>
        /// Creates the specified SolutionsRoot using POST and returns a <see cref="GraphResponse{SolutionsRoot}"/> object.
        /// </summary>
        /// <param name="solutionsRootToCreate">The SolutionsRoot to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{SolutionsRoot}"/> object of the request.</returns>
        public System.Threading.Tasks.Task<GraphResponse<SolutionsRoot>> CreateResponseAsync(SolutionsRoot solutionsRootToCreate, CancellationToken cancellationToken = default)
        {
            this.ContentType = CoreConstants.MimeTypeNames.Application.Json;
            this.Method = HttpMethods.POST;
            return this.SendAsyncWithGraphResponse<SolutionsRoot>(solutionsRootToCreate, cancellationToken);
        }

        /// <summary>
        /// Deletes the specified SolutionsRoot.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        public async System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default)
        {
            this.Method = HttpMethods.DELETE;
            await this.SendAsync<SolutionsRoot>(null, cancellationToken).ConfigureAwait(false);
        }

        /// <summary>
        /// Deletes the specified SolutionsRoot and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        public System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default)
        {
            this.Method = HttpMethods.DELETE;
            return this.SendAsyncWithGraphResponse(null, cancellationToken);
        }

        /// <summary>
        /// Gets the specified SolutionsRoot.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The SolutionsRoot.</returns>
        public async System.Threading.Tasks.Task<SolutionsRoot> GetAsync(CancellationToken cancellationToken = default)
        {
            this.Method = HttpMethods.GET;
            var retrievedEntity = await this.SendAsync<SolutionsRoot>(null, cancellationToken).ConfigureAwait(false);
            this.InitializeCollectionProperties(retrievedEntity);
            return retrievedEntity;
        }

        /// <summary>
        /// Gets the specified SolutionsRoot and returns a <see cref="GraphResponse{SolutionsRoot}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{SolutionsRoot}"/> object of the request.</returns>
        public System.Threading.Tasks.Task<GraphResponse<SolutionsRoot>> GetResponseAsync(CancellationToken cancellationToken = default)
        {
            this.Method = HttpMethods.GET;
            return this.SendAsyncWithGraphResponse<SolutionsRoot>(null, cancellationToken);
        }

        /// <summary>
        /// Updates the specified SolutionsRoot using PATCH.
        /// </summary>
        /// <param name="solutionsRootToUpdate">The SolutionsRoot to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated SolutionsRoot.</returns>
        public async System.Threading.Tasks.Task<SolutionsRoot> UpdateAsync(SolutionsRoot solutionsRootToUpdate, CancellationToken cancellationToken = default)
        {
            this.ContentType = CoreConstants.MimeTypeNames.Application.Json;
            this.Method = HttpMethods.PATCH;
            var updatedEntity = await this.SendAsync<SolutionsRoot>(solutionsRootToUpdate, cancellationToken).ConfigureAwait(false);
            this.InitializeCollectionProperties(updatedEntity);
            return updatedEntity;
        }

        /// <summary>
        /// Updates the specified SolutionsRoot using PATCH and returns a <see cref="GraphResponse{SolutionsRoot}"/> object.
        /// </summary>
        /// <param name="solutionsRootToUpdate">The SolutionsRoot to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{SolutionsRoot}"/> object of the request.</returns>
        public System.Threading.Tasks.Task<GraphResponse<SolutionsRoot>> UpdateResponseAsync(SolutionsRoot solutionsRootToUpdate, CancellationToken cancellationToken = default)
        {
            this.ContentType = CoreConstants.MimeTypeNames.Application.Json;
            this.Method = HttpMethods.PATCH;
            return this.SendAsyncWithGraphResponse<SolutionsRoot>(solutionsRootToUpdate, cancellationToken);
        }

        /// <summary>
        /// Updates the specified SolutionsRoot using PUT.
        /// </summary>
        /// <param name="solutionsRootToUpdate">The SolutionsRoot object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        public async System.Threading.Tasks.Task<SolutionsRoot> PutAsync(SolutionsRoot solutionsRootToUpdate, CancellationToken cancellationToken = default)
        {
            this.ContentType = CoreConstants.MimeTypeNames.Application.Json;
            this.Method = HttpMethods.PUT;
            var updatedEntity = await this.SendAsync<SolutionsRoot>(solutionsRootToUpdate, cancellationToken).ConfigureAwait(false);
            this.InitializeCollectionProperties(updatedEntity);
            return updatedEntity;
        }

        /// <summary>
        /// Updates the specified SolutionsRoot using PUT and returns a <see cref="GraphResponse{SolutionsRoot}"/> object.
        /// </summary>
        /// <param name="solutionsRootToUpdate">The SolutionsRoot object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await of <see cref="GraphResponse{SolutionsRoot}"/>.</returns>
        public System.Threading.Tasks.Task<GraphResponse<SolutionsRoot>> PutResponseAsync(SolutionsRoot solutionsRootToUpdate, CancellationToken cancellationToken = default)
        {
            this.ContentType = CoreConstants.MimeTypeNames.Application.Json;
            this.Method = HttpMethods.PUT;
            return this.SendAsyncWithGraphResponse<SolutionsRoot>(solutionsRootToUpdate, cancellationToken);
        }

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        public ISolutionsRootRequest Expand(string value)
        {
            this.QueryOptions.Add(new QueryOption("$expand", value));
            return this;
        }

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        public ISolutionsRootRequest Expand(Expression<Func<SolutionsRoot, object>> expandExpression)
        {
		    if (expandExpression == null)
            {
                throw new ArgumentNullException(nameof(expandExpression));
            }
            string error;
            string value = ExpressionExtractHelper.ExtractMembers(expandExpression, out error);
            if (value == null)
            {
                throw new ArgumentException(error, nameof(expandExpression));
            }
            else
            {
                this.QueryOptions.Add(new QueryOption("$expand", value));
            }
            return this;
        }

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        public ISolutionsRootRequest Select(string value)
        {
            this.QueryOptions.Add(new QueryOption("$select", value));
            return this;
        }

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        public ISolutionsRootRequest Select(Expression<Func<SolutionsRoot, object>> selectExpression)
        {
            if (selectExpression == null)
            {
                throw new ArgumentNullException(nameof(selectExpression));
            }
            string error;
            string value = ExpressionExtractHelper.ExtractMembers(selectExpression, out error);
            if (value == null)
            {
                throw new ArgumentException(error, nameof(selectExpression));
            }
            else
            {
                this.QueryOptions.Add(new QueryOption("$select", value));
            }
            return this;
        }

        /// <summary>
        /// Initializes any collection properties after deserialization, like next requests for paging.
        /// </summary>
        /// <param name="solutionsRootToInitialize">The <see cref="SolutionsRoot"/> with the collection properties to initialize.</param>
        private void InitializeCollectionProperties(SolutionsRoot solutionsRootToInitialize)
        {

            if (solutionsRootToInitialize != null)
            {
                if (solutionsRootToInitialize.BookingBusinesses != null && solutionsRootToInitialize.BookingBusinesses.CurrentPage != null)
                {
                    solutionsRootToInitialize.BookingBusinesses.InitializeNextPageRequest(this.Client, solutionsRootToInitialize.BookingBusinessesNextLink);
                    // Copy the additional data collection to the page itself so that information is not lost
                    solutionsRootToInitialize.BookingBusinesses.AdditionalData = solutionsRootToInitialize.AdditionalData;
                }
                if (solutionsRootToInitialize.BookingCurrencies != null && solutionsRootToInitialize.BookingCurrencies.CurrentPage != null)
                {
                    solutionsRootToInitialize.BookingCurrencies.InitializeNextPageRequest(this.Client, solutionsRootToInitialize.BookingCurrenciesNextLink);
                    // Copy the additional data collection to the page itself so that information is not lost
                    solutionsRootToInitialize.BookingCurrencies.AdditionalData = solutionsRootToInitialize.AdditionalData;
                }

            }


        }
    }
}
