// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type TargetedManagedAppConfigurationRequestBuilder.
    /// </summary>
    public partial class TargetedManagedAppConfigurationRequestBuilder : ManagedAppConfigurationRequestBuilder, ITargetedManagedAppConfigurationRequestBuilder
    {

        /// <summary>
        /// Constructs a new TargetedManagedAppConfigurationRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public TargetedManagedAppConfigurationRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public new ITargetedManagedAppConfigurationRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public new ITargetedManagedAppConfigurationRequest Request(IEnumerable<Option> options)
        {
            return new TargetedManagedAppConfigurationRequest(this.RequestUrl, this.Client, options);
        }
    
        /// <summary>
        /// Gets the request builder for Apps.
        /// </summary>
        /// <returns>The <see cref="ITargetedManagedAppConfigurationAppsCollectionRequestBuilder"/>.</returns>
        public ITargetedManagedAppConfigurationAppsCollectionRequestBuilder Apps
        {
            get
            {
                return new TargetedManagedAppConfigurationAppsCollectionRequestBuilder(this.AppendSegmentToRequestUrl("apps"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for Assignments.
        /// </summary>
        /// <returns>The <see cref="ITargetedManagedAppConfigurationAssignmentsCollectionRequestBuilder"/>.</returns>
        public ITargetedManagedAppConfigurationAssignmentsCollectionRequestBuilder Assignments
        {
            get
            {
                return new TargetedManagedAppConfigurationAssignmentsCollectionRequestBuilder(this.AppendSegmentToRequestUrl("assignments"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for DeploymentSummary.
        /// </summary>
        /// <returns>The <see cref="IManagedAppPolicyDeploymentSummaryRequestBuilder"/>.</returns>
        public IManagedAppPolicyDeploymentSummaryRequestBuilder DeploymentSummary
        {
            get
            {
                return new ManagedAppPolicyDeploymentSummaryRequestBuilder(this.AppendSegmentToRequestUrl("deploymentSummary"), this.Client);
            }
        }
    
        /// <summary>
        /// Gets the request builder for TargetedManagedAppConfigurationAssign.
        /// </summary>
        /// <returns>The <see cref="ITargetedManagedAppConfigurationAssignRequestBuilder"/>.</returns>
        public ITargetedManagedAppConfigurationAssignRequestBuilder Assign(
            IEnumerable<TargetedManagedAppPolicyAssignment> assignments = null)
        {
            return new TargetedManagedAppConfigurationAssignRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.assign"),
                this.Client,
                assignments);
        }

        /// <summary>
        /// Gets the request builder for TargetedManagedAppConfigurationTargetApps.
        /// </summary>
        /// <returns>The <see cref="ITargetedManagedAppConfigurationTargetAppsRequestBuilder"/>.</returns>
        public ITargetedManagedAppConfigurationTargetAppsRequestBuilder TargetApps(
            IEnumerable<ManagedMobileApp> apps = null,
            TargetedManagedAppGroupType? appGroupType = null)
        {
            return new TargetedManagedAppConfigurationTargetAppsRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.targetApps"),
                this.Client,
                apps,
                appGroupType);
        }
    
    }
}
