// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityCollectionRequestBuilder.cs.tt
namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// The type TeamMembersCollectionRequestBuilder.
    /// </summary>
    public partial class TeamMembersCollectionRequestBuilder : BaseRequestBuilder, ITeamMembersCollectionRequestBuilder
    {
        /// <summary>
        /// Constructs a new TeamMembersCollectionRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public TeamMembersCollectionRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public ITeamMembersCollectionRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public ITeamMembersCollectionRequest Request(IEnumerable<Option> options)
        {
            return new TeamMembersCollectionRequest(this.RequestUrl, this.Client, options);
        }

        /// <summary>
        /// Gets an <see cref="IConversationMemberRequestBuilder"/> for the specified TeamConversationMember.
        /// </summary>
        /// <param name="id">The ID for the TeamConversationMember.</param>
        /// <returns>The <see cref="IConversationMemberRequestBuilder"/>.</returns>
        public IConversationMemberRequestBuilder this[string id]
        {
            get
            {
                return new ConversationMemberRequestBuilder(this.AppendSegmentToRequestUrl(id), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for ConversationMemberAdd.
        /// </summary>
        /// <returns>The <see cref="IConversationMemberAddRequestBuilder"/>.</returns>
        public IConversationMemberAddRequestBuilder Add(
            IEnumerable<ConversationMember> values = null)
        {
            return new ConversationMemberAddRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.add"),
                this.Client,
                values);
        }
    }
}
