// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityCollectionRequestBuilder.cs.tt
namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// The type TeamOperationsCollectionRequestBuilder.
    /// </summary>
    public partial class TeamOperationsCollectionRequestBuilder : BaseRequestBuilder, ITeamOperationsCollectionRequestBuilder
    {
        /// <summary>
        /// Constructs a new TeamOperationsCollectionRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public TeamOperationsCollectionRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public ITeamOperationsCollectionRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public ITeamOperationsCollectionRequest Request(IEnumerable<Option> options)
        {
            return new TeamOperationsCollectionRequest(this.RequestUrl, this.Client, options);
        }

        /// <summary>
        /// Gets an <see cref="ITeamsAsyncOperationRequestBuilder"/> for the specified TeamTeamsAsyncOperation.
        /// </summary>
        /// <param name="id">The ID for the TeamTeamsAsyncOperation.</param>
        /// <returns>The <see cref="ITeamsAsyncOperationRequestBuilder"/>.</returns>
        public ITeamsAsyncOperationRequestBuilder this[string id]
        {
            get
            {
                return new TeamsAsyncOperationRequestBuilder(this.AppendSegmentToRequestUrl(id), this.Client);
            }
        }

        
    }
}
