// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityRequest.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The type TeamsAppInstallationRequest.
    /// </summary>
    public partial class TeamsAppInstallationRequest : BaseRequest, ITeamsAppInstallationRequest
    {
        /// <summary>
        /// Constructs a new TeamsAppInstallationRequest.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        /// <param name="options">Query and header option name value pairs for the request.</param>
        public TeamsAppInstallationRequest(
            string requestUrl,
            IBaseClient client,
            IEnumerable<Option> options)
            : base(requestUrl, client, options)
        {
        }

        /// <summary>
        /// Creates the specified TeamsAppInstallation using POST.
        /// </summary>
        /// <param name="teamsAppInstallationToCreate">The TeamsAppInstallation to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created TeamsAppInstallation.</returns>
        public async System.Threading.Tasks.Task<TeamsAppInstallation> CreateAsync(TeamsAppInstallation teamsAppInstallationToCreate, CancellationToken cancellationToken = default)
        {
            this.ContentType = CoreConstants.MimeTypeNames.Application.Json;
            this.Method = HttpMethods.POST;
            var newEntity = await this.SendAsync<TeamsAppInstallation>(teamsAppInstallationToCreate, cancellationToken).ConfigureAwait(false);
            this.InitializeCollectionProperties(newEntity);
            return newEntity;
        }

        /// <summary>
        /// Creates the specified TeamsAppInstallation using POST and returns a <see cref="GraphResponse{TeamsAppInstallation}"/> object.
        /// </summary>
        /// <param name="teamsAppInstallationToCreate">The TeamsAppInstallation to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{TeamsAppInstallation}"/> object of the request.</returns>
        public System.Threading.Tasks.Task<GraphResponse<TeamsAppInstallation>> CreateResponseAsync(TeamsAppInstallation teamsAppInstallationToCreate, CancellationToken cancellationToken = default)
        {
            this.ContentType = CoreConstants.MimeTypeNames.Application.Json;
            this.Method = HttpMethods.POST;
            return this.SendAsyncWithGraphResponse<TeamsAppInstallation>(teamsAppInstallationToCreate, cancellationToken);
        }

        /// <summary>
        /// Deletes the specified TeamsAppInstallation.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        public async System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default)
        {
            this.Method = HttpMethods.DELETE;
            await this.SendAsync<TeamsAppInstallation>(null, cancellationToken).ConfigureAwait(false);
        }

        /// <summary>
        /// Deletes the specified TeamsAppInstallation and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        public System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default)
        {
            this.Method = HttpMethods.DELETE;
            return this.SendAsyncWithGraphResponse(null, cancellationToken);
        }

        /// <summary>
        /// Gets the specified TeamsAppInstallation.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The TeamsAppInstallation.</returns>
        public async System.Threading.Tasks.Task<TeamsAppInstallation> GetAsync(CancellationToken cancellationToken = default)
        {
            this.Method = HttpMethods.GET;
            var retrievedEntity = await this.SendAsync<TeamsAppInstallation>(null, cancellationToken).ConfigureAwait(false);
            this.InitializeCollectionProperties(retrievedEntity);
            return retrievedEntity;
        }

        /// <summary>
        /// Gets the specified TeamsAppInstallation and returns a <see cref="GraphResponse{TeamsAppInstallation}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{TeamsAppInstallation}"/> object of the request.</returns>
        public System.Threading.Tasks.Task<GraphResponse<TeamsAppInstallation>> GetResponseAsync(CancellationToken cancellationToken = default)
        {
            this.Method = HttpMethods.GET;
            return this.SendAsyncWithGraphResponse<TeamsAppInstallation>(null, cancellationToken);
        }

        /// <summary>
        /// Updates the specified TeamsAppInstallation using PATCH.
        /// </summary>
        /// <param name="teamsAppInstallationToUpdate">The TeamsAppInstallation to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated TeamsAppInstallation.</returns>
        public async System.Threading.Tasks.Task<TeamsAppInstallation> UpdateAsync(TeamsAppInstallation teamsAppInstallationToUpdate, CancellationToken cancellationToken = default)
        {
            this.ContentType = CoreConstants.MimeTypeNames.Application.Json;
            this.Method = HttpMethods.PATCH;
            var updatedEntity = await this.SendAsync<TeamsAppInstallation>(teamsAppInstallationToUpdate, cancellationToken).ConfigureAwait(false);
            this.InitializeCollectionProperties(updatedEntity);
            return updatedEntity;
        }

        /// <summary>
        /// Updates the specified TeamsAppInstallation using PATCH and returns a <see cref="GraphResponse{TeamsAppInstallation}"/> object.
        /// </summary>
        /// <param name="teamsAppInstallationToUpdate">The TeamsAppInstallation to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{TeamsAppInstallation}"/> object of the request.</returns>
        public System.Threading.Tasks.Task<GraphResponse<TeamsAppInstallation>> UpdateResponseAsync(TeamsAppInstallation teamsAppInstallationToUpdate, CancellationToken cancellationToken = default)
        {
            this.ContentType = CoreConstants.MimeTypeNames.Application.Json;
            this.Method = HttpMethods.PATCH;
            return this.SendAsyncWithGraphResponse<TeamsAppInstallation>(teamsAppInstallationToUpdate, cancellationToken);
        }

        /// <summary>
        /// Updates the specified TeamsAppInstallation using PUT.
        /// </summary>
        /// <param name="teamsAppInstallationToUpdate">The TeamsAppInstallation object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        public async System.Threading.Tasks.Task<TeamsAppInstallation> PutAsync(TeamsAppInstallation teamsAppInstallationToUpdate, CancellationToken cancellationToken = default)
        {
            this.ContentType = CoreConstants.MimeTypeNames.Application.Json;
            this.Method = HttpMethods.PUT;
            var updatedEntity = await this.SendAsync<TeamsAppInstallation>(teamsAppInstallationToUpdate, cancellationToken).ConfigureAwait(false);
            this.InitializeCollectionProperties(updatedEntity);
            return updatedEntity;
        }

        /// <summary>
        /// Updates the specified TeamsAppInstallation using PUT and returns a <see cref="GraphResponse{TeamsAppInstallation}"/> object.
        /// </summary>
        /// <param name="teamsAppInstallationToUpdate">The TeamsAppInstallation object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await of <see cref="GraphResponse{TeamsAppInstallation}"/>.</returns>
        public System.Threading.Tasks.Task<GraphResponse<TeamsAppInstallation>> PutResponseAsync(TeamsAppInstallation teamsAppInstallationToUpdate, CancellationToken cancellationToken = default)
        {
            this.ContentType = CoreConstants.MimeTypeNames.Application.Json;
            this.Method = HttpMethods.PUT;
            return this.SendAsyncWithGraphResponse<TeamsAppInstallation>(teamsAppInstallationToUpdate, cancellationToken);
        }

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        public ITeamsAppInstallationRequest Expand(string value)
        {
            this.QueryOptions.Add(new QueryOption("$expand", value));
            return this;
        }

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        public ITeamsAppInstallationRequest Expand(Expression<Func<TeamsAppInstallation, object>> expandExpression)
        {
		    if (expandExpression == null)
            {
                throw new ArgumentNullException(nameof(expandExpression));
            }
            string error;
            string value = ExpressionExtractHelper.ExtractMembers(expandExpression, out error);
            if (value == null)
            {
                throw new ArgumentException(error, nameof(expandExpression));
            }
            else
            {
                this.QueryOptions.Add(new QueryOption("$expand", value));
            }
            return this;
        }

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        public ITeamsAppInstallationRequest Select(string value)
        {
            this.QueryOptions.Add(new QueryOption("$select", value));
            return this;
        }

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        public ITeamsAppInstallationRequest Select(Expression<Func<TeamsAppInstallation, object>> selectExpression)
        {
            if (selectExpression == null)
            {
                throw new ArgumentNullException(nameof(selectExpression));
            }
            string error;
            string value = ExpressionExtractHelper.ExtractMembers(selectExpression, out error);
            if (value == null)
            {
                throw new ArgumentException(error, nameof(selectExpression));
            }
            else
            {
                this.QueryOptions.Add(new QueryOption("$select", value));
            }
            return this;
        }

        /// <summary>
        /// Initializes any collection properties after deserialization, like next requests for paging.
        /// </summary>
        /// <param name="teamsAppInstallationToInitialize">The <see cref="TeamsAppInstallation"/> with the collection properties to initialize.</param>
        private void InitializeCollectionProperties(TeamsAppInstallation teamsAppInstallationToInitialize)
        {

        }
    }
}
