// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type TeamsAppInstallationRequestBuilder.
    /// </summary>
    public partial class TeamsAppInstallationRequestBuilder : EntityRequestBuilder, ITeamsAppInstallationRequestBuilder
    {

        /// <summary>
        /// Constructs a new TeamsAppInstallationRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public TeamsAppInstallationRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public new ITeamsAppInstallationRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public new ITeamsAppInstallationRequest Request(IEnumerable<Option> options)
        {
            return new TeamsAppInstallationRequest(this.RequestUrl, this.Client, options);
        }
    
        /// <summary>
        /// Gets the request builder for TeamsApp.
        /// </summary>
        /// <returns>The <see cref="ITeamsAppWithReferenceRequestBuilder"/>.</returns>
        public ITeamsAppWithReferenceRequestBuilder TeamsApp
        {
            get
            {
                return new TeamsAppWithReferenceRequestBuilder(this.AppendSegmentToRequestUrl("teamsApp"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for TeamsAppDefinition.
        /// </summary>
        /// <returns>The <see cref="ITeamsAppDefinitionWithReferenceRequestBuilder"/>.</returns>
        public ITeamsAppDefinitionWithReferenceRequestBuilder TeamsAppDefinition
        {
            get
            {
                return new TeamsAppDefinitionWithReferenceRequestBuilder(this.AppendSegmentToRequestUrl("teamsAppDefinition"), this.Client);
            }
        }
    
        /// <summary>
        /// Gets the request builder for TeamsAppInstallationUpgrade.
        /// </summary>
        /// <returns>The <see cref="ITeamsAppInstallationUpgradeRequestBuilder"/>.</returns>
        public ITeamsAppInstallationUpgradeRequestBuilder Upgrade()
        {
            return new TeamsAppInstallationUpgradeRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.upgrade"),
                this.Client);
        }
    
    }
}
