// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type TermsAndConditionsRequestBuilder.
    /// </summary>
    public partial class TermsAndConditionsRequestBuilder : EntityRequestBuilder, ITermsAndConditionsRequestBuilder
    {

        /// <summary>
        /// Constructs a new TermsAndConditionsRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public TermsAndConditionsRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public new ITermsAndConditionsRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public new ITermsAndConditionsRequest Request(IEnumerable<Option> options)
        {
            return new TermsAndConditionsRequest(this.RequestUrl, this.Client, options);
        }
    
        /// <summary>
        /// Gets the request builder for AcceptanceStatuses.
        /// </summary>
        /// <returns>The <see cref="ITermsAndConditionsAcceptanceStatusesCollectionRequestBuilder"/>.</returns>
        public ITermsAndConditionsAcceptanceStatusesCollectionRequestBuilder AcceptanceStatuses
        {
            get
            {
                return new TermsAndConditionsAcceptanceStatusesCollectionRequestBuilder(this.AppendSegmentToRequestUrl("acceptanceStatuses"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for Assignments.
        /// </summary>
        /// <returns>The <see cref="ITermsAndConditionsAssignmentsCollectionRequestBuilder"/>.</returns>
        public ITermsAndConditionsAssignmentsCollectionRequestBuilder Assignments
        {
            get
            {
                return new TermsAndConditionsAssignmentsCollectionRequestBuilder(this.AppendSegmentToRequestUrl("assignments"), this.Client);
            }
        }
    
    }
}
