// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type TermsOfUseContainerRequestBuilder.
    /// </summary>
    public partial class TermsOfUseContainerRequestBuilder : EntityRequestBuilder, ITermsOfUseContainerRequestBuilder
    {

        /// <summary>
        /// Constructs a new TermsOfUseContainerRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public TermsOfUseContainerRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public new ITermsOfUseContainerRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public new ITermsOfUseContainerRequest Request(IEnumerable<Option> options)
        {
            return new TermsOfUseContainerRequest(this.RequestUrl, this.Client, options);
        }
    
        /// <summary>
        /// Gets the request builder for AgreementAcceptances.
        /// </summary>
        /// <returns>The <see cref="ITermsOfUseContainerAgreementAcceptancesCollectionRequestBuilder"/>.</returns>
        public ITermsOfUseContainerAgreementAcceptancesCollectionRequestBuilder AgreementAcceptances
        {
            get
            {
                return new TermsOfUseContainerAgreementAcceptancesCollectionRequestBuilder(this.AppendSegmentToRequestUrl("agreementAcceptances"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for Agreements.
        /// </summary>
        /// <returns>The <see cref="ITermsOfUseContainerAgreementsCollectionRequestBuilder"/>.</returns>
        public ITermsOfUseContainerAgreementsCollectionRequestBuilder Agreements
        {
            get
            {
                return new TermsOfUseContainerAgreementsCollectionRequestBuilder(this.AppendSegmentToRequestUrl("agreements"), this.Client);
            }
        }
    
    }
}
