// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type TodoTaskListRequestBuilder.
    /// </summary>
    public partial class TodoTaskListRequestBuilder : EntityRequestBuilder, ITodoTaskListRequestBuilder
    {

        /// <summary>
        /// Constructs a new TodoTaskListRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public TodoTaskListRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public new ITodoTaskListRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public new ITodoTaskListRequest Request(IEnumerable<Option> options)
        {
            return new TodoTaskListRequest(this.RequestUrl, this.Client, options);
        }
    
        /// <summary>
        /// Gets the request builder for Extensions.
        /// </summary>
        /// <returns>The <see cref="ITodoTaskListExtensionsCollectionRequestBuilder"/>.</returns>
        public ITodoTaskListExtensionsCollectionRequestBuilder Extensions
        {
            get
            {
                return new TodoTaskListExtensionsCollectionRequestBuilder(this.AppendSegmentToRequestUrl("extensions"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for Tasks.
        /// </summary>
        /// <returns>The <see cref="ITodoTaskListTasksCollectionRequestBuilder"/>.</returns>
        public ITodoTaskListTasksCollectionRequestBuilder Tasks
        {
            get
            {
                return new TodoTaskListTasksCollectionRequestBuilder(this.AppendSegmentToRequestUrl("tasks"), this.Client);
            }
        }
    
        
    
    }
}
