// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type UnifiedRoleAssignmentRequestBuilder.
    /// </summary>
    public partial class UnifiedRoleAssignmentRequestBuilder : EntityRequestBuilder, IUnifiedRoleAssignmentRequestBuilder
    {

        /// <summary>
        /// Constructs a new UnifiedRoleAssignmentRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public UnifiedRoleAssignmentRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public new IUnifiedRoleAssignmentRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public new IUnifiedRoleAssignmentRequest Request(IEnumerable<Option> options)
        {
            return new UnifiedRoleAssignmentRequest(this.RequestUrl, this.Client, options);
        }
    
        /// <summary>
        /// Gets the request builder for AppScope.
        /// </summary>
        /// <returns>The <see cref="IAppScopeRequestBuilder"/>.</returns>
        public IAppScopeRequestBuilder AppScope
        {
            get
            {
                return new AppScopeRequestBuilder(this.AppendSegmentToRequestUrl("appScope"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for DirectoryScope.
        /// </summary>
        /// <returns>The <see cref="IDirectoryObjectWithReferenceRequestBuilder"/>.</returns>
        public IDirectoryObjectWithReferenceRequestBuilder DirectoryScope
        {
            get
            {
                return new DirectoryObjectWithReferenceRequestBuilder(this.AppendSegmentToRequestUrl("directoryScope"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for Principal.
        /// </summary>
        /// <returns>The <see cref="IDirectoryObjectWithReferenceRequestBuilder"/>.</returns>
        public IDirectoryObjectWithReferenceRequestBuilder Principal
        {
            get
            {
                return new DirectoryObjectWithReferenceRequestBuilder(this.AppendSegmentToRequestUrl("principal"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for RoleDefinition.
        /// </summary>
        /// <returns>The <see cref="IUnifiedRoleDefinitionWithReferenceRequestBuilder"/>.</returns>
        public IUnifiedRoleDefinitionWithReferenceRequestBuilder RoleDefinition
        {
            get
            {
                return new UnifiedRoleDefinitionWithReferenceRequestBuilder(this.AppendSegmentToRequestUrl("roleDefinition"), this.Client);
            }
        }
    
    }
}
