// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityCollectionWithReferencesRequestBuilder.cs.tt
namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// The type UserAgreementAcceptancesCollectionWithReferencesRequestBuilder.
    /// </summary>
    public partial class UserAgreementAcceptancesCollectionWithReferencesRequestBuilder : BaseRequestBuilder, IUserAgreementAcceptancesCollectionWithReferencesRequestBuilder
    {

        /// <summary>
        /// Constructs a new UserAgreementAcceptancesCollectionWithReferencesRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public UserAgreementAcceptancesCollectionWithReferencesRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public IUserAgreementAcceptancesCollectionWithReferencesRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public IUserAgreementAcceptancesCollectionWithReferencesRequest Request(IEnumerable<Option> options)
        {
            return new UserAgreementAcceptancesCollectionWithReferencesRequest(this.RequestUrl, this.Client, options);
        }

        /// <summary>
        /// Gets an <see cref="IAgreementAcceptanceWithReferenceRequestBuilder"/> for the specified UserAgreementAcceptance.
        /// </summary>
        /// <param name="id">The ID for the UserAgreementAcceptance.</param>
        /// <returns>The <see cref="IAgreementAcceptanceWithReferenceRequestBuilder"/>.</returns>
        public IAgreementAcceptanceWithReferenceRequestBuilder this[string id]
        {
            get
            {
                return new AgreementAcceptanceWithReferenceRequestBuilder(this.AppendSegmentToRequestUrl(id), this.Client);
            }
        }

        
        /// <summary>
        /// Gets an <see cref="IUserAgreementAcceptancesCollectionReferencesRequestBuilder"/> for the references in the collection.
        /// </summary>
        /// <returns>The <see cref="IUserAgreementAcceptancesCollectionReferencesRequestBuilder"/>.</returns>
        public IUserAgreementAcceptancesCollectionReferencesRequestBuilder References
        {
            get
            {
                return new UserAgreementAcceptancesCollectionReferencesRequestBuilder(this.AppendSegmentToRequestUrl("$ref"), this.Client);
            }
        }

    }
}
