// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: MethodRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type UserExportPersonalDataRequestBuilder.
    /// </summary>
    public partial class UserExportPersonalDataRequestBuilder : BaseActionMethodRequestBuilder<IUserExportPersonalDataRequest>, IUserExportPersonalDataRequestBuilder
    {
        /// <summary>
        /// Constructs a new <see cref="UserExportPersonalDataRequestBuilder"/>.
        /// </summary>
        /// <param name="requestUrl">The URL for the request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        /// <param name="storageLocation">A storageLocation parameter for the OData method call.</param>
        public UserExportPersonalDataRequestBuilder(
            string requestUrl,
            IBaseClient client,
            string storageLocation)
            : base(requestUrl, client)
        {
            this.SetParameter("storageLocation", storageLocation, true);
        }

        /// <summary>
        /// A method used by the base class to construct a request class instance.
        /// </summary>
        /// <param name="functionUrl">The request URL to </param>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>An instance of a specific request class.</returns>
        protected override IUserExportPersonalDataRequest CreateRequest(string functionUrl, IEnumerable<Option> options)
        {
            var request = new UserExportPersonalDataRequest(functionUrl, this.Client, options);

            if (this.HasParameter("storageLocation"))
            {
                request.RequestBody.StorageLocation = this.GetParameter<string>("storageLocation");
            }

            return request;
        }
    }
}
