// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityCollectionRequestBuilder.cs.tt
namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// The type UserLicenseDetailsCollectionRequestBuilder.
    /// </summary>
    public partial class UserLicenseDetailsCollectionRequestBuilder : BaseRequestBuilder, IUserLicenseDetailsCollectionRequestBuilder
    {
        /// <summary>
        /// Constructs a new UserLicenseDetailsCollectionRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public UserLicenseDetailsCollectionRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public IUserLicenseDetailsCollectionRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public IUserLicenseDetailsCollectionRequest Request(IEnumerable<Option> options)
        {
            return new UserLicenseDetailsCollectionRequest(this.RequestUrl, this.Client, options);
        }

        /// <summary>
        /// Gets an <see cref="ILicenseDetailsRequestBuilder"/> for the specified UserLicenseDetails.
        /// </summary>
        /// <param name="id">The ID for the UserLicenseDetails.</param>
        /// <returns>The <see cref="ILicenseDetailsRequestBuilder"/>.</returns>
        public ILicenseDetailsRequestBuilder this[string id]
        {
            get
            {
                return new LicenseDetailsRequestBuilder(this.AppendSegmentToRequestUrl(id), this.Client);
            }
        }

        
    }
}
