// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type UserTeamworkRequestBuilder.
    /// </summary>
    public partial class UserTeamworkRequestBuilder : EntityRequestBuilder, IUserTeamworkRequestBuilder
    {

        /// <summary>
        /// Constructs a new UserTeamworkRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public UserTeamworkRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public new IUserTeamworkRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public new IUserTeamworkRequest Request(IEnumerable<Option> options)
        {
            return new UserTeamworkRequest(this.RequestUrl, this.Client, options);
        }
    
        /// <summary>
        /// Gets the request builder for InstalledApps.
        /// </summary>
        /// <returns>The <see cref="IUserTeamworkInstalledAppsCollectionRequestBuilder"/>.</returns>
        public IUserTeamworkInstalledAppsCollectionRequestBuilder InstalledApps
        {
            get
            {
                return new UserTeamworkInstalledAppsCollectionRequestBuilder(this.AppendSegmentToRequestUrl("installedApps"), this.Client);
            }
        }
    
        /// <summary>
        /// Gets the request builder for UserTeamworkSendActivityNotification.
        /// </summary>
        /// <returns>The <see cref="IUserTeamworkSendActivityNotificationRequestBuilder"/>.</returns>
        public IUserTeamworkSendActivityNotificationRequestBuilder SendActivityNotification(
            TeamworkActivityTopic topic = null,
            string activityType = null,
            Int64? chainId = null,
            ItemBody previewText = null,
            IEnumerable<KeyValuePair> templateParameters = null)
        {
            return new UserTeamworkSendActivityNotificationRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.sendActivityNotification"),
                this.Client,
                topic,
                activityType,
                chainId,
                previewText,
                templateParameters);
        }
    
    }
}
