// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: MethodRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type WindowsAutopilotDeviceIdentityAssignUserToDeviceRequestBuilder.
    /// </summary>
    public partial class WindowsAutopilotDeviceIdentityAssignUserToDeviceRequestBuilder : BaseActionMethodRequestBuilder<IWindowsAutopilotDeviceIdentityAssignUserToDeviceRequest>, IWindowsAutopilotDeviceIdentityAssignUserToDeviceRequestBuilder
    {
        /// <summary>
        /// Constructs a new <see cref="WindowsAutopilotDeviceIdentityAssignUserToDeviceRequestBuilder"/>.
        /// </summary>
        /// <param name="requestUrl">The URL for the request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        /// <param name="userPrincipalName">A userPrincipalName parameter for the OData method call.</param>
        /// <param name="addressableUserName">A addressableUserName parameter for the OData method call.</param>
        public WindowsAutopilotDeviceIdentityAssignUserToDeviceRequestBuilder(
            string requestUrl,
            IBaseClient client,
            string userPrincipalName,
            string addressableUserName)
            : base(requestUrl, client)
        {
            this.SetParameter("userPrincipalName", userPrincipalName, true);
            this.SetParameter("addressableUserName", addressableUserName, true);
        }

        /// <summary>
        /// A method used by the base class to construct a request class instance.
        /// </summary>
        /// <param name="functionUrl">The request URL to </param>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>An instance of a specific request class.</returns>
        protected override IWindowsAutopilotDeviceIdentityAssignUserToDeviceRequest CreateRequest(string functionUrl, IEnumerable<Option> options)
        {
            var request = new WindowsAutopilotDeviceIdentityAssignUserToDeviceRequest(functionUrl, this.Client, options);

            if (this.HasParameter("userPrincipalName"))
            {
                request.RequestBody.UserPrincipalName = this.GetParameter<string>("userPrincipalName");
            }

            if (this.HasParameter("addressableUserName"))
            {
                request.RequestBody.AddressableUserName = this.GetParameter<string>("addressableUserName");
            }

            return request;
        }
    }
}
