// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type WindowsInformationProtectionRequestBuilder.
    /// </summary>
    public partial class WindowsInformationProtectionRequestBuilder : ManagedAppPolicyRequestBuilder, IWindowsInformationProtectionRequestBuilder
    {

        /// <summary>
        /// Constructs a new WindowsInformationProtectionRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public WindowsInformationProtectionRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public new IWindowsInformationProtectionRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public new IWindowsInformationProtectionRequest Request(IEnumerable<Option> options)
        {
            return new WindowsInformationProtectionRequest(this.RequestUrl, this.Client, options);
        }
    
        /// <summary>
        /// Gets the request builder for Assignments.
        /// </summary>
        /// <returns>The <see cref="IWindowsInformationProtectionAssignmentsCollectionRequestBuilder"/>.</returns>
        public IWindowsInformationProtectionAssignmentsCollectionRequestBuilder Assignments
        {
            get
            {
                return new WindowsInformationProtectionAssignmentsCollectionRequestBuilder(this.AppendSegmentToRequestUrl("assignments"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for ExemptAppLockerFiles.
        /// </summary>
        /// <returns>The <see cref="IWindowsInformationProtectionExemptAppLockerFilesCollectionRequestBuilder"/>.</returns>
        public IWindowsInformationProtectionExemptAppLockerFilesCollectionRequestBuilder ExemptAppLockerFiles
        {
            get
            {
                return new WindowsInformationProtectionExemptAppLockerFilesCollectionRequestBuilder(this.AppendSegmentToRequestUrl("exemptAppLockerFiles"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for ProtectedAppLockerFiles.
        /// </summary>
        /// <returns>The <see cref="IWindowsInformationProtectionProtectedAppLockerFilesCollectionRequestBuilder"/>.</returns>
        public IWindowsInformationProtectionProtectedAppLockerFilesCollectionRequestBuilder ProtectedAppLockerFiles
        {
            get
            {
                return new WindowsInformationProtectionProtectedAppLockerFilesCollectionRequestBuilder(this.AppendSegmentToRequestUrl("protectedAppLockerFiles"), this.Client);
            }
        }
    
        /// <summary>
        /// Gets the request builder for WindowsInformationProtectionAssign.
        /// </summary>
        /// <returns>The <see cref="IWindowsInformationProtectionAssignRequestBuilder"/>.</returns>
        public IWindowsInformationProtectionAssignRequestBuilder Assign(
            IEnumerable<TargetedManagedAppPolicyAssignment> assignments = null)
        {
            return new WindowsInformationProtectionAssignRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.assign"),
                this.Client,
                assignments);
        }
    
    }
}
