// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type WorkbookChartAxesRequestBuilder.
    /// </summary>
    public partial class WorkbookChartAxesRequestBuilder : EntityRequestBuilder, IWorkbookChartAxesRequestBuilder
    {

        /// <summary>
        /// Constructs a new WorkbookChartAxesRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public WorkbookChartAxesRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public new IWorkbookChartAxesRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public new IWorkbookChartAxesRequest Request(IEnumerable<Option> options)
        {
            return new WorkbookChartAxesRequest(this.RequestUrl, this.Client, options);
        }
    
        /// <summary>
        /// Gets the request builder for CategoryAxis.
        /// </summary>
        /// <returns>The <see cref="IWorkbookChartAxisRequestBuilder"/>.</returns>
        public IWorkbookChartAxisRequestBuilder CategoryAxis
        {
            get
            {
                return new WorkbookChartAxisRequestBuilder(this.AppendSegmentToRequestUrl("categoryAxis"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for SeriesAxis.
        /// </summary>
        /// <returns>The <see cref="IWorkbookChartAxisRequestBuilder"/>.</returns>
        public IWorkbookChartAxisRequestBuilder SeriesAxis
        {
            get
            {
                return new WorkbookChartAxisRequestBuilder(this.AppendSegmentToRequestUrl("seriesAxis"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for ValueAxis.
        /// </summary>
        /// <returns>The <see cref="IWorkbookChartAxisRequestBuilder"/>.</returns>
        public IWorkbookChartAxisRequestBuilder ValueAxis
        {
            get
            {
                return new WorkbookChartAxisRequestBuilder(this.AppendSegmentToRequestUrl("valueAxis"), this.Client);
            }
        }
    
    }
}
