// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: MethodRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type WorkbookChartImageRequestBuilder.
    /// </summary>
    public partial class WorkbookChartImageRequestBuilder : BaseFunctionMethodRequestBuilder<IWorkbookChartImageRequest>, IWorkbookChartImageRequestBuilder
    {
        /// <summary>
        /// Constructs a new <see cref="WorkbookChartImageRequestBuilder"/>.
        /// </summary>
        /// <param name="requestUrl">The URL for the request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public WorkbookChartImageRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
            this.SetFunctionParameters();
        }

        /// <summary>
        /// Constructs a new <see cref="WorkbookChartImageRequestBuilder"/>.
        /// </summary>
        /// <param name="requestUrl">The URL for the request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        /// <param name="width">A width parameter for the OData method call.</param>
        public WorkbookChartImageRequestBuilder(
            string requestUrl,
            IBaseClient client,
            Int32 width)
            : base(requestUrl, client)
        {
            this.SetParameter("width", width, false);
            this.SetFunctionParameters();
        }

        /// <summary>
        /// Constructs a new <see cref="WorkbookChartImageRequestBuilder"/>.
        /// </summary>
        /// <param name="requestUrl">The URL for the request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        /// <param name="width">A width parameter for the OData method call.</param>
        /// <param name="height">A height parameter for the OData method call.</param>
        public WorkbookChartImageRequestBuilder(
            string requestUrl,
            IBaseClient client,
            Int32 width,
            Int32 height)
            : base(requestUrl, client)
        {
            this.SetParameter("width", width, false);
            this.SetParameter("height", height, false);
            this.SetFunctionParameters();
        }

        /// <summary>
        /// Constructs a new <see cref="WorkbookChartImageRequestBuilder"/>.
        /// </summary>
        /// <param name="requestUrl">The URL for the request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        /// <param name="width">A width parameter for the OData method call.</param>
        /// <param name="height">A height parameter for the OData method call.</param>
        /// <param name="fittingMode">A fittingMode parameter for the OData method call.</param>
        public WorkbookChartImageRequestBuilder(
            string requestUrl,
            IBaseClient client,
            Int32 width,
            Int32 height,
            string fittingMode)
            : base(requestUrl, client)
        {
            this.SetParameter("width", width, false);
            this.SetParameter("height", height, false);
            this.SetParameter("fittingMode", fittingMode, false);
            this.SetFunctionParameters();
        }

        /// <summary>
        /// A method used by the base class to construct a request class instance.
        /// </summary>
        /// <param name="functionUrl">The request URL to </param>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>An instance of a specific request class.</returns>
        protected override IWorkbookChartImageRequest CreateRequest(string functionUrl, IEnumerable<Option> options)
        {
            var request = new WorkbookChartImageRequest(functionUrl, this.Client, options);

            return request;
        }
    }
}
