// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: MethodRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type WorkbookChartSetPositionRequestBuilder.
    /// </summary>
    public partial class WorkbookChartSetPositionRequestBuilder : BaseActionMethodRequestBuilder<IWorkbookChartSetPositionRequest>, IWorkbookChartSetPositionRequestBuilder
    {
        /// <summary>
        /// Constructs a new <see cref="WorkbookChartSetPositionRequestBuilder"/>.
        /// </summary>
        /// <param name="requestUrl">The URL for the request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        /// <param name="startCell">A startCell parameter for the OData method call.</param>
        /// <param name="endCell">A endCell parameter for the OData method call.</param>
        public WorkbookChartSetPositionRequestBuilder(
            string requestUrl,
            IBaseClient client,
            System.Text.Json.JsonDocument startCell,
            System.Text.Json.JsonDocument endCell)
            : base(requestUrl, client)
        {
            this.SetParameter("startCell", startCell, true);
            this.SetParameter("endCell", endCell, true);
        }

        /// <summary>
        /// A method used by the base class to construct a request class instance.
        /// </summary>
        /// <param name="functionUrl">The request URL to </param>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>An instance of a specific request class.</returns>
        protected override IWorkbookChartSetPositionRequest CreateRequest(string functionUrl, IEnumerable<Option> options)
        {
            var request = new WorkbookChartSetPositionRequest(functionUrl, this.Client, options);

            if (this.HasParameter("startCell"))
            {
                request.RequestBody.StartCell = this.GetParameter<System.Text.Json.JsonDocument>("startCell");
            }

            if (this.HasParameter("endCell"))
            {
                request.RequestBody.EndCell = this.GetParameter<System.Text.Json.JsonDocument>("endCell");
            }

            return request;
        }
    }
}
