// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type WorkbookCommentRequestBuilder.
    /// </summary>
    public partial class WorkbookCommentRequestBuilder : EntityRequestBuilder, IWorkbookCommentRequestBuilder
    {

        /// <summary>
        /// Constructs a new WorkbookCommentRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public WorkbookCommentRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public new IWorkbookCommentRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public new IWorkbookCommentRequest Request(IEnumerable<Option> options)
        {
            return new WorkbookCommentRequest(this.RequestUrl, this.Client, options);
        }
    
        /// <summary>
        /// Gets the request builder for Replies.
        /// </summary>
        /// <returns>The <see cref="IWorkbookCommentRepliesCollectionRequestBuilder"/>.</returns>
        public IWorkbookCommentRepliesCollectionRequestBuilder Replies
        {
            get
            {
                return new WorkbookCommentRepliesCollectionRequestBuilder(this.AppendSegmentToRequestUrl("replies"), this.Client);
            }
        }
    
    }
}
