// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: MethodRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type WorkbookFunctionsBaseRequestBuilder.
    /// </summary>
    public partial class WorkbookFunctionsBaseRequestBuilder : BaseActionMethodRequestBuilder<IWorkbookFunctionsBaseRequest>, IWorkbookFunctionsBaseRequestBuilder
    {
        /// <summary>
        /// Constructs a new <see cref="WorkbookFunctionsBaseRequestBuilder"/>.
        /// </summary>
        /// <param name="requestUrl">The URL for the request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        /// <param name="number">A number parameter for the OData method call.</param>
        /// <param name="radix">A radix parameter for the OData method call.</param>
        /// <param name="minLength">A minLength parameter for the OData method call.</param>
        public WorkbookFunctionsBaseRequestBuilder(
            string requestUrl,
            IBaseClient client,
            System.Text.Json.JsonDocument number,
            System.Text.Json.JsonDocument radix,
            System.Text.Json.JsonDocument minLength)
            : base(requestUrl, client)
        {
            this.SetParameter("number", number, true);
            this.SetParameter("radix", radix, true);
            this.SetParameter("minLength", minLength, true);
        }

        /// <summary>
        /// A method used by the base class to construct a request class instance.
        /// </summary>
        /// <param name="functionUrl">The request URL to </param>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>An instance of a specific request class.</returns>
        protected override IWorkbookFunctionsBaseRequest CreateRequest(string functionUrl, IEnumerable<Option> options)
        {
            var request = new WorkbookFunctionsBaseRequest(functionUrl, this.Client, options);

            if (this.HasParameter("number"))
            {
                request.RequestBody.Number = this.GetParameter<System.Text.Json.JsonDocument>("number");
            }

            if (this.HasParameter("radix"))
            {
                request.RequestBody.Radix = this.GetParameter<System.Text.Json.JsonDocument>("radix");
            }

            if (this.HasParameter("minLength"))
            {
                request.RequestBody.MinLength = this.GetParameter<System.Text.Json.JsonDocument>("minLength");
            }

            return request;
        }
    }
}
