// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: MethodRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type WorkbookFunctionsBinom_InvRequestBuilder.
    /// </summary>
    public partial class WorkbookFunctionsBinom_InvRequestBuilder : BaseActionMethodRequestBuilder<IWorkbookFunctionsBinom_InvRequest>, IWorkbookFunctionsBinom_InvRequestBuilder
    {
        /// <summary>
        /// Constructs a new <see cref="WorkbookFunctionsBinom_InvRequestBuilder"/>.
        /// </summary>
        /// <param name="requestUrl">The URL for the request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        /// <param name="trials">A trials parameter for the OData method call.</param>
        /// <param name="probabilityS">A probabilityS parameter for the OData method call.</param>
        /// <param name="alpha">A alpha parameter for the OData method call.</param>
        public WorkbookFunctionsBinom_InvRequestBuilder(
            string requestUrl,
            IBaseClient client,
            System.Text.Json.JsonDocument trials,
            System.Text.Json.JsonDocument probabilityS,
            System.Text.Json.JsonDocument alpha)
            : base(requestUrl, client)
        {
            this.SetParameter("trials", trials, true);
            this.SetParameter("probabilityS", probabilityS, true);
            this.SetParameter("alpha", alpha, true);
        }

        /// <summary>
        /// A method used by the base class to construct a request class instance.
        /// </summary>
        /// <param name="functionUrl">The request URL to </param>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>An instance of a specific request class.</returns>
        protected override IWorkbookFunctionsBinom_InvRequest CreateRequest(string functionUrl, IEnumerable<Option> options)
        {
            var request = new WorkbookFunctionsBinom_InvRequest(functionUrl, this.Client, options);

            if (this.HasParameter("trials"))
            {
                request.RequestBody.Trials = this.GetParameter<System.Text.Json.JsonDocument>("trials");
            }

            if (this.HasParameter("probabilityS"))
            {
                request.RequestBody.ProbabilityS = this.GetParameter<System.Text.Json.JsonDocument>("probabilityS");
            }

            if (this.HasParameter("alpha"))
            {
                request.RequestBody.Alpha = this.GetParameter<System.Text.Json.JsonDocument>("alpha");
            }

            return request;
        }
    }
}
