// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: MethodRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type WorkbookFunctionsExactRequestBuilder.
    /// </summary>
    public partial class WorkbookFunctionsExactRequestBuilder : BaseActionMethodRequestBuilder<IWorkbookFunctionsExactRequest>, IWorkbookFunctionsExactRequestBuilder
    {
        /// <summary>
        /// Constructs a new <see cref="WorkbookFunctionsExactRequestBuilder"/>.
        /// </summary>
        /// <param name="requestUrl">The URL for the request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        /// <param name="text1">A text1 parameter for the OData method call.</param>
        /// <param name="text2">A text2 parameter for the OData method call.</param>
        public WorkbookFunctionsExactRequestBuilder(
            string requestUrl,
            IBaseClient client,
            System.Text.Json.JsonDocument text1,
            System.Text.Json.JsonDocument text2)
            : base(requestUrl, client)
        {
            this.SetParameter("text1", text1, true);
            this.SetParameter("text2", text2, true);
        }

        /// <summary>
        /// A method used by the base class to construct a request class instance.
        /// </summary>
        /// <param name="functionUrl">The request URL to </param>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>An instance of a specific request class.</returns>
        protected override IWorkbookFunctionsExactRequest CreateRequest(string functionUrl, IEnumerable<Option> options)
        {
            var request = new WorkbookFunctionsExactRequest(functionUrl, this.Client, options);

            if (this.HasParameter("text1"))
            {
                request.RequestBody.Text1 = this.GetParameter<System.Text.Json.JsonDocument>("text1");
            }

            if (this.HasParameter("text2"))
            {
                request.RequestBody.Text2 = this.GetParameter<System.Text.Json.JsonDocument>("text2");
            }

            return request;
        }
    }
}
