// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: MethodRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type WorkbookFunctionsNetworkDays_IntlRequestBuilder.
    /// </summary>
    public partial class WorkbookFunctionsNetworkDays_IntlRequestBuilder : BaseActionMethodRequestBuilder<IWorkbookFunctionsNetworkDays_IntlRequest>, IWorkbookFunctionsNetworkDays_IntlRequestBuilder
    {
        /// <summary>
        /// Constructs a new <see cref="WorkbookFunctionsNetworkDays_IntlRequestBuilder"/>.
        /// </summary>
        /// <param name="requestUrl">The URL for the request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        /// <param name="startDate">A startDate parameter for the OData method call.</param>
        /// <param name="endDate">A endDate parameter for the OData method call.</param>
        /// <param name="weekend">A weekend parameter for the OData method call.</param>
        /// <param name="holidays">A holidays parameter for the OData method call.</param>
        public WorkbookFunctionsNetworkDays_IntlRequestBuilder(
            string requestUrl,
            IBaseClient client,
            System.Text.Json.JsonDocument startDate,
            System.Text.Json.JsonDocument endDate,
            System.Text.Json.JsonDocument weekend,
            System.Text.Json.JsonDocument holidays)
            : base(requestUrl, client)
        {
            this.SetParameter("startDate", startDate, true);
            this.SetParameter("endDate", endDate, true);
            this.SetParameter("weekend", weekend, true);
            this.SetParameter("holidays", holidays, true);
        }

        /// <summary>
        /// A method used by the base class to construct a request class instance.
        /// </summary>
        /// <param name="functionUrl">The request URL to </param>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>An instance of a specific request class.</returns>
        protected override IWorkbookFunctionsNetworkDays_IntlRequest CreateRequest(string functionUrl, IEnumerable<Option> options)
        {
            var request = new WorkbookFunctionsNetworkDays_IntlRequest(functionUrl, this.Client, options);

            if (this.HasParameter("startDate"))
            {
                request.RequestBody.StartDate = this.GetParameter<System.Text.Json.JsonDocument>("startDate");
            }

            if (this.HasParameter("endDate"))
            {
                request.RequestBody.EndDate = this.GetParameter<System.Text.Json.JsonDocument>("endDate");
            }

            if (this.HasParameter("weekend"))
            {
                request.RequestBody.Weekend = this.GetParameter<System.Text.Json.JsonDocument>("weekend");
            }

            if (this.HasParameter("holidays"))
            {
                request.RequestBody.Holidays = this.GetParameter<System.Text.Json.JsonDocument>("holidays");
            }

            return request;
        }
    }
}
