// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: MethodRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type WorkbookFunctionsRandBetweenRequestBuilder.
    /// </summary>
    public partial class WorkbookFunctionsRandBetweenRequestBuilder : BaseActionMethodRequestBuilder<IWorkbookFunctionsRandBetweenRequest>, IWorkbookFunctionsRandBetweenRequestBuilder
    {
        /// <summary>
        /// Constructs a new <see cref="WorkbookFunctionsRandBetweenRequestBuilder"/>.
        /// </summary>
        /// <param name="requestUrl">The URL for the request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        /// <param name="bottom">A bottom parameter for the OData method call.</param>
        /// <param name="top">A top parameter for the OData method call.</param>
        public WorkbookFunctionsRandBetweenRequestBuilder(
            string requestUrl,
            IBaseClient client,
            System.Text.Json.JsonDocument bottom,
            System.Text.Json.JsonDocument top)
            : base(requestUrl, client)
        {
            this.SetParameter("bottom", bottom, true);
            this.SetParameter("top", top, true);
        }

        /// <summary>
        /// A method used by the base class to construct a request class instance.
        /// </summary>
        /// <param name="functionUrl">The request URL to </param>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>An instance of a specific request class.</returns>
        protected override IWorkbookFunctionsRandBetweenRequest CreateRequest(string functionUrl, IEnumerable<Option> options)
        {
            var request = new WorkbookFunctionsRandBetweenRequest(functionUrl, this.Client, options);

            if (this.HasParameter("bottom"))
            {
                request.RequestBody.Bottom = this.GetParameter<System.Text.Json.JsonDocument>("bottom");
            }

            if (this.HasParameter("top"))
            {
                request.RequestBody.Top = this.GetParameter<System.Text.Json.JsonDocument>("top");
            }

            return request;
        }
    }
}
