// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: MethodRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type WorkbookFunctionsReplaceRequestBuilder.
    /// </summary>
    public partial class WorkbookFunctionsReplaceRequestBuilder : BaseActionMethodRequestBuilder<IWorkbookFunctionsReplaceRequest>, IWorkbookFunctionsReplaceRequestBuilder
    {
        /// <summary>
        /// Constructs a new <see cref="WorkbookFunctionsReplaceRequestBuilder"/>.
        /// </summary>
        /// <param name="requestUrl">The URL for the request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        /// <param name="oldText">A oldText parameter for the OData method call.</param>
        /// <param name="startNum">A startNum parameter for the OData method call.</param>
        /// <param name="numChars">A numChars parameter for the OData method call.</param>
        /// <param name="newText">A newText parameter for the OData method call.</param>
        public WorkbookFunctionsReplaceRequestBuilder(
            string requestUrl,
            IBaseClient client,
            System.Text.Json.JsonDocument oldText,
            System.Text.Json.JsonDocument startNum,
            System.Text.Json.JsonDocument numChars,
            System.Text.Json.JsonDocument newText)
            : base(requestUrl, client)
        {
            this.SetParameter("oldText", oldText, true);
            this.SetParameter("startNum", startNum, true);
            this.SetParameter("numChars", numChars, true);
            this.SetParameter("newText", newText, true);
        }

        /// <summary>
        /// A method used by the base class to construct a request class instance.
        /// </summary>
        /// <param name="functionUrl">The request URL to </param>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>An instance of a specific request class.</returns>
        protected override IWorkbookFunctionsReplaceRequest CreateRequest(string functionUrl, IEnumerable<Option> options)
        {
            var request = new WorkbookFunctionsReplaceRequest(functionUrl, this.Client, options);

            if (this.HasParameter("oldText"))
            {
                request.RequestBody.OldText = this.GetParameter<System.Text.Json.JsonDocument>("oldText");
            }

            if (this.HasParameter("startNum"))
            {
                request.RequestBody.StartNum = this.GetParameter<System.Text.Json.JsonDocument>("startNum");
            }

            if (this.HasParameter("numChars"))
            {
                request.RequestBody.NumChars = this.GetParameter<System.Text.Json.JsonDocument>("numChars");
            }

            if (this.HasParameter("newText"))
            {
                request.RequestBody.NewText = this.GetParameter<System.Text.Json.JsonDocument>("newText");
            }

            return request;
        }
    }
}
