// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityCollectionRequestBuilder.cs.tt
namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// The type WorkbookNamesCollectionRequestBuilder.
    /// </summary>
    public partial class WorkbookNamesCollectionRequestBuilder : BaseRequestBuilder, IWorkbookNamesCollectionRequestBuilder
    {
        /// <summary>
        /// Constructs a new WorkbookNamesCollectionRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public WorkbookNamesCollectionRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public IWorkbookNamesCollectionRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public IWorkbookNamesCollectionRequest Request(IEnumerable<Option> options)
        {
            return new WorkbookNamesCollectionRequest(this.RequestUrl, this.Client, options);
        }

        /// <summary>
        /// Gets an <see cref="IWorkbookNamedItemRequestBuilder"/> for the specified WorkbookWorkbookNamedItem.
        /// </summary>
        /// <param name="id">The ID for the WorkbookWorkbookNamedItem.</param>
        /// <returns>The <see cref="IWorkbookNamedItemRequestBuilder"/>.</returns>
        public IWorkbookNamedItemRequestBuilder this[string id]
        {
            get
            {
                return new WorkbookNamedItemRequestBuilder(this.AppendSegmentToRequestUrl(id), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for WorkbookNamedItemAdd.
        /// </summary>
        /// <returns>The <see cref="IWorkbookNamedItemAddRequestBuilder"/>.</returns>
        public IWorkbookNamedItemAddRequestBuilder Add(
            string name = null,
            System.Text.Json.JsonDocument reference = null,
            string comment = null)
        {
            return new WorkbookNamedItemAddRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.add"),
                this.Client,
                name,
                reference,
                comment);
        }

        /// <summary>
        /// Gets the request builder for WorkbookNamedItemAddFormulaLocal.
        /// </summary>
        /// <returns>The <see cref="IWorkbookNamedItemAddFormulaLocalRequestBuilder"/>.</returns>
        public IWorkbookNamedItemAddFormulaLocalRequestBuilder AddFormulaLocal(
            string name = null,
            string formula = null,
            string comment = null)
        {
            return new WorkbookNamedItemAddFormulaLocalRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.addFormulaLocal"),
                this.Client,
                name,
                formula,
                comment);
        }
    }
}
