// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type WorkbookPivotTableRequestBuilder.
    /// </summary>
    public partial class WorkbookPivotTableRequestBuilder : EntityRequestBuilder, IWorkbookPivotTableRequestBuilder
    {

        /// <summary>
        /// Constructs a new WorkbookPivotTableRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public WorkbookPivotTableRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public new IWorkbookPivotTableRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public new IWorkbookPivotTableRequest Request(IEnumerable<Option> options)
        {
            return new WorkbookPivotTableRequest(this.RequestUrl, this.Client, options);
        }
    
        /// <summary>
        /// Gets the request builder for Worksheet.
        /// </summary>
        /// <returns>The <see cref="IWorkbookWorksheetRequestBuilder"/>.</returns>
        public IWorkbookWorksheetRequestBuilder Worksheet
        {
            get
            {
                return new WorkbookWorksheetRequestBuilder(this.AppendSegmentToRequestUrl("worksheet"), this.Client);
            }
        }
    
        /// <summary>
        /// Gets the request builder for WorkbookPivotTableRefresh.
        /// </summary>
        /// <returns>The <see cref="IWorkbookPivotTableRefreshRequestBuilder"/>.</returns>
        public IWorkbookPivotTableRefreshRequestBuilder Refresh()
        {
            return new WorkbookPivotTableRefreshRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.refresh"),
                this.Client);
        }
    
    }
}
