// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type WorkbookRangeFormatRequestBuilder.
    /// </summary>
    public partial class WorkbookRangeFormatRequestBuilder : EntityRequestBuilder, IWorkbookRangeFormatRequestBuilder
    {

        /// <summary>
        /// Constructs a new WorkbookRangeFormatRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public WorkbookRangeFormatRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public new IWorkbookRangeFormatRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public new IWorkbookRangeFormatRequest Request(IEnumerable<Option> options)
        {
            return new WorkbookRangeFormatRequest(this.RequestUrl, this.Client, options);
        }
    
        /// <summary>
        /// Gets the request builder for Borders.
        /// </summary>
        /// <returns>The <see cref="IWorkbookRangeFormatBordersCollectionRequestBuilder"/>.</returns>
        public IWorkbookRangeFormatBordersCollectionRequestBuilder Borders
        {
            get
            {
                return new WorkbookRangeFormatBordersCollectionRequestBuilder(this.AppendSegmentToRequestUrl("borders"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for Fill.
        /// </summary>
        /// <returns>The <see cref="IWorkbookRangeFillRequestBuilder"/>.</returns>
        public IWorkbookRangeFillRequestBuilder Fill
        {
            get
            {
                return new WorkbookRangeFillRequestBuilder(this.AppendSegmentToRequestUrl("fill"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for Font.
        /// </summary>
        /// <returns>The <see cref="IWorkbookRangeFontRequestBuilder"/>.</returns>
        public IWorkbookRangeFontRequestBuilder Font
        {
            get
            {
                return new WorkbookRangeFontRequestBuilder(this.AppendSegmentToRequestUrl("font"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for Protection.
        /// </summary>
        /// <returns>The <see cref="IWorkbookFormatProtectionRequestBuilder"/>.</returns>
        public IWorkbookFormatProtectionRequestBuilder Protection
        {
            get
            {
                return new WorkbookFormatProtectionRequestBuilder(this.AppendSegmentToRequestUrl("protection"), this.Client);
            }
        }
    
        /// <summary>
        /// Gets the request builder for WorkbookRangeFormatAutofitColumns.
        /// </summary>
        /// <returns>The <see cref="IWorkbookRangeFormatAutofitColumnsRequestBuilder"/>.</returns>
        public IWorkbookRangeFormatAutofitColumnsRequestBuilder AutofitColumns()
        {
            return new WorkbookRangeFormatAutofitColumnsRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.autofitColumns"),
                this.Client);
        }

        /// <summary>
        /// Gets the request builder for WorkbookRangeFormatAutofitRows.
        /// </summary>
        /// <returns>The <see cref="IWorkbookRangeFormatAutofitRowsRequestBuilder"/>.</returns>
        public IWorkbookRangeFormatAutofitRowsRequestBuilder AutofitRows()
        {
            return new WorkbookRangeFormatAutofitRowsRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.autofitRows"),
                this.Client);
        }
    
    }
}
