// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type WorkbookRangeRequestBuilder.
    /// </summary>
    public partial class WorkbookRangeRequestBuilder : EntityRequestBuilder, IWorkbookRangeRequestBuilder
    {

        /// <summary>
        /// Constructs a new WorkbookRangeRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public WorkbookRangeRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public new IWorkbookRangeRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public new IWorkbookRangeRequest Request(IEnumerable<Option> options)
        {
            return new WorkbookRangeRequest(this.RequestUrl, this.Client, options);
        }
    
        /// <summary>
        /// Gets the request builder for Format.
        /// </summary>
        /// <returns>The <see cref="IWorkbookRangeFormatRequestBuilder"/>.</returns>
        public IWorkbookRangeFormatRequestBuilder Format
        {
            get
            {
                return new WorkbookRangeFormatRequestBuilder(this.AppendSegmentToRequestUrl("format"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for Sort.
        /// </summary>
        /// <returns>The <see cref="IWorkbookRangeSortRequestBuilder"/>.</returns>
        public IWorkbookRangeSortRequestBuilder Sort
        {
            get
            {
                return new WorkbookRangeSortRequestBuilder(this.AppendSegmentToRequestUrl("sort"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for Worksheet.
        /// </summary>
        /// <returns>The <see cref="IWorkbookWorksheetRequestBuilder"/>.</returns>
        public IWorkbookWorksheetRequestBuilder Worksheet
        {
            get
            {
                return new WorkbookWorksheetRequestBuilder(this.AppendSegmentToRequestUrl("worksheet"), this.Client);
            }
        }
    
        /// <summary>
        /// Gets the request builder for WorkbookRangeClear.
        /// </summary>
        /// <returns>The <see cref="IWorkbookRangeClearRequestBuilder"/>.</returns>
        public IWorkbookRangeClearRequestBuilder Clear(
            string applyTo)
        {
            return new WorkbookRangeClearRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.clear"),
                this.Client,
                applyTo);
        }

        /// <summary>
        /// Gets the request builder for WorkbookRangeDelete.
        /// </summary>
        /// <returns>The <see cref="IWorkbookRangeDeleteRequestBuilder"/>.</returns>
        public IWorkbookRangeDeleteRequestBuilder Delete(
            string shift)
        {
            return new WorkbookRangeDeleteRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.delete"),
                this.Client,
                shift);
        }

        /// <summary>
        /// Gets the request builder for WorkbookRangeInsert.
        /// </summary>
        /// <returns>The <see cref="IWorkbookRangeInsertRequestBuilder"/>.</returns>
        public IWorkbookRangeInsertRequestBuilder Insert(
            string shift)
        {
            return new WorkbookRangeInsertRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.insert"),
                this.Client,
                shift);
        }

        /// <summary>
        /// Gets the request builder for WorkbookRangeMerge.
        /// </summary>
        /// <returns>The <see cref="IWorkbookRangeMergeRequestBuilder"/>.</returns>
        public IWorkbookRangeMergeRequestBuilder Merge(
            bool across)
        {
            return new WorkbookRangeMergeRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.merge"),
                this.Client,
                across);
        }

        /// <summary>
        /// Gets the request builder for WorkbookRangeUnmerge.
        /// </summary>
        /// <returns>The <see cref="IWorkbookRangeUnmergeRequestBuilder"/>.</returns>
        public IWorkbookRangeUnmergeRequestBuilder Unmerge()
        {
            return new WorkbookRangeUnmergeRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.unmerge"),
                this.Client);
        }

        /// <summary>
        /// Gets the request builder for WorkbookRangeBoundingRect.
        /// </summary>
        /// <returns>The <see cref="IWorkbookRangeBoundingRectRequestBuilder"/>.</returns>
        public IWorkbookRangeBoundingRectRequestBuilder BoundingRect(
            string anotherRange = null)
        {
            return new WorkbookRangeBoundingRectRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.boundingRect"),
                this.Client,
                anotherRange);
        }

        /// <summary>
        /// Gets the request builder for WorkbookRangeCell.
        /// </summary>
        /// <returns>The <see cref="IWorkbookRangeCellRequestBuilder"/>.</returns>
        public IWorkbookRangeCellRequestBuilder Cell(
            Int32 row,
            Int32 column)
        {
            return new WorkbookRangeCellRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.cell"),
                this.Client,
                row,
                column);
        }

        /// <summary>
        /// Gets the request builder for WorkbookRangeColumn.
        /// </summary>
        /// <returns>The <see cref="IWorkbookRangeColumnRequestBuilder"/>.</returns>
        public IWorkbookRangeColumnRequestBuilder Column(
            Int32 column)
        {
            return new WorkbookRangeColumnRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.column"),
                this.Client,
                column);
        }

        /// <summary>
        /// Gets the request builder for WorkbookRangeColumnsAfter.
        /// </summary>
        /// <returns>The <see cref="IWorkbookRangeColumnsAfterRequestBuilder"/>.</returns>
        public IWorkbookRangeColumnsAfterRequestBuilder ColumnsAfter()
        {
            return new WorkbookRangeColumnsAfterRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.columnsAfter"),
                this.Client);
        }

        /// <summary>
        /// Gets the request builder for WorkbookRangeColumnsAfter.
        /// </summary>
        /// <returns>The <see cref="IWorkbookRangeColumnsAfterRequestBuilder"/>.</returns>
        public IWorkbookRangeColumnsAfterRequestBuilder ColumnsAfter(
            Int32? count = null)
        {
            return new WorkbookRangeColumnsAfterRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.columnsAfter"),
                this.Client,
                count);
        }

        /// <summary>
        /// Gets the request builder for WorkbookRangeColumnsBefore.
        /// </summary>
        /// <returns>The <see cref="IWorkbookRangeColumnsBeforeRequestBuilder"/>.</returns>
        public IWorkbookRangeColumnsBeforeRequestBuilder ColumnsBefore()
        {
            return new WorkbookRangeColumnsBeforeRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.columnsBefore"),
                this.Client);
        }

        /// <summary>
        /// Gets the request builder for WorkbookRangeColumnsBefore.
        /// </summary>
        /// <returns>The <see cref="IWorkbookRangeColumnsBeforeRequestBuilder"/>.</returns>
        public IWorkbookRangeColumnsBeforeRequestBuilder ColumnsBefore(
            Int32? count = null)
        {
            return new WorkbookRangeColumnsBeforeRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.columnsBefore"),
                this.Client,
                count);
        }

        /// <summary>
        /// Gets the request builder for WorkbookRangeEntireColumn.
        /// </summary>
        /// <returns>The <see cref="IWorkbookRangeEntireColumnRequestBuilder"/>.</returns>
        public IWorkbookRangeEntireColumnRequestBuilder EntireColumn()
        {
            return new WorkbookRangeEntireColumnRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.entireColumn"),
                this.Client);
        }

        /// <summary>
        /// Gets the request builder for WorkbookRangeEntireRow.
        /// </summary>
        /// <returns>The <see cref="IWorkbookRangeEntireRowRequestBuilder"/>.</returns>
        public IWorkbookRangeEntireRowRequestBuilder EntireRow()
        {
            return new WorkbookRangeEntireRowRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.entireRow"),
                this.Client);
        }

        /// <summary>
        /// Gets the request builder for WorkbookRangeIntersection.
        /// </summary>
        /// <returns>The <see cref="IWorkbookRangeIntersectionRequestBuilder"/>.</returns>
        public IWorkbookRangeIntersectionRequestBuilder Intersection(
            string anotherRange = null)
        {
            return new WorkbookRangeIntersectionRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.intersection"),
                this.Client,
                anotherRange);
        }

        /// <summary>
        /// Gets the request builder for WorkbookRangeLastCell.
        /// </summary>
        /// <returns>The <see cref="IWorkbookRangeLastCellRequestBuilder"/>.</returns>
        public IWorkbookRangeLastCellRequestBuilder LastCell()
        {
            return new WorkbookRangeLastCellRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.lastCell"),
                this.Client);
        }

        /// <summary>
        /// Gets the request builder for WorkbookRangeLastColumn.
        /// </summary>
        /// <returns>The <see cref="IWorkbookRangeLastColumnRequestBuilder"/>.</returns>
        public IWorkbookRangeLastColumnRequestBuilder LastColumn()
        {
            return new WorkbookRangeLastColumnRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.lastColumn"),
                this.Client);
        }

        /// <summary>
        /// Gets the request builder for WorkbookRangeLastRow.
        /// </summary>
        /// <returns>The <see cref="IWorkbookRangeLastRowRequestBuilder"/>.</returns>
        public IWorkbookRangeLastRowRequestBuilder LastRow()
        {
            return new WorkbookRangeLastRowRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.lastRow"),
                this.Client);
        }

        /// <summary>
        /// Gets the request builder for WorkbookRangeOffsetRange.
        /// </summary>
        /// <returns>The <see cref="IWorkbookRangeOffsetRangeRequestBuilder"/>.</returns>
        public IWorkbookRangeOffsetRangeRequestBuilder OffsetRange(
            Int32 rowOffset,
            Int32 columnOffset)
        {
            return new WorkbookRangeOffsetRangeRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.offsetRange"),
                this.Client,
                rowOffset,
                columnOffset);
        }

        /// <summary>
        /// Gets the request builder for WorkbookRangeResizedRange.
        /// </summary>
        /// <returns>The <see cref="IWorkbookRangeResizedRangeRequestBuilder"/>.</returns>
        public IWorkbookRangeResizedRangeRequestBuilder ResizedRange(
            Int32 deltaRows,
            Int32 deltaColumns)
        {
            return new WorkbookRangeResizedRangeRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.resizedRange"),
                this.Client,
                deltaRows,
                deltaColumns);
        }

        /// <summary>
        /// Gets the request builder for WorkbookRangeRow.
        /// </summary>
        /// <returns>The <see cref="IWorkbookRangeRowRequestBuilder"/>.</returns>
        public IWorkbookRangeRowRequestBuilder Row(
            Int32 row)
        {
            return new WorkbookRangeRowRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.row"),
                this.Client,
                row);
        }

        /// <summary>
        /// Gets the request builder for WorkbookRangeRowsAbove.
        /// </summary>
        /// <returns>The <see cref="IWorkbookRangeRowsAboveRequestBuilder"/>.</returns>
        public IWorkbookRangeRowsAboveRequestBuilder RowsAbove()
        {
            return new WorkbookRangeRowsAboveRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.rowsAbove"),
                this.Client);
        }

        /// <summary>
        /// Gets the request builder for WorkbookRangeRowsAbove.
        /// </summary>
        /// <returns>The <see cref="IWorkbookRangeRowsAboveRequestBuilder"/>.</returns>
        public IWorkbookRangeRowsAboveRequestBuilder RowsAbove(
            Int32? count = null)
        {
            return new WorkbookRangeRowsAboveRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.rowsAbove"),
                this.Client,
                count);
        }

        /// <summary>
        /// Gets the request builder for WorkbookRangeRowsBelow.
        /// </summary>
        /// <returns>The <see cref="IWorkbookRangeRowsBelowRequestBuilder"/>.</returns>
        public IWorkbookRangeRowsBelowRequestBuilder RowsBelow()
        {
            return new WorkbookRangeRowsBelowRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.rowsBelow"),
                this.Client);
        }

        /// <summary>
        /// Gets the request builder for WorkbookRangeRowsBelow.
        /// </summary>
        /// <returns>The <see cref="IWorkbookRangeRowsBelowRequestBuilder"/>.</returns>
        public IWorkbookRangeRowsBelowRequestBuilder RowsBelow(
            Int32? count = null)
        {
            return new WorkbookRangeRowsBelowRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.rowsBelow"),
                this.Client,
                count);
        }

        /// <summary>
        /// Gets the request builder for WorkbookRangeUsedRange.
        /// </summary>
        /// <returns>The <see cref="IWorkbookRangeUsedRangeRequestBuilder"/>.</returns>
        public IWorkbookRangeUsedRangeRequestBuilder UsedRange()
        {
            return new WorkbookRangeUsedRangeRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.usedRange"),
                this.Client);
        }

        /// <summary>
        /// Gets the request builder for WorkbookRangeUsedRange.
        /// </summary>
        /// <returns>The <see cref="IWorkbookRangeUsedRangeRequestBuilder"/>.</returns>
        public IWorkbookRangeUsedRangeRequestBuilder UsedRange(
            bool valuesOnly)
        {
            return new WorkbookRangeUsedRangeRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.usedRange"),
                this.Client,
                valuesOnly);
        }

        /// <summary>
        /// Gets the request builder for WorkbookRangeVisibleView.
        /// </summary>
        /// <returns>The <see cref="IWorkbookRangeVisibleViewRequestBuilder"/>.</returns>
        public IWorkbookRangeVisibleViewRequestBuilder VisibleView()
        {
            return new WorkbookRangeVisibleViewRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.visibleView"),
                this.Client);
        }
    
    }
}
