// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityCollectionRequestBuilder.cs.tt
namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// The type WorkbookRangeViewRowsCollectionRequestBuilder.
    /// </summary>
    public partial class WorkbookRangeViewRowsCollectionRequestBuilder : BaseRequestBuilder, IWorkbookRangeViewRowsCollectionRequestBuilder
    {
        /// <summary>
        /// Constructs a new WorkbookRangeViewRowsCollectionRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public WorkbookRangeViewRowsCollectionRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public IWorkbookRangeViewRowsCollectionRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public IWorkbookRangeViewRowsCollectionRequest Request(IEnumerable<Option> options)
        {
            return new WorkbookRangeViewRowsCollectionRequest(this.RequestUrl, this.Client, options);
        }

        /// <summary>
        /// Gets an <see cref="IWorkbookRangeViewRequestBuilder"/> for the specified WorkbookRangeViewWorkbookRangeView.
        /// </summary>
        /// <param name="id">The ID for the WorkbookRangeViewWorkbookRangeView.</param>
        /// <returns>The <see cref="IWorkbookRangeViewRequestBuilder"/>.</returns>
        public IWorkbookRangeViewRequestBuilder this[string id]
        {
            get
            {
                return new WorkbookRangeViewRequestBuilder(this.AppendSegmentToRequestUrl(id), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for WorkbookRangeViewItemAt.
        /// </summary>
        /// <returns>The <see cref="IWorkbookRangeViewItemAtRequestBuilder"/>.</returns>
        public IWorkbookRangeViewItemAtRequestBuilder ItemAt(
            Int32 index)
        {
            return new WorkbookRangeViewItemAtRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.itemAt"),
                this.Client,
                index);
        }
    }
}
