// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityRequestBuilder.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type WorkbookTableRequestBuilder.
    /// </summary>
    public partial class WorkbookTableRequestBuilder : EntityRequestBuilder, IWorkbookTableRequestBuilder
    {

        /// <summary>
        /// Constructs a new WorkbookTableRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="IBaseClient"/> for handling requests.</param>
        public WorkbookTableRequestBuilder(
            string requestUrl,
            IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public new IWorkbookTableRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public new IWorkbookTableRequest Request(IEnumerable<Option> options)
        {
            return new WorkbookTableRequest(this.RequestUrl, this.Client, options);
        }
    
        /// <summary>
        /// Gets the request builder for Columns.
        /// </summary>
        /// <returns>The <see cref="IWorkbookTableColumnsCollectionRequestBuilder"/>.</returns>
        public IWorkbookTableColumnsCollectionRequestBuilder Columns
        {
            get
            {
                return new WorkbookTableColumnsCollectionRequestBuilder(this.AppendSegmentToRequestUrl("columns"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for Rows.
        /// </summary>
        /// <returns>The <see cref="IWorkbookTableRowsCollectionRequestBuilder"/>.</returns>
        public IWorkbookTableRowsCollectionRequestBuilder Rows
        {
            get
            {
                return new WorkbookTableRowsCollectionRequestBuilder(this.AppendSegmentToRequestUrl("rows"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for Sort.
        /// </summary>
        /// <returns>The <see cref="IWorkbookTableSortRequestBuilder"/>.</returns>
        public IWorkbookTableSortRequestBuilder Sort
        {
            get
            {
                return new WorkbookTableSortRequestBuilder(this.AppendSegmentToRequestUrl("sort"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for Worksheet.
        /// </summary>
        /// <returns>The <see cref="IWorkbookWorksheetRequestBuilder"/>.</returns>
        public IWorkbookWorksheetRequestBuilder Worksheet
        {
            get
            {
                return new WorkbookWorksheetRequestBuilder(this.AppendSegmentToRequestUrl("worksheet"), this.Client);
            }
        }
    
        /// <summary>
        /// Gets the request builder for WorkbookTableClearFilters.
        /// </summary>
        /// <returns>The <see cref="IWorkbookTableClearFiltersRequestBuilder"/>.</returns>
        public IWorkbookTableClearFiltersRequestBuilder ClearFilters()
        {
            return new WorkbookTableClearFiltersRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.clearFilters"),
                this.Client);
        }

        /// <summary>
        /// Gets the request builder for WorkbookTableConvertToRange.
        /// </summary>
        /// <returns>The <see cref="IWorkbookTableConvertToRangeRequestBuilder"/>.</returns>
        public IWorkbookTableConvertToRangeRequestBuilder ConvertToRange()
        {
            return new WorkbookTableConvertToRangeRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.convertToRange"),
                this.Client);
        }

        /// <summary>
        /// Gets the request builder for WorkbookTableReapplyFilters.
        /// </summary>
        /// <returns>The <see cref="IWorkbookTableReapplyFiltersRequestBuilder"/>.</returns>
        public IWorkbookTableReapplyFiltersRequestBuilder ReapplyFilters()
        {
            return new WorkbookTableReapplyFiltersRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.reapplyFilters"),
                this.Client);
        }

        /// <summary>
        /// Gets the request builder for WorkbookTableDataBodyRange.
        /// </summary>
        /// <returns>The <see cref="IWorkbookTableDataBodyRangeRequestBuilder"/>.</returns>
        public IWorkbookTableDataBodyRangeRequestBuilder DataBodyRange()
        {
            return new WorkbookTableDataBodyRangeRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.dataBodyRange"),
                this.Client);
        }

        /// <summary>
        /// Gets the request builder for WorkbookTableHeaderRowRange.
        /// </summary>
        /// <returns>The <see cref="IWorkbookTableHeaderRowRangeRequestBuilder"/>.</returns>
        public IWorkbookTableHeaderRowRangeRequestBuilder HeaderRowRange()
        {
            return new WorkbookTableHeaderRowRangeRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.headerRowRange"),
                this.Client);
        }

        /// <summary>
        /// Gets the request builder for WorkbookTableRange.
        /// </summary>
        /// <returns>The <see cref="IWorkbookTableRangeRequestBuilder"/>.</returns>
        public IWorkbookTableRangeRequestBuilder Range()
        {
            return new WorkbookTableRangeRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.range"),
                this.Client);
        }

        /// <summary>
        /// Gets the request builder for WorkbookTableTotalRowRange.
        /// </summary>
        /// <returns>The <see cref="IWorkbookTableTotalRowRangeRequestBuilder"/>.</returns>
        public IWorkbookTableTotalRowRangeRequestBuilder TotalRowRange()
        {
            return new WorkbookTableTotalRowRangeRequestBuilder(
                this.AppendSegmentToRequestUrl("microsoft.graph.totalRowRange"),
                this.Client);
        }
    
    }
}
