// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityType.cs.tt

namespace Microsoft.Graph.TermStore
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type Group.
    /// </summary>
    [JsonConverter(typeof(Microsoft.Graph.DerivedTypeConverter<Group>))]
    public partial class Group : Microsoft.Graph.Entity
    {
    
        /// <summary>
        /// Gets or sets created date time.
        /// Date and time of group creation. Read-only.
        /// </summary>
        [JsonPropertyName("createdDateTime")]
        public DateTimeOffset? CreatedDateTime { get; set; }
    
        /// <summary>
        /// Gets or sets description.
        /// Description giving details on the term usage.
        /// </summary>
        [JsonPropertyName("description")]
        public string Description { get; set; }
    
        /// <summary>
        /// Gets or sets display name.
        /// Name of group.
        /// </summary>
        [JsonPropertyName("displayName")]
        public string DisplayName { get; set; }
    
        /// <summary>
        /// Gets or sets parent site id.
        /// Id of the parent site of this group.
        /// </summary>
        [JsonPropertyName("parentSiteId")]
        public string ParentSiteId { get; set; }
    
        /// <summary>
        /// Gets or sets scope.
        /// Returns type of group. Possible values are 'global', 'system' and 'siteCollection'.
        /// </summary>
        [JsonPropertyName("scope")]
        public TermGroupScope? Scope { get; set; }
    
        /// <summary>
        /// Gets or sets sets.
        /// All sets under the group in a term [store].
        /// </summary>
        [JsonPropertyName("sets")]
        public IGroupSetsCollectionPage Sets { get; set; }

        /// <summary>
        /// Gets or sets setsNextLink.
        /// </summary>
        [JsonPropertyName("sets@odata.nextLink")]
        [JsonConverter(typeof(NextLinkConverter))]
        public string SetsNextLink { get; set; }
    
    }
}

