// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: IEntityRequest.cs.tt

namespace Microsoft.Graph.TermStore
{
    using System;
    using System.IO;
    using System.Net.Http;
    using System.Threading;
    using System.Linq.Expressions;

    /// <summary>
    /// The interface IRelationRequest.
    /// </summary>
    public partial interface IRelationRequest : Microsoft.Graph.IBaseRequest
    {
        /// <summary>
        /// Creates the specified Relation using POST.
        /// </summary>
        /// <param name="relationToCreate">The Relation to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The created Relation.</returns>
        System.Threading.Tasks.Task<Relation> CreateAsync(Relation relationToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Creates the specified Relation using POST and returns a <see cref="GraphResponse{Relation}"/> object.
        /// </summary>
        /// <param name="relationToCreate">The Relation to create.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{Relation}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<Relation>> CreateResponseAsync(Relation relationToCreate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified Relation.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task DeleteAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Deletes the specified Relation and returns a <see cref="GraphResponse"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse> DeleteResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified Relation.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The Relation.</returns>
        System.Threading.Tasks.Task<Relation> GetAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Gets the specified Relation and returns a <see cref="GraphResponse{Relation}"/> object.
        /// </summary>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The <see cref="GraphResponse{Relation}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<Relation>> GetResponseAsync(CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified Relation using PATCH.
        /// </summary>
        /// <param name="relationToUpdate">The Relation to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="Microsoft.Graph.ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The updated Relation.</returns>
        System.Threading.Tasks.Task<Relation> UpdateAsync(Relation relationToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified Relation using PATCH and returns a <see cref="GraphResponse{Relation}"/> object.
        /// </summary>
        /// <param name="relationToUpdate">The Relation to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <exception cref="Microsoft.Graph.ClientException">Thrown when an object returned in a response is used for updating an object in Microsoft Graph.</exception>
        /// <returns>The <see cref="GraphResponse{Relation}"/> object of the request.</returns>
        System.Threading.Tasks.Task<GraphResponse<Relation>> UpdateResponseAsync(Relation relationToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified Relation using PUT.
        /// </summary>
        /// <param name="relationToUpdate">The Relation object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task to await.</returns>
        System.Threading.Tasks.Task<Relation> PutAsync(Relation relationToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Updates the specified Relation using PUT and returns a <see cref="GraphResponse{Relation}"/> object.
        /// </summary>
        /// <param name="relationToUpdate">The Relation object to update.</param>
        /// <param name="cancellationToken">The <see cref="CancellationToken"/> for the request.</param>
        /// <returns>The task of <see cref="GraphResponse{Relation}"/> to await.</returns>
        System.Threading.Tasks.Task<GraphResponse<Relation>> PutResponseAsync(Relation relationToUpdate, CancellationToken cancellationToken = default);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="value">The expand value.</param>
        /// <returns>The request object to send.</returns>
        IRelationRequest Expand(string value);

        /// <summary>
        /// Adds the specified expand value to the request.
        /// </summary>
        /// <param name="expandExpression">The expression from which to calculate the expand value.</param>
        /// <returns>The request object to send.</returns>
        IRelationRequest Expand(Expression<Func<Relation, object>> expandExpression);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="value">The select value.</param>
        /// <returns>The request object to send.</returns>
        IRelationRequest Select(string value);

        /// <summary>
        /// Adds the specified select value to the request.
        /// </summary>
        /// <param name="selectExpression">The expression from which to calculate the select value.</param>
        /// <returns>The request object to send.</returns>
        IRelationRequest Select(Expression<Func<Relation, object>> selectExpression);

    }
}
