// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: EntityRequestBuilder.cs.tt

namespace Microsoft.Graph.TermStore
{
    using System;
    using System.Collections.Generic;
    using System.IO;

    /// <summary>
    /// The type TermRequestBuilder.
    /// </summary>
    public partial class TermRequestBuilder : Microsoft.Graph.EntityRequestBuilder, ITermRequestBuilder
    {

        /// <summary>
        /// Constructs a new TermRequestBuilder.
        /// </summary>
        /// <param name="requestUrl">The URL for the built request.</param>
        /// <param name="client">The <see cref="Microsoft.Graph.IBaseClient"/> for handling requests.</param>
        public TermRequestBuilder(
            string requestUrl,
            Microsoft.Graph.IBaseClient client)
            : base(requestUrl, client)
        {
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <returns>The built request.</returns>
        public new ITermRequest Request()
        {
            return this.Request(null);
        }

        /// <summary>
        /// Builds the request.
        /// </summary>
        /// <param name="options">The query and header options for the request.</param>
        /// <returns>The built request.</returns>
        public new ITermRequest Request(IEnumerable<Microsoft.Graph.Option> options)
        {
            return new TermRequest(this.RequestUrl, this.Client, options);
        }
    
        /// <summary>
        /// Gets the request builder for Children.
        /// </summary>
        /// <returns>The <see cref="ITermChildrenCollectionRequestBuilder"/>.</returns>
        public ITermChildrenCollectionRequestBuilder Children
        {
            get
            {
                return new TermChildrenCollectionRequestBuilder(this.AppendSegmentToRequestUrl("children"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for Relations.
        /// </summary>
        /// <returns>The <see cref="ITermRelationsCollectionRequestBuilder"/>.</returns>
        public ITermRelationsCollectionRequestBuilder Relations
        {
            get
            {
                return new TermRelationsCollectionRequestBuilder(this.AppendSegmentToRequestUrl("relations"), this.Client);
            }
        }

        /// <summary>
        /// Gets the request builder for Set.
        /// </summary>
        /// <returns>The <see cref="ISetWithReferenceRequestBuilder"/>.</returns>
        public ISetWithReferenceRequestBuilder Set
        {
            get
            {
                return new SetWithReferenceRequestBuilder(this.AppendSegmentToRequestUrl("set"), this.Client);
            }
        }
    
    }
}
