// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: ComplexType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type DefenderDetectedMalwareActions.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<DefenderDetectedMalwareActions>))]
    public partial class DefenderDetectedMalwareActions
    {

        /// <summary>
        /// Gets or sets highSeverity.
        /// Indicates a Defender action to take for high severity Malware threat detected. Possible values are: deviceDefault, clean, quarantine, remove, allow, userDefined, block.
        /// </summary>
        [JsonPropertyName("highSeverity")]
        public DefenderThreatAction? HighSeverity { get; set; }
    
        /// <summary>
        /// Gets or sets lowSeverity.
        /// Indicates a Defender action to take for low severity Malware threat detected. Possible values are: deviceDefault, clean, quarantine, remove, allow, userDefined, block.
        /// </summary>
        [JsonPropertyName("lowSeverity")]
        public DefenderThreatAction? LowSeverity { get; set; }
    
        /// <summary>
        /// Gets or sets moderateSeverity.
        /// Indicates a Defender action to take for moderate severity Malware threat detected. Possible values are: deviceDefault, clean, quarantine, remove, allow, userDefined, block.
        /// </summary>
        [JsonPropertyName("moderateSeverity")]
        public DefenderThreatAction? ModerateSeverity { get; set; }
    
        /// <summary>
        /// Gets or sets severeSeverity.
        /// Indicates a Defender action to take for severe severity Malware threat detected. Possible values are: deviceDefault, clean, quarantine, remove, allow, userDefined, block.
        /// </summary>
        [JsonPropertyName("severeSeverity")]
        public DefenderThreatAction? SevereSeverity { get; set; }
    
        /// <summary>
        /// Gets or sets additional data.
        /// </summary>
        [JsonExtensionData]
        public IDictionary<string, object> AdditionalData { get; set; }

        /// <summary>
        /// Gets or sets @odata.type.
        /// </summary>
        [JsonPropertyName("@odata.type")]
        public string ODataType { get; set; }
    
    }
}
