// ------------------------------------------------------------------------------
//  Copyright (c) Microsoft Corporation.  All Rights Reserved.  Licensed under the MIT License.  See License in the project root for license information.
// ------------------------------------------------------------------------------

// **NOTE** This file was generated by a tool and any changes will be overwritten.
// <auto-generated/>

// Template Source: ComplexType.cs.tt

namespace Microsoft.Graph
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text.Json.Serialization;

    /// <summary>
    /// The type VulnerabilityState.
    /// </summary>
    [JsonConverter(typeof(DerivedTypeConverter<VulnerabilityState>))]
    public partial class VulnerabilityState
    {

        /// <summary>
        /// Gets or sets cve.
        /// Common Vulnerabilities and Exposures (CVE) for the vulnerability.
        /// </summary>
        [JsonPropertyName("cve")]
        public string Cve { get; set; }
    
        /// <summary>
        /// Gets or sets severity.
        /// Base Common Vulnerability Scoring System (CVSS) severity score for this vulnerability.
        /// </summary>
        [JsonPropertyName("severity")]
        public string Severity { get; set; }
    
        /// <summary>
        /// Gets or sets wasRunning.
        /// Indicates whether the detected vulnerability (file) was running at the time of detection or was the file detected at rest on the disk.
        /// </summary>
        [JsonPropertyName("wasRunning")]
        public bool? WasRunning { get; set; }
    
        /// <summary>
        /// Gets or sets additional data.
        /// </summary>
        [JsonExtensionData]
        public IDictionary<string, object> AdditionalData { get; set; }

        /// <summary>
        /// Gets or sets @odata.type.
        /// </summary>
        [JsonPropertyName("@odata.type")]
        public string ODataType { get; set; }
    
    }
}
